Building/Installing HDF-EOS2 using Autoconf/Automake
----------------------------------------------------

Prerequisite
------------
The HDF-EOS2 library requires HDF4 library version 4.2.10 or later. You can download HDF4
from the HDF Group:

    https://confluence.hdfgroup.org/display/support/Download+HDF4

or, depending upon your system, you may be able to install it from a package. The HDF4
libary may depend upon other libraries, such as szip, jpeg, and z (compress). The HDF-EOS2
configure script will do its best to determine these dependencies and find the appropriate
libraries, but it may occasionally need help. Please refer to the troubleshooting section
at the bottom of this document.



Configuring
-----------
After downloading and unpacking the tar file, 'cd' into the hdfeos directory and type

    ./configure

This will run a series of tests to determine the necessary library dependencies, and
configure the makefiles accordingly. The configure script will output a summary of the
configuration options at completion. These can be useful for troubleshooting.

By default, the HDF-EOS2 libraries and include headers will be installed in /usr/local. This
can be changed by using the --prefix option when running configure, e.g.

    ./configure --prefix=/custom/install/location

A number of other options may be provided to the configure script. You can get details
of these options using the command:

    ./configure --help




Building
--------

To build HDF-EOS2, simply type

    make

from the hdfeos directory.


Tests
-----
The HDF-EOS2 library comes with some tests. You can run these using the command

    make check

from the hdfeos directory. These test are primarily for internal testing and are not
part of the official delivery. However, they may provide useful examples. USE AT YOUR
OWN RISK.



Installing
----------

To install HDF-EOS2, simply type

    make install

from the hdfeos directory. You need to make sure you have the necessary permissions to
install the files in the chosen location.




Build HDF-EOS2 using Visual Studio
----------------------------------
For building on Windows, the HDF-EOS2 comes with a Visual Studio 2019 project that can be used to
build native Windows versions of the libraries. This combines both the GCTP and HDF-EOS2 code into
a single library. To build on Windows, after starting up Visual Studio load the HDF-EOS2 project
file in the vs2019/HDF-EOS2 directory. Then select Build -> Build HDF-EOS2 from the menu, or
type <ctrl> B.



Fortran API
-----------
The HDF-EOS2 library can build a FORTRAN API to provide access to HDF-EOS2 functions from FORTRAN
programs. By default, the FORTRAN API is disabled. To enable the FORTRAN API on Autoconf systems,
use the 

    --enable-fortran

option. The configure script will attempt to determine the appropriate API naming convention used
by the fortran compiler automatically. You can still build the FORTRAN API on Autotools systems
even if you do not have access to a FORTRAN compiler. To do this, do not use the --enable-fortran
option, but instead use the options listed below for enabling the API on windows. e.g.

./configure CPPFLAGS="-DFORTRAN_API -DFORTRAN_API_UPPERCASE -DFORTRAN_API_SUFFIX=_"


For building the FORTRAN API on Windows using Visual Studio, you will need to configure some
additional compiler options. These are:

FORTRAN_API                 Just add this as a preprocessor definition (it does not need a
                            specific value)

FORTRAN_API_UPPERCASE       Add this as a preprocessor definition if your FORTRAN compiler uses
                            upper-case for external functions names (e.g. ifort)

FORTRAN_API_LOWERCASE       Add this as a preprocessor definition if your FORTRAN compiler uses
                            lower-case for external functions names.

FORTRAN_API_PREFIX          Add this as a preprocessor definition if your FORTRAN compiler adds
                            a prefix of any sort to external function names. The value of this
                            definition should be the character prefix (e.g. _)

FORTRAN_API_SUFFIX          Add this as a preprocessor definition if your FORTRAN compiler adds
                            a suffix of any sort to external function names. The value of this
                            definition should be the character suffix (e.g. _)

The HDF-EOS2 Visual Studio project file is preconfigure with FORTRAN_API and FORTRAN_API_UPPERCASE,
to suit the Intel ifort compiler. Note that a FORTRAN compiler is not actually needed in order
to generate the FORTRAN API.


Troubleshooting
---------------

General
-------
This section contains general troubleshooting tips. Additional sections below detail
know issues for specific platforms.

* Determining HDF4 Dependencies

    It can be difficult to find out what additional libraries HDF4 depends upon. This is usually
    libjpeg, and libz, but may also include libsz. You can get an idea of the dependencies
    by using the h4cc tool (you may have to search for this):

        h4cc -show

    This will produce output similar to the following:

        cc -O2 -g -pipe -Wall -Wp,-D_FORTIFY_SOURCE=2 -fexceptions -fstack-protector-strong
           --param=ssp-buffer-size=4 -grecord-gcc-switches -m64 -mtune=generic -fPIC -Wl,-z,relro
           -L/usr/lib64/hdf /usr/lib64/hdf/libmfhdf.a /usr/lib64/hdf/libdf.a -ljpeg -lz

    It lists the libraries that HDF4 (and hence HDF-EOS2) programs will need to link against.
    In this case, -ljpeg (libjpeg) and -lz (libz). If HDF4 was built with szip support, it
    will also show -lsz (libsz).


* Finding libraries

    Most of the libraries need by HDF4 and HDF-EOS2 should be found automatically by
    the configure script, but if it cannot find them, they can be found using a simple
    command. e.g. To find the jpeg library:

        find / -name 'libjpeg.*'

    This might produce output as follows:

        /usr/lib64/pkgconfig/libjpeg.pc
        /usr/lib64/libjpeg.so.62
        /usr/lib64/libjpeg.so.62.1.0
        /usr/lib64/libjpeg.so

    In this case, we have a dynamic (shared) jpeg library in /usr/lib64  We can tell configure
    where to find it as follows:

        ./configure --with-jpeg=/usr/lib64

    If you cannot find a particular library, you will need to install the appropriate
    package.


* Installing missing packages

    Linux distributions generally use a package manager to install software packages, though
    the specific tool varies depending upon the distribution. For example, CentOS uses 'yum'
    while Ubuntu uses 'apt'.

    Max OSX systems, while linux like, do not have the 'OS ready' packages for most of the
    dependencies needed by HDF-EOS2. However, there are independently developed tools such as
    MacPorts (https://www.macports.org/) and HomeBrew (https://brew.sh/) which are just
    as capable, and can provide everything you need.

    Packages often come in two different 'flavors' - regular, and 'devel'. The regular versions
    contain the libraries needed to run programs that use them. The 'devel' packages are
    developer orientated packages that include headers files needed to compile your own
    programs using that use the libraries. The following is a list of the key packages
    needed by HDF-EOS2:

        hdf     The main HDF4 package. A 'devel' version is needed since HDF-EOS2 compiles
                against this library and needs the header files.

        libjpeg Only needed if hdf uses it, but this is almost always the case. A regular
                version can be used since HDF-EOS2 does not explicity invoke jpeg functions.

        zlib    Compression library. As with libjpeg, a regular version can be used.

        aec     Adaptive Entropy Encoding library (szip). This may or may not be needed,
                depending upon how HDF4 was built. If you have access to the h4cc commmand,
                you can use 'h4cc -show' to determine whether or not it is needed. If
                the output contains '-lsz', then you need aec. Most package versions of
                HDF4 do not use aec.

    Examples of command to install packages on some of the common linux distributions are
    given below.




Linux (Ubuntu/Debian)
---------------------

* Finding/Installing packages

    These distributions tend to use 'apt' as the package manager. You can search for packages
    using apt as follows:

        apt-cache search hdf

    A package can be installed as follows:

        apt-get install libhdf4-dev

    One of the advantages of package manages is that if you install a package in this way, it
    will also install all the depenencies required by the package. You can see which additional
    packages a given package depends on as follows:

        apt-cache depends libhdf4-dev

    This is also a good way to determine whether or not aec is required.



Linux (Redhat/Centos)
---------------------

* Finding/Installing packages

    These distributions tend to use 'yum' as the package manager. You can search for packages
    using yum as follows:

        yum search hdf

    A package can be installed as follows:

        yum install hdf-devel

    One of the advantages of package manages is that if you install a package in this way, it
    will also install all the depenencies required by the pacakge. You can see which additional
    packages a given package depends on as follows:

        yum deplist hdf-devel

    This is also a good way to determine whether or not aec is required.



Mac OSX
-------

* Finding/Installing packages using MacPorts

    You can search for packages using MacPorts as follows:

        port search --name "*hdf*"

    A package can be installed as follows (you may need to run this using sudo):

        port install hdf4

    As with Linux base package managers, MacPorts will also install all the depenencies required
    by a pacakge. You can see which additional packages a given package depends on as follows:

        port info hdf4

    Look for a line beginning 'Library Dependencies'. You can ignore any line beginning with
    'Build Dependences' since you will not be build HDF4.


* Missing library 'System'.

    If your build fails with a message indicating it cannot find a library called 'System',
    try adding the following configure option:

    ./configure LDFLAGS=-L/usr/local

    This gives the location of the library to the linker.



Windows Cygwin
--------------
Building HDFEOS on Cygwin can be problematic because it depends on how the HDF4 library was built (refer
to HDF4-README for further details). In general, the following configure command should suffice:

./configure CPPFLAGS="-D__linux__ -D__x86_64__" LIBS="-lxdr" LDFLAGS="-L/usr/local/lib"

You will need to change the library location in LDFLAGS if you installed the HDF4 library in a different
location, and make sure the CPPFLAGS defines match those used to build the hdf4 library.

These files are provided as an aid to the user for examples in how to use the
HDF-EOS library.  The test drivers have been run on every platform supported
by the Toolkit.  Platforms supported by the Toolkit are listed in the 
README file located in doc directory.

==============================================================================
NOTE:  YOU MUST HAVE ALL OF THE TEXT FILES IN THE SAME DIRECTORY AS YOUR POINT 
	TEST DRIVERS.  THEY WILL CRASH WITHOUT THEM!!!!!!!!!!!!!!!!!!!!!!!!
==============================================================================


DRIVER(S)			PLATFORM(S)
=========			===========
testswath.c			C on all supported platforms
testgrid.c
testpoint.c

testswath.f			FORTRAN 77 on all supported platforms
testgrid.f			FORTRAN 90 on Power Challenge
testpoint.f



Compiling test drivers
Below are samples of how the test driver can be compilied and linked to create 
executables.

The c version of the test drivers were also compiled and linked in C++.

The HDFSYS flag is set by the user.  The list below gives what it should be
for each supported platform:
PLATFORM		HDFSYS FLAG
========		===========
Dec			DEC_ALPHA
Sgi			IRIX
Sgi Power Chall.	SGI64
Ibm			IBM6000
Sun Solaris 2.5		SUN5
Hp			HP9000

Swath & Point
=============
cc -DHDFSYS -o filename.o -I$HDFINC -I$HDFEOS_INC -c filename.c
cc -DHDFSYS -o filename filename.o -L$HDFLIB -L$HDFEOS_LIB \
        -lhdfeos -lmfhdf -ldf -ljpeg -lz -lnsl -lm

NOTE: subsitute "filename" with the name of a driver, AND THE ORDER OF THE LIBRARIES
      IS IMPORTANT. 
      IN ADDITION NOTICE THAT WE POINT TO BOTH STANDARD HDF AND HDFEOS LIBRARIES.
      THE "-lnsl" FLAG IS REQUIRED FOR THE SUN PLATFORMS ONLY

Grid
====
cc -DHDFSYS -o filename.o -I$HDFINC -I$HDFEOS_INC -c filename.c
cc -DHDFSYS -o filename filename.o -L$HDFLIB -L$HDFEOS_LIB \
        -lhdfeos -lGctp -lmfhdf -ldf -ljpeg -lz -lnsl -lm

NOTE: subsitute "filename" with the name of a driver, AND THE ORDER OF THE LIBRARIES
      IS IMPORTANT.  
      IN ADDITION:  NOTICE THAT THE GCTP LIBRARY IS SECOND IN THE LIBRARY LIST
      ALSO: YOU NEED TO POINT TO WHERE THE GEOLIB LIBRARY IS LOCATED ON YOUR
      SYSTEM
      THE "-lnsl" FLAG IS REQUIRED FOR THE SUN PLATFORMS ONLY

Copyright (C) 1996 Hughes and Applied Research Corporation

Permission to use, modify, and distribute this software and its documentation 
for any purpose without fee is hereby granted, provided that the above 
copyright notice appear in all copies and that both that copyright notice and 
this permission notice appear in supporting documentation.

#-----------------------------------------------------------------------------
# filename:	
# 	README
# 	
# description:
#       Installation instructions for HDFEOS
# 	
# author:
#	Mike Sucher / Applied Research Corp.
# 	
# history:
#       18-Jun-1996 MES Initial version
#	10-Apr-1997 DaW Updated for Release B0
#	29-Oct-1997 DaW Updated for Release 2.1
#	23-Mar-1998 MEDS Updated for Release 2.2
#	16-Jun-1998 MEDS Updated for Release 2.3
#	27-Aug-1998 MEDS Updated for Release 2.4
#	30-Oct-2002 Phuong Nguyen - Updated for Release 2.8
#       10-Oct-2007 Abe Taaheri - Updated for Release 2.15
#       10-Jun-2009 Abe Taaheri - Updated for Release 2.16
#	19-Aug-2010 Abe Taaheri - Updated for Release 2.17
#	14-Dec--2011 Abe Taaheri - Updated for Release 2.18
#	05-Nov--2013 Abe Taaheri - Updated for Release 2.19
#-----------------------------------------------------------------------------

Contents
========


    Installation Instructions

        Preliminary

        Unpacking the distribution file

        Starting the installation procedure

        User Account Setup

        File Cleanup

        Compiling and Linking with HDFEOS


    Notes

        Approved platforms

        Architecture type names

        Directory and file environment variables

        Other environment variables

        Copyright notice for cfortran.h





Installation Instructions
=========================

    Preliminary
    -----------

    Before installing HDFEOS, you must already have installed HDF,
    version 4.2.13, on your host.  The installation script will prompt
    for the paths to the HDF include and library directories.You also may 
    need to install  zlib-1.2.11, szip-2.1.1, and jpeg.v6b.


    Unpacking the distribution file
    -------------------------------

    1)  Select a location for the HDFEOS directory tree.  Installing
        HDFEOS alone requires a disk partition with at least 35 Mb  
        of free space.  

    2)  Copy the file HDF-EOS2.20v1.00.tar.Z to the target directory by  
        typing the command:
    
    	    cp HDF-EOS2.20v1.00.tar.Z <target-dir>
    
        where <target-dir> is the full pathname of your target directory.
         
    3)  Set your default directory to the target directory by typing 
        the command:
    
            cd <target-dir>
    
    4)  Uncompress this file and extract the contents by typing the command:
    
    	    zcat HDF-EOS2.20v1.00.tar.Z | tar xvf -

        This will create a subdirectory of the current directory 
        called 'hdfeos'.  This is the top-level HDFEOS directory,  
        which contains the full HDFEOS directory structure.


    Starting the installation procedure
    -----------------------------------

    1)  Set your default directory to the top-level HDFEOS directory by  
        typing the command:
    
            cd hdfeos

	You can install hdfeos using the INSTALL-HDFEOS (see steps 2, and 3). However, 
	starting with some previous version we added INSTALL script and some 
	other related scripts to the bin directory for more robust installation 
	of hdfeos in supported platforms. The INSTALL script interactively can 
	install zlib, szip, jpeg, and hdf4 in addition to the hdfeos. So we 
	recommend that users this script, rather than the INSTALL-HDFEOS 
	script (the INSTALL-HDFEOS is internally used by INSTALL script). 
	By using INSTALL script you will also have a chance to 
	install hdf5 and hdfeos5 while installing hdf4 and hdfeos.

	To see INSTALL command options type:
	    bin/INSTALL -h
	For a simple installation you may type just type:
	    bin/INSTALL -log MyLogfile

	Please note that if you want to install zlib, jpeg, szip, hdf5, and 
	hdfeos5, you should also download relevant releases for these software 
	from our ftp site, where you have downloaded the hdfeos distribution.

	If you use INSTALL script, please skip steps 2 and 3 below.

	For all platforms (supported and unsupported) you may also use auto 
	configuration (as for HDF4) and make.As stated above we prefer that 
	you use INSTALL script for all supported platforms instead of auto 
	configuration and make. If you would like to install hdfeos using auto 
	configuration, please read AUTOCONF_INSTALL in hdfeos/doc directory


    2) Select installation options.
    
       Currently, the only options are those specific to the SGI Power 
       Challenge platform.
 
       On the SGI Power Challenge, the default is to build HDFEOS in
       64-bit mode.  The following table gives the option
       to specify the appropriate architecture to be built:

            binary format	architecture	<install-options>
            -------------	------------	---------------
            old-style 32 bit	sgi		-sgi
            new-style 32 bit    sgi32		-sgi32
            64 bit         	sgi64		<default>

	Please note that the old-32-bit mode has been dropped as the default 
	because it is no longer being supported by SGI, it is therefore 
	recommended that all users migrate to new-style 32 bit or 64 bit mode.

    3)  Run the installation script. 

        Please note that the installation script for this release of  
        HDFEOS requires user interaction.  Because of this, it should NOT 
        be run as a background task.  
        
        3.0) (optional)
            If you wish to generate a log of this session, use the Unix 
            'script' command.  This command runs a sub-shell that saves 
            all terminal output to the specified file.  
            
            To log the session, type:
        
              script <logfile-name>

            where <logfile-name> is the name of the log file.

        3.1) 
           To run the installation script, type the command:
    
             bin/INSTALL-HDFEOS <install-options>
    
           where <install-options> is the list of options determined in
           the previous step.

           The installation script will then run.  It will output various
           startup messages, beginning with:

             HDFEOS installation starting at <date/time>

        3.2) 
           Enter the full pathnames for the HDF4.2 library and include  
           directory paths, when the script prompts for them.  If there
           is an error in the supplied paths, the script will exit.
        
          NOTE:
            If the environment variables HDFLIB and/or HDFINC are set
            in your shell, the script will use these for the default values.
            If this is not the first run of the script, the default values
            will be taken from the values used for the last run of the script.
        
            In either of these cases, the installation script will prompt with:
        
              Current value of the HDF library directory is: <path>
              Accept [y]/n:  

            and/or

              Current value of the HDF include directory is: <path>
              Accept [y]/n:  

            Make sure to type 'n' and hit return, if the defaults do not 
            point to the correct directories.  The script will then prompt 
            for the new values.
        

         3.3) 
            The installation script will finish with the following message:
    
              HDFEOS installation ending at <date/time>

         3.4) (optional - see 3.0) 
            If you ran the Unix 'script' command to create a log file, then
            type 'exit' and hit return at the command prompt.  This will 
            exit the sub-shell stated by 'script' and save the log file.
        
            HINT:
              The log file generated by the script command may contain 'hard
              return' characters at the end of each line.  These appear in
              some text editors as "^M".   They can be removed with the 
              following command:
          
                sed 's/.$//' <logfile-name> > <logfile-name>.new
            
              where <logfile-name> is the name of the log file.



    User Account Setup
    ------------------

    Once HDFEOS has been installed, the accounts of HDFEOS users
    must be set up to define environment variables needed to compile and
    run code with HDFEOS (see parts 2 and 3 of the Notes section, below).
    The type of setup depends on the user's login shell.
    
    1A) C shell (csh) users:

        Edit the HDFEOS user's .cshrc file to include the
        following line:

 	    source <HDFEOS-home-dir>/bin/$BRAND/hdfeos_env.csh  
	
 	where <HDFEOS-home-dir> is the full path of the HDFEOS home 
        directory, and $BRAND is an architecture-specific value for 
        your host.  Please refer to part 2 of the Notes section, 
        below, to determine the correct value.

        The script hdfeos_env.csh sets up all the variables discussed in 
        parts 2 and 3 of the Notes section, below, and it adds the HDFEOS 
        bin directory to the user path. 

        The environment variables will become available during all 
        subsequent login sessions.  To activate them for the current 
        session, simply type one of the two lines listed above, at the
        Unix prompt.

        Note regarding path setup with hdfeos_env.csh
        ----------------------------------------------
            The script hdfeos_env.csh also makes available a variable
            called hdfeos_path.  This can be added to the user's path to
            ensure that it accesses the directories necessary for the
            compilers and other utilities used to generate executable
            programs.  It is not added to the user path by default,
            because in many cases it adds unnecessary complexity to
            the user path.  To add hdfeos_path to the user path, modify
            the HDFEOS user's .cshrc file to include the following:

                set my_path = ($path)			# save path
                source <HDFEOS-HOME-DIR>/bin/$BRAND/hdfeos_env.csh # HDFEOS setup
                set path = ($my_path $hdfeos_path)	# add hdfeos_path 

            INSTEAD OF the line listed at the beginning of this step.  
            Note that it is the user's responsibility to set up 
            his or her own path so that it doesn't duplicate the 
            directories set up in hdfeos_path.  Please also note that the 
            hdfeos_path is added AFTER the user's path.  This way, the 
            user's directories will be searched first when running Unix 
            commands.

    1B) Korn shell (ksh) users: 32-bit mode

        Edit the HDFEOS user's .profile file to include the following line:

 	    . <HDFEOS-home-dir>/bin/$BRAND/hdfeos_env.ksh  
	
 	where <HDFEOS-home-dir> is the full path of the HDFEOS home 
        directory, and $BRAND is an architecture-specific value for 
        your host.  Please refer to part 2 of the Notes section, 
        below, to determine the correct value.

        The script hdfeos_env.ksh sets up all the variables discussed in 
        part 2 and 3 of the Notes section, below, and it adds the HDFEOS 
        bin directory to the user path. 

        The environment variables will become available during all 
        subsequent login sessions.  To activate them for the current 
        session, simply type one of the two lines listed above, at the
        Unix prompt.

        Note regarding path setup with hdfeos_env.ksh
        ----------------------------------------------
            The script hdfeos_env.ksh also makes available a variable
            called hdfeos_path.  This can be added to the user's path to
            ensure that it accesses the directories necessary for the
            compilers and other utilities used to generate executable
            programs.  It is not added to the user path by default,
            because in many cases it adds unnecessary complexity to
            the user path.  To add hdfeos_path to the user path, modify
            the HDFEOS user's .profile file to include the following:

                my_path="$PATH"				    # save path
                . <HDFEOS-HOME-DIR>/bin/$BRAND/hdfeos_env.ksh # HDFEOS setup
                PATH="$my_path:$hdfeos_path" ; export PATH     # add hdfeos_path 

            INSTEAD OF the line listed at the beginning of this step.  
            Note that it is the user's responsibility to set up 
            his or her own path so that it doesn't duplicate the 
            directories set up in hdfeos_path.  Please also note that the 
            hdfeos_path is added AFTER the user's path.  This way, the 
            user's directories will be searched first when running Unix 
            commands.

    1C) Bourne shell (sh) users:

        Set up the required HDFEOS environment variables by appending  
        the contents of the file <HDFEOS-home-dir>/bin/$BRAND/hdfeos_env.ksh 
        to the end of the HDFEOS user's .profile, where <HDFEOS-home-dir> 
        is the full path of the HDFEOS home directory, and $BRAND is an 
        architecture-specific value for your host.  Please refer to part
        2 of the Notes section, below, to determine the correct value.

        The environment variables will become available during all 
        subsequent login sessions.  To activate them, log out and
        then log back in.
    

    File Cleanup
    ------------

    Once HDFEOS has been built and tested, you can delete certain 
    temporary files and directories to save some disk space.   Note 
    that once these files have been removed, you will need to unpack 
    the original distribution file in order to re-do the installation.

    To remove these files:
    
        cd <HDFEOS-home-dir>/bin
        rm -rf tmp
        cd <HDFEOS-home-dir>/lib
        rm -rf tmp
 


    Compiling and Linking with HDFEOS
    ---------------------------------
    
    In order to compile and link programs with the HDFEOS you must
    access the HDFEOS include and library files.   To do this be
    sure that your makefiles include something like the following:


    INCLUDE = -I. -I$(HDFEOS_INC) -I$(HDFINC)
    LIBRARY = -L. -L$(HDFEOS_LIB) -L$(HDFLIB)


    LDFLAGS = -lhdfeos -lGctp -lmfhdf -ldf -ljpeg -lnsl -lz -lm -lsz (Sun platform)
    LDFLAGS = -lhdfeos -lGctp -lmfhdf -ldf -ljpeg -lz -lm -lsz 	(others)


    The environment variables HDFEOS_INC, HDFEOS_LIB, HDFINC and HDFLIB
    are set up by the HDFEOS environment scripts (see User Setup, above).
    They refer to the include and library directories for HDFEOS and HDF,
    respectively.
    
    The INCLUDE macro should be included in all compilation statements.
    The LIBRARY an LDFLAGS macros should be included in all link statements.



Notes
=====

    1)  Approved platforms

        HDFEOS was built and tested in a multi-platform environment.
        The list of approved platforms, which includes information about 
        operating system and compiler versions, may be found in the
        HDFEOS User's Guide.


    2)  Architecture type names

        To track architecture dependencies, HDFEOS defines the 
        environment variable $BRAND.  Following is a list of valid values 
        for this variable, which is referred to throughout this document:
	(we officially does not support some platforms startinfg with
	 HDF-EOS2.16, such as dec, hp, ibm, sgi, and sun5.8 and sun5.9 )

        $BRAND		Architecture
        ======		============

        dec*       	DEC Alpha
        hp*        	HP 9000, HPUX-11 9000/785
        ibm*       	IBM RS-6000
        sgi*       	IRIX 5.3;6.2
        sgi32*     	SGI Power Challenge (new-style 32-bit mode)
        sgi64*     	SGI Power Challenge (64-bit mode)
        sun5.X     	Sun: SunOS 5.x (5.8*,5.9*,5.10)
        linux      	Linux: Red Hat Enterprise
        linux32    	64-bit linux platform in 32-bit mode
        linux64    	64-bit linux platform in 64-bit mode
        macintosh  	Darwin6.8
	macintel32   	Darwin, Intel i386 32-bit mode
	macintel64   	Darwin, Intel i386 64-bit mode
        Windows    	Windows 7: Microsoft Visual C++ 2013
        cygwin     	i686 cygwin 
   
        * These platforms are not officially supported anymore

    3)  Directory and file environment variables

        In order to use the HDFEOS libraries and utilities, a number of
        environment variables MUST be set up to point to HDFEOS directories
        and files.  These variables are automatically set up in User Account 
        Setup section of the installation instructions.  They are 
        listed here for reference:

	name			value			   description
	====			=====			   ===========

	HDFEOS_HOME 		<install-path>/hdfeos	   top-level directory

	(where <install-path> is the absolute directory path above hdfeos)

	HDFEOS_BIN 		$HDFEOS_HOME/bin/$BRAND	  executable files
	HDFEOS_INC 		$HDFEOS_HOME/include      header files
	HDFEOS_LIB 		$HDFEOS_HOME/lib/$BRAND   library files
	HDFEOS_OBJ 		$HDFEOS_HOME/obj/$BRAND   object files
	HDFEOS_SRC 		$HDFEOS_HOME/src          source files


    4)  Other environment variables

        In addition, the makefiles which are used to build the libraries
        require certain machine-specific environment variables.  These set
        compilers, compilation flags and libraries, allowing a single set of
        makefiles to serve on multiple platforms.  The User Account Setup 
        section of the installation instructions explains how to set them up.  
        They are listed here for reference:
       
	name			description
	====	 		===========

	CC 			C compiler
	CFLAGS 			default C flags (optimize, ANSI)
	C_CFH 			C w/ cfortran.h callable from FORTRAN
	CFHFLAGS 		CFLAGS + C_CFH
	C_F77_CFH 		C w/ cfortran.h calling FORTRAN
	C_F77_LIB 		FORTRAN lib called by C main
	F77 			FORTRAN compiler
	F77FLAGS		common FORTRAN flags
	F77_CFH			FORTRAN callable from C w/ cfortran.h
	F77_C_CFH 	 	FORTRAN calling C w/ cfortran.h
	CFH_F77 		same as F77_C_CFH
	F77_C_LIB  		C lib called by FORTRAN main

	
    5)  Tools provided with this release

        For a complete list of the tools provided with this release of 
        HDFEOS, please refer to HDFEOS User's Guide.

    6)  Copyright notice for cfortran.h

        The majority of the HDFEOS functions are written in C.
        These C-based tools include the file cfortran.h, using it to 
        generate machine-independent FORTRAN bindings. The cfortran.h 
        facility includes the following notice which must accompany
        distributions that use it:

THIS PACKAGE, I.E. CFORTRAN.H, THIS DOCUMENT, AND THE CFORTRAN.H EXAMPLE
PROGRAMS ARE PROPERTY OF THE AUTHOR WHO RESERVES ALL RIGHTS. THIS PACKAGE AND
THE CODE IT PRODUCES MAY BE FREELY DISTRIBUTED WITHOUT FEES, SUBJECT TO THE
FOLLOWING RESTRICTIONS:
- YOU MUST ACCOMPANY ANY COPIES OR DISTRIBUTION WITH THIS (UNALTERED) NOTICE.
- YOU MAY NOT RECEIVE MONEY FOR THE DISTRIBUTION OR FOR ITS MEDIA 
  (E.G. TAPE, DISK, COMPUTER, PAPER.)
- YOU MAY NOT PREVENT OTHERS FROM COPYING IT FREELY.
- YOU MAY NOT DISTRIBUTE MODIFIED VERSIONS WITHOUT CLEARLY DOCUMENTING YOUR
  CHANGES AND NOTIFYING THE AUTHOR.
- YOU MAY NOT MISREPRESENTED THE ORIGIN OF THIS SOFTWARE, EITHER BY EXPLICIT
  CLAIM OR BY OMISSION.

THE INTENT OF THE ABOVE TERMS IS TO ENSURE THAT THE CFORTRAN.H PACKAGE NOT BE
USED FOR PROFIT MAKING ACTIVITIES UNLESS SOME ROYALTY ARRANGEMENT IS ENTERED
INTO WITH ITS AUTHOR.
              
THIS SOFTWARE IS PROVIDED "AS IS" WITHOUT WARRANTY OF ANY KIND, EITHER
EXPRESSED OR IMPLIED. THE ENTIRE RISK AS TO THE QUALITY AND PERFORMANCE OF THE
SOFTWARE IS WITH YOU. SHOULD THE SOFTWARE PROVE DEFECTIVE, YOU ASSUME THE COST
OF ALL NECESSARY SERVICING, REPAIR OR CORRECTION. THE AUTHOR IS NOT RESPONSIBLE
FOR ANY SUPPORT OR SERVICE OF THE CFORTRAN.H PACKAGE.

                                              Burkhard Burow 
                                              burow@vxdesy.cern.ch

January 1995

This directory contains the source code for the new C version
of the GCTP.

The files nad27sp and nad83sp are used for State Plane.  If there 
seems to be a problem with these, the files nad1927.dat and nad1983.dat 
can be converted from ASCII to the proper binary format by using SPLOAD.

The following is a list containing the files in the geolib/source directory.

Makefile
README
alberfor.c
alberinv.c
alconfor.c
alconinv.c
azimfor.c
aziminv.c
br_gctp.c
cproj.c
cproj.h
eqconfor.c
eqconinv.c
equifor.c
equiinv.c
for_init.c
gctp.c
gnomfor.c
gnominv.c
goodfor.c
goodinv.c
gvnspfor.c
gvnspinv.c
hamfor.c
haminv.c
imolwfor.c
imolwinv.c
inv_init.c
lamazfor.c
lamazinv.c
lamccfor.c
lamccinv.c
make.com
merfor.c
merinv.c
millfor.c
millinv.c
molwfor.c
molwinv.c
nad1927.dat
nad1983.dat
nad27sp
nad83sp
obleqfor.c
obleqinv.c
omerfor.c
omerinv.c
orthfor.c
orthinv.c
paksz.c
polyfor.c
polyinv.c
proj.h
psfor.c
psinv.c
report.c
robfor.c
robinv.c
sinfor.c
sininv.c
somfor.c
sominv.c
sphdz.c
spload.f
sterfor.c
sterinv.c
stplnfor.c
stplninv.c
tmfor.c
tminv.c
untfz.c
utmfor.c
utminv.c
vandgfor.c
vandginv.c
wivfor.c
wivinv.c
wviifor.c
wviiinv.c

This directory provides sample programs for the user to run to check if the 
HDF-EOS library installed correctly.  Below is a description of what routines 
are available and the order in which the routines should be run.

Swath Demonstration Programs
----------------------------
SetupSwath:   1) Creates swath file, "SwathFile.hdf" and a single swath within
                 it, "Swath1".

              2) Defines dimensions and the geolocation relation between 
	         them.

FORTRAN: setupswath


DefineFields:    Defines a number of fields within the swath, "Swath1".

FORTRAN: definefields


WriteFields:     Writes data to the "Longitude", "Latitude", and "Spectra" 
                 fields.

FORTRAN: writefields


ReadFields:      Reads data from the "Longitude" field.

FORTRAN: readfields


InquireSwath:    Retrieves and print information on the swath dimensions,
                 geolocation relations and swath fields.

FORTRAN: inquireswath


AppendField:     Demonstrates use of unlimited dimension for appendable
                 fields.

FORTRAN: appendfield


SubsetSwath:     Demonstrates subsetting on the "Spectra" field.

FORTRAN: subsetswath




Grid Demonstration Programs
---------------------------
SetupGrid:        Creates grid file, "GridFile.hdf" containing two grid 
	          structures.

FORTRAN: subsetgrid


DefineGDflds:     Defines fields within the two grid structures.

FORTRAN: definegdflds


WriteGDflds:      Write to fields within the two grid structures.

FORTRAN: writegdflds


ReadGDflds:       Reads from fields within the two grid structures.

FORTRAN: readgdflds


InquireGrid:      Demonstrates the use of various inquiry routines in the
                  grid API.

FORTRAN: inquiregrid


SubsetGrid:       Demonstrates subsetting on the "Temperature" field
                  in the "PolarGrid" grid.

FORTRAN: subsetgrid


Swath Demonstration Programs
----------------------------
SetupPoint:   1) Creates point file, "PointFile.hdf" and defines three point
                 structures, "Simple Point", "Fixed Buoy Point", and 
                 "Float Buoy Point".
 
 
FORTRAN: setuppoint
 
DefineLevels:    Defines levels within the pointfile.
 
FORTRAN: definelevels
 

WriteLevels:     Writes data to levels within the pointfile.
 
FORTRAN: writelevels
 
 
ReadLevels:      Reads data from levels within pointfile.
 
FORTRAN: readlevels
 
 
UpdateLevels:    Updates levels within pointfile.
 
FORTRAN: updatelevels
 
 
SubsetPoint:     Demonstrates subsetting with the point interface.
 
FORTRAN: subsetpoint
 




Restrictions
------------
1) The "HDFE_ANYPOINT" option for swath subsetting has not yet been
   implemented.  In additin swath subseting does not work with the
   "Colatitude" field yet.

	program updatelevels

	integer            ptuplev, ptdetach, ptclose, ptgetrecnums
	integer*4          ptfid, ptid1, ptid2
	integer*4          recs(32), inlevel, outlevel
	integer*4          ptopen, ptattach
	integer*4          outrecs(32), outnrec
	real*8             f64
	
	character          datbuf*256, c8*8
	equivalence        (f64,c8)
	
	integer DFACC_RDWR
	parameter (DFACC_RDWR=3)

c
c     Open the HDF point file, "PointFile.hdf".
c

	ptfid = ptopen("PointFile.hdf", DFACC_RDWR)

	ptid1 = ptattach(ptfid, "Simple Point")
	ptid2 = ptattach(ptfid, "FixedBuoy Point")

	f64 = 43.2
	datbuf(1:8) = c8
	recs(1) = 1
	
	status = ptuplev(ptid2, 0, "Longitude", 1, recs, datbuf)


	datbuf(1:1) = 'F'
	recs(1) = 0
	status = ptuplev(ptid2, 0, "ID", 1, recs, datbuf)
	    
	inlevel = 0
	outlevel = 1
	nrec = 1
	status = ptgetrecnums(ptid2, inlevel, outlevel, nrec, recs, 
     1			      outnrec, outrecs)

	
	do 10 i=1,outnrec
		datbuf(i:i) = 'F'
 10	continue

	status = ptuplev(ptid2, outlevel, "ID", outnrec, outrecs, datbuf)

	status = ptdetach(ptid1)
	status = ptdetach(ptid2)
	
	status = ptclose(ptfid)
	
	stop
	end

c
c  In this example we will (1) open the "PointFile" HDF file, (2) attach to
c  the points, and (3) write data to each level of the points.
c 


	program writelevels
	implicit none
	
	integer            status, i, pntr
	integer*2          wgt
	integer*4          ptfid, ptid, n, date

	real*4             rain, temp, conc(4)       
	real*8             lon, lat, time

	character          buffer*10000, id*3, desc*16, spc*8
	character          ctime*8, cconc*16, clon*8, clat*8
	character          cdate*4, crain*4, ctemp*4, cwgt*2
	equivalence        (time,ctime), (conc,cconc), (lon,clon)
	equivalence        (lat,clat), (rain,crain), (temp,ctemp)
	equivalence        (date,cdate), (wgt,cwgt)
	
	integer            ptwrlev, ptdetach, ptclose
	integer*4          ptopen, ptattach


	integer DFACC_RDWR
	parameter (DFACC_RDWR=3)

c
c     Open the HDF point file, "PointFile.hdf".
c

	ptfid = ptopen("PointFile_created_with_hadeos_sample_file_write"//
     1"r_of_HDFEOS2_version_219_or_higher_release.hdf", DFACC_RDWR)


c
c    Write to Simple Point
c
	ptid = ptattach(ptfid, "Simple Point")

	open(unit=1, file='simple.txt', status='OLD')

	n = 0
	pntr = 1
	do 10 i=1,1000
	      
	   read(1, *, end=100)  time, conc(1), conc(2), conc(3), 
     1                            conc(4), spc
	   n = n + 1
	
	   buffer(pntr:pntr+8) = ctime
	   pntr = pntr + 8
	   buffer(pntr:pntr+4*4) = cconc
	   pntr = pntr + 4*4
	   buffer(pntr:pntr+4) = spc
	   pntr = pntr + 4
10	continue

100	close(unit=1)
    
	status = ptwrlev(ptid, 0, n, buffer)
	status = ptdetach(ptid)
    

c
c    Write to Fixed Buoy Point 
c

	ptid = ptattach(ptfid, "FixedBuoy Point")
c
c        Write First (0th) Level
c
	open(unit=1, file='fixedBuoy0.txt', status='OLD')

	n = 0
	pntr = 1
	do 20 i=1,1000
		      
	   read(1, *, end=200)  desc, lon, lat, date, id
	      
	   n = n + 1
	
	   buffer(pntr:pntr+8) = desc
	   pntr = pntr + 8
	   buffer(pntr:pntr+8) = clon
	   pntr = pntr + 8
	   buffer(pntr:pntr+8) = clat
	   pntr = pntr + 8
	   buffer(pntr:pntr+4) = cdate
	   pntr = pntr + 4
	   buffer(pntr:pntr+1) = id
	   pntr = pntr + 1
 20	continue

 200	close(unit=1)

    
	status = ptwrlev(ptid, 0, n, buffer)



c
c      Write Second (1th) Level */
c
	open(unit=1, file='fixedBuoy1.txt', status='OLD')

	n = 0
	pntr = 1
	do 30 i=1,1000

	   read(1, *, end=300) time, rain, temp, id
	   
	   n = n + 1
	   
	   buffer(pntr:pntr+8) = ctime
	   pntr = pntr + 8
	   buffer(pntr:pntr+4) = crain
	   pntr = pntr + 4
	   buffer(pntr:pntr+4) = ctemp
	   pntr = pntr + 4
	   buffer(pntr:pntr+1) = id
	   pntr = pntr + 1
 30	continue
	
 300	close(unit=1)
	  
	status = ptwrlev(ptid, 1, n, buffer)
	  
	status = ptdetach(ptid)
    

c
c    Write to Float Buoy Point 
c

	ptid = ptattach(ptfid, "FloatBuoy Point")

c
c        Write First (0th) Level
c
	open(unit=1, file='floatBuoy0.txt', status='OLD')

	n = 0
	pntr = 1
	do 40 i=1,1000
	      
	   read(1, *, end=400)  desc, date, wgt, id
	   write(*,*) desc,date,wgt,id
	   n = n + 1
	
	   buffer(pntr:pntr+8) = desc
	   pntr = pntr + 8
	   buffer(pntr:pntr+4) = cdate
	   pntr = pntr + 4
	   buffer(pntr:pntr+2) = cwgt
	   pntr = pntr + 2
	   buffer(pntr:pntr+1) = id
	   pntr = pntr + 1
 40	continue

 400	close(unit=1)

    
	status = ptwrlev(ptid, 0, n, buffer)


c
c      Write Second (1th) Level */
c
	open(unit=1, file='floatBuoy1.txt', status='OLD')

	n = 0
	pntr = 1
	do 50 i=1,1000

	   read(1, *, end=500) time, lon, lat, rain, temp, id
	      
	   n = n + 1
	
	   buffer(pntr:pntr+8) = ctime
	   pntr = pntr + 8
	   buffer(pntr:pntr+8) = clon
	   pntr = pntr + 8
	   buffer(pntr:pntr+8) = clat
	   pntr = pntr + 8	      
	   buffer(pntr:pntr+4) = crain
	   pntr = pntr + 4
	   buffer(pntr:pntr+4) = ctemp
	   pntr = pntr + 4
	   buffer(pntr:pntr+1) = id
	   pntr = pntr + 1
 50	continue

 500	close(unit=1)

	status = ptwrlev(ptid, 1, n, buffer)

	status = ptdetach(ptid)
	
 2000	continue
	
	status = ptclose(ptfid)

	stop
	end
	

c
c  In this example we will (1) open the "GridFile" HDF file, (2) attach to
c  the "PolarGrid" grid, and (3) subset data from the "Temperature" field.
c 


	program subsetgrid

	integer            status, gdextreg, gdreginfo, gddetach, gdclose
	integer*4          gdfid, gdid, gdopen, gdattach, dims(8)
	integer*4          rank, ntype, gddefboxreg

	real*8             cornerlon(2), cornerlat(2)
	real*8             upleft(2), lowright(2)
	real*4             datbuf(100*100)
	
	integer DFACC_READ
	parameter (DFACC_READ=1)


c    
c     Open the HDF grid file, "GridFile.hdf"
c 

	gdfid = gdopen("GridFile_created_with_hadeos_sample_file_write"//
     1"r_of_HDFEOS2_version_219_or_higher_release.hdf", DFACC_READ)

	if (gdfid .NE. -1) then

	   gdid = gdattach(gdfid, "PolarGrid")

	   if (gdid .NE. -1) then

	      cornerlon(1) = 0
	      cornerlat(1) = 90.
	      cornerlon(2) = 90
	      cornerlat(2) = 0

	      regionid = gddefboxreg(gdid, cornerlon, cornerlat)
	      
	      status = gdreginfo(gdid, regionid, "Temperature", ntype,
     1	                         rank, dims, size, upleft, lowright)
	      write(*,*) dims(1), dims(2), dims(3), rank, ntype
	      
	      status = gdextreg(gdid, regionid, "Temperature", 
     1	                        datbuf)
	    

	   endif
	
	   status = gddetach(gdid)
	   status = gdclose(gdfid)

	endif
	stop
	end
	

c
c  In this example we will (1) open the "SwathFile" HDF file, (2) attach to
c  the "Swath1" swath, and (3) subset data from the "Spectra" field.
c 


	program subsetswath

	integer            status, swextreg, swreginfo, swdetach
	integer            swextper, swperinfo, swclose
	
	integer*4          swfid, swid, swopen, swattach, dims(8)
	integer*4          rank, ntype, size, swdefboxreg, swdeftmeper
	integer*4          regionid, periodid

	real*8             cornerlon(2), cornerlat(2)
	real*8             datbuf(40,20,15), tmebuf(20)
	
	integer DFACC_READ
	parameter (DFACC_READ=1)
	integer HDFE_MIDPOINT
	parameter (HDFE_MIDPOINT=0)
	integer HDFE_INTERNAL
	parameter (HDFE_INTERNAL=0)


c    
c     Open the HDF swath file, "SwathFile.hdf"
c 

	swfid = swopen("SwathFile.hdf", DFACC_READ)

	if (swfid .NE. -1) then

	   swid = swattach(swfid, "Swath1")

	   if (swid .NE. -1) then
	      cornerlon(1) = 3.
	      cornerlat(1) = 5.
	      cornerlon(2) = 7.
	      cornerlat(2) = 12.

	      regionid = swdefboxreg(swid, cornerlon, cornerlat,
     1	                             HDFE_MIDPOINT)
	      write(*,*) regionid,swid
	      
	      status = swreginfo(swid, regionid, "Spectra", ntype,
     1	                         rank, dims, size)
	      write(*,*) dims(1), dims(2), dims(3), rank, ntype, size
	      
	      status = swextreg(swid, regionid, "Spectra", 
     1	                HDFE_INTERNAL, datbuf)

	      
c             Time Subsetting	      
	      periodid = swdeftmeper(swid, 35232487.2d0, 36609898.1d0,
     1	                             HDFE_MIDPOINT)
	      write(*,*) 'Time Subset: ', periodid,swid
	      
	      status = swperinfo(swid, periodid, "Time", ntype,
     1	                         rank, dims, size)
	      write(*,*) 'Time Subset: ', rank, dims(1), size
	      
	      status = swextper(swid, periodid, "Time", 
     1	                        HDFE_INTERNAL, tmebuf)
	      
	      do 10 i=1,size/8
		 write(*,*) i, tmebuf(i)
 10		 continue

	   endif
	
	   status = swdetach(swid)
	   status = swclose(swfid)

	endif
	stop
	end
	

c
 
      program testpoint
 
      integer*4       ptfid, ptid1, ptid2, ptid3, ptdetach, ptclose
      integer*4       ptopen, ptcreate
      integer         status
      integer*4       ptid, fldsz, nlevels, nflds, fldlevels(5)
      integer*4	      npoint
      integer*4       fieldtype(8), fieldorder(8)
      character*72    fldlist, ptlist
      character*30    attrlist
 
      integer*4       ptattach, ptinqpoint
      integer         ptdeflev, ptdeflink, ptwrattr
      integer         ptrdattr, ptattrinfo
      integer         i, j, k, pntr, strbufsize
      integer*4	      strbufsize2
      integer*2       wgt
      integer*4       n, date, nt, sz, zero
      integer*4	      strbuf, nrec
      integer*4	      regrec
      integer*4	      regrecs(20)
 
      real*4          rain, temp, conc(4), f32, b32 
      real*8          lon, lat, time
      real*8          range(2)
 
      character       buffer*10000, id*2, desc*8, spc*4
      character       linkfield*8
      character       ctime*8, cconc*16, clon*8, clat*8
      character       cdate*4, crain*4, ctemp*4, cwgt*2
      equivalence     (time,ctime), (conc,cconc), (lon,clon)
      equivalence     (lat,clat), (rain,crain), (temp,ctemp)
      equivalence     (date,cdate), (wgt,cwgt)

      integer         ptwrlev, ptperrecs, ptregrecs

      integer*4       recs(32)
      integer*4       fldtype(32), fldorder(32)
 
      integer         ptrdlev
      integer         ptlevinfo, ptblinkinfo, ptflinkinfo
      integer	      ptgetlevname
      integer*4       ptnrecs, ptnlevs, ptsizeof, ptnflds
      integer*4	      ptlevidx, ptinqattrs

      integer         ptuplev, ptgetrecnums
      integer*4       inlevel, outlevel, levndx
      integer*4       outrecs(32), outnrec
      real*8          f64
 
      character       datbuf*256, c8*8
      character*(72)  levname
      equivalence     (f64,c8)

      integer         ptextreg, ptreginfo
      integer         ptextper, ptperinfo
 
      integer*4       size, ptdefboxreg, ptdeftmeper
      integer*4       ptdefvrtreg
      integer*4       regionid, periodid
 
      real*4          dtbuff32(25)
      real*8          cornerlon(2), cornerlat(2)
      real*8          dtbuf(128)
      real*8          starttime
      real*8          stoptime
 
 
      integer DFACC_CREATE
      parameter (DFACC_CREATE=4)
 
      integer  DFACC_RDWR
      parameter (DFACC_RDWR=3)

      integer  DFNT_CHAR8, DFNT_INT16, DFNT_INT32
      parameter (DFNT_CHAR8=4)
      parameter (DFNT_INT16=22)
      parameter (DFNT_INT32=24)
 
      integer  DFNT_FLOAT32, DFNT_FLOAT64
      parameter (DFNT_FLOAT32=5)
      parameter (DFNT_FLOAT64=6)

      integer DFACC_READ
      parameter (DFACC_READ=1)

      integer HDFE_NOPREVSUB
      parameter (HDFE_NOPREVSUB=-1)

      zero = 0

      open(unit=3, file='testpoint_f.txtout', status = 'NEW')
 
      write(*,*)'Testing Point FORTRAN 77 interface'
      write(*,*)'=================================='
      write(3,*)'Testing Point FORTRAN 77 interface'
      write(3,*)'=================================='
      write(*,*)' '
      write(3,*)' '
 
c Test Case -- ptopen
c
      write(*,*)'Testing ptopen '
      write(*,*)'================='
      write(3,*)'Testing ptopen '
      write(3,*)'================='

      ptfid = ptopen("Pointf_Test.hdf", DFACC_CREATE)
      if (ptfid .lt. zero) then
         write(*,*)'********** Error unexpected **********'
         write(3,*)'********** Error unexpected **********'
         call heprnt(0)
      else
         write(*,*)'       ptfid = ptopen("Pointf_Test.hdf", DFACC_CREAT       &
     1E)'
         write(*,*)'       File id  returned by ptopen ', ptfid
         write(3,*)'       ptfid = ptopen("Pointf_Test.hdf", DFACC_CREAT       &
     1E)'
         write(3,*)'       File id returned by ptopen ', ptfid
         write(*,*)' '
         write(3,*)' '
      endif


 
c Test Case -- ptcreate
c
      write(*,*)'Testing ptcreate '
      write(*,*)'================='
      write(3,*)'Testing ptcreate '
      write(3,*)'================='

      ptid1 = ptcreate(ptfid, "Simple Point")
      if (ptid1 .lt. zero) then
         write(*,*)'********** Error unexpected **********'
         write(3,*)'********** Error unexpected **********'
         call heprnt(0)
      else
         write(*,*)'      ptid1 = ptcreate(ptfid, "Simple Point")'
         write(*,*)'      Point id returned by ptcreate ',ptid1
         write(3,*)'      ptid1 = ptcreate(ptfid, "Simple Point")'
         write(3,*)'      Point id returned by ptcreate ',ptid1
      endif

      ptid2 = ptcreate(ptfid, "FixedBuoy Point")
      if (ptid2 .lt. zero) then
         write(*,*)'********** Error unexpected **********'
         write(3,*)'********** Error unexpected **********'
         call heprnt(0)
      else
         write(*,*)'      ptid2 = ptcreate(ptfid, "FixedBuoy Point")'
         write(*,*)'      Point id returned by ptcreate ',ptid2
         write(3,*)'      ptid2 = ptcreate(ptfid, "FixedBuoy Point")'
         write(3,*)'      Point id returned by ptcreate ',ptid2
      endif

      ptid3 = ptcreate(ptfid, "FloatBuoy Point")
      if (ptid3 .lt. zero) then
         write(*,*)'********** Error unexpected **********'
         write(3,*)'********** Error unexpected **********'
         call heprnt(0)
      else
         write(*,*)'      ptid3 = ptcreate(ptfid, "FloatBuoy Point")'
         write(*,*)'      Point id returned by ptcreate ',ptid3
         write(3,*)'      ptid3 = ptcreate(ptfid, "FloatBuoy Point")'
         write(3,*)'      Point id returned by ptcreate ',ptid3
      endif
 
 
      write(*,*)' '
      write(3,*)' '
c Test Case -- ptdetach
c  
      write(3,27)
      write(*,*)'Testing ptdetach '
      write(*,*)'================='
      write(3,*)'Testing ptdetach '
      write(3,*)'================='

      status = ptdetach(ptid1)
      if (status .lt. zero) then
         write(*,*)'********** Error unexpected **********'
         write(3,*)'********** Error unexpected **********'
         call heprnt(0)
      else
         write(*,*)'      status = ptdetach(ptid1)'
         write(*,*)'      Status returned by ptdetach ',status
         write(3,*)'      status = ptdetach(ptid1)'
         write(3,*)'      Status returned by ptdetach ',status
      endif

      status = ptdetach(ptid2)
      if (status .lt. zero) then
         write(*,*)'********** Error unexpected **********'
         write(3,*)'********** Error unexpected **********'
         call heprnt(0)
      else
         write(*,*)'      status = ptdetach(ptid2)'
         write(*,*)'      Status returned by ptdetach ',status
         write(3,*)'      status = ptdetach(ptid2)'
         write(3,*)'      Status returned by ptdetach ',status
      endif

      status = ptdetach(ptid3)
      if (status .lt. zero) then
         write(*,*)'********** Error unexpected **********'
         write(3,*)'********** Error unexpected **********'
         call heprnt(0)
      else
         write(*,*)'      status = ptdetach(ptid3)'
         write(*,*)'      Status returned by ptdetach ',status
         write(3,*)'      status = ptdetach(ptid3)'
         write(3,*)'      Status returned by ptdetach ',status
      endif
 
 
      write(*,*)' '
      write(3,*)' '
c Test Case -- ptclose
c  
      write(3,27)
      write(*,*)'Testing ptclose '
      write(*,*)'================='
      write(3,*)'Testing ptclose '
      write(3,*)'================='

      status = ptclose(ptfid)
      if (status .lt. zero) then
         write(*,*)'********** Error unexpected **********'
         write(3,*)'********** Error unexpected **********'
         call heprnt(0)
      else
         write(*,*)'      status = ptclose(ptfid)'
         write(*,*)'      Status returned by ptclose ',status
         write(3,*)'      status = ptclose(ptfid)'
         write(3,*)'      Status returned by ptclose ',status
      endif

      ptfid = ptopen("Pointf_Test.hdf", DFACC_RDWR)
      if (ptfid .lt. zero) then
         write(*,*)'********** Error unexpected **********'
         write(3,*)'********** Error unexpected **********'
         call heprnt(0)
      else
         write(*,*)'      ptfid = ptopen("Pointf_Test.hdf", DFACC_RDWR)'
         write(*,*)'      Point file id returned by ptopen ',ptfid
         write(3,*)'      ptfid = ptopen("Pointf_Test.hdf", DFACC_RDWR)'
         write(3,*)'      Point file id returned by ptopen ',ptfid
      endif

 
      write(*,*)' '
      write(3,*)' '
c Test Case -- ptattach
c  
      write(3,27)
      write(*,*)'Testing ptattach '
      write(*,*)'================='
      write(3,*)'Testing ptattach '
      write(3,*)'================='

      ptid = ptattach(ptfid, "Simple Point")
      if (ptid .lt. zero) then
         write(*,*)'********** Error unexpected **********'
         write(3,*)'********** Error unexpected **********'
         call heprnt(0)
      else
         write(*,*)'      ptid = ptattach(ptfid, "Simple Point")'
         write(*,*)'      Point id returned by ptattach ',ptid
         write(3,*)'      ptid = ptattach(ptfid, "Simple Point")'
         write(3,*)'      Point id returned by ptattach ',ptid
      endif

      fldlist = "Time,Concentration,Species"
 
 
      fieldtype(1) = DFNT_FLOAT64
      fieldtype(2) = DFNT_FLOAT32
      fieldtype(3) = DFNT_CHAR8
 
      fieldorder(1) = 1
      fieldorder(2) = 4
      fieldorder(3) = 4
 
      write(*,*)' '
      write(3,*)' '
c Test Case -- ptdeflev
c  
      write(3,27)
      write(*,*)'Testing ptdeflev '
      write(*,*)'================='
      write(3,*)'Testing ptdeflev '
      write(3,*)'================='

      status = ptdeflev(ptid, "Sensor", fldlist, fieldtype, fieldorder         &
     1)
      if (status .lt. zero) then
         write(*,*)'********** Error unexpected **********'
         write(3,*)'********** Error unexpected **********'
         call heprnt(0)
      else
         write(*,*)'      status = ptdeflev(ptid, "Sensor", fldlist, f         &
     1ieldtype,fieldorder)'
         write(*,*)'      Status returned by ptdeflev ',status
         write(3,*)'      status = ptdeflev(ptid, "Sensor", fldlist, f         &
     1ieldtype,fieldorder)'
         write(3,*)'      Status returned by ptdeflev ',status
      endif
 
      status = ptdetach(ptid)
      if (status .lt. zero) then
         write(*,*)'********** Error unexpected **********'
         write(3,*)'********** Error unexpected **********'
         call heprnt(0)
      else
         write(*,*)'      status = ptdetach(ptid)'
         write(*,*)'      Status returned by ptdetach ',status
         write(3,*)'      status = ptdetach(ptid)'
         write(3,*)'      Status returned by ptdetach ',status
      endif
 
 
      ptid = ptattach(ptfid, "FixedBuoy Point")
      if (ptid .lt. zero) then
         write(*,*)'********** Error unexpected **********'
         write(3,*)'********** Error unexpected **********'
         call heprnt(0)
      else
         write(*,*)'      ptid = ptattach(ptfid, "FixedBuoy Point")'
         write(*,*)'      Point id returned by ptattach ',ptid
         write(3,*)'      ptid = ptattach(ptfid, "FixedBuoy Point")'
         write(3,*)'      Point id returned by ptattach ',ptid
      endif
 
 
 
      fldlist = "Label,Longitude,Latitude,DeployDate,ID"
 
      fieldtype(1) = DFNT_CHAR8
      fieldtype(2) = DFNT_FLOAT64
      fieldtype(3) = DFNT_FLOAT64
      fieldtype(4) = DFNT_INT32
      fieldtype(5) = DFNT_CHAR8
 
 
      fieldorder(1) = 8
      fieldorder(2) = 0
      fieldorder(3) = 0
      fieldorder(4) = 0
      fieldorder(5) = 1

      status = ptdeflev(ptid, "Desc-Loc", fldlist, fieldtype, fieldorde        &
     1r)
      if (status .lt. zero) then
         write(*,*)'********** Error unexpected **********'
         write(3,*)'********** Error unexpected **********'
         call heprnt(0)
      else
         write(*,*)'      status = ptdeflev(ptid, "Desc-Loc", fldlist,         &
     1fieldtype,fieldorder)'
         write(*,*)'      Status returned by ptdeflev ',status
         write(3,*)'      status = ptdeflev(ptid, "Desc-Loc", fldlist,         &
     1fieldtype,fieldorder)'
         write(3,*)'      Status returned by ptdeflev ',status
      endif
 
 
 
      fldlist = "Time,Rainfall,Temperature,ID"
 
      fieldtype(1) = DFNT_FLOAT64
      fieldtype(2) = DFNT_FLOAT32
      fieldtype(3) = DFNT_FLOAT32
      fieldtype(4) = DFNT_CHAR8
 
      fieldorder(1) = 0
      fieldorder(2) = 0
      fieldorder(3) = 0
      fieldorder(4) = 1
 
      status = ptdeflev(ptid, "Observations", fldlist,
     1fieldtype, fieldorder)
      if (status .lt. zero) then
         write(*,*)'********** Error unexpected **********'
         write(3,*)'********** Error unexpected **********'
         call heprnt(0)
      else
         write(*,*)'       status = ptdeflev(ptid, "Observations",             &
     1fldlist,fieldtype, fieldorder)'
         write(*,*)'       Status returned by ptdeflev ',status
         write(3,*)'       status = ptdeflev(ptid, "Observations",             &
     1fldlist,fieldtype, fieldorder)'
         write(3,*)'       Status returned by ptdeflev ',status
      endif
 
      write(*,*)' '
      write(3,*)' '
c Test Case -- ptdeflink
c
      write(3,27)
      write(*,*)'Testing ptdeflink '
      write(*,*)'================='
      write(3,*)'Testing ptdeflink '
      write(3,*)'================='

      status = ptdeflink(ptid, "Desc-Loc", "Observations", "ID")
      if (status .lt. zero) then
         write(*,*)'********** Error unexpected **********'
         write(3,*)'********** Error unexpected **********'
         call heprnt(0)
      else
         write(*,*)'       status = ptdeflink(ptid, "Desc-Loc",                &
     1"Observations", "ID")'
         write(*,*)'       Status returned by ptdeflink ',status
         write(3,*)'       status = ptdeflink(ptid, "Desc-Loc",                &
     1"Observations", "ID")'
         write(3,*)'       Status returned by ptdeflink ',status
      endif

 
      status = ptdetach(ptid)
      if (status .lt. zero) then
         write(*,*)'********** Error unexpected **********'
         write(3,*)'********** Error unexpected **********'
         call heprnt(0)
      else
         write(*,*)'       status = ptdetach(ptid)'
         write(*,*)'       Status returned by ptdetach ',status
         write(3,*)'       status = ptdetach(ptid)'
         write(3,*)'       Status returned by ptdetach ',status
      endif
 

      ptid = ptattach(ptfid, "FloatBuoy Point")
      if (status .lt. zero) then
         write(*,*)'********** Error unexpected **********'
         write(3,*)'********** Error unexpected **********'
         call heprnt(0)
      else
         write(*,*)'       ptid = ptattach(ptfid, "FloatBuoy Point")'
         write(*,*)'       Point id returned by ptattach ',ptid
         write(3,*)'       ptid = ptattach(ptfid, "FloatBuoy Point")'
         write(3,*)'       Point id returned by ptattach ',ptid
      endif
 
 
c      Define Description Level */
 
      fldlist = "Label,DeployDate,Weight,ID"

      fieldtype(1) = DFNT_CHAR8
      fieldtype(2) = DFNT_INT32
      fieldtype(3) = DFNT_INT16
      fieldtype(4) = DFNT_CHAR8

      fieldorder(1) = 8
      fieldorder(2) = 0
      fieldorder(3) = 0
      fieldorder(4) = 1

 
      status = ptdeflev(ptid, "Description", fldlist,
     1fieldtype, fieldorder)
      if (status .lt. zero) then
         write(*,*)'********** Error unexpected **********'
         write(3,*)'********** Error unexpected **********'
         call heprnt(0)
      else
         write(*,*)'       status = ptdeflev(ptid, "Description",              &
     1fldlist,fieldtype, fieldorder)'
         write(*,*)'       Status returned by ptdeflev ',status
         write(3,*)'       status = ptdeflev(ptid, "Description",              &
     1fldlist,fieldtype, fieldorder)'
         write(3,*)'       Status returned by ptdeflev ',status
      endif
 
 
c       Define Data Level
 
      fldlist = "Time,Longitude,Latitude,Rainfall,Temperature,ID"
 
      fieldtype(1) = DFNT_FLOAT64
      fieldtype(2) = DFNT_FLOAT64
      fieldtype(3) = DFNT_FLOAT64
      fieldtype(4) = DFNT_FLOAT32
      fieldtype(5) = DFNT_FLOAT32
      fieldtype(6) = DFNT_CHAR8
 
      fieldorder(1) = 0
      fieldorder(2) = 0
      fieldorder(3) = 0
      fieldorder(4) = 0
      fieldorder(5) = 0
      fieldorder(6) = 1
 
      status = ptdeflev(ptid, "Measurements", fldlist,
     1fieldtype, fieldorder)
      if (status .lt. zero) then
         write(*,*)'********** Error unexpected **********'
         write(3,*)'********** Error unexpected **********'
         call heprnt(0)
      else
         write(*,*)'       status = ptdeflev(ptid, "Measurements",             &
     1fldlist,fieldtype, fieldorder)'
         write(*,*)'       Status returned by ptdeflev ',status
         write(3,*)'       status = ptdeflev(ptid, "Measurements",             &
     1fldlist,fieldtype, fieldorder)'
         write(3,*)'       Status returned by ptdeflev ',status
      endif
 

      status = ptdeflink(ptid, "Description", "Measurements", "ID")
      if (status .lt. zero) then
         write(*,*)'********** Error unexpected **********'
         write(3,*)'********** Error unexpected **********'
         call heprnt(0)
      else
         write(*,*)'       status = ptdeflink(ptid, "Description",                &
     1"Measurements", "ID")'
         write(*,*)'       Status returned by ptdeflink ',status
         write(3,*)'       status = ptdeflink(ptid, "Description",                &
     1"Measurements", "ID")'
         write(3,*)'       Status returned by ptdeflink ',status
      endif
 
      status = ptdetach(ptid)
      if (status .lt. zero) then
         write(*,*)'********** Error unexpected **********'
         write(3,*)'********** Error unexpected **********'
         call heprnt(0)
      else
         write(*,*)'       status = ptdetach(ptid)'
         write(*,*)'       Status returned by ptdetach ',status
         write(3,*)'       status = ptdetach(ptid)'
         write(3,*)'       Status returned by ptdetach ',status
      endif
 
 
      write(*,*)' '
      status = ptclose(ptfid)
      if (status .lt. zero) then
         write(*,*)'********** Error unexpected **********'
         write(3,*)'********** Error unexpected **********'
         call heprnt(0)
      else
         write(*,*)'       status = ptclose(ptfid)'
         write(*,*)'       Status returned by ptclose ',status
         write(3,*)'       status = ptclose(ptfid)'
         write(3,*)'       Status returned by ptclose ',status
      endif

 

 
      write(*,*)' '
      ptfid = ptopen("Pointf_Test.hdf", DFACC_RDWR)
      if (ptfid .lt. zero) then
         write(*,*)'********** Error unexpected **********'
         write(3,*)'********** Error unexpected **********'
         call heprnt(0)
      else
         write(*,*)'       ptfid = ptopen("Pointf_Test.hdf", DFACC_RDWR        &
     1)'
         write(*,*)'       Point file id returned by ptopen ',ptfid
         write(3,*)'       ptfid = ptopen("Pointf_Test.hdf", DFACC_RDWR        &
     1)'
         write(3,*)'       Point file id returned by ptopen ',ptfid
      endif
 
      write(*,*)' '
      ptid = ptattach(ptfid, "Simple Point")
      if (ptfid .lt. zero) then
         write(*,*)'********** Error unexpected **********'
         write(3,*)'********** Error unexpected **********'
         call heprnt(0)
      else
         write(*,*)'       ptid = ptattach(ptfid, "Simple Point")'
         write(*,*)'       Point id returned by ptattach ',ptid
         write(3,*)'       ptid = ptattach(ptfid, "Simple Point")'
         write(3,*)'       Point id returned by ptattach ',ptid
      endif

      open(unit=1, file='simple.txt',STATUS='OLD')
      n = 0
      pntr = 1
      do 10 i=1,1000

           read(1,32,end=100)time,conc(1),conc(2),conc(3),conc(4),spc
           
           n = n + 1
           buffer(pntr:pntr+8) = ctime
           pntr = pntr + 8
           buffer(pntr:pntr+4*4) = cconc
           pntr = pntr + 4*4
           buffer(pntr:pntr+4) = spc
           pntr = pntr + 4
10      continue
 
100     close(unit=1)
   32  format(3x,f10.1,2x,f4.2,2x,f4.2,2x,f4.2,2x,f4.2,1x,a) 

      write(*,*)' '
      write(3,*)' '
c Test Case -- ptwrlev
c
      write(3,27)
      write(*,*)'Testing ptwrlev '
      write(*,*)'================='
      write(3,*)'Testing ptwrlev '
      write(3,*)'================='

      status = ptwrlev(ptid, 0, n, buffer)
      if (status .lt. zero) then
         write(*,*)'********** Error unexpected **********'
         write(3,*)'********** Error unexpected **********'
         call heprnt(0)
      else
         write(*,*)'         status = ptwrlev(ptid, 0, n, buffer)'
         write(*,*)'         Status returned by ptwrlev ',status
         write(3,*)'         status = ptwrlev(ptid, 0, n, buffer)'
         write(3,*)'         Status returned by ptwrlev ',status
      endif

      status = ptdetach(ptid)
      if (status .lt. zero) then
         write(*,*)'********** Error unexpected **********'
         write(3,*)'********** Error unexpected **********'
         call heprnt(0)
      else
         write(*,*)'         status = ptdetach(ptid)'
         write(*,*)'         Status returned by ptdetach ',status
         write(3,*)'         status = ptdetach(ptid)'
         write(3,*)'         Status returned by ptdetach ',status
      endif
   
 
      ptid = ptattach(ptfid, "FixedBuoy Point")
      if (ptid .lt. zero) then
         write(*,*)'********** Error unexpected **********'
         write(3,*)'********** Error unexpected **********'
         call heprnt(0)
      else
         write(*,*)'        ptid = ptattach(ptfid, "FixedBuoy Point")'
         write(*,*)'        Point id returned by ptattach ',ptid
         write(3,*)'        ptid = ptattach(ptfid, "FixedBuoy Point")'
         write(3,*)'        Point id returned by ptattach ',ptid
      endif

      open(unit=1, file='fixedBuoy0.txt', STATUS='OLD')
 
      n = 0
      pntr = 1
      do 20 i=1,1000
 
           read(1, 34, end=200)desc,lon,lat,date,id
           
           n = n + 1
           buffer(pntr:pntr+8) = desc
           pntr = pntr + 8
           buffer(pntr:pntr+8) = clon
           pntr = pntr + 8
           buffer(pntr:pntr+8) = clat
           pntr = pntr + 8
           buffer(pntr:pntr+4) = cdate
           pntr = pntr + 4
           buffer(pntr:pntr+1) = id
           pntr = pntr + 1
 20   continue
 
 200  close(unit=1)
   34 format(a8,1x,f12.7,1x,f12.7,1x,i6,1x,a)

      status = ptwrlev(ptid, 0, n, buffer)
      if (status .lt. zero) then
         write(*,*)'********** Error unexpected **********'
         write(3,*)'********** Error unexpected **********'
         call heprnt(0)
      else
         write(*,*)'        status = ptwrlev(ptid, 0, n, buffer)'
         write(*,*)'        Status returned by ptwrlev ',status
         write(3,*)'        status = ptwrlev(ptid, 0, n, buffer)'
         write(3,*)'        Status returned by ptwrlev ',status
      endif
 
 
      open(unit=1, file='fixedBuoy1.txt', STATUS='OLD')
 
      n = 0
      pntr = 1
      do 30 i=1,1000

           read(1, 35, end=300) time, rain, temp, id
           
           n = n + 1
 
           buffer(pntr:pntr+8) = ctime
           pntr = pntr + 8
           buffer(pntr:pntr+4) = crain
           pntr = pntr + 4
           buffer(pntr:pntr+4) = ctemp
           pntr = pntr + 4
           buffer(pntr:pntr+1) = id
           pntr = pntr + 1
 30   continue
 
 300  close(unit=1)
  35  format(3x,f10.1,5x,f3.1,3x,f5.2,3x,a)
      status = ptwrlev(ptid, 1, n, buffer)
      if (status .lt. zero) then
         write(*,*)'********** Error unexpected **********'
         write(3,*)'********** Error unexpected **********'
         call heprnt(0)
      else
         write(*,*)'          status = ptwrlev(ptid, 1, n, buffer)'
         write(*,*)'          Status returned by ptwrlev ',status
         write(3,*)'          status = ptwrlev(ptid, 1, n, buffer)'
         write(3,*)'          Status returned by ptwrlev ',status
      endif

      write(*,*)' '
      write(3,*)' '
c Test Case -- ptwrattr
c
      write(3,27)
      write(*,*)'Testing ptwrattr '
      write(*,*)'================='
      write(3,*)'Testing ptwrattr '
      write(3,*)'================='

      f32 = -7.5
      status = ptwrattr(ptid, "float32", 5, 1, f32)
      if (status .lt. zero) then
         write(*,*)'********** Error unexpected **********'
         write(3,*)'********** Error unexpected **********'
         call heprnt(0)
      else
         write(*,*)'         status = ptwrattr(ptid, "float32", 5, 1,          &
     1f32)'
         write(*,*)'         Status returned by ptwrattr ', status
         write(3,*)'         status = ptwrattr(ptid, "float32", 5, 1,          &
     1f32)'
         write(3,*)'         Status returned by ptwrattr ', status
      endif
 
      status = ptdetach(ptid)
      if (status .lt. zero) then
         write(*,*)'********** Error unexpected **********'
         write(3,*)'********** Error unexpected **********'
         call heprnt(0)
      else
         write(*,*)'       status = ptdetach(ptid)'
         write(*,*)'       Status returned by ptdetach ',status
         write(3,*)'       status = ptdetach(ptid)'
         write(3,*)'       Status returned by ptdetach ',status
      endif
 
 
      ptid = ptattach(ptfid, "FloatBuoy Point")
      if (ptid .lt. zero) then
         write(*,*)'********** Error unexpected **********'
         write(3,*)'********** Error unexpected **********'
         call heprnt(0)
      else
         write(*,*)'      ptid = ptattach(ptfid, "FloatBuoy Point")'
         write(*,*)'      Point id returned by ptattach ',ptid
         write(3,*)'      ptid = ptattach(ptfid, "FloatBuoy Point")'
         write(3,*)'      Point id returned by ptattach ',ptid
      endif
 
      open(unit=1, file='floatBuoy0.txt', STATUS='OLD')
 
      n = 0
      pntr = 1
      do 40 i=1,1000
 
           read(1, 36, end=400)  desc, date, wgt, id
           
           n = n + 1
 
           buffer(pntr:pntr+8) = desc
           pntr = pntr + 8
           buffer(pntr:pntr+4) = cdate
           pntr = pntr + 4
           buffer(pntr:pntr+2) = cwgt
           pntr = pntr + 2
           buffer(pntr:pntr+1) = id
           pntr = pntr + 1
 40   continue
 
 400  close(unit=1)
   36 format(a8,2x,i6,3x,i4,2x,a)
   
      status = ptwrlev(ptid, 0, n, buffer)
      if (status .lt. zero) then
         write(*,*)'********** Error unexpected **********'
         write(3,*)'********** Error unexpected **********'
         call heprnt(0)
      else
         write(*,*)'      status = ptwrlev(ptid, 0, n, buffer)'
         write(*,*)'      Status returned by ptwrlev ',status
         write(3,*)'      status = ptwrlev(ptid, 0, n, buffer)'
         write(3,*)'      Status returned by ptwrlev ',status
      endif
 
      open(unit=1, file='floatBuoy1.txt', STATUS='OLD')
 
      n = 0
      pntr = 1
      do 50 i=1,1000
 
           read(1, 37, end=500)time,lon,lat,rain,temp,id
           
           n = n + 1
 
           buffer(pntr:pntr+8) = ctime
           pntr = pntr + 8
           buffer(pntr:pntr+8) = clon
           pntr = pntr + 8
           buffer(pntr:pntr+8) = clat
           pntr = pntr + 8
           buffer(pntr:pntr+4) = crain
           pntr = pntr + 4
           buffer(pntr:pntr+4) = ctemp
           pntr = pntr + 4
           buffer(pntr:pntr+1) = id
           pntr = pntr + 1
 50   continue
 
 500  close(unit=1)
   37 format(3x,f10.1,2x,f11.6,2x,f11.6,5x,f3.1,3x,f5.2,3x,a)
 
      status = ptwrlev(ptid, 1, n, buffer)
      if (status .lt. zero) then
         write(*,*)'********** Error unexpected **********'
         write(3,*)'********** Error unexpected **********'
         call heprnt(0)
      else
         write(*,*)'        status = ptwrlev(ptid, 1, n, buffer)'
         write(*,*)'        Status returned by ptwrlev ',status
         write(3,*)'        status = ptwrlev(ptid, 1, n, buffer)'
         write(3,*)'        Status returned by ptwrlev ',status
      endif

      status = ptdetach(ptid)
      if (status .lt. zero) then
         write(*,*)'********** Error unexpected **********'
         write(3,*)'********** Error unexpected **********'
         call heprnt(0)
      else
         write(*,*)'       status = ptdetach(ptid)'
         write(*,*)'      Status returned by ptdetach ',status
         write(3,*)'       status = ptdetach(ptid)'
         write(3,*)'      Status returned by ptdetach ',status
      endif
 
 
      status = ptclose(ptfid)
      if (status .lt. zero) then
         write(*,*)'********** Error unexpected **********'
         write(3,*)'********** Error unexpected **********'
         call heprnt(0)
      else
         write(*,*)'      status = ptclose(ptfid)'
         write(*,*)'      Status returned by ptclose ',status
         write(3,*)'      status = ptclose(ptfid)'
         write(3,*)'      Status returned by ptclose ',status
      endif

 
      ptfid = ptopen("Pointf_Test.hdf", DFACC_READ)
      if (ptfid .lt. zero) then
         write(*,*)'********** Error unexpected **********'
         write(3,*)'********** Error unexpected **********'
         call heprnt(0)
      else
         write(*,*)'        ptfid = ptopen("Pointf_Test.hdf", DFACC_REA        &
     1D)'
         write(*,*)'        Point id returned by ptopen ',ptfid
         write(3,*)'        ptfid = ptopen("Pointf_Test.hdf", DFACC_REA        &
     1D)'
         write(3,*)'        Point id returned by ptopen ',ptfid
      endif

      ptid = ptattach(ptfid, "Simple Point")
      if (ptid .lt. zero) then
         write(*,*)'********** Error unexpected **********'
         write(3,*)'********** Error unexpected **********'
         call heprnt(0)
      else
         write(*,*)'       ptid = ptattach(ptfid, "Simple Point")'
         write(*,*)'       Point id returned by ptattach ',ptid
         write(3,*)'       ptid = ptattach(ptfid, "Simple Point")'
         write(3,*)'       Point id returned by ptattach ',ptid
      endif
 
      write(*,*)' '
      write(3,*)' '
c Test Case -- ptlevidx
c
      write(3,27)
      write(*,*)'Testing ptlevidx '
      write(*,*)'================='
      write(3,*)'Testing ptlevidx '
      write(3,*)'================='

      levndx = ptlevidx(ptid, "Sensor")
      if (levndx .lt. zero) then
         write(*,*)'********** Error unexpected **********'
         write(3,*)'********** Error unexpected **********'
         call heprnt(0)
      else
         write(*,*)'     levndx = ptlevidx(ptid, "Sensor")'
         write(*,*)'     Level index of Sensor ',levndx
         write(3,*)'     levndx = ptlevidx(ptid, "Sensor")'
         write(3,*)'     Level index of Sensor ',levndx
      endif

      write(*,*)' '
      write(3,*)' '
c Test Case -- ptlevinfo
c
      write(3,27)
      write(*,*)'Testing ptlevinfo '
      write(*,*)'================='
      write(3,*)'Testing ptlevinfo '
      write(3,*)'================='

      nlevels = ptlevinfo(ptid, 0, fldlist, fldtype, fldorder)
      if (nlevels .lt. zero) then
         write(*,*)'********** Error unexpected **********'
         write(3,*)'********** Error unexpected **********'
         call heprnt(0)
      else
         write(*,*)'      nlevels = ptlevinfo(ptid, 0, fldlist,                &
     1   fldtype, fldorder)'
         write(*,*)'      Number of fields in level 0 ',status
         write(*,*)'      List of fields in level 0 ',fldlist
         write(3,*)'      Number of fields in level 0 ',status
         write(3,*)'      List of fields in level 0 ',fldlist
         do 7 i=1,nlevels
            write(*,*)' Number type of field ',fldtype(i)
            write(*,*)' Order of field ', fldorder(i)
            write(3,*)' Number type of field ',fldtype(i)
            write(3,*)' Order of field ', fldorder(i)
 7       continue
         write(3,*)'      status = ptlevinfo(ptid, 0, fldlist,                 &
     1   fldtype, fldorder)'
         write(3,*)'      Status returned by ptlevinfo ',status
      endif

      write(*,*)' '
      write(3,*)' '
c Test Case -- ptnrecs
c
      write(3,27)
      write(*,*)'Testing ptnrecs '
      write(*,*)'================='
      write(3,*)'Testing ptnrecs '
      write(3,*)'================='

      n = ptnrecs(ptid, 0)
      if (n .lt. zero) then
         write(*,*)'********** Error unexpected **********'
         write(3,*)'********** Error unexpected **********'
         call heprnt(0)
      else
         write(*,*)'     n = ptnrecs(ptid, 0)'
         write(*,*)'     Number of records in level ',n
         write(3,*)'     n = ptnrecs(ptid, 0)'
         write(3,*)'     Number of records in level ',n
      endif
 
      do 5 i=1,n
         recs(i) = i - 1
 5    continue
 
      write(*,*)' '
      write(3,*)' '
c Test Case -- ptrdlev
c
      write(3,27)
      write(*,*)'Testing ptrdlev '
      write(*,*)'================='
      write(3,*)'Testing ptrdlev '
      write(3,*)'================='

      status = ptrdlev(ptid, 0, fldlist, n, recs, buffer)
      if (status .lt. zero) then
         write(*,*)'********** Error unexpected **********'
         write(3,*)'********** Error unexpected **********'
         call heprnt(0)
      else
         write(*,*)'      status = ptrdlev(ptid,0,fldlist,n,recs,buffer        &
     1)'
         write(*,*)'      Status returned by ptrdlev ',status
         write(3,*)'      status = ptrdlev(ptid,0,fldlist,n,recs,buffer        &
     1)'
         write(3,*)'      Status returned by ptrdlev ',status
      endif

      pntr = 1
      do 11 i=1,n
           ctime = buffer(pntr:pntr+8)
           pntr = pntr + 8
           cconc = buffer(pntr:pntr+4*4)
           pntr = pntr + 4*4
           spc = buffer(pntr:pntr+4)
           pntr = pntr + 4
           write(*,*)time,conc(1),conc(2),conc(3),conc(4),' ',spc
           write(3,*)time,conc(1),conc(2),conc(3),conc(4),' ',spc
11    continue
 
      status = ptdetach(ptid)
      if (status .lt. zero) then
         write(*,*)'********** Error unexpected **********'
         write(3,*)'********** Error unexpected **********'
         call heprnt(0)
      else
         write(*,*)'       status = ptdetach(ptid)'
         write(*,*)'       Status returned by ptdetach ',status
         write(3,*)'       status = ptdetach(ptid)'
         write(3,*)'       Status returned by ptdetach ',status
      endif
 
      ptid = ptattach(ptfid, "FixedBuoy Point")
      if (ptid .lt. zero) then
         write(*,*)'********** Error unexpected **********'
         write(3,*)'********** Error unexpected **********'
         call heprnt(0)
      else
         write(*,*)'       ptid = ptattach(ptfid, "FixedBuoy Point")'
         write(*,*)'       Point id returned by ptattach ',ptid
         write(3,*)'       ptid = ptattach(ptfid, "FixedBuoy Point")'
         write(3,*)'       Point id returned by ptattach ',ptid
      endif
 
      status = ptlevinfo(ptid, 0, fldlist, fldtype, fldorder)
      if (status .lt. zero) then
         write(*,*)'********** Error unexpected **********'
         write(3,*)'********** Error unexpected **********'
         call heprnt(0)
      else
         write(*,*)'    status = ptlevinfo(ptid, 0, fldlist,                   &
     1fldtype, fldorder)'
         write(*,*)'    Status returned by ptlevinfo ',status
         write(3,*)'    status = ptlevinfo(ptid, 0, fldlist,                   &
     1fldtype, fldorder)'
         write(3,*)'    Status returned by ptlevinfo ',status
      endif

      write(*,*)' '
      write(3,*)' '
c Test Case -- ptsizeof
c
      write(3,27)
      write(*,*)'Testing ptsizeof '
      write(*,*)'================='
      write(3,*)'Testing ptsizeof '
      write(3,*)'================='

      fldsz = ptsizeof(ptid, fldlist, fldlevels)
      if (fldsz .lt. zero) then
         write(*,*)'********** Error unexpected **********'
         write(3,*)'********** Error unexpected **********'
         call heprnt(0)
      else
         write(*,*)'       fldsz = ptsizeof(ptid, fldlist, fldlevels)'
         write(*,*)'       fieldsize ', fldsz
         write(*,*)'Field list'
         write(*,*)'  ',fldlist
         write(*,*)'       Field levels ',fldlevels
         write(3,*)'       fldsz = ptsizeof(ptid, fldlist, fldlevels)'
         write(3,*)'       fieldsize ', fldsz
         write(3,*)'Field list'
         write(3,*)'  ',fldlist
         write(3,*)'       Field levels ',fldlevels
      endif

      write(*,*)' '
      write(3,*)' '
c Test Case -- ptflinkinfo
c
      write(3,27)
      write(*,*)'Testing ptflinkinfo '
      write(*,*)'================='
      write(3,*)'Testing ptflinkinfo '
      write(3,*)'================='

      status = ptflinkinfo(ptid, 0, linkfield)
      if (status .lt. zero) then
         write(*,*)'********** Error unexpected **********'
         write(3,*)'********** Error unexpected **********'
         call heprnt(0)
      else
         write(*,*)'       status = ptflinkinfo(ptid, 0, linkfield)'
         write(*,*)'       Status returned by ptflinkinfo ', status
         write(*,57) linkfield
         write(3,*)'       status = ptflinkinfo(ptid, 0, linkfield)'
         write(3,*)'       Status returned by ptflinkinfo ', status
         write(3,57) linkfield
      endif
  57  format('        The link field to the following level is ',a8)

      write(*,*)' '
      write(3,*)' '
c Test Case -- ptblinkinfo
c
      write(3,27)
      write(*,*)'Testing ptblinkinfo '
      write(*,*)'================='
      write(3,*)'Testing ptblinkinfo '
      write(3,*)'================='

      status = ptblinkinfo(ptid, 1, linkfield)
      if (status .lt. zero) then
         write(*,*)'********** Error unexpected **********'
         write(3,*)'********** Error unexpected **********'
         call heprnt(0)
      else
         write(*,*)'       status = ptblinkinfo(ptid, 1, linkfield)'
         write(*,*)'       Status returned by ptblinkinfo ', status
         write(*,58) linkfield
         write(3,*)'       status = ptblinkinfo(ptid, 1, linkfield)'
         write(3,*)'       Status returned by ptblinkinfo ', status
         write(3,58) linkfield
      endif
   58 format('        The link field to the previous level ',a8)

      write(*,*)' '
      write(3,*)' '
c Test Case -- ptnlevs
c
      write(3,27)
      write(*,*)'Testing ptnlevs '
      write(*,*)'================='
      write(3,*)'Testing ptnlevs '
      write(3,*)'================='

      nlevels = ptnlevs(ptid)
      if (nlevels .lt. zero) then
         write(*,*)'********** Error unexpected **********'
         write(3,*)'********** Error unexpected **********'
         call heprnt(0)
      else
         write(*,*)'       nlevels = ptnlevs(ptid)'
         write(*,*)'       Number of levels ',nlevels
         write(3,*)'       nlevels = ptnlevs(ptid)'
         write(3,*)'       Number of levels ',nlevels
      endif

      write(*,*)' '
      write(3,*)' '
c Test Case -- ptnflds
c
      write(3,27)
      write(*,*)'Testing ptnflds '
      write(*,*)'================='
      write(3,*)'Testing ptnflds '
      write(3,*)'================='

      nflds = ptnflds(ptid,1, strbufsize)
      if (nflds .lt. zero) then
         write(*,*)'********** Error unexpected **********'
         write(3,*)'********** Error unexpected **********'
         call heprnt(0)
      else
         write(*,*)'       nflds = ptnflds(ptid,1, strbufsize)'
         write(*,*)'       Number of fields ',nflds
         write(*,*)'       Size in bytes of field list ',strbufsize
         write(3,*)'       nflds = ptnflds(ptid,1, strbufsize)'
         write(3,*)'       Number of fields ',nflds
         write(3,*)'       Size in bytes of field list ',strbufsize
       endif
  
      n = 2
      recs(1) = 0
      recs(2) = 2
 
      write(*,*)' '
      write(3,*)' '
c Test Case -- ptrdlev
c
      write(3,27)
      write(*,*)'Testing ptrdlev '
      write(*,*)'================='
      write(3,*)'Testing ptrdlev '
      write(3,*)'================='

      pntr = 1
      status = ptrdlev(ptid, 0, fldlist, n, recs, buffer)
      if (status .lt. zero) then
         write(*,*)'********** Error unexpected **********'
         write(3,*)'********** Error unexpected **********'
         call heprnt(0)
      else
         write(*,*)'     status = ptrdlev(ptid, 0, fldlist,                    &
     1n, recs, buffer)'
         write(*,*)'     Status returned by ptrdlev ',status
         write(3,*)'     status = ptrdlev(ptid, 0, fldlist,                    &
     1n, recs, buffer)'
         write(3,*)'     Status returned by ptrdlev ',status
      endif
 
      do 21 i=1,n
           desc = buffer(pntr:pntr+8)
           pntr = pntr + 8
           clon = buffer(pntr:pntr+8)
           pntr = pntr + 8
           clat = buffer(pntr:pntr+8)
           pntr = pntr + 8
           cdate = buffer(pntr:pntr+4)
           pntr = pntr + 4
           id = buffer(pntr:pntr+1)
           pntr = pntr + 1
           write(*,*) desc, lon, lat, date, id(1:1)
           write(3,*) desc, lon, lat, date, id(1:1)
 21   continue

      status = ptlevinfo(ptid, 1, fldlist, fldtype, fldorder)
      if (status .lt. zero) then
         write(*,*)'********** Error unexpected **********'
         write(3,*)'********** Error unexpected **********'
         call heprnt(0)
      else
         write(*,*)'      status = ptlevinfo(ptid, 1, fldlist,                 &
     1fldtype, fldorder)'
         write(*,*)'      Status returned by ptlevinfo ',status
         write(3,*)'      status = ptlevinfo(ptid, 1, fldlist,                 &
     1fldtype, fldorder)'
         write(3,*)'      Status returned by ptlevinfo ',status
      endif

      n = ptnrecs(ptid, 1)
      if (n .lt. zero) then
         write(*,*)'********** Error unexpected **********'
         write(3,*)'********** Error unexpected **********'
         call heprnt(0)
      else
         write(*,*)'      n = ptnrecs(ptid, 1)'
         write(*,*)'      Number of records ',n
         write(3,*)'      n = ptnrecs(ptid, 1)'
         write(3,*)'      Number of records ',n
      endif
 
 
      do 31 i=1,n
 
           recs(1) = i - 1
           status = ptrdlev(ptid, 1, fldlist, 1, recs, buffer)
           if (status .lt. zero) then
              write(*,*)'********** Error unexpected **********'
              write(3,*)'********** Error unexpected **********'
              call heprnt(0)
           else
           endif
 
           pntr = 1
 
           ctime = buffer(pntr:pntr+8)
           pntr = pntr + 8
           crain = buffer(pntr:pntr+4)
           pntr = pntr + 4
           ctemp = buffer(pntr:pntr+4)
           pntr = pntr + 4
           id = buffer(pntr:pntr+1)
           pntr = pntr + 1
           write(*,*) time, rain, temp, '  ', id(1:1)
           write(3,*) time, rain, temp, '  ', id(1:1)
 31   continue

      write(*,*)' '
      write(3,*)' '
c Test Case -- ptinqattrs
c
      write(3,27)
      write(*,*)'Testing ptinqattrs '
      write(*,*)'================='
      write(3,*)'Testing ptinqattrs '
      write(3,*)'================='

      nmattrs = ptinqattrs(ptid, attrlist,strbufsize)
      if (nmattrs .lt. zero) then
         write(*,*)'********** Error unexpected **********'
         write(3,*)'********** Error unexpected **********'
         call heprnt(0)
      else
         write(*,*)'   nmattrs = ptinqattrs(ptid, attrlist,strbufsize)'
         write(*,*)'   Number of attributes ',nmattrs
         write(*,*)'   Attribute list ',attrlist
         write(3,*)'   nmattrs = ptinqattrs(ptid, attrlist,strbufsize)'
         write(3,*)'   Number of attributes ',nmattrs
         write(3,*)'   Attribute list ',attrlist
      endif

c Test Case -- ptrdattr
c
      write(3,27)
      write(*,*)'Testing ptrdattr '
      write(*,*)'================='
      write(3,*)'Testing ptrdattr '
      write(3,*)'================='

      status = ptrdattr(ptid, "float32", b32)
      if (status .lt. zero) then
         write(*,*)'********** Error unexpected **********'
         write(3,*)'********** Error unexpected **********'
         call heprnt(0)
      else
         write(*,*)'      status = ptrdattr(ptid, "float32", b32)'
         write(*,*)'      Status returned by ptrdattr ',status
         write(*,*) 'b32 = ', b32
         write(3,*)'      status = ptrdattr(ptid, "float32", b32)'
         write(3,*)'      Status returned by ptrdattr ',status
         write(3,*) 'b32 = ', b32
      endif

c Test Case -- ptattrinfo
c
      write(3,27)
      write(*,*)'Testing ptattrinfo '
      write(*,*)'================='
      write(3,*)'Testing ptattrinfo '
      write(3,*)'================='

      status = ptattrinfo(ptid, "float32", nt, sz)
      if (status .lt. zero) then
         write(*,*)'********** Error unexpected **********'
         write(3,*)'********** Error unexpected **********'
         call heprnt(0)
      else
         write(*,*)'      status = ptattrinfo(ptid, "float32", nt, sz)'
         write(*,*)'      Status returned by ptattrinfo ',status
         write(*,*) 'nt = ', nt
         write(*,*) 'sz = ', sz
         write(3,*)'      status = ptattrinfo(ptid, "float32", nt, sz)'
         write(3,*)'      Status returned by ptattrinfo ',status
         write(3,*) 'nt = ', nt
         write(3,*) 'sz = ', sz
      endif
 
      status = ptdetach(ptid)
      if (status .lt. zero) then
         write(*,*)'********** Error unexpected **********'
         write(3,*)'********** Error unexpected **********'
         call heprnt(0)
      else
         write(*,*)'       status = ptdetach(ptid)'
         write(*,*)'       Status returned by ptdetach ',status
         write(3,*)'       status = ptdetach(ptid)'
         write(3,*)'       Status returned by ptdetach ',status
      endif

      status = ptclose(ptfid)
      if (status .lt. zero) then
         write(*,*)'********** Error unexpected **********'
         write(3,*)'********** Error unexpected **********'
         call heprnt(0)
      else
         write(*,*)'       status = ptclose(ptfid)'
         write(*,*)'       Status returned by ptclose ',status
         write(3,*)'       status = ptclose(ptfid)'
         write(3,*)'       Status returned by ptclose ',status
      endif


      ptfid = ptopen("Pointf_Test.hdf", DFACC_RDWR)
      if (ptfid .lt. zero) then
         write(*,*)'********** Error unexpected **********'
         write(3,*)'********** Error unexpected **********'
         call heprnt(0)
      else
         write(*,*)'     ptfid = ptopen("Pointf_Test.hdf", DFACC_RDWR)'
         write(*,*)'     Point id returned by ptopen ',ptfid
         write(3,*)'     ptfid = ptopen("Pointf_Test.hdf", DFACC_RDWR)'
         write(3,*)'     Point id returned by ptopen ',ptfid
      endif

      ptid1 = ptattach(ptfid, "Simple Point")
      if (ptid1 .lt. zero) then
         write(*,*)'********** Error unexpected **********'
         write(3,*)'********** Error unexpected **********'
         call heprnt(0)
      else
         write(*,*)'      ptid1 = ptattach(ptfid, "Simple Point")'
         write(*,*)'      Point id returned by ptattach ',ptid1
         write(3,*)'      ptid1 = ptattach(ptfid, "Simple Point")'
         write(3,*)'      Point id returned by ptattach ',ptid1
      endif

      ptid2 = ptattach(ptfid, "FixedBuoy Point")
      if (ptid2 .lt. zero) then
         write(*,*)'********** Error unexpected **********'
         write(3,*)'********** Error unexpected **********'
         call heprnt(0)
      else
         write(*,*)'      ptid2 = ptattach(ptfid, "FixedBuoy Point")'
         write(*,*)'      Point id returned by ptattach ',ptid2
         write(3,*)'      ptid2 = ptattach(ptfid, "FixedBuoy Point")'
         write(3,*)'      Point id returned by ptattach ',ptid2
      endif

      f64 = 43.2
      datbuf(1:8) = c8
      recs(1) = 1

c Test Case -- ptuplev
c
      write(3,27)
      write(*,*)'Testing ptuplev '
      write(*,*)'================='
      write(3,*)'Testing ptuplev '
      write(3,*)'================='

      status = ptuplev(ptid2, 0, "Longitude", 1, recs, datbuf)
      if (status .lt. zero) then
         write(*,*)'********** Error unexpected **********'
         write(3,*)'********** Error unexpected **********'
         call heprnt(0)
      else
         write(*,*)'      status = ptuplev(ptid2, 0, "Longitude",              &
     11, recs, datbuf)'
         write(*,*)'      Status returned by ptuplev ',status
         write(3,*)'      status = ptuplev(ptid2, 0, "Longitude",              &
     11, recs, datbuf)'
         write(3,*)'      Status returned by ptuplev ',status
      endif

      datbuf(1:1) = 'F'
      recs(1) = 0
      status = ptuplev(ptid2, 0, "ID", 1, recs, datbuf)
      if (status .lt. zero) then
         write(*,*)'********** Error unexpected **********'
         write(3,*)'********** Error unexpected **********'
         call heprnt(0)
      else
         write(*,*)'     status = ptuplev(ptid2, 0, "ID", 1,                   &
     1recs, datbuf)'
         write(*,*)'     Status returned by ptuplev ',status
         write(3,*)'     status = ptuplev(ptid2, 0, "ID", 1,                   &
     1recs, datbuf)'
         write(3,*)'     Status returned by ptuplev ',status
      endif

c Test Case -- ptgetrecnums
c
      write(3,27)
      write(*,*)'Testing ptgetrecnums '
      write(*,*)'================='
      write(3,*)'Testing ptgetrecnums '
      write(3,*)'================='

      inlevel = 0
      outlevel = 1
      nrec = 1
      status = ptgetrecnums(ptid2, inlevel, outlevel, nrec, recs, 
     1outnrec, outrecs)
      if (status .lt. zero) then
         write(*,*)'********** Error unexpected **********'
         write(3,*)'********** Error unexpected **********'
         call heprnt(0)
      else
         write(*,*)'      status = ptgetrecnums(ptid2, inlevel, outlevel       &
     1,nrec, recs,outnrec, outrecs)'
         write(*,*)'      Status returned by ptgetrecnums ',status
         write(*,59) outnrec
         write(3,*)'      status = ptgetrecnums(ptid2, inlevel, outlevel       &
     1,nrec, recs,outnrec, outrecs)'
         write(3,*)'      Status returned by ptgetrecnums ',status
         write(3,59) outnrec
   59 format('      Number of related records in next level ',I4)

         do 71 i=1,outnrec
            datbuf(i:i) = 'F'
 71      continue
      endif

      status = ptuplev(ptid2, outlevel, "ID", outnrec, outrecs, 
     1datbuf)
      if (status .lt. zero) then
         write(*,*)'********** Error unexpected **********'
         write(3,*)'********** Error unexpected **********'
         call heprnt(0)
      else
         write(*,*)'       status = ptuplev(ptid2, outlevel, "ID",             &
     1outnrec, outrecs,datbuf)'
         write(*,*)'       Status returned by ptuplev ',status
         write(3,*)'       status = ptuplev(ptid2, outlevel, "ID",             &
     1outnrec, outrecs,datbuf)'
         write(3,*)'       Status returned by ptuplev ',status
      endif

c Test Case -- ptgetlevname
c
      write(3,27)
      write(*,*)'Testing ptgetlevname '
      write(*,*)'================='
      write(3,*)'Testing ptgetlevname '
      write(3,*)'================='

      status=ptgetlevname(ptid2,0,levname,strbuf)
      if (status .lt. zero) then
        write(*,*)'**********Error unexpected******'
        write(3,*)'**********Error unexpected******'
        call heprnt(0)
      else
        write(*,*)'Get level name '
        write(*,*)'Level name ',levname
        write(*,*)'Size of level name ',strbuf
        write(3,*)'Get level name '
        write(3,*)'Level name ',levname
        write(3,*)'Size of level name ',strbuf
        write(*,*)' '
        write(3,*)' '
      endif

      status = ptdetach(ptid1)
      if (status .lt. zero) then
        write(*,*)'**********Error unexpected******'
        write(3,*)'**********Error unexpected******'
        call heprnt(0)
      else
         write(*,*)'      status = ptdetach(ptid1)'
         write(*,*)'      Status returned by ptdetach ',status
         write(3,*)'      status = ptdetach(ptid1)'
         write(3,*)'      Status returned by ptdetach ',status
      endif

      status = ptdetach(ptid2)
      if (status .lt. zero) then
        write(*,*)'**********Error unexpected******'
        write(3,*)'**********Error unexpected******'
        call heprnt(0)
      else
         write(*,*)'      status = ptdetach(ptid2)'
         write(*,*)'      Status returned by ptdetach ',status
         write(3,*)'      status = ptdetach(ptid2)'
         write(3,*)'      Status returned by ptdetach ',status
      endif


      status = ptclose(ptfid)
      if (status .lt. zero) then
        write(*,*)'**********Error unexpected******'
        write(3,*)'**********Error unexpected******'
        call heprnt(0)
      else
         write(*,*)'      status = ptclose(ptfid)'
         write(*,*)'      Status returned by ptclose ',status
         write(3,*)'      status = ptclose(ptfid)'
         write(3,*)'      Status returned by ptclose ',status
      endif


      ptfid = ptopen("Pointf_Test.hdf", DFACC_READ)
      if (ptfid .lt. zero) then
        write(*,*)'**********Error unexpected******'
        write(3,*)'**********Error unexpected******'
        call heprnt(0)
      else
         write(*,*)'    ptfid = ptopen("Pointf_Test.hdf", DFACC_READ)'
         write(*,*)'    Point id returned by ptopen ',ptfid
         write(3,*)'    ptfid = ptopen("Pointf_Test.hdf", DFACC_READ)'
         write(3,*)'    Point id returned by ptopen ',ptfid
      endif

c Test Case -- ptinqpoint
c
      write(3,27)
      write(*,*)'Testing ptinqpoint '
      write(*,*)'================='
      write(3,*)'Testing ptinqpoint '
      write(3,*)'================='

      npoint = ptinqpoint("Pointf_Test.hdf",ptlist,strbufsize2)
      if (npoint .lt. zero) then
        write(*,*)'**********Error unexpected******'
        write(3,*)'**********Error unexpected******'
        call heprnt(0)
      else
         write(*,*)'  Number of points in file ',npoint
         write(*,*)'  List of points in file ',ptlist
         write(3,*)'  Number of points in file ',npoint
         write(3,*)'  List of points in file ',ptlist
      endif

      ptid = ptattach(ptfid, "FloatBuoy Point")
      if (ptid .lt. zero) then
        write(*,*)'**********Error unexpected******'
        write(3,*)'**********Error unexpected******'
        call heprnt(0)
      else
         write(*,*)'     ptid = ptattach(ptfid, "FloatBuoy Point")'
         write(*,*)'     Point id returned by ptattach ',ptid
         write(3,*)'     ptid = ptattach(ptfid, "FloatBuoy Point")'
         write(3,*)'     Point id returned by ptattach ',ptid
      endif

c Test Case -- ptdefboxreg
c
      write(3,27)
      write(*,*)'Testing ptdefboxreg '
      write(*,*)'===================='
      write(3,*)'Testing ptdefboxreg '
      write(3,*)'===================='

      cornerlon(1) = -75.0d0
      cornerlat(1) = -25.0d0
      cornerlon(2) = 75.0d0
      cornerlat(2) = 25.0d0

      regionid = ptdefboxreg(ptid, cornerlon, cornerlat)
      if (regionid .lt. zero) then
        write(*,*)'**********Error unexpected******'
        write(3,*)'**********Error unexpected******'
        call heprnt(0)
      else
         write(*,*)'      regionid = ptdefboxreg(ptid,cornerlon, cornerlat     &
     1)'
         write(*,*)'      Region id returned by ptdefboxreg ',regionid
         write(3,*)'      regionid = ptdefboxreg(ptid,cornerlon, cornerlat     &
     1)'
         write(3,*)'      Region id returned by ptdefboxreg ',regionid
      endif

c Test Case -- ptregrecs
c
      write(3,27)
      write(*,*)'Testing ptregrecs '
      write(*,*)'================='
      write(3,*)'Testing ptregrecs '
      write(3,*)'================='

      status=ptregrecs(ptid,regionid,0,regrec,regrecs)
      if (status .lt. zero) then
         write(*,*)'*********Error unexpected********'
         write(3,*)'*********Error unexpected********'
         call heprnt(0)
      else
        write(*,*)'status=ptregrecs(ptid,regionid,0,regrec,regrecs)'
        write(*,*)'Status returned by call to ptregrecs ',status
        write(*,38) regrec
        write(3,*)'status=ptregrecs(ptid,regionid,0,regrec,regrecs)'
        write(3,*)'Status returned by call to ptregrecs ',status
        write(3,38) regrec
        do 26 i=1,regrec
           write(*,*)'Record number of subsetted records ',regrecs(i)
           write(3,*)'Record number of subsetted records ',regrecs(i)
   26   continue
      endif
        write(*,*)' '
        write(3,*)' '
   38 format('Number of records in region ',I4)

      status=ptregrecs(ptid,regionid,1,regrec,regrecs)
      if (status .lt. zero) then
         write(*,*)'*********Error unexpected********'
         write(3,*)'*********Error unexpected********'
         call heprnt(0)
      else
        write(*,*)'status=ptregrecs(ptid,regionid,1,regrec,regrecs)'
        write(*,*)'Status returned by call to ptregrecs ',status
        write(*,38) regrec
        write(3,*)'status=ptregrecs(ptid,regionid,1,regrec,regrecs)'
        write(3,*)'Status returned by call to ptregrecs ',status
        write(3,38) regrec
        do 28 i=1,regrec
           write(*,*)'Record number of subsetted records ',regrecs(i)
           write(3,*)'Record number of subsetted records ',regrecs(i)
   28   continue
      endif
        write(*,*)' '
        write(3,*)' '

c Test Case -- ptreginfo
c
      write(3,27)
      write(*,*)'Testing ptreginfo '
      write(*,*)'================='
      write(3,*)'Testing ptreginfo '
      write(3,*)'================='

      level = 1
      status = ptreginfo(ptid, regionid, level, "Longitude,Latitude",          &
     1size)
      if (status .lt. zero) then
         write(*,*)'*********Error unexpected********'
         write(3,*)'*********Error unexpected********'
         call heprnt(0)
      else
         write(*,*)'       status = ptreginfo(ptid, regionid, level,           &
     1"Longitude,Latitude", size)'
         write(*,*)'       Status returned by ptreginfo ',status
         write(3,*)'       status = ptreginfo(ptid, regionid, level,           &
     1"Longitude,Latitude", size)'
         write(3,*)'       Status returned by ptreginfo ',status
      endif

c Test Case -- ptextreg
c
      write(3,27)
      write(*,*)'Testing ptextreg '
      write(*,*)'================='
      write(3,*)'Testing ptextreg '
      write(3,*)'================='

      call heprnt(0)
      status = ptextreg(ptid, regionid, level, "Longitude,Latitude", d         &
     1tbuf)
      if (status .lt. zero) then
         write(*,*)'*********Error unexpected********'
         write(3,*)'*********Error unexpected********'
         call heprnt(0)
      else
         write(*,*)'    status = ptextreg(ptid, regionid, level,               &
     1"Longitude,Latitude", dtbuf)'
         write(*,*)'    Status returned by ptextreg ',status
         write(3,*)'    status = ptextreg(ptid, regionid, level,               &
     1"Longitude,Latitude", dtbuf)'
         write(3,*)'    Status returned by ptextreg ',status

         do 81 j = 1,size/16
            write(*,17) j, dtbuf(2*j-1),dtbuf(2*j)
            write(3,17) j, dtbuf(2*j-1),dtbuf(2*j)
 81      continue
   17    format(i2,3x,f14.5,3x,f14.5)
      endif
      

c Test Case -- ptdeftmeper
c
      write(3,27)
      write(*,*)'Testing ptdeftmeper '
      write(*,*)'================='
      write(3,*)'Testing ptdeftmeper '
      write(3,*)'================='

      starttime=35000000.0d0
      stoptime=36500000.0d0
      write(*,*)' Start time ',starttime,  '  Stop time ',stoptime
    
      periodid = ptdeftmeper(ptid, starttime, stoptime)
      write(*,*)' Start time ',starttime,  '  Stop time ',stoptime
      if (periodid .lt. zero) then
         write(*,*)'*********Error unexpected********'
         write(3,*)'*********Error unexpected********'
         call heprnt(0)
      else
         write(*,*)'    periodid = ptdeftmeper(ptid, starttime, stoptim        &
     1e)'
         write(*,*)'    Period id returned by ptdeftmeper ',periodid
         write(3,*)'    periodid = ptdeftmeper(ptid, starttime, stoptim        &
     1e)'
         write(3,*)'    Period id returned by ptdeftmeper ',periodid
      endif

c Test Case -- ptperrecs
c
      write(3,27)
      write(*,*)'Testing ptperrecs '
      write(*,*)'================='
      write(3,*)'Testing ptperrecs '
      write(3,*)'================='

      status=ptperrecs(ptid,periodid,0,regrec,regrecs)
      if (status .lt. zero) then
         write(*,*)'*********Error unexpected********'
         write(3,*)'*********Error unexpected********'
         call heprnt(0)
      else
        write(*,*)'status=ptperrecs(ptid,periodid,0,regrec,regrecs)'
        write(*,*)'Status returned by call to ptperrecs ',status
        write(*,*)'Number of records in period ',regrec
        write(3,*)'status=ptperrecs(ptid,periodid,0,regrec,regrecs)'
        write(3,*)'Status returned by call to ptperrecs ',status
        write(3,*)'Number of records in period ',regrec
        do 22 i=1,regrec
           write(*,*)'Record number of subsetted records ',regrecs(i)
           write(3,*)'Record number of subsetted records ',regrecs(i)
   22   continue
      endif

      status=ptperrecs(ptid,periodid,1,regrec,regrecs)
      if (status .lt. zero) then
         write(*,*)'*********Error unexpected********'
         write(3,*)'*********Error unexpected********'
         call heprnt(0)
      else
        write(*,*)'status=ptperrecs(ptid,periodid,1,regrec,regrecs)'
        write(*,*)'Status returned by call to ptperrecs ',status
        write(*,*)'Number of records in period ',regrec
        write(3,*)'status=ptperrecs(ptid,periodid,1,regrec,regrecs)'
        write(3,*)'Status returned by call to ptperrecs ',status
        write(3,*)'Number of records in period ',regrec
        do 23 i=1,regrec
           write(*,*)'Record number of subsetted records ',regrecs(i)
           write(3,*)'Record number of subsetted records ',regrecs(i)
   23   continue
      endif
        write(*,*)' '
        write(3,*)' '

c Test Case -- ptperinfo
c
      write(3,27)
      write(*,*)'Testing ptperinfo '
      write(*,*)'================='
      write(3,*)'Testing ptperinfo '
      write(3,*)'================='

      level = 1
      status = ptperinfo(ptid, periodid, level, "Time", size)
      if (status .lt. zero) then
         write(*,*)'*********Error unexpected********'
         write(3,*)'*********Error unexpected********'
         call heprnt(0)
      else
         write(*,*)'    status = ptperinfo(ptid, periodid, level,              &
     1"Time", size)'
         write(*,*)'    Status returned by ptperinfo ',status
         write(*,*)'    Size of region in bytes ',size
         write(3,*)'    status = ptperinfo(ptid, periodid, level,              &
     1"Time", size)'
         write(3,*)'    Status returned by ptperinfo ',status
         write(3,*)'    Size of region in bytes ',size
      endif

c Test Case -- ptextper
c
      write(3,27)
      write(*,*)'Testing ptextper '
      write(*,*)'================='
      write(3,*)'Testing ptextper '
      write(3,*)'================='

      status = ptextper(ptid, periodid, level, "Time", dtbuf)
      if (status .lt. zero) then
         write(*,*)'*********Error unexpected********'
         write(3,*)'*********Error unexpected********'
         call heprnt(0)
      else
         write(*,*)'    status = ptextper(ptid, periodid, level,               &
     1"Time", dtbuf)'
         write(*,*)'    Status returned by ptextper ',status
         write(3,*)'    status = ptextper(ptid, periodid, level,               &
     1"Time", dtbuf)'
         write(3,*)'    Status returned by ptextper ',status
     
         do 91 k=1,size/8
            write(*,42) k, dtbuf(k)
            write(3,42) k, dtbuf(k)
   91    continue
   42    format(i2,3x,f10.1)
      endif
     
c Test Case -- ptdefvrtreg
c
      write(3,27)
      write(*,*)'Testing ptdefvrtreg and NCRs 6598 & 8827'
      write(*,*)'========================================='
      write(3,*)'Testing ptdefvrtreg and NCRs 6598 & 8827'
      write(3,*)'========================================='

      range(1)=0.0d0
      range(2)=2.0d0
      regionid=ptdefvrtreg(ptid,HDFE_NOPREVSUB,"Rainfall",range)
      if (regionid .lt. zero) then
         write(*,*)'*********Error unexpected********'
         write(3,*)'*********Error unexpected********'
         call heprnt(0)
      else
         write(*,*)'      regionid=ptdefvrtreg(ptid,HDFE_NOPREVSUB,"Rai        &
     1nfall",range)'
         write(*,*)'      Region ID  returned by ptdefvrtreg ',regionid
         write(3,*)'      regionid=ptdefvrtreg(ptid,HDFE_NOPREVSUB,"Rai        &
     1nfall",range)'
         write(3,*)'      Region ID  returned by ptdefvrtreg ',regionid
      endif

      status=ptreginfo(ptid,regionid,1,"Rainfall",size)
      if (status .lt. zero) then
         write(*,*)'*********Error unexpected********'
         write(3,*)'*********Error unexpected********'
         call heprnt(0)
      else
         write(*,*)'      status=ptreginfo(ptid,regionid,1,"Rainfall",si       &
     1ze)'
         write(*,*)'      Status returned by ptreginfo ',status
         write(*,*)'    Size of region ',size
         write(3,*)'      status=ptreginfo(ptid,regionid,1,"Rainfall",si       &
     1ze)'
         write(3,*)'      Status returned by ptreginfo ',status
         write(3,*)'    Size of region ',size
      endif

      status=ptextreg(ptid,regionid,1,"Rainfall",dtbuff32)
      if (status .lt. zero) then
         write(*,*)'*********Error unexpected********'
         write(3,*)'*********Error unexpected********'
         call heprnt(0)
      else
         write(*,*)'      status=ptextreg(ptid,regionid,1,"Rainfall",dtb       &
     1uff32)'
         write(*,*)'      Status returned by ptreginfo ',status
         write(*,*)'      status=ptextreg(ptid,regionid,1,"Rainfall",dtb       &
     1uff32)'
         write(3,*)'      Status returned by ptreginfo ',status
         write(*,*)'  Data from region'
         write(3,*)'  Data from region'
         do 92 k=1,size/4
            write(*,43) k, dtbuff32(k)
            write(3,43) k, dtbuff32(k)
   92    continue
   43    format(i2,3x,f10.1)
      endif


      status = ptdetach(ptid)
      if (status .lt. zero) then
         write(*,*)'*********Error unexpected********'
         write(3,*)'*********Error unexpected********'
         call heprnt(0)
      else
         write(*,*)'      status = ptdetach(ptid)'
         write(*,*)'      Status returned by ptdetach ',status
         write(3,*)'      status = ptdetach(ptid)'
         write(3,*)'      Status returned by ptdetach ',status
      endif

      status = ptclose(ptfid)
      if (status .lt. zero) then
         write(*,*)'*********Error unexpected********'
         write(3,*)'*********Error unexpected********'
         call heprnt(0)
      else
         write(*,*)'      status = ptclose(ptfid)'
         write(*,*)'      Status returned by ptclose ',status
         write(3,*)'      status = ptclose(ptfid)'
         write(3,*)'      Status returned by ptclose ',status
      endif


      close(unit=3)
   27 format('')
      stop
      end

c
c  In this example we will (1) open the "PointFile" HDF file, (2) attach to
c  the points, and (3) write data to each level of the points.
c 


	program writelevels
	implicit none
	
	integer            status, i, pntr
	integer*2          wgt
	integer*4          ptfid, ptid, n, date

	real*4             rain, temp, conc(4)       
	real*8             lon, lat, time

	character          buffer*10000, id*3, desc*16, spc*8
	character          ctime*8, cconc*16, clon*8, clat*8
	character          cdate*4, crain*4, ctemp*4, cwgt*2
	equivalence        (time,ctime), (conc,cconc), (lon,clon)
	equivalence        (lat,clat), (rain,crain), (temp,ctemp)
	equivalence        (date,cdate), (wgt,cwgt)
	
	integer            ptwrlev, ptdetach, ptclose
	integer*4          ptopen, ptattach


	integer DFACC_RDWR
	parameter (DFACC_RDWR=3)

c
c     Open the HDF point file, "PointFile.hdf".
c

	ptfid = ptopen("PointFile_created_with_hadeos_sample_file_writer
     1_of_HDFEOS2_version_219_or_higher_release.hdf", DFACC_RDWR)


c
c    Write to Simple Point
c
	ptid = ptattach(ptfid, "Simple Point")

	open(unit=1, file='simple.txt', status='OLD')

	n = 0
	pntr = 1
	do 10 i=1,1000
	      
	   read(1, *, end=100)  time, conc(1), conc(2), conc(3), 
     1                            conc(4), spc
	   n = n + 1
	
	   buffer(pntr:pntr+8) = ctime
	   pntr = pntr + 8
	   buffer(pntr:pntr+4*4) = cconc
	   pntr = pntr + 4*4
	   buffer(pntr:pntr+4) = spc
	   pntr = pntr + 4
10	continue

100	close(unit=1)
    
	status = ptwrlev(ptid, 0, n, buffer)
	status = ptdetach(ptid)
    

c
c    Write to Fixed Buoy Point 
c

	ptid = ptattach(ptfid, "FixedBuoy Point")
c
c        Write First (0th) Level
c
	open(unit=1, file='fixedBuoy0.txt', status='OLD')

	n = 0
	pntr = 1
	do 20 i=1,1000
		      
	   read(1, *, end=200)  desc, lon, lat, date, id
	      
	   n = n + 1
	
	   buffer(pntr:pntr+8) = desc
	   pntr = pntr + 8
	   buffer(pntr:pntr+8) = clon
	   pntr = pntr + 8
	   buffer(pntr:pntr+8) = clat
	   pntr = pntr + 8
	   buffer(pntr:pntr+4) = cdate
	   pntr = pntr + 4
	   buffer(pntr:pntr+1) = id
	   pntr = pntr + 1
 20	continue

 200	close(unit=1)

    
	status = ptwrlev(ptid, 0, n, buffer)



c
c      Write Second (1th) Level */
c
	open(unit=1, file='fixedBuoy1.txt', status='OLD')

	n = 0
	pntr = 1
	do 30 i=1,1000

	   read(1, *, end=300) time, rain, temp, id
	   
	   n = n + 1
	   
	   buffer(pntr:pntr+8) = ctime
	   pntr = pntr + 8
	   buffer(pntr:pntr+4) = crain
	   pntr = pntr + 4
	   buffer(pntr:pntr+4) = ctemp
	   pntr = pntr + 4
	   buffer(pntr:pntr+1) = id
	   pntr = pntr + 1
 30	continue
	
 300	close(unit=1)
	  
	status = ptwrlev(ptid, 1, n, buffer)
	  
	status = ptdetach(ptid)
    

c
c    Write to Float Buoy Point 
c

	ptid = ptattach(ptfid, "FloatBuoy Point")

c
c        Write First (0th) Level
c
	open(unit=1, file='floatBuoy0.txt', status='OLD')

	n = 0
	pntr = 1
	do 40 i=1,1000
	      
	   read(1, *, end=400)  desc, date, wgt, id
	   write(*,*) desc,date,wgt,id
	   n = n + 1
	
	   buffer(pntr:pntr+8) = desc
	   pntr = pntr + 8
	   buffer(pntr:pntr+4) = cdate
	   pntr = pntr + 4
	   buffer(pntr:pntr+2) = cwgt
	   pntr = pntr + 2
	   buffer(pntr:pntr+1) = id
	   pntr = pntr + 1
 40	continue

 400	close(unit=1)

    
	status = ptwrlev(ptid, 0, n, buffer)


c
c      Write Second (1th) Level */
c
	open(unit=1, file='floatBuoy1.txt', status='OLD')

	n = 0
	pntr = 1
	do 50 i=1,1000

	   read(1, *, end=500) time, lon, lat, rain, temp, id
	      
	   n = n + 1
	
	   buffer(pntr:pntr+8) = ctime
	   pntr = pntr + 8
	   buffer(pntr:pntr+8) = clon
	   pntr = pntr + 8
	   buffer(pntr:pntr+8) = clat
	   pntr = pntr + 8	      
	   buffer(pntr:pntr+4) = crain
	   pntr = pntr + 4
	   buffer(pntr:pntr+4) = ctemp
	   pntr = pntr + 4
	   buffer(pntr:pntr+1) = id
	   pntr = pntr + 1
 50	continue

 500	close(unit=1)

	status = ptwrlev(ptid, 1, n, buffer)

	status = ptdetach(ptid)
	
 2000	continue
	
	status = ptclose(ptfid)

	stop
	end
	

	program inquiregrid

	integer      status, i, gddetach, gdclose, gdgridinfo
	integer      gdprojinfo
	integer*4    gdfid, gdid1, ndim, nflds, gddiminfo
	integer*4    dims(32), rank(32), ntype(32), gdopen, gdattach
	integer*4    n, strbufsize, gdid2, gdinqdims, gdinqflds
	integer*4    xdimsize, ydimsize, dimsize, projcode,zonecode
	integer*4    spherecode, origincode
    
	real*8       upleftpt(2), lowrightpt(2), projparm(13)
    
	character*72   dimname, fieldlist


	integer DFACC_READ
	parameter (DFACC_READ=1)


	
	gdfid = gdopen('GridFile.hdf', DFACC_READ)

    
	if (gdfid .ne. -1) then

	   gdid1 = gdattach(gdfid, 'UTMGrid')
	   gdid2 = gdattach(gdfid, 'PolarGrid')

	   ndim = gdinqdims(gdid1, dimname, dims)
	   write(*,*) 'Dimension list (UTMGrid): ', dimname
	   do i=1,ndim
	      write(*,*) 'dim size: ', dims(i)
	   enddo
	   
	   ndim = gdinqdims(gdid2, dimname, dims)
	   write(*,*) 'Dimension list (PolarGrid): ', dimname
	   do i=1,ndim
	      write(*,*) 'dim size: ', dims(i)
	   enddo
	   
	   dimsize = gddiminfo(gdid1, 'Time')
	   write(*,*) 'Size of "Time" Array: ', dimsize
	
	   dimsize = gddiminfo(gdid2, 'Bands')
	   write(*,*) 'Size of "Bands" Array: ', dimsize
	
	
	   status = gdgridinfo(gdid1, xdimsize, ydimsize,
     1                  	   upleftpt, lowrightpt)
	   write(*,*) 'X dim size, Y dim size (UTMGrid): ', 
     1 	               xdimsize, ydimsize
	   
	   write(*,*) 'Up left pt (UTMGrid): ', 
     1	               upleftpt(1), upleftpt(2)
	   write(*,*) 'Low right pt (UTMGrid): ', 
     1		       lowrightpt(1), lowrightpt(2)
	   
	   
	   status = gdgridinfo(gdid2, xdimsize, ydimsize,
     1                  	   upleftpt, lowrightpt)
	   write(*,*) 'X dim size, Y dim size (PolarGrid): ', 
     1 	               xdimsize, ydimsize
	   
	   write(*,*) 'Up left pt (PolarGrid): ', 
     1	               upleftpt(1), upleftpt(2)
	   write(*,*) 'Low right pt (PolarGrid): ', 
     1	               lowrightpt(1), lowrightpt(2)

	       
	   status = gdprojinfo(gdid1, projcode, zonecode,
     1	                       spherecode, projparm)
	   write(*,*) 'projcode , zonecode (UTMGrid): ', projcode,
     1	               zonecode
	   write(*,*) 'spherecode (UTMGrid): ', spherecode	

	
	   status = gdprojinfo(gdid2, projcode, zonecode,
     1	                       spherecode, projparm)

	   status = gdprojinfo(gdid2, projcode, zonecode,
     1	                       spherecode, projparm)
	   
	   write(*,*) 'projcode (PolarGrid): ', projcode
	   write(*,*) 'spherecode (PolarGrid): ', spherecode
	   do i=1,13
	      write(*,*) 'Projection Parameter: ',i,projparm(i)
	   enddo
	   

	   nflds = gdinqflds(gdid1, fieldlist, rank, ntype)
	   if (nflds .ne. 0) then
	      write(*,*) 'Data fields (UTMGrid): ', fieldlist
	      do i=1,nflds
		 write(*,*) 'rank type: ',rank(i),ntype(i)
	      enddo
	   endif
	
	
	   nflds = gdinqflds(gdid2, fieldlist, rank, ntype)
	   if (nflds .ne. 0) then
	      write(*,*) 'Data fields (PolarGrid): ', fieldlist
	      do i=1,nflds
		 write(*,*) 'rank type: ',rank(i),ntype(i)
	      enddo
	   endif	
	
	
	   status = gdfldinfo(gdid2, 'Spectra', rank, 
     1	                        dims, ntype, dimname)
	   write(*,*) 'Spectra rank dims: ',rank(1)
	   do i=1,rank(1)
	      write(*,*) 'Spectra dims: ',i,dims(i), dimname
	   enddo
	
C	   n = gdnentries(gdid1, HDFE_NENTDIM, strbufsize)
C	   write(*,*) 'Number of dimension entries (UTMGrid): ', n
C	   write(*,*) 'Length of Dimension List (UTMGrid): ', strbufsize
	   
C	   n = gdnentries(gdid1, HDFE_NENTDFLD, strbufsize)
C	   write(*,*) 'Number of data fields (UTMGrid): ', n
C	   write(*,*) 'Length of Field List (UTMGrid): ', strbufsize
	   
	endif
	
	status = gddetach(gdid1)
	status = gddetach(gdid2)
	status = gdclose(gdfid)

	stop
	end

c
c  In this example we will (1) open the "GridFile" HDF file, (2) attach to
c  the "PolarGrid" grid, and (3) subset data from the "Temperature" field.
c 


	program subsetgrid

	integer            status, gdextreg, gdreginfo, gddetach, gdclose
	integer*4          gdfid, gdid, gdopen, gdattach, dims(8)
	integer*4          rank, ntype, gddefboxreg

	real*8             cornerlon(2), cornerlat(2)
	real*8             upleft(2), lowright(2)
	real*4             datbuf(100*100)
	
	integer DFACC_READ
	parameter (DFACC_READ=1)


c    
c     Open the HDF grid file, "GridFile.hdf"
c 

	gdfid = gdopen("GridFile_created_with_hadeos_sample_file_writer_
     1of_HDFEOS2_version_219_or_higher_release.hdf", DFACC_READ)

	if (gdfid .NE. -1) then

	   gdid = gdattach(gdfid, "PolarGrid")

	   if (gdid .NE. -1) then

	      cornerlon(1) = 0
	      cornerlat(1) = 90.
	      cornerlon(2) = 90
	      cornerlat(2) = 0

	      regionid = gddefboxreg(gdid, cornerlon, cornerlat)
	      
	      status = gdreginfo(gdid, regionid, "Temperature", ntype,
     1	                         rank, dims, size, upleft, lowright)
	      write(*,*) dims(1), dims(2), dims(3), rank, ntype
	      
	      status = gdextreg(gdid, regionid, "Temperature", 
     1	                        datbuf)
	    

	   endif
	
	   status = gddetach(gdid)
	   status = gdclose(gdfid)

	endif
	stop
	end
	

c
c  In this example we will (1) open an HDF file, (2) create the swath
c  interface within the file and (3) define the swath field dimensions.
c

      program setupswath

      integer            status, swdefdim, swdefmap, swdefimap
      integer            swdetach, swclose
      integer*4          swfid, swid, swopen, swcreate
      integer*4          indx(12) /0,1,3,6,7,8,11,12,14,24,32,39/

      integer DFACC_CREATE
      parameter (DFACC_CREATE=4)
      integer SD_UNLIMITED
      parameter (SD_UNLIMITED=0)      

c   
c      We first open the HDF swath file, "SwathFile.hdf".  Because this
c      file does not already exist, we use the DFACC_CREATE access
c      code in the open statement.  The SWopen routine returns the swath
c      file id, swfid, which is used to identify the file in subsequent
c      routines in the library.
c
      swfid = swopen('SwathFile.hdf',DFACC_CREATE)

c    
c     The first of these, SWcreate, creates the swath, "Swath1", within the
c     file designated by the file id, swfid.  It returns the swath id, SWid,
c     which identifies the swath in subsequent routines.  We will show how
c     to define, write and read field swaths in later programs.
c     
      swid = swcreate(swfid, "Swath1")


c    
c     Typically, many fields within a swath share the same dimension. The
c     swath interface therefore provides a way of defining dimensions that
c     will then be used to define swath fields.  A dimension is defined with
c     a name and a size and is connected to the particular swath through the
c     swath id.  In this example, we define the geo- location track and
c     cross track dimensions with size 20 and 10 respectively and two
c     dimensions corresponding to these but with twice the resolution.
c     We also define a dimension corresponding to a number of spectral
c     bands.

      status = swdefdim(swid, "GeoTrack", 20)
      status = swdefdim(swid, "GeoXtrack", 10)

      status = swdefdim(swid, "Res2tr", 40)
      status = swdefdim(swid, "Res2xtr", 20)
      status = swdefdim(swid, "Bands", 15)
      status = swdefdim(swid, "IndxTrack", 12)
      
c     Define Unlimited (appendable) dimension
      status = swdefdim(swid, "Unlim", SD_UNLIMITED)
      
c   
c     Once the dimensions are defined, the relationship (mapping)between the
c     geolocation dimensions, such as track and cross track, and the data
c     dimensions, must be established.  This is done through the SWdefdimmap
c     routine.  It takes as input the swath id, the names of the dimensions
c     designating the geolocation and data dimensions, respectively, and the
c     offset and increment defining the relation.
c     
c     In the first example we relate the "GeoTrack" and "Res2tr" dimensions
c     with an offset of 0 and an increment of 2.  Thus the ith element of
c     "Geotrack" corresponds to the 2 * ith element of "Res2tr".
c   
c     In the second example, the ith element of "GeoXtrack" corresponds to the
c     2 * ith + 1 element of "Res2xtr".
c     

      status = swdefmap(swid, "GeoTrack", "Res2tr", 0, 2)
      status = swdefmap(swid, "GeoXtrack", "Res2xt", 1, 2)

      status = swdefimap(swid, "IndxTrack", "Res2tr", indx)

c    
c     We now close the swath interface with the SWdetach routine.  This step
c     is necessary to properly store the swath information within the file.
c     
      status = swdetach(swid)


c    
c     Finally, we close the swath file using the SWclose routine.  This will
c     release the swath file handles established by SWopen.
c     

      status = swclose(swfid)

      stop
      end

c
c  In this example we will (1) open the "SwathFile" HDF file, (2) attach to
c  the "Swath1" swath, and (3) read data from the "Longitude" field.
c 


	program readfields

	integer            status, swrdfld, swrdattr, swdetach, swclose
	integer            start(2),stride(2),count(2), attr(4)
	integer*4          swfid, swid, swopen, swattach

	real*4         lng(10,20)
	
	integer DFACC_READ
	parameter (DFACC_READ=1)
	

c    
c     Open the HDF swath file, "SwathFile.hdf"
c 

	swfid = swopen("SwathFile_created_with_hadeos_sample_file_write"//
     1"r_of_HDFEOS2_version_219_or_higher_release.hdf", DFACC_READ)


	if (swfid .NE. -1) then

	   swid = swattach(swfid, "Swath1")

	   if (swid .NE. -1) then

	      
c     Read the entire Longitude field

	      start(1) = 0
	      start(2) = 0
	      stride(1) = 1
	      stride(2) = 1
	      count(1) = 10
	      count(2) = 20

	      status = swrdfld(swid, "Longitude", start, stride, count,
     1                         lng)

	      do i=1,20
		 do j=1,10
		    write(*,*)'i j Longitude ',i,j,lng(j,i)
		 enddo
	      enddo


c      Read Attribute	      
	      status = swrdattr(swid, "TestAttr", attr)
	      do i=1,4
		 write(*,*) 'Attribute Element', i, ':', attr(i)
	      enddo
	      
	      
	   endif
	endif
	
	status = swdetach(swid)
	status = swclose(swfid)

	stop
	end

	program readgdflds

	integer       status, gdrdfld, gdrdattr, gddetach, gdclose
	integer*4     gdfid, gdid, gdopen, gdattach
	integer*4     start(2), stride(2), count(2)
	real*4        f32, veg(120,200)
	integer DFACC_RDWR
	parameter (DFACC_RDWR=3)
	integer DFNT_FLOAT32
	parameter (DFNT_FLOAT32=5)

	gdfid = gdopen("GridFile.hdf", DFACC_RDWR)

	if (gdfid .ne. -1) then

	   gdid = gdattach(gdfid, "UTMGrid")

	   if (gdid .ne. -1) then
	
	      start(1) = 0
	      start(2) = 0
	      stride(1) = 1
	      stride(2) = 1
	      count(1) = 120
	      count(2) = 200
	      status = gdrdfld(gdid, "Vegetation", 
     1    	               start, stride, count, veg)
	      
	      

	      status = gdrdattr(gdid, "float32", f32)
	      write(*,*) 'f32: ', f32
	      
	   endif
	endif

	status = gddetach(gdid)
	status = gdclose(gdfid)

	stop
	end

c
c  In this example we will (1) open the "SwathFile" HDF file, (2) attach to
c  the "Swath1" swath, and (3) read data from the "Longitude" field.
c 


	program readfields

	integer            status, swrdfld, swrdattr, swdetach, swclose
	integer            start(2),stride(2),count(2), attr(4)
	integer*4          swfid, swid, swopen, swattach

	real*4         lng(10,20)
	
	integer DFACC_READ
	parameter (DFACC_READ=1)
	

c    
c     Open the HDF swath file, "SwathFile.hdf"
c 

	swfid = swopen("SwathFile_created_with_hadeos_sample_file_writer
     1_of_HDFEOS2_version_219_or_higher_release.hdf", DFACC_READ)


	if (swfid .NE. -1) then

	   swid = swattach(swfid, "Swath1")

	   if (swid .NE. -1) then

	      
c     Read the entire Longitude field

	      start(1) = 0
	      start(2) = 0
	      stride(1) = 1
	      stride(2) = 1
	      count(1) = 10
	      count(2) = 20

	      status = swrdfld(swid, "Longitude", start, stride, count,
     1                         lng)

	      do i=1,20
		 do j=1,10
		    write(*,*)'i j Longitude ',i,j,lng(j,i)
		 enddo
	      enddo


c      Read Attribute	      
	      status = swrdattr(swid, "TestAttr", attr)
	      do i=1,4
		 write(*,*) 'Attribute Element', i, ':', attr(i)
	      enddo
	      
	      
	   endif
	endif
	
	status = swdetach(swid)
	status = swclose(swfid)

	stop
	end

	
!/*
! * In this example we will (1) open the "SwathFile" HDF file, (2) attach to
! * the "swid" swath, and (3) set dimension scale for a dimension in a filed.
! */

	program writedimscaleswath

	integer       j, status, swdetach, swclose
	integer*4     swfid, swid, swopen, swattach
	integer*4     swsetdimscale, swsetdimstrs
	real*8        BuffGeoTrack(20)
	real*4        BuffGeoTrack2(10)
	integer*4     GTdim,GTdim1,GTdim2,GTdim3
	integer*4     bands(15)
	integer*4     IBuffGeoTrack(40)
	integer*4     IBuffGeoTrack2(20)
	integer DFACC_RDWR
	parameter (DFACC_RDWR=3)
	integer DFNT_FLOAT32
	parameter (DFNT_FLOAT32=5)
	integer DFNT_FLOAT64
	parameter (DFNT_FLOAT64=6)
	integer DFNT_INT32
	parameter (DFNT_INT32=24)

!    /*
!     * We first open the HDF swath file, "SwathFile.hdf".  Because this file
!     * already exist and we wish to write to it, we use the DFACC_RDWR access
!     * code in the open statement.  The swopen routine returns the swath file
!     * id, swfid, which is used to identify the file in subsequent routines.
!     */

	swfid = swopen("SwathFile_created_with_hadeos_sample_file_write
     1r_of_HDFEOS2_version_219_or_higher_release.hdf", DFACC_RDWR)

!    /*
!     * If the swath file cannot be found, swopen will return -1 for the file
!     * handle (swfid).  We there check that this is not the case before
!     * proceeding with the other routines.
!     * 
!     * The swattach routine returns the handle to the existing swath "swid",
!     * swid.  If the swath is not found, swattach returns -1 for the handle.
!     */
	      write(*,*) '=================================='
	if (swfid .ne. -1) then

!	/* the field Density has GeoTrack dimensions.
!	   the field Spectra has Res2xtr,Res2tr,Bands dimensions.
!	   see setupswath.f and defineflds.f
!	   nbands = 15;
!	   GeoTrack = 20;
!	*/
	  swid = swattach(swfid, "Swath1")
	  
	  if (swid .ne. -1) then
	    GTdim = 20
	    GTdim1 = 40
	    GTdim2 = 20
	    GTdim3 = 10
	    
	    do j=1,GTdim1
	       IBuffGeoTrack(j) = j
	    enddo
	    do j=1,GTdim
	       BuffGeoTrack(j) = j*2.5
	    enddo
	    status = swsetdimscale(swid,"Pressure","Res2tr",GTdim1,
     1	    DFNT_INT32, IBuffGeoTrack)
	    write(*,*) 'status swsetdimscale:Pressure:Res2tr=',status
	    status = swsetdimstrs(swid, "Pressure", "Res2tr", 
     1	    "Res2tr", "degrees", "I2")
	     
	     
	    status = swsetdimscale(swid,"Pressure","Res2xtr",GTdim2,
     1	    DFNT_INT32, IBuffGeoTrack2)
	    write(*,*) 'status swsetdimscale:Pressure:Res2xtr=',status

	    status = swsetdimscale(swid,"Density","GeoTrack",GTdim,
     1	    DFNT_FLOAT64, BuffGeoTrack)
	    write(*,*) 'status swsetdimscale:Density=',status,
     1      '    Error expected. Field is 1-dimensional'
	    
	    status = swsetdimscale(swid,"Temperature","GeoTrack",GTdim,
     1	    DFNT_FLOAT64, BuffGeoTrack)
	    write(*,*) 'status swsetdimscale:Temperature:GeoTrack=',
     1	    status
	    status = swsetdimstrs(swid, "Temperature", "GeoTrack", 
     1	    "GeoTrack", "degrees", "F7.2")
	    write(*,*) 'status swsetdimstrs:Temperature:GeoTrack=',
     1      status
	    
	    status = swsetdimscale(swid, "Temperature", "GeoXtrack",
     1	    GTdim3,DFNT_FLAOT32, BuffGeoTrack2)
	    write(*,*) 'status swsetdimscale:Temperature:GeoXtrack=',
     1	    status
	    
	    nbands = 15;
	    do j=1,nbands
	       bands(j) = j*2+1
	    enddo
	    status = swsetdimscale(swid, "Spectra", "Bands", nbands, 
     1	    DFNT_INT32, bands);
	    write(*,*) 'status swsetdimscale:Spectra =',status
	    
	    status = swsetdimstrs(swid, "Spectra", "Bands", "BANDS", 
     1	    "None", "I2")
	    
	    status = swdetach(swid)
	 endif
	 status = swclose(swfid)
	endif
	
	stop
	end
	

	program updatelevels

	integer            ptuplev, ptdetach, ptclose, ptgetrecnums
	integer*4          ptfid, ptid1, ptid2
	integer*4          recs(32), inlevel, outlevel
	integer*4          ptopen, ptattach
	integer*4          outrecs(32), outnrec
	real*8             f64
	
	character          datbuf*256, c8*8
	equivalence        (f64,c8)
	
	integer DFACC_RDWR
	parameter (DFACC_RDWR=3)

c
c     Open the HDF point file, "PointFile.hdf".
c

	ptfid = ptopen("PointFile_created_with_hadeos_sample_file_write"//
     1"r_of_HDFEOS2_version_219_or_higher_release.hdf", DFACC_RDWR)

	ptid1 = ptattach(ptfid, "Simple Point")
	ptid2 = ptattach(ptfid, "FixedBuoy Point")

	f64 = 43.2
	datbuf(1:8) = c8
	recs(1) = 1
	
	status = ptuplev(ptid2, 0, "Longitude", 1, recs, datbuf)


	datbuf(1:1) = 'F'
	recs(1) = 0
	status = ptuplev(ptid2, 0, "ID", 1, recs, datbuf)
	    
	inlevel = 0
	outlevel = 1
	nrec = 1
	status = ptgetrecnums(ptid2, inlevel, outlevel, nrec, recs, 
     1			      outnrec, outrecs)

	
	do 10 i=1,outnrec
		datbuf(i:i) = 'F'
 10	continue

	status = ptuplev(ptid2, outlevel, "ID", outnrec, outrecs, datbuf)

	status = ptdetach(ptid1)
	status = ptdetach(ptid2)
	
	status = ptclose(ptfid)
	
	stop
	end

c
c  In this example we will open an HDF file and create UTM and Polar
c  Stereographic grid structures within the file.
c

      program setupgrid

      integer            status, gddefdim
      integer            gddetach, gdclose
      integer*4          gdfid, gdid, gdid2, gdid3, gdopen, gdcreate
      integer*4          xdim, ydim
      integer*4          zonecode, spherecode
      real*8             uplft(2), lowrgt(2), projparm(16), ehconvang

      integer DFACC_CREATE
      parameter (DFACC_CREATE=4)
      integer SD_UNLIMITED
      parameter (SD_UNLIMITED=0)      
      integer GCTP_UTM
      parameter (GCTP_UTM=1)
      integer GCTP_PS
      parameter (GCTP_PS=6)      
      integer GCTP_GEO
      parameter (GCTP_GEO=0)      
      integer HDFE_GD_LR
      parameter (HDFE_GD_LR=3)      
      integer HDFE_DEG_DMS
      parameter (HDFE_DEG_DMS=3)      
      
c   
c      We first open the HDF grid file, "GridFile.hdf".  Because this
c      file does not already exist, we use the DFACC_CREATE access
c      code in the open statement.  The GDopen routine returns the grid
c      file id, gdfid, which is used to identify the file in subsequent
c      routines in the library.
c
      gdfid = gdopen('GridFile_created_with_hadeos_sample_file_writer_of
     1_HDFEOS2_version_219_or_higher_release.hdf',DFACC_CREATE)

c    
c     Create UTM Grid
c     

c     Region is bounded by 54 E and 60 E longitude and 20 N and 30 N latitude.
c     UTM Zone 40
c 
c     Use default spheriod (Clarke 1866 - spherecode = 0)
c 
c     Grid into 120 bins along x-axis and 200 bins along y-axis
c                   (approx 3' by 3' bins)


      zonecode = 40
      spherecode = 0

c    Upper Left and Lower Right points in meters
c    -------------------------------------------
      uplft(1) =   210584.50041
      uplft(2) =  3322395.95445
      lowrgt(1) =  813931.10959
      lowrgt(2) = 2214162.53278

      xdim = 120
      ydim = 200
    
      gdid = gdcreate(gdfid, "UTMGrid", xdim, ydim, uplft, lowrgt)
      status = gddefproj(gdid, GCTP_UTM, zonecode, 
     1                   spherecode, projparm)
    
c    Define "Time" Dimension
      status = gddefdim(gdid, "Time", 10)



c   
c     Create polar stereographic grid
c     
c     Northern Hemisphere  (True Scale at 90 N, 0 Longitude below pole)
c     
c     Use International 1967 spheriod (spherecode = 3)
c     
c     Grid into 100 bins along x-axis and y-axis
c
      
      xdim = 100
      ydim = 100
      
      spherecode = 3

c     Define GCTP Projection Parameters
c     ---------------------------------
      do i=1,16
         projparm(i) = 0
      enddo
      
c     Set Longitude below pole & true scale in DDDMMMSSS.SSS format)
      projparm(5) = 0.0
      projparm(6) = 90000000.00

c     Use default boundaries for Polar Stereographic (hemisphere)
      uplft(1) =   0
      uplft(2) =   0
      lowrgt(1) =  0
      lowrgt(2) =  0
      
      gdid2 = gdcreate(gdfid, "PolarGrid", xdim, ydim, uplft, lowrgt)
      status = gddefproj(gdid2, GCTP_PS, 0, spherecode, projparm)
      status = gddeforigin(gdid2, HDFE_GD_LR)
      
c     Define "Bands" Dimension
      status = gddefdim(gdid2, "Bands", 3)

      
      
c
c     Create geographic (linear scale) grid
c
c     0 - 15 degrees longitude,  20 - 30 degrees latitude
c
      xdim = 60
      ydim = 40

      uplft(1) = ehconvAng(0.d0, HDFE_DEG_DMS)
      uplft(2) = ehconvAng(30.d0, HDFE_DEG_DMS)
      lowrgt(1) = ehconvAng(15.d0, HDFE_DEG_DMS)
      lowrgt(2) = ehconvAng(20.d0, HDFE_DEG_DMS)
      
      gdid3 = gdcreate(gdfid, "GEOGrid", xdim, ydim, uplft, lowrgt)
      status = gddefproj(gdid3, GCTP_GEO, 0, 0, 0)
      
      
c
c     We now close the grid interface with the GDdetach routine.  This step
c     is necessary to properly store the grid information within the file
c     AND SHOULD BE DONE BEFORE WRITING OR READING DATA TO OR FROM THE FIELD.
c

      status = gddetach(gdid)
      status = gddetach(gdid2)
      status = gddetach(gdid3)


c    
c     Finally, we close the grid file using the gdclose routine.  This will
c     release the grid file handles established by gdopen.
c     

      status = gdclose(gdfid)

      stop
      end

!/*
! * In this example we will (1) open the "GridFile" HDF file, (2) attach to
! * the "gdid" grid, and (3) set dimension scale for a dimension in a filed.
! */

	program readdimscalegrid
	
	integer       j, status, gddetach, gdclose
	integer*4     gdfid, gdid1, gdid2, gdopen, gdattach
	integer*4     gdgetdimscale, gdgetdimstrs
	real*8        veg1(120),veg2(200)
	real*8        temp1(100),temp2(100)
	integer*4     bands(3)
	integer*4     xdimsize, ydimsize,dimsize
	integer*4     xdimsize1, ydimsize1,dimsize1
	real*8        upleftpt(2), lowrightpt(2)
	integer*4     ntype(32)
	character*16  label, unit, format
	integer*4     len
	integer*4     nbands
	integer DFACC_RDWR
	parameter (DFACC_RDWR=3)
	integer DFNT_FLOAT32
	parameter (DFNT_FLOAT32=5)
	integer DFNT_FLOAT64
	parameter (DFNT_FLOAT64=6)
	integer DFNT_INT32
	parameter (DFNT_INT32=24)

!    /*
!     * We first open the HDF grid file, "GridFile.hdf".  Because this file
!     * already exist and we wish to write to it, we use the DFACC_RDWR access
!     * code in the open statement.  The gdopen routine returns the grid file
!     * id, gdfid, which is used to identify the file in subsequent routines.
!     */

	gdfid = gdopen("GridFile_created_with_hadeos_sample_file_writer_
     1of_HDFEOS2_version_219_or_higher_release.hdf", DFACC_RDWR)

!    /*
!     * If the grid file cannot be found, gdopen will return -1 for the file
!     * handle (gdfid).  We there check that this is not the case before
!     * proceeding with the other routines.
!     * 
!     * The GDattach routine returns the handle to the existing grid "gdid",
!     * gdid.  If the grid is not found, gdattach returns -1 for the handle.
!     */	
	if (gdfid .ne. -1) then
	   
	   gdid1 = gdattach(gdfid, "UTMGrid")
	   
	   if (gdid1 .ne. -1) then
	      
	      status = gdgridinfo(gdid1, xdimsize, ydimsize,
     1	      upleftpt, lowrightpt)
	      
	      write(*,*) 'X dim size, Y dim size (PolarGrid): ', 
     1	      xdimsize, ydimsize
	      write(*,*) 'Up left pt (UTMGrid): ', 
     1	      upleftpt(1), upleftpt(2)
	      write(*,*) 'Low right pt (UTMGrid): ', 
     1	      lowrightpt(1), lowrightpt(2)
	      
	      buffsize = gdgetdimscale(gdid1, "Vegetation",
     1         "XDim", xdimsize1, ntype,veg1)
	      if (buffsize .eq. -1) then	   
		 write(*,*) 'Error:Cannot get Dim Scale for XDim',
     1                      ' in field Vegetation'
		 stop  
	      else
		 write(*,*) 'For Vegetation field XDim: xdimsize1 = ', 
     1                      xdimsize1
		 write(*,*) 'For Vegetation field XDim: buffsize = ', 
     1                      buffsize
	      endif
	      
	      write(*,*) 'First 10 elements for Vegetation field XDim',
     1                   ' dimension scale values:'
	      do j=1,10
		 write(*,*) 'j =',j,'         veg1 = ',veg1(j)
	      enddo
	      write(*,*) '  '
	      
	      buffsize = gdgetdimscale(gdid1, "Vegetation", "YDim",
     1                                  ydimsize1,ntype,veg2)
	      if (buffsize .eq. -1) then	   
		 write(*,*) 'Error:Cannot get Dim Scale for YDim',
     1                      ' in field Vegetation"'
		 stop  
	      else
		 write(*,*) 'For Vegetation field YDim: ydimsize1 = ', 
     1                      ydimsize1
		 write(*,*) 'For Vegetation field YDim: buffsize = ', 
     1                      buffsize
	      endif
	      
	      write(*,*) 'First 10 elements for Vegetation field YDim',
     1                   ' dimension scale values:'
	      do j=1,10
		 write(*,*) 'j =',j,'         veg2 = ',veg2(j)
	      enddo
	      write(*,*) '  '
	      label = ''
	      unit = ''
	      format = ''
	      len = 15
	      status = gdgetdimstrs(gdid1, "Vegetation", "YDim", 
     1	      label, unit, format, len)
	      
	      
	      if(status .eq. 0) then	  
		 write(*,*) 'For Vegetation field YDim',
     1                      ' dimension scale attr. strings:'
		 write(*,*) 'label =',label,'  unit =',
     1                      unit,'  format = ',format
	      endif
	      write(*,*) ' '
	      status = gddetach(gdid1)
	   endif

	   gdid2 = gdattach(gdfid, "PolarGrid")
	   if (gdid2 .ne. -1) then
	      
!	/* we should get
!       ydim = 100	
!       nbands = 3;	
!	*/		
!        /* get YDim */	
	   
	      status = gdgridinfo(gdid2, xdimsize, ydimsize,
     1	      upleftpt, lowrightpt)
	      
	      write(*,*) 'X dim size, Y dim size (PolarGrid): ', 
     1	      xdimsize, ydimsize
	      write(*,*) 'Up left pt (PolarGrid): ', 
     1	      upleftpt(1), upleftpt(2)
	      write(*,*) 'Low right pt (PolarGrid): ', 
     1	      lowrightpt(1), lowrightpt(2)
	      
	      buffsize = gdgetdimscale(gdid2, "Spectra", "YDim",
     1	                               ydimsize1,ntype, temp2)
	      if (buffsize .eq. -1) then	   
		 write(*,*) 'Error:Cannot get Dim Scale for YDim',
     1                      ' in field Spectra'
		 stop  
	      else
		 write(*,*) 'For Spectra field YDim: ydimsize1 = ', 
     1                      ydimsize1
		 write(*,*) 'For Spectra field YDim: buffsize = ', 
     1                       buffsize
	      endif
	      
	      write(*,*) 'First 10 elements for Spectra field YDim',
     1                   ' dimension scale values:'
	      do j=1,10
		 write(*,*) 'j =',j,'         temp2 = ',temp2(j)
	      enddo
	      write(*,*) '  '
	      
!	/* get str attributes */
	      len = 15
	      status = gdgetdimstrs(gdid2, "Spectra", "YDim", 
     1	      label, unit, format, len)
	      
	      
	      if(status .eq. 0) then	  
		 write(*,*) 'For Spectra field YDim',
     1                      ' dimension scale attr. strings:'
		 write(*,*) 'label =',label,'  unit =',
     1                      unit,'  format = ',format
	      endif
	      write(*,*) ' '
	      
	      dimsize = gddiminfo(gdid2, "Bands");
	      status = gdgetdimscale(gdid2, "Spectra", "Bands", 
     1                               nbands,ntype, bands)
	      write(*,*) 'For Spectra field Bands: nbands = ', 
     1	                  nbands
	      write(*,*) 'For Spectra field Bands',
     1	                 'dimension scale values:'

	      do j=1,nbands
		 write(*,*) 'j =',j,'         Bnads = ',bands(j)
	      enddo
	      write(*,*) '  '
	      
	      status = gdgetdimstrs(gdid2, "Spectra", "Bands", 
     1	      label, unit, format, len)
	      
	      if(status .eq. 0) then
		 write(*,*) 'For Spectra field Bands',
     1                      ' dimension scale attr. strings:'
		 write(*,*) 'label =',label,'  unit =',
     1                      unit,'  format = ',format
	      endif
	      
	      status = gddetach(gdid2)
	   endif
	   status = gdclose(gdfid)
	endif
	stop
	end

c
c  In this example we will (1) open an HDF file, and (2) create three point
c  interfaces within the file.
c

      program setuppoint

      integer*4          ptfid, ptid1, ptid2, ptid3, ptdetach, ptclose
      integer*4          ptopen, ptcreate
      
      integer DFACC_CREATE
      parameter (DFACC_CREATE=4)

c   
c      We first open the HDF swath point, "PointFile.hdf".  Because this
c      file does not already exist, we use the DFACC_CREATE access
c      code in the open statement.  The ehopen routine returns the point
c      file id, ptfid, which is used to identify the file in subsequent
c      routines in the library.
c
      ptfid = ptopen("PointFile_created_with_hadeos_sample_file_writer_o
     1f_HDFEOS2_version_219_or_higher_release.hdf", DFACC_CREATE)


      ptid1 = ptcreate(ptfid, "Simple Point")
      ptid2 = ptcreate(ptfid, "FixedBuoy Point")
      ptid3 = ptcreate(ptfid, "FloatBuoy Point")

c    
c     We now close the point interface with the ptdetach routine.  This step
c     is necessary to properly store the point information within the file.
c     

      status = ptdetach(ptid1)
      status = ptdetach(ptid2)
      status = ptdetach(ptid3)

c    
c     Finally, we close the point file using the ehclose routine.  This will
c     release the point file handles established by ptopen.
c     

      status = ptclose(ptfid)

      stop
      end

c
c  In this example we will open an HDF file and create UTM and Polar
c  Stereographic grid structures within the file.
c

      program setupgrid

      integer            status, gddefdim
      integer            gddetach, gdclose
      integer*4          gdfid, gdid, gdid2, gdid3, gdopen, gdcreate
      integer*4          xdim, ydim
      integer*4          zonecode, spherecode
      real*8             uplft(2), lowrgt(2), projparm(16), ehconvang

      integer DFACC_CREATE
      parameter (DFACC_CREATE=4)
      integer SD_UNLIMITED
      parameter (SD_UNLIMITED=0)      
      integer GCTP_UTM
      parameter (GCTP_UTM=1)
      integer GCTP_PS
      parameter (GCTP_PS=6)      
      integer GCTP_GEO
      parameter (GCTP_GEO=0)      
      integer HDFE_GD_LR
      parameter (HDFE_GD_LR=3)      
      integer HDFE_DEG_DMS
      parameter (HDFE_DEG_DMS=3)      
      
c   
c      We first open the HDF grid file, "GridFile.hdf".  Because this
c      file does not already exist, we use the DFACC_CREATE access
c      code in the open statement.  The GDopen routine returns the grid
c      file id, gdfid, which is used to identify the file in subsequent
c      routines in the library.
c
      gdfid = gdopen("GridFile_created_with_hadeos_sample_file_write"//
     1"r_of_HDFEOS2_version_219_or_higher_release.hdf",DFACC_CREATE)

c    
c     Create UTM Grid
c     

c     Region is bounded by 54 E and 60 E longitude and 20 N and 30 N latitude.
c     UTM Zone 40
c 
c     Use default spheriod (Clarke 1866 - spherecode = 0)
c 
c     Grid into 120 bins along x-axis and 200 bins along y-axis
c                   (approx 3' by 3' bins)


      zonecode = 40
      spherecode = 0

c    Upper Left and Lower Right points in meters
c    -------------------------------------------
      uplft(1) =   210584.50041
      uplft(2) =  3322395.95445
      lowrgt(1) =  813931.10959
      lowrgt(2) = 2214162.53278

      xdim = 120
      ydim = 200
    
      gdid = gdcreate(gdfid, "UTMGrid", xdim, ydim, uplft, lowrgt)
      status = gddefproj(gdid, GCTP_UTM, zonecode, 
     1                   spherecode, projparm)
    
c    Define "Time" Dimension
      status = gddefdim(gdid, "Time", 10)



c   
c     Create polar stereographic grid
c     
c     Northern Hemisphere  (True Scale at 90 N, 0 Longitude below pole)
c     
c     Use International 1967 spheriod (spherecode = 3)
c     
c     Grid into 100 bins along x-axis and y-axis
c
      
      xdim = 100
      ydim = 100
      
      spherecode = 3

c     Define GCTP Projection Parameters
c     ---------------------------------
      do i=1,16
         projparm(i) = 0
      enddo
      
c     Set Longitude below pole & true scale in DDDMMMSSS.SSS format)
      projparm(5) = 0.0
      projparm(6) = 90000000.00

c     Use default boundaries for Polar Stereographic (hemisphere)
      uplft(1) =   0
      uplft(2) =   0
      lowrgt(1) =  0
      lowrgt(2) =  0
      
      gdid2 = gdcreate(gdfid, "PolarGrid", xdim, ydim, uplft, lowrgt)
      status = gddefproj(gdid2, GCTP_PS, 0, spherecode, projparm)
      status = gddeforigin(gdid2, HDFE_GD_LR)
      
c     Define "Bands" Dimension
      status = gddefdim(gdid2, "Bands", 3)

      
      
c
c     Create geographic (linear scale) grid
c
c     0 - 15 degrees longitude,  20 - 30 degrees latitude
c
      xdim = 60
      ydim = 40

      uplft(1) = ehconvAng(0.d0, HDFE_DEG_DMS)
      uplft(2) = ehconvAng(30.d0, HDFE_DEG_DMS)
      lowrgt(1) = ehconvAng(15.d0, HDFE_DEG_DMS)
      lowrgt(2) = ehconvAng(20.d0, HDFE_DEG_DMS)
      
      gdid3 = gdcreate(gdfid, "GEOGrid", xdim, ydim, uplft, lowrgt)
      status = gddefproj(gdid3, GCTP_GEO, 0, 0, 0)
      
      
c
c     We now close the grid interface with the GDdetach routine.  This step
c     is necessary to properly store the grid information within the file
c     AND SHOULD BE DONE BEFORE WRITING OR READING DATA TO OR FROM THE FIELD.
c

      status = gddetach(gdid)
      status = gddetach(gdid2)
      status = gddetach(gdid3)


c    
c     Finally, we close the grid file using the gdclose routine.  This will
c     release the grid file handles established by gdopen.
c     

      status = gdclose(gdfid)

      stop
      end

c
c	In this example we will (1) open the "SwathFile" HDF file, (2)
c	attach to
c	the "Swath1" swath, and (3) define the swath fields.
c
	program definefields

	integer            status, swdefgfld, swdefdfld, swdetach, swclose
	integer*4          swfid, swid, swopen, swattach

	integer  DFACC_RDWR
	parameter (DFACC_RDWR=3)
	integer  DFNT_INT16, DFNT_FLOAT32, DFNT_FLOAT64
	parameter (DFNT_INT16=22)
	parameter (DFNT_FLOAT32=5)	
	parameter (DFNT_FLOAT64=6)
	integer*4 HDFE_NOMERGE, HDFE_AUTOMERGE
	parameter (HDFE_NOMERGE=0)
	parameter (HDFE_AUTOMERGE=1)
c
c	We first open the HDF swath file, "SwathFile.hdf".  Because this
c	file already exist and we wish to write to it, we use the
c	DFACC_RDWR accesscode in the open statement.  The SWopen
c	routine returns the swath fileid, swfid, which is used to
c	identify the file in subsequent routines.

	swfid = swopen("SwathFile.hdf", DFACC_RDWR)


c
c	If the swath file cannot be found, SWopen will return -1 for the
c	filehandle (swfid).  We there check that this is not the
c       case becforeproceeding with the other routines.  The SWattach
c	routine returns the handle to the existing swath "Swath1", swid.
c	If the swath is not found, SWattach returns -1 for
c	the handle.
c

	if (swfid .NE. -1) then

	   swid = swattach(swfid, "Swath1")

	   if (swid .NE. -1) then

c
c	     We define six fields.  The first three, "Time", "Longitude"
c	     and "Latitude" are geolocation fields and thus we use the
c	     geolocation dimensions "GeoTrack" and "GeoXtrack" in the field
c	     definitions.  We also must specify the data type using the
c	     standard HDF data type codes.  In this example the geolocation
c	     are 4-byte (32 bit) floating point numbers.
c	     
c	     The next three fields are data fields.  Note that either
c	     geolocation or data dimensions can be used.  If an error
c            occurs during the definition, such as a dimension that cannot
c	     be found, then the return status will be set to -1.
c

	      status = swdefgfld(swid, "Time", "GeoTrack", DFNT_FLOAT64,
     1                           HDFE_NOMERGE)

	      status = swdefgfld(swid, "Longitude", "GeoXtrack,GeoTrack",
     1	                         DFNT_FLOAT32, HDFE_AUTOMERGE)

	      status = swdefgfld(swid, "Latitude", "GeoXtrack,GeoTrack",
     1                           DFNT_FLOAT32, HDFE_AUTOMERGE)

	      status = swdefdfld(swid, "Density", "GeoTrack",
     1                           DFNT_FLOAT32, HDFE_NOMERGE)

	      status = swdefdfld(swid, "Temperature", 
     1	                         "GeoXtrack,GeoTrack", DFNT_FLOAT32,
     2                           HDFE_NOMERGE)	      
	      
	      status = swdefdfld(swid, "Pressure", "Res2xtr,Res2tr",
     1                           DFNT_FLOAT64, HDFE_NOMERGE)
	      
	      status = swdefdfld(swid, "Spectra", "Res2xtr,Res2tr,Bands",
     1                           DFNT_FLOAT64, HDFE_NOMERGE)	      


c       Define Appendable Field
	      status = swdefdfld(swid, "Count", "Unlim",
     1                           DFNT_INT16, HDFE_NOMERGE)	      

	      endif

	   endif

	   status = swdetach(swid)
	   status = swclose(swfid)

	   stop
	   end

c
c  In this example we will (1) open an HDF file, and (2) create three point
c  interfaces within the file.
c

      program setuppoint

      integer*4          ptfid, ptid1, ptid2, ptid3, ptdetach, ptclose
      integer*4          ptopen, ptcreate
      
      integer DFACC_CREATE
      parameter (DFACC_CREATE=4)

c   
c      We first open the HDF swath point, "PointFile.hdf".  Because this
c      file does not already exist, we use the DFACC_CREATE access
c      code in the open statement.  The ehopen routine returns the point
c      file id, ptfid, which is used to identify the file in subsequent
c      routines in the library.
c
      ptfid = ptopen("PointFile_created_with_hadeos_sample_file_write"//
     1"r_of_HDFEOS2_version_219_or_higher_release.hdf", DFACC_CREATE)


      ptid1 = ptcreate(ptfid, "Simple Point")
      ptid2 = ptcreate(ptfid, "FixedBuoy Point")
      ptid3 = ptcreate(ptfid, "FloatBuoy Point")

c    
c     We now close the point interface with the ptdetach routine.  This step
c     is necessary to properly store the point information within the file.
c     

      status = ptdetach(ptid1)
      status = ptdetach(ptid2)
      status = ptdetach(ptid3)

c    
c     Finally, we close the point file using the ehclose routine.  This will
c     release the point file handles established by ptopen.
c     

      status = ptclose(ptfid)

      stop
      end

c
c  In this example we will (1) open the "SwathFile" HDF file, (2) attach to
c  the "Swath1" swath, and (3) subset data from the "Spectra" field.
c 


	program subsetswath

	integer            status, swextreg, swreginfo, swdetach
	integer            swextper, swperinfo, swclose
	
	integer*4          swfid, swid, swopen, swattach, dims(8)
	integer*4          rank, ntype, size, swdefboxreg, swdeftmeper
	integer*4          regionid, periodid

	real*8             cornerlon(2), cornerlat(2)
	real*8             datbuf(40,20,15), tmebuf(20)
	
	integer DFACC_READ
	parameter (DFACC_READ=1)
	integer HDFE_MIDPOINT
	parameter (HDFE_MIDPOINT=0)
	integer HDFE_INTERNAL
	parameter (HDFE_INTERNAL=0)


c    
c     Open the HDF swath file, "SwathFile.hdf"
c 

	swfid = swopen("SwathFile_created_with_hadeos_sample_file_write"//
     1"r_of_HDFEOS2_version_219_or_higher_release.hdf", DFACC_READ)

	if (swfid .NE. -1) then

	   swid = swattach(swfid, "Swath1")

	   if (swid .NE. -1) then
	      cornerlon(1) = 3.
	      cornerlat(1) = 5.
	      cornerlon(2) = 7.
	      cornerlat(2) = 12.

	      regionid = swdefboxreg(swid, cornerlon, cornerlat,
     1	                             HDFE_MIDPOINT)
	      write(*,*) regionid,swid
	      
	      status = swreginfo(swid, regionid, "Spectra", ntype,
     1	                         rank, dims, size)
	      write(*,*) dims(1), dims(2), dims(3), rank, ntype, size
	      
	      status = swextreg(swid, regionid, "Spectra", 
     1	                HDFE_INTERNAL, datbuf)

	      
c             Time Subsetting	      
	      periodid = swdeftmeper(swid, 35232487.2d0, 36609898.1d0,
     1	                             HDFE_MIDPOINT)
	      write(*,*) 'Time Subset: ', periodid,swid
	      
	      status = swperinfo(swid, periodid, "Time", ntype,
     1	                         rank, dims, size)
	      write(*,*) 'Time Subset: ', rank, dims(1), size
	      
	      status = swextper(swid, periodid, "Time", 
     1	                        HDFE_INTERNAL, tmebuf)
	      
	      do 10 i=1,size/8
		 write(*,*) i, tmebuf(i)
 10		 continue

	   endif
	
	   status = swdetach(swid)
	   status = swclose(swfid)

	endif
	stop
	end
	

	program definegdflds

	integer            status, gddeffld, gdsetfill, gdwrmeta
	integer            gddetach, gdclose
	integer*4          gdfid, gdid1, gdid2, gdopen, gdattach
    
	real*4             fillval1, fillval2
	
	integer DFACC_RDWR
	parameter (DFACC_RDWR=3)
	integer DFNT_FLOAT32
	parameter (DFNT_FLOAT32=5)
	integer DFNT_FLOAT64
	parameter (DFNT_FLOAT64=6)
	integer HDFE_NOMERGE
	parameter (HDFE_NOMERGE=0)
	integer HDFE_AUTOMERGE
	parameter (HDFE_AUTOMERGE=1)

	fillval1=-7.0
	fillval2=-9999.0

	gdfid = gdopen("GridFile.hdf", DFACC_RDWR)


	gdid1 = gdattach(gdfid, "UTMGrid")

	status = gddeffld(gdid1, "Pollution", "XDim,YDim,Time",
     1			    DFNT_FLOAT32, HDFE_NOMERGE)
	
	status = gddeffld(gdid1, "Vegetation", "XDim,YDim",
     1			    DFNT_FLOAT32, HDFE_NOMERGE)

	status = gdwrmeta(gdid1, "Extern", "XDim,YDim",
     1				  DFNT_FLOAT32)

	status = gdsetfill(gdid1, "Pollution", fillval1)
     1	

	

	gdid2 = gdattach(gdfid, "PolarGrid")

	status = gddeffld(gdid2, "Temperature", "XDim,YDim",
     1			    DFNT_FLOAT32, HDFE_AUTOMERGE)

	status = gddeffld(gdid2, "Pressure", "XDim,YDim",
     1			    DFNT_FLOAT32, HDFE_AUTOMERGE)

	status = gddeffld(gdid2, "Soil Dryness", "XDim,YDim",
     1				DFNT_FLOAT32, HDFE_NOMERGE)

	status = gddeffld(gdid2, "Spectra", "XDim,YDim,Bands",
     1			    DFNT_FLOAT64, HDFE_AUTOMERGE)

	status = gdsetfill(gdid2, "Pressure", fillval2)

	status = gddetach(gdid1)
	status = gddetach(gdid2)


	status = gdclose(gdfid)

	stop
	end

	program inquiregrid

	integer      status, i, gddetach, gdclose, gdgridinfo
	integer      gdprojinfo
	integer*4    gdfid, gdid1, ndim, nflds, gddiminfo
	integer*4    dims(32), rank(32), ntype(32), gdopen, gdattach
	integer*4    n, strbufsize, gdid2, gdinqdims, gdinqflds
	integer*4    xdimsize, ydimsize, dimsize, projcode,zonecode
	integer*4    spherecode, origincode
    
	real*8       upleftpt(2), lowrightpt(2), projparm(13)
    
	character*72   dimname, fieldlist


	integer DFACC_READ
	parameter (DFACC_READ=1)


	
	gdfid = gdopen("GridFile_created_with_hadeos_sample_file_write"//
     1"r_of_HDFEOS2_version_219_or_higher_release.hdf", DFACC_READ)

    
	if (gdfid .ne. -1) then

	   gdid1 = gdattach(gdfid, 'UTMGrid')
	   gdid2 = gdattach(gdfid, 'PolarGrid')

	   ndim = gdinqdims(gdid1, dimname, dims)
	   write(*,*) 'Dimension list (UTMGrid): ', dimname
	   do i=1,ndim
	      write(*,*) 'dim size: ', dims(i)
	   enddo
	   
	   ndim = gdinqdims(gdid2, dimname, dims)
	   write(*,*) 'Dimension list (PolarGrid): ', dimname
	   do i=1,ndim
	      write(*,*) 'dim size: ', dims(i)
	   enddo
	   
	   dimsize = gddiminfo(gdid1, 'Time')
	   write(*,*) 'Size of "Time" Array: ', dimsize
	
	   dimsize = gddiminfo(gdid2, 'Bands')
	   write(*,*) 'Size of "Bands" Array: ', dimsize
	
	
	   status = gdgridinfo(gdid1, xdimsize, ydimsize,
     1                  	   upleftpt, lowrightpt)
	   write(*,*) 'X dim size, Y dim size (UTMGrid): ', 
     1 	               xdimsize, ydimsize
	   
	   write(*,*) 'Up left pt (UTMGrid): ', 
     1	               upleftpt(1), upleftpt(2)
	   write(*,*) 'Low right pt (UTMGrid): ', 
     1		       lowrightpt(1), lowrightpt(2)
	   
	   
	   status = gdgridinfo(gdid2, xdimsize, ydimsize,
     1                  	   upleftpt, lowrightpt)
	   write(*,*) 'X dim size, Y dim size (PolarGrid): ', 
     1 	               xdimsize, ydimsize
	   
	   write(*,*) 'Up left pt (PolarGrid): ', 
     1	               upleftpt(1), upleftpt(2)
	   write(*,*) 'Low right pt (PolarGrid): ', 
     1	               lowrightpt(1), lowrightpt(2)

	       
	   status = gdprojinfo(gdid1, projcode, zonecode,
     1	                       spherecode, projparm)
	   write(*,*) 'projcode , zonecode (UTMGrid): ', projcode,
     1	               zonecode
	   write(*,*) 'spherecode (UTMGrid): ', spherecode	

	
	   status = gdprojinfo(gdid2, projcode, zonecode,
     1	                       spherecode, projparm)

	   status = gdprojinfo(gdid2, projcode, zonecode,
     1	                       spherecode, projparm)
	   
	   write(*,*) 'projcode (PolarGrid): ', projcode
	   write(*,*) 'spherecode (PolarGrid): ', spherecode
	   do i=1,13
	      write(*,*) 'Projection Parameter: ',i,projparm(i)
	   enddo
	   

	   nflds = gdinqflds(gdid1, fieldlist, rank, ntype)
	   if (nflds .ne. 0) then
	      write(*,*) 'Data fields (UTMGrid): ', fieldlist
	      do i=1,nflds
		 write(*,*) 'rank type: ',rank(i),ntype(i)
	      enddo
	   endif
	
	
	   nflds = gdinqflds(gdid2, fieldlist, rank, ntype)
	   if (nflds .ne. 0) then
	      write(*,*) 'Data fields (PolarGrid): ', fieldlist
	      do i=1,nflds
		 write(*,*) 'rank type: ',rank(i),ntype(i)
	      enddo
	   endif	
	
	
	   status = gdfldinfo(gdid2, 'Spectra', rank, 
     1	                        dims, ntype, dimname)
	   write(*,*) 'Spectra rank dims: ',rank(1)
	   do i=1,rank(1)
	      write(*,*) 'Spectra dims: ',i,dims(i), dimname
	   enddo
	
C	   n = gdnentries(gdid1, HDFE_NENTDIM, strbufsize)
C	   write(*,*) 'Number of dimension entries (UTMGrid): ', n
C	   write(*,*) 'Length of Dimension List (UTMGrid): ', strbufsize
	   
C	   n = gdnentries(gdid1, HDFE_NENTDFLD, strbufsize)
C	   write(*,*) 'Number of data fields (UTMGrid): ', n
C	   write(*,*) 'Length of Field List (UTMGrid): ', strbufsize
	   
	endif
	
	status = gddetach(gdid1)
	status = gddetach(gdid2)
	status = gdclose(gdfid)

	stop
	end

c
c 


	program subsetpoint

	integer            status, ptextreg, ptreginfo, ptdetach
	integer            ptextper, ptperinfo, ptclose
	
	integer*4          ptfid, ptid, ptopen, ptattach
	integer*4          size, ptdefboxreg, ptdeftmeper
	integer*4          regionid, periodid

	real*8             cornerlon(2), cornerlat(2)
	real*8             datbuf(128), starttime, stoptime
	
	integer DFACC_READ
	parameter (DFACC_READ=1)

c    
c     Open the HDF point file, "PointFile.hdf"
c 

	ptfid = ptopen("PointFile.hdf", DFACC_READ)

	if (ptfid .NE. -1) then

	   ptid = ptattach(ptfid, "FloatBuoy Point")

	   if (ptid .NE. -1) then
	      cornerlon(1) = -145.
	      cornerlat(1) = -15.
	      cornerlon(2) = -135.
	      cornerlat(2) = 8.



	      regionid = ptdefboxreg(ptid, cornerlon, cornerlat)

	      level = 1
	      status = ptreginfo(ptid, regionid, level, 
     1				 "Longitude,Latitude", size)

	      status = ptextreg(ptid, regionid, level, 
     1	                        "Longitude,Latitude", datbuf)

	      do 100 i=1,size/16
		 write(*,*) i, datbuf(2*i-1),datbuf(2*i)
 100	      continue
	      
c             Time Subsetting	      

	      starttime = 35208757.6d0
	      stoptime = 35984639.2d0
	    
	      periodid = ptdeftmeper(ptid, starttime, stoptime)

	      level = 1
	      status = ptperinfo(ptid, periodid, level, "Time", size)

	      status = ptextper(ptid, periodid, level, "Time", datbuf)
	      
	      do 200 i=1,size/8
		 write(*,*) i, datbuf(i)
 200	      continue
	      
	   endif
	
	   status = ptdetach(ptid)
	   status = ptclose(ptfid)

	endif
	stop
	end

c testgrid.f
c In this program we create, define and write a simple grid hdfeos file
c using the grid interface
c

      program testgrid
      
      integer*4		index1
      integer*4		index2
      integer*4		dimsizes(2)
      real*4		ray3(250)
      real*4		utmray(60,80), georay(60,80)
      real*4		utmcnt, geocnt
      real*4		fillvalue, ifillv
      real*4		raycnt, ray3cnt
      real*4		tempray(60,80)
      real*4		datbuf(4800)
      
      integer   	status
      integer*4		lstatus, n, one
      integer*4 	gdfid, gdfid2, gdid_utm, gdid2
      integer*4 	zonecode
      integer*4		attr(4), iattr(4)
      integer*4 	spherecode, xdim, ydim, zero
      integer*4		tmpvar1, nt, rk, size, tmpvar2
      integer*4 	start(2)
      integer*4 	stride(2)
      integer*4 	edge(2)
      integer*4 	start1d(1), stride1d(1), edge1d(1)
      real*8		projparm(16), uplft(2), lowrgt(2), pparm(16)
      real*8		iuplft(2), ilrgt(2)

      integer*4		lat(40,50)
      integer*4		latcnt
      integer*4		lon(40,50)
      integer*4		loncnt

      integer   	gddefproj, gddefdim, gddeffld, gddetach 
      integer		gdclose, gdgetfill, gdreginfo
      integer   	gdwrfld, gdwrattr, gdsetfill, gddeforigin
      integer		gdgridinfo, gdprojinfo,gdfldinfo
      integer		gdrdfld, gddefpreg,gdrdattr, gdextreg
      integer		gdattrinfo, gdwrmeta
      integer*4 	gdopen, gdcreate, gdattach, gdinqgrid
      integer*4		gdinqdims, gddiminfo, gdinqflds
      integer*4		gdnentries, gdinqattrs, gddefboxreg
      integer*4		gdorginfo, gdpreginfo

      integer*4		strbufsize, pcode,nflds
      integer		zcode, scode
      character*80	grdnames, dimname, fldlist, attrlist
      integer*4		dims(8), rnk(8), numtype(8)
      real*8		upleftpt(2), lowrtpt(2),corlon(2),corlat(2)
      integer*4		xdimsize, ydimsize, regionid
      
      integer DFACC_CREATE
      parameter (DFACC_CREATE=4)
      integer DFACC_RDWR
      parameter (DFACC_RDWR=3)
      integer DFACC_READ
      parameter (DFACC_READ=1)      
      integer GCTP_UTM
      parameter (GCTP_UTM=1)

      integer DFNT_FLOAT32
      parameter (DFNT_FLOAT32=5)
      integer DFNT_INT32
      parameter (DFNT_INT32=24)      
      
      integer HDFE_NOMERGE
      parameter (HDFE_NOMERGE=0)
      integer HDFE_AUTOMERGE
      parameter (HDFE_AUTOMERGE=1)
      
      integer HDFE_CORNER
      parameter (HDFE_CORNER=1)
      integer HDFE_GD_UL
      parameter (HDFE_GD_UL=0)
      integer HDFE_NENTDIM
      parameter(HDFE_NENTDIM=0)
      integer HDFE_NENTDFLD
      parameter (HDFE_NENTDFLD=4)

      index1 = 0
      index2 = 0
      dimsizes(1) = 40
      dimsizes(2) = 100
      fillvalue = 1996.0
      raycnt = -799.0
      ray3cnt = -19.5
      attr(1) = 11
      attr(2) = 33
      attr(3) = 66
      attr(4) = 99
      utmcnt=-799.0
      geocnt=2001.0

      latcnt = 38.0
      loncnt = 78.0
      zero = 0
      one = 1
      
c
c This section of the program just fills some arrays with data that we will
c use later in the program
c
      do 70 index1=1,60
         do 80 index2=1,80
            utmray(index2,index1) = utmcnt
            georay(index2,index1) = geocnt
            utmcnt = utmcnt + .4
            geocnt = geocnt + .2
 80      continue
 70   continue
  
      
      do 30 index1=1,250
            ray3(index1) = ray3cnt
            ray3cnt = ray3cnt + .1
 30   continue
      

      do 50 index1=1,50
         do 60 index2=1,40      
            lat(index2,index1) = latcnt
            lon(index2,index1) = loncnt
            loncnt = loncnt - 0.1
 60      continue
         latcnt = latcnt + 0.1
         loncnt = 78.0
 50   continue
      

      open(unit=10, file='testgridf.txt')

      write(*,*)'Testing Grid FORTRAN 77 interface '
      write(*,*)'=================================='
      write(10,*)'Testing Grid FORTRAN 77 interface '
      write(10,*)'=================================='
      write(10,*)' '
      write(*,*)' '

c Test Case -- gdopen
c
      write(10,*)'Testing gdopen... '
      write(10,*)'=================='
      write(*,*)'Testing gdopen... '
      write(*,*)'=================='
      gdfid2 = gdopen("Gridf_Test2.hdf", DFACC_READ)
      write(10,*)'gdfid2 = gdopen("Gridf_Test2.hdf", DFACC_READ)'
      write(10,*)'********Error Expected************'
      write(10,*)'Value returned by gdopen ', gdfid2
      write(*,*)'gdfid2 = gdopen("Gridf_Test2.hdf", DFACC_READ)'
      write(*,*)'********Error Expected************'
      write(*,*)'Value returned by gdopen ', gdfid2
      if(gdfid2 .le. zero) call heprnt(0)

      write(*,*)'Opening file Gridf_Test.hdf'
      write(10,*)'Opening file Gridf_Test.hdf'
      gdfid = gdopen('Gridf_Test.hdf', DFACC_CREATE)
      write(10,*) 'gdfid = gdopen("Gridf_Test.hdf", DFACC_CREATE)'
      write(10,*) 'File id returned from gdopen ', gdfid
      write(*,*) 'gdfid = gdopen("Gridf_Test.hdf", DFACC_CREATE)'
      write(*,*) 'File id returned from gdopen ', gdfid
      write(10,*)' '
      write(*,*)' '


c Test Case -- gdcreate
c
      write(10,27)
      write(10,*)'Testing gdcreate... '
      write(10,*)'=================='
      write(*,*)'Testing gdcreate... '
      write(*,*)'=================='

      xdim = 60
      ydim = 80
      uplft(1) = 353299.39125
      uplft(2) = -7100284.64348
      lowrgt(1) = 603434.52148
      lowrgt(2) = -7991341.17870

      gdid2 = gdcreate(gdfid2, 'UTMGrid2', xdim, ydim, uplft, lowrgt)
      write(10,*) 'Create UTMGrid2'
      write(10,*) 'Value returned by gdcreate ', gdid2
      write(*,*) 'Create UTMGrid2'
      write(*,*) 'Value returned by gdcreate ', gdid2
      if(gdid2 .le. zero) call heprnt(0)
    
      write(10,*)'Creating UTMGrid'
      write(*,*)'Creating UTMGrid'
      gdid_utm = gdcreate(gdfid, 'UTMGrid', xdim, ydim, uplft, lowrgt)
      write(*,*)'gdid_utm = gdcreate(gdfid, "UTMGrid", xdim,
     1ydim, uplft, lowrgt)'
      write(10,*)'gdid_utm = gdcreate(gdfid, "UTMGrid", xdim,
     1ydim, uplft, lowrgt)'
      write(10,*)'UTM grid id returned from gdcreate ', gdid_utm
      write(*,*)'UTM grid id returned from gdcreate ', gdid_utm
      write(10,*)' '
      write(*,*)' '

c Test Case -- gddefproj
c
      write(10,27)
      write(10,*)'Testing gddefproj... '
      write(10,*)'=================='
      write(*,*)'Testing gddefproj... '
      write(*,*)'=================='

      zonecode = 10
      spherecode = 0

      do 120 index1=1,16
         projparm(index1)=0
 120  continue
  
      write(10,*)'Defining UTM projection'
      write(*,*)'Defining UTM projection'
      status = gddefproj(gdid_utm, GCTP_UTM, zonecode, 
     1spherecode, projparm)
      write(*,*)'status = gddefproj(gdid_utm, GCTP_UTM, zonecode,
     1spherecode, projparm)'
      write(10,*)'status = gddefproj(gdid_utm, GCTP_UTM, zonecode,
     1spherecode, projparm)'
      write(10,*)'Returned value from gddefproj ', status
      write(*,*)'Returned value from gddefproj ', status

      status = gddefproj(gdid2,GCTP_UTM,zonecode,spherecode,projparm)
      write(10,*)'Defining UTM'
      write(10,*)'Value returned by gddefproj ', status
      write(*,*)'Defining UTM'
      write(*,*)'Value returned by gddefproj ', status
      if(status .lt. zero) call heprnt(0)
      write(10,*)' '
      write(*,*)' '


c Test Case -- gddefpreg
c
      write(10,27)
      write(10,*)'Testing gddefpreg... '
      write(10,*)'=================='
      write(*,*)'Testing gddefpreg... '
      write(*,*)'=================='
      status = gddefpreg(gdid_utm, HDFE_CORNER)
      write(10,*)'Returned from gddefpreg ', status
      write(*,*)'Returned from gddefpreg ', status
      write(10,*)' '
      write(*,*)' '

c Test Case -- gddeforigin
c
      write(10,27)
      write(10,*)'Testing gddeforigin... '
      write(10,*)'=================='
      write(*,*)'Testing gddeforigin... '
      write(*,*)'=================='
      status = gddeforigin(gdid_utm, HDFE_GD_UL)
      write(*,*)'status = gddeforigin(gdid_utm, HDFE_GD_UL)'
      write(*,*)'Value of status from gddeforigin ',status
      write(10,*)' '
      write(*,*)' '

c Test Case -- gddefdim
c
      write(10,27)
      write(10,*)'Testing gddefdim... '
      write(10,*)'=================='
      write(*,*)'Testing gddefdim... '
      write(*,*)'=================='
      status = gddefdim(gdid2, 'TestDim1', 40)
      write(10,*)'status = gddefdim(gdid2, "TestDim1", 40)'
      write(10,*)'Value returned by gddefdim ', status
      write(*,*)'status = gddefdim(gdid2, "TestDim1", 40)'
      write(*,*)'Value returned by gddefdim ', status
      if(status .lt. zero) call heprnt(0)

      status = gddefdim(gdid2, 'TestDim2', 25)
      write(10,*)'status = gddefdim(gdid2, "TestDim2", 25)'
      write(10,*)'Value returned by gddefdim ', status
      write(*,*)'status = gddefdim(gdid2, "TestDim2", 25)'
      write(*,*)'Value returned by gddefdim ', status
      if(status .lt. zero) call      heprnt(0)


      status = gddefdim(gdid_utm, 'Conduction', 250)
      write(10,*)'status = gddefdim(gdid_utm, "Conduction", 250)'
      write(10,*)'Returned value from gddefdim ', status
      write(*,*)'status = gddefdim(gdid_utm, "Conduction", 250)'
      write(*,*)'Returned value from gddefdim ', status
      write(10,*)' '
      write(*,*)' '

c Test Case -- gddetach
c
      write(10,27)
      write(10,*)'Testing gddetach... '
      write(10,*)'=================='
      write(*,*)'Testing gddetach... '
      write(*,*)'=================='
      status = gddetach(gdid2)
      write(10,*)'status = gddetach(gdid2)'
      write(10,*)'Value returned by gddetach ', status
      write(*,*)'status = gddetach(gdid2)'
      write(*,*)'Value returned by gddetach ', status

      status = gddetach(gdid_utm)
      write(10,*)'status = gddetach(gdid_utm)'
      write(10,*)'Returned value from gddetach ', status
      write(*,*)'status = gddetach(gdid_utm)'
      write(*,*)'Returned value from gddetach ', status
      write(10,*)' '
      write(*,*)' '
 
c Test Case -- gdattach
c
      write(10,27)
      write(10,*)'Testing gdattach... '
      write(10,*)'=================='
      write(*,*)'Testing gdattach... '
      write(*,*)'=================='
      gdid_utm = gdattach(gdfid, 'UTMGrid')
      write(10,*)'gdid_utm = gdattach(gdfid, "UTMGrid")'
      write(10,*)'Handle returned from gdattach ', gdid_utm
      write(*,*)'gdid_utm = gdattach(gdfid, "UTMGrid")'
      write(*,*)'Handle returned from gdattach ', gdid_utm

      gdid2 = gdattach(gdfid2, 'UTMGrid2')
      write(10,*)'gdid2 = gdattach(gdfid2, "UTMGrid2")'
      write(10,*)'Value returned by gdattach ', status
      write(*,*)'gdid2 = gdattach(gdfid2, "UTMGrid2")'
      write(*,*)'Value returned by gdattach ', status
      write(10,*)' '
      write(*,*)' '

c Test Case -- gddeffld
c
      write(10,27)
      write(10,*)'Testing gddeffld... '
      write(10,*)'=================='
      write(*,*)'Testing gddeffld... '
      write(*,*)'=================='

      status = gddeffld(gdid2, 'tempfield', 'TestDim2,TestDim1', 
     1 DFNT_FLOAT32, HDFE_NOMERGE)
      write(10,*)'Define: "tempfield"'
      write(10,*)'Value returned by gddeffld ', status
      write(*,*)'Define: "tempfield"'
      write(*,*)'Value returned by gddeffld ', status
      if(status .lt. zero) call heprnt(0)


      status = gddeffld(gdid_utm,'Voltage','XDim,YDim',
     1DFNT_FLOAT32,HDFE_AUTOMERGE)
      if(status .lt. zero) call heprnt(0)
      write(10,*)'Define: "Voltage"'
      write(10,*)'Value returned from gddeffld ', status
      write(*,*)'Define: "Voltage"'
      write(*,*)'Value returned from gddeffld ', status

      status = gddeffld(gdid_utm, 'Drift', 'XDim,YDim',DFNT_FLOAT32,
     1HDFE_AUTOMERGE)
      if(status .lt. zero) call heprnt(0)
      write(10,*)'Define: "Drift"'      
      write(10,*)'Value returned from gddeffld ', status
      write(*,*)'Define: "Drift"'      
      write(*,*)'Value returned from gddeffld ', status

      status = gddeffld(gdid_utm, 'Impedance', 'XDim,YDim', 
     1DFNT_FLOAT32,HDFE_AUTOMERGE)
      if(status .lt. zero) call heprnt(0)
      write(10,*)'Define: "Impedance"'            
      write(10,*)'Value returned from gddeffld ', status
      write(*,*)'Define: "Impedance"'            
      write(*,*)'Value returned from gddeffld ', status

      status = gddeffld(gdid_utm, 'Grounding', 'Conduction', 
     1DFNT_FLOAT32, HDFE_NOMERGE)
      write(10,*)'Define: "Grounding"'                  
      write(10,*)'Value returned by gddeffld ', status
      write(*,*)'Define: "Grounding"'                  
      write(*,*)'Value returned by gddeffld ', status
      call heprnt(0)
      write(10,*)' '
      write(*,*)' '

c Test Case -- gdwrmeta
c
      write(10,27)
      write(10,*)'Testing gdwrmeta... '
      write(10,*)'=================='
      write(*,*)'Testing gdwrmeta... '
      write(*,*)'=================='

      status = gdwrmeta(gdid_utm, 'Extern',
     1'XDim,YDim',DFNT_FLOAT32)
      write(*,*)'Value returned by gdwrmeta ',status
      write(10,*)' '
      write(*,*)' '

c Test Case -- gdsetfill
c
      write(10,27)
      write(10,*)'Testing gdsetfill... '
      write(10,*)'=================='
      write(*,*)'Testing gdsetfill... '
      write(*,*)'=================='

      status = gdsetfill(gdid_utm, 'Voltage', fillvalue)
      write(10,*)'Testing gdsetfill'
      write(10,*)'Returned from gdsetfill ', status
      write(*,*)'Testing gdsetfill'
      write(*,*)'Returned from gdsetfill ', status
      write(10,*)' '
      write(*,*)' '

      status = gddetach(gdid_utm)
      write(10,*)'status = gddetach(gdid_utm)'
      write(*,*)'status = gddetach(gdid_utm)'
      if(status .lt. zero) call heprnt(0)
      write(10,*)'Returned value from gddetach ', status
      write(*,*)'Returned value from gddetach ', status
      write(10,*)' '
      write(*,*)' '

      gdid_utm = gdattach(gdfid, 'UTMGrid')
      write(10,*)'gdid_utm = gdattach(gdfid, "UTMGrid")'
      write(10,*)'Handle returned from gdattach ', gdid_utm
      write(*,*)'gdid_utm = gdattach(gdfid, "UTMGrid")'
      write(*,*)'Handle returned from gdattach ', gdid_utm
      write(10,*)' '
      write(*,*)' '

c Test Case -- gdwrfld
c
      write(10,27)
      write(10,*)'Testing gdwrfld... '
      write(10,*)'=================='
      write(*,*)'Testing gdwrfld... '
      write(*,*)'=================='

      start(1) = 10
      start(2) = 10
      stride(1) = 1
      stride(2) = 1
      edge(1) = 10
      edge(2) = 10
      
      status = gdwrfld(gdid_utm, 'Voltage', start, stride, edge, utmray)
      write(10,*)
     1'status=gdwrfld(gdid_utm,"Voltage",start,stride,edge,utmray)'
      write(10,*)'Value returned by gdwrietfield ', status
      write(*,*)
     1'status=gdwrfld(gdid_utm,"Voltage",start,stride,edge,utmray)'
      write(*,*)'Value returned by gdwrietfield ', status


      start(1) = 0
      start(2) = 0
      edge(1) = 60
      edge(2) = 80
      status = gdwrfld(gdid_utm, 'Drift', start,stride,edge,utmray)
      write(10,*)
     1'status = gdwrfld(gdid_utm, "Drift", start,stride,edge,utmray)'
      write(10,*)'Returned from gdwrfld ', status
      write(*,*)
     1'status = gdwrfld(gdid_utm, "Drift", start,stride,edge,utmray)'
      write(*,*)'Returned from gdwrfld ', status

      status = gdwrfld(gdid_utm, 'Impedance', start,stride,edge,utmray)
      write(10,*) 
     1'status=gdwrfld(gdid_utm,"Impedance",start,stride,edge,utmray)'
      write(10,*)'Returned from gdwrfld ', status
      write(*,*) 
     1'status=gdwrfld(gdid_utm,"Impedance",start,stride,edge,utmray)'
      write(*,*)'Returned from gdwrfld ', status

      start1d(1)=0
      stride1d(1)=1
      edge1d(1)=250
      status=gdwrfld(gdid_utm,'Grounding',start1d,stride1d,edge1d,ray3)
      call heprnt(0)
      write(10,*)'status=gdwrfld(gdid_utm,"Grounding",start1d,
     1stride1d,edge1d,ray3)'
      write(10,*)'Value returned by gdwrfld ', status
      write(*,*)'status=gdwrfld(gdid_utm,"Grounding",start1d,
     1stride1d,edge1d,ray3)'
      write(*,*)'Value returned by gdwrfld ', status
      write(10,*)' '
      write(*,*)' '


c Test Case -- gdwrattr
c
      write(10,27)
      write(10,*)'Testing gdwrattr... '
      write(10,*)'=================='
      write(*,*)'Testing gdwrattr... '
      write(*,*)'=================='

      status = gdwrattr(gdid_utm, 'Resistance', DFNT_INT32, 4, attr)
      write(10,*)
     1'status = gdwrattr(gdid_utm, "Resistance", DFNT_INT32, 4, attr)'
      write(10,*)'Returned from gdwrattr ', status
      write(*,*)
     1'status = gdwrattr(gdid_utm, "Resistance", DFNT_INT32, 4, attr)'
      write(*,*)'Returned from gdwrattr ', status

      status = gddetach(gdid_utm)
      write(10,*)'status = gddetach(gdid_utm)'
      write(10,*)'Returned from gddetach ', status
      write(*,*)'status = gddetach(gdid_utm)'
      write(*,*)'Returned from gddetach ', status

      status = gddetach(gdid2)
      write(10,*)'status = gddetach(gdid2)'
      write(10,*)'Value returned by gddetach ', status
      write(*,*)'status = gddetach(gdid2)'
      write(*,*)'Value returned by gddetach ', status
      write(10,*)' '
      write(*,*)' '

c Test Case -- gdclose
c
      write(10,27)
      write(10,*)'Testing gdclose... '
      write(10,*)'=================='
      write(*,*)'Testing gdclose... '
      write(*,*)'=================='

      status = gdclose(gdfid2)
      write(10,*)'status = gdclose(gdfid2)'
      write(10,*)'Value returned by gdclose ', status
      write(*,*)'status = gdclose(gdfid2)'
      write(*,*)'Value returned by gdclose ', status
      if(status .lt. zero) call heprnt(0)

      status = gdclose(gdfid)
      write(10,*)'status = gdclose(gdfid)'
      write(10,*)'Returned from gdclose ', status
      write(*,*)'status = gdclose(gdfid)'
      write(*,*)'Returned from gdclose ', status
      write(10,*)' '
      write(*,*)' '

      
      gdfid = gdopen('Gridf_Test.hdf', DFACC_RDWR)
      write(*,*)'gdfid = gdopen("Gridf_Test.hdf", DFACC_RDWR)'
      write(10,*)'gdfid = gdopen("Gridf_Test.hdf", DFACC_RDWR)'
      write(*,*)'Grid file id returned by gdopen ',gdfid
      write(10,*)'Grid file id returned by gdopen ',gdfid

      gdid_utm = gdattach(gdfid, 'UTMGrid')
      write(*,*)'gdid_utm = gdattach(gdfid, "UTMGrid")'
      write(10,*)'gdid_utm = gdattach(gdfid, "UTMGrid")'
      write(*,*)'Grid id returned by gdattach ',gdid_utm
      write(10,*)'Grid id returned by gdattach ',gdid_utm
      write(*,*)' '

c Test Case -- gdinqgrid
c
      write(10,27)
      write(10,*)'Testing gdinqgrid... '
      write(10,*)'=================='
      write(*,*)'Testing gdinqgrid... '
      write(*,*)'=================='

      lstatus = gdinqgrid('Gridf_Test.hdf',grdnames,strbufsize)
      write(*,*)'Names of grids ',grdnames
      write(*,*)'Number of grids ',lstatus
      write(*,*)'Size of names of grids ',strbufsize
      write(10,*)'Names of grids ',grdnames
      write(10,*)'Number of grids ',lstatus
      write(10,*)'Size of names of grids ',strbufsize
      write(10,*)' '
      write(*,*)' '

c Test Case -- gdorginfo
c
      write(10,27)
      write(10,*)'Testing gdorginfo... '
      write(10,*)'=================='
      write(*,*)'Testing gdorginfo... '
      write(*,*)'=================='

      lstatus = gdorginfo(gdid_utm, tmpvar1)
      write(*,*)'lstatus = gdorginfo(gdid_utm, tmpvar1)'
      write(10,*)'lstatus = gdorginfo(gdid_utm, tmpvar1)'
      write(*,*)'Value returned by gdorginfo ',lstatus
      write(10,*)'Value returned by gdorginfo ',lstatus
      write(10,*)' '
      write(*,*)' '

c Test Case -- gdpreginfo
c
      write(10,27)
      write(10,*)'Testing gdpreginfo... '
      write(10,*)'=================='
      write(*,*)'Testing gdpreginfo... '
      write(*,*)'=================='

      lstatus = gdpreginfo(gdid_utm, tmpvar1)
      write(*,*)'lstatus = gdpreginfo(gdid_utm, tmpvar1)'
      write(10,*)'lstatus = gdpreginfo(gdid_utm, tmpvar1)'
      write(*,*)'Value returned by gdpreginfo ',lstatus
      write(10,*)'Value returned by gdpreginfo ',lstatus
      write(10,*)' '
      write(*,*)' '

c Test Case -- gdinqdims
c
      write(10,27)
      write(10,*)'Testing gdinqdims... '
      write(10,*)'=================='
      write(*,*)'Testing gdinqdims... '
      write(*,*)'=================='

      lstatus = gdinqdims(gdid_utm, dimname, dims)
      write(*,*)'lstatus = gdinqdims(gdid_utm, dimname, dims)'
      write(*,*)'Number of dimensions ',lstatus
      write(*,*)'Dimensions in grid UTM ',dimname
      write(*,*)'Size of dimensions '
      write(10,*)'lstatus = gdinqdims(gdid_utm, dimname, dims)'
      write(10,*)'Number of dimensions ',lstatus
      write(10,*)'Dimensions in grid UTM ',dimname
      write(10,*)'Size of dimensions '
      do 130 i=1,lstatus
         write(*,*)' ',dims(i)
         write(10,*)' ',dims(i)
 130  continue
      write(10,*)' '
      write(*,*)' '

c Test Case -- gddiminfo
c
      write(10,27)
      write(10,*)'Testing gddiminfo... '
      write(10,*)'=================='
      write(*,*)'Testing gddiminfo... '
      write(*,*)'=================='

      lstatus = gddiminfo(gdid_utm, 'Conduction')
      write(*,*)'lstatus = gddiminfo(gdid_utm, "Conduction")'
      write(*,*)'Size of dimension Conduction ',lstatus
      write(10,*)'lstatus = gddiminfo(gdid_utm, "Conduction")'
      write(10,*)'Size of dimension Conduction ',lstatus
      write(10,*)' '
      write(*,*)' '

c Test Case -- gdgridinfo
c
      write(10,27)
      write(10,*)'Testing gdgridinfo... '
      write(10,*)'=================='
      write(*,*)'Testing gdgridinfo... '
      write(*,*)'=================='

      status = gdgridinfo(gdid_utm,xdimsize,ydimsize,upleftpt,lowrtpt)
      write(*,*)'status = gdgridinfo(gdid_utm,xdimsize,ydimsize,
     1upleftpt,lowrtpt)'
      write(*,*)'Value returned by gdgridinfo ',status
      write(*,*)'X dim size ',xdimsize, ' Y dim size ',ydimsize
      write(*,*)'Upper left pt ',upleftpt(1),upleftpt(2)
      write(*,*)'Lower right pt ',lowrtpt(1),lowrtpt(2)
      write(10,*)'status = gdgridinfo(gdid_utm,xdimsize,ydimsize,
     1upleftpt,lowrtpt)'
      write(10,*)'Value returned by gdgridinfo ',status
      write(10,*)'X dim size ',xdimsize, ' Y dim size ',ydimsize
      write(10,*)'Upper left pt ',upleftpt(1),upleftpt(2)
      write(10,*)'Lower right pt ',lowrtpt(1),lowrtpt(2)
      write(10,*)' '
      write(*,*)' '

c Test Case -- gdprojinfo
c
      write(10,27)
      write(10,*)'Testing gdprojinfo... '
      write(10,*)'=================='
      write(*,*)'Testing gdprojinfo... '
      write(*,*)'=================='

      status = gdprojinfo(gdid_utm,pcode,zcode,scode,pparm)
      write(*,*)'status = gdprojinfo(gdid_utm,pcode,
     1zcode,scode,pparm)'
      write(*,*)'Value returned by gdprojinfo ',status
      write(*,*)'Projection code ',pcode, ' Zone code ',zcode
      write(*,*)'Sphere code ',scode
      write(10,*)'status = gdprojinfo(gdid_utm,pcode,
     1zcode,scode,pparm)'
      write(10,*)'Value returned by gdprojinfo ',status
      write(10,*)'Projection code ',pcode, ' Zone code ',zcode
      write(10,*)'Sphere code ',scode
      do 140 i=1,16
         write(*,*)' ',pparm(i)
         write(10,*)' ',pparm(i)
 140  continue
      write(10,*)' '
      write(*,*)' '

c Test Case -- gdinqflds
c
      write(10,27)
      write(10,*)'Testing gdinqflds... '
      write(10,*)'=================='
      write(*,*)'Testing gdinqflds... '
      write(*,*)'=================='

      nflds = gdinqflds(gdid_utm,fldlist,rnk,numtype)
      write(*,*)'nflds = gdinqflds(gdid_utm,fldlist,rnk,numtype)'
      write(*,*)'Number of fields ',nflds
      write(10,*)'nflds = gdinqflds(gdid_utm,fldlist,rnk,numtype)'
      write(10,*)'Number of fields ',nflds
      if (nflds .ne. 0) then
         write(*,*)'Fields ',fldlist
         write(10,*)'Fields ',fldlist
         do 150 i=1,nflds
            write(*,*)'Rank and type ',rnk(i), ' ', numtype(i)
            write(10,*)'Rank and type ',rnk(i), ' ', numtype(i)
  150    continue
      end if
      write(10,*)' '
      write(*,*)' '

c Test Case -- gdfldinfo
c
      write(10,27)
      write(10,*)'Testing gdfldinfo... '
      write(10,*)'=================='
      write(*,*)'Testing gdfldinfo... '
      write(*,*)'=================='

      status = gdfldinfo(gdid_utm,'Drift',rnk,dims,
     1numtype,dimname)
      write(*,*)'status = gdfldinfo(gdid_utm,"Drift",rnk,dims,
     1numtype,dimname)'
      write(*,*)'Value returned by gdfldinfo for field Drift ',status
      write(*,*)'Drift rank ',rnk(1)
      write(10,*)'status = gdfldinfo(gdid_utm,"Drift",rnk,dims,
     1numtype,dimname)'
      write(10,*)'Value returned by gdfldinfo for field Drift ',status
      write(10,*)'Drift rank ',rnk(1)
      write(10,*)' '
      write(*,*)' '

c Test Case -- gdrdfld
c
      write(10,27)
      write(10,*)'Testing gdrdfld... '
      write(10,*)'=================='
      write(*,*)'Testing gdrdfld... '
      write(*,*)'=================='

      start(1) = 0
      start(2) = 0
      stride(1) = 1
      stride(2) = 1
      edge(1) = 60
      edge(2) = 80
      status = gdrdfld(gdid_utm,'Drift',start,stride,edge,tempray)
      write(*,*)'status = gdrdfld(gdid_utm,"Drift",start,stride,
     1edge,tempray)'
      write(*,*)'Value returned by gdrdfld ',status
      write(10,*)'status = gdrdfld(gdid_utm,"Drift",start,stride,
     1edge,tempray)'
      write(10,*)'Value returned by gdrdfld ',status
      write(10,*)' '
      write(*,*)' '

c Test Case -- gdnentries
c
      write(10,27)
      write(10,*)'Testing gdnentries... '
      write(10,*)'=================='
      write(*,*)'Testing gdnentries... '
      write(*,*)'=================='

      n = gdnentries(gdid_utm, HDFE_NENTDIM, strbufsize)
      write(*,*)'n = gdnentries(gdid_utm, HDFE_NENTDIM, strbufsize)'
      write(*,*)'Number of dimensions ', n
      write(*,*)'Dimension ',strbufsize
      write(10,*)'n = gdnentries(gdid_utm, HDFE_NENTDIM, strbufsize)'
      write(10,*)'Number of dimensions ', n
      write(10,*)'Dimension ',strbufsize

      n = gdnentries(gdid_utm,HDFE_NENTDFLD,strbufsize)
      write(*,*)'n = gdnentries(gdid_utm,HDFE_NENTDFLD,strbufsize)'
      write(*,*)'Number of data fields ',n
      write(10,*)'n = gdnentries(gdid_utm,HDFE_NENTDFLD,strbufsize)'
      write(10,*)'Number of data fields ',n
      write(10,*)' '
      write(*,*)' '

c Test Case -- gdattrinfo
c
      write(10,27)
      write(10,*)'Testing gdattrinfo... '
      write(10,*)'=================='
      write(*,*)'Testing gdattrinfo... '
      write(*,*)'=================='

      status = gdattrinfo(gdid_utm,'Resistance',tmpvar1,
     1tmpvar2)
      write(*,*)'status = gdattrinfo(gdid_utm,"Resistance",tmpvar1,
     1tmpvar2)'
      write(*,*)'Value returned by gdattrinfo ',status
      write(10,*)'status = gdattrinfo(gdid_utm,"Resistance",tmpvar1,
     1tmpvar2)'
      write(10,*)'Value returned by gdattrinfo ',status
      write(10,*)' '
      write(*,*)' '

c Test Case -- gdrdattr
c
      write(10,27)
      write(10,*)'Testing gdrdattr... '
      write(10,*)'=================='
      write(*,*)'Testing gdrdattr... '
      write(*,*)'=================='

      status = gdrdattr(gdid_utm,'Resistance',iattr)
      write(*,*)'status = gdrdattr(gdid_utm,"Resistance",iattr)'
      write(*,*)'Value returned by gdrdattr ',status
      write(10,*)'status = gdrdattr(gdid_utm,"Resistance",iattr)'
      write(10,*)'Value returned by gdrdattr ',status
      write(10,*)' '
      write(*,*)' '
  
c Test Case -- gdinqattrs
c
      write(10,27)
      write(10,*)'Testing gdinqattrs... '
      write(10,*)'=================='
      write(*,*)'Testing gdinqattrs... '
      write(*,*)'=================='

      lstatus = gdinqattrs(gdid_utm, attrlist,tmpvar1)
      write(*,*)'lstatus = gdinqattrs(gdid_utm, attrlist,tmpvar1)'
      write(*,*)'Value returned by gdinqattrs ',lstatus
      write(*,*)'List of attributes ',attrlist
      write(10,*)'lstatus = gdinqattrs(gdid_utm, attrlist,tmpvar1)'
      write(10,*)'Value returned by gdinqattrs ',lstatus
      write(10,*)'List of attributes ',attrlist
      write(10,*)' '
      write(*,*)' '

c Test Case -- gdgetfill
c
      write(10,27)
      write(10,*)'Testing gdgetfill... '
      write(10,*)'=================='
      write(*,*)'Testing gdgetfill... '
      write(*,*)'=================='

      status = gdgetfill(gdid_utm,'Voltage',ifillv)
      write(*,*)'status = gdgetfill(gdid_utm,"Voltage",ifillv)'
      write(*,*)'Value returned by gdgetfill ',status
      write(*,*)'Fill value ',ifillv
      write(10,*)'status = gdgetfill(gdid_utm,"Voltage",ifillv)'
      write(10,*)'Value returned by gdgetfill ',status
      write(10,*)'Fill value ',ifillv
      write(10,*)' '
      write(*,*)' '

c Test Case -- gddefboxreg
c
      write(10,27)
      write(10,*)'Testing gddefboxreg... '
      write(10,*)'=================='
      write(*,*)'Testing gddefboxreg... '
      write(*,*)'=================='

      corlon(1)=-126.0
      corlon(2)=-121.5
      corlat(1)=-70.0
      corlat(2)=-65.0

      regionid = gddefboxreg(gdid_utm,corlon,corlat)
      write(*,*)'regionid = gddefboxreg(gdid_utm,corlon,corlat)'
      write(*,*)'Region id returned by gddefboxreg ',regionid
      write(10,*)'regionid = gddefboxreg(gdid_utm,corlon,corlat)'
      write(10,*)'Region id returned by gddefboxreg ',regionid
      write(10,*)' '
      write(*,*)' '

c Test Case -- gdreginfo
c
      write(10,27)
      write(10,*)'Testing gdreginfo... '
      write(10,*)'=================='
      write(*,*)'Testing gdreginfo... '
      write(*,*)'=================='

      status = gdreginfo(gdid_utm,regionid,'Impedance',nt,
     1rk,dims,size,iuplft,ilrgt)
      write(*,*)'status = gdreginfo(gdid_utm,regionid,"Impedance",nt,
     1rk,dims,size,iuplft,ilrgt)'
      write(*,*)'Value returned by gdreginfo ',status
      write(*,*)'Number type of region ',nt
      write(*,*)'Rank of region ',rk
      write(*,*)'Size of region ',size
      write(*,*)'Dimensions of region',dims(1),' ',dims(2)
      write(*,*)'Upper left point of region ',iuplft(1),' ',iuplft(2)
      write(*,*)'Lower right point of region ',ilrgt(1),' ',ilrgt(2)
      write(10,*)'status = gdreginfo(gdid_utm,regionid,"Impedance",nt,
     1rk,dims,size,iuplft,ilrgt)'
      write(10,*)'Value returned by gdreginfo ',status
      write(10,*)'Number type of region ',nt
      write(10,*)'Rank of region ',rk
      write(10,*)'Size of region ',size
      write(10,*)'Dimensions of region',dims(1),' ',dims(2)
      write(10,*)'Upper left point of region ',iuplft(1),' ',iuplft(2)
      write(10,*)'Lower right point of region ',ilrgt(1),' ',ilrgt(2)
      write(10,*)' '
      write(*,*)' '

c Test Case -- gdextreg
c
      write(10,27)
      write(10,*)'Testing gdextreg... '
      write(10,*)'=================='
      write(*,*)'Testing gdextreg... '
      write(*,*)'=================='

      status = gdextreg(gdid_utm,regionid,'Impedance',datbuf)
      write(*,*)'status = gdextreg(gdid_utm,regionid,
     1"Impedance",datbuf)'
      write(*,*)'Value returned by gdextreg ',status
      write(10,*)'status = gdextreg(gdid_utm,regionid,
     1"Impedance",datbuf)'
      write(10,*)'Value returned by gdextreg ',status
      do 175 i=100,150
         write(*,*)'Value of region ',datbuf(i)
         write(10,*)'Value of region ',datbuf(i)
  175 continue


      status = gddetach(gdid_utm)
      write(*,*)'status = gddetach(gdid_utm)'
      write(*,*)'Value returned by gddetach ',status
      write(10,*)'status = gddetach(gdid_utm)'
      write(10,*)'Value returned by gddetach ',status

      status = gdclose(gdfid)
      write(*,*)'status = gdclose(gdfid)'
      write(*,*)'Returned from gdclose ', status
      write(10,*)'status = gdclose(gdfid)'
      write(10,*)'Returned from gdclose ', status

      close(unit=10)
  27  format('')
      stop
      end

c testswath.f
c In this program we create, define and write a simple swath hdfeos file
c using the swath interface
c
      program testswath

      integer index1, index2, swfid, swid, status
      integer swid2, rank, sd_id, sds1_id, sds2_id
      integer dim_id, strbufsize, nmaps, ndims, dimsize
      integer i, n, size
      integer start(2), stride(2), dataedge(2), geoedge(2)
      integer rdattr(4),geostart(2), attr(4)
      integer istart(2),iedge(2),dedge(2)
      integer dimsizes(2), compparm(5)
      integer sd_start(2), sd_stride(2), sd_edge(2)
      integer rd_start(2), rd_stride(2), rd_edge(2)
      integer*4 indexmap(30)
      integer*4	nattr, nswath, compcode, idxsz
      integer*4	tstart(1),tstride(1),tedge(1)

      integer swdefdim, swdetach, swdefgfld, swdefdfld
      integer swdefmap, swwrfld, swwrattr, swclose, sfsdmname
      integer sfwdata, sfendacc, sfend, swwrdmeta, swwrgmeta
      integer swfldinfo,swmapinfo, swattrinfo, swrdfld
      integer swrdattr, swgetfill, swsetfill, swdefimap
      integer swreginfo, swextreg, swperinfo, swextper
      integer swdefcomp, swcompinfo, swgmapinfo

      integer*4 swopen, swcreate, swattach, sfstart
      integer*4 swinqmaps, regionid, regionid2
      integer*4 sfcreate, sfdimid, swnentries, swinqimaps
      integer*4 swinqdims, swinqgflds, swinqdflds, swdiminfo
      integer*4 swdefboxreg, swdeftmeper, swimapinfo
      integer*4	swinqattrs, swinqswath, swdupreg
      integer*4 swdefvrtreg, swupimap
      integer*4 swidxinfo

      integer*4 offset, inc, nt, zero,status4
      integer*4 ndxmap(2), rnk(4), ntype(4), dims(5),latdims(2)
      integer*4 rnkd(4), ntyped(4)
      integer*4 idxmap(30), upidxmap(30)

      real*4 ray1(100,40), ray2(100,40)
      real*4 lat(40,50), lon(40,50)
      real*4 ray4(40,100)
      real*4 ray3(40,40), temp(100,40)
      real*4 idxlat(30,30), idxlon(30,30)
      real*4 latcnt, loncnt, raycnt, idxlatcnt, idxloncnt	
      real*4 fillvalue, rdfilval, tempbuf(13000)

      real*8 cornerlon(2), cornerlat(2)
      real*8 twodtime(40,50)
      real*8 onedtime(40)
      real*8 range(2)
      real*8 tmcnt,starttime, endtime
      integer indicies(2)
      integer*4 idx(8)

      character*(39) idxdimmap
      character*(72) dimmap, dimname, fieldlist, dimens
      character*(72) dimlist, attrlist, swathlist

      integer DFACC_CREATE
      parameter (DFACC_CREATE=4)
      integer DFACC_RDWR
      parameter (DFACC_RDWR=3)
      integer DFNT_FLOAT32
      parameter (DFNT_FLOAT32=5)
      integer DFNT_FLOAT64
      parameter (DFNT_FLOAT64=6)
      integer DFNT_INT32
      parameter (DFNT_INT32=24)
      integer HDFE_NOMERGE
      parameter (HDFE_NOMERGE=0)
      integer HDFE_AUTOMERGE
      parameter (HDFE_AUTOMERGE=1)
      integer HDFE_MIDPOINT
      parameter (HDFE_MIDPOINT=0)
      integer HDFE_ENDPOINT
      parameter (HDFE_ENDPOINT=1)
      integer HDFE_INTERNAL
      parameter (HDFE_INTERNAL=0)
      integer HDFE_COMP_SKPHUFF
      parameter (HDFE_COMP_SKPHUFF=3)
      integer HDFE_COMP_NONE
      parameter (HDFE_COMP_NONE=0)
      integer HDFE_NOPREVSUB
      parameter (HDFE_NOPREVSUB=-1)

      compparm(1) = 0
      compparm(2) = 0
      compparm(3) = 0
      compparm(4) = 0
      compparm(5) = 0
      raycnt=-799.0
      tmcnt=46353400.0d0
      starttime=46353450.0d0
      endtime=46500000.0d0
      range(1)=46353450.0d0
      range(2)=46500000.0d0
      latcnt=39.8
      loncnt=78.0
      attr(1)=11
      attr(2)=33
      attr(3)=66
      attr(4)=99
      start(1)=10
      start(2)=10
      tstart(1)=0
      tstride(1)=1
      tedge(1)=50
      geostart(1)=0
      geostart(2)=0
      stride(1)=1
      stride(2)=1
      sd_start(1)=0
      sd_start(2)=0
      sd_stride(1)=1
      sd_stride(2)=1
      sd_edge(1)=100
      sd_edge(2)=40
      rd_start(1)=0
      rd_start(2)=0
      rd_stride(1)=1
      rd_stride(2)=1
      rd_edge(1)=40
      rd_edge(2)=100
      dataedge(1)=20
      dataedge(2)=50
      geoedge(1)=40
      geoedge(2)=50
      idxlatcnt=39.8
      idxloncnt=78.0
      istart(1)=0
      istart(2)=0
      iedge(1)=30
      iedge(2)=30
      dedge(1)=40
      dedge(2)=40
      dimsizes(1)=100
      dimsizes(2)=40
      rank=2
      fillvalue=16.0
      cornerlon(1)=75.3
      cornerlon(2)=77.6
      cornerlat(1)=38.0
      cornerlat(2)=39.8
      indexmap(1)=1
      indexmap(2)=2
      indexmap(3)=3
      indexmap(4)=4
      indexmap(5)=6
      indexmap(6)=7
      indexmap(7)=8
      indexmap(8)=9
      indexmap(9)=11
      indexmap(10)=12
      indexmap(11)=13
      indexmap(12)=14
      indexmap(13)=16
      indexmap(14)=17
      indexmap(15)=18
      indexmap(16)=19
      indexmap(17)=21
      indexmap(18)=22
      indexmap(19)=23
      indexmap(20)=24
      indexmap(21)=26
      indexmap(22)=27
      indexmap(23)=28
      indexmap(24)=29
      indexmap(25)=31
      indexmap(26)=32
      indexmap(27)=33
      indexmap(28)=34
      indexmap(29)=36
      indexmap(30)=37
      zero = 0

c
c This section of the program just fills some arrays with data that will be
c used later in the program
c
      do 110 index1=1,100
         do 100 index2=1,40
            ray1(index1, index2)=raycnt
            ray2(index1, index2)=raycnt + 1.0
            ray4(index2,index1) = raycnt
            raycnt = raycnt +1.
  100    continue
  110 continue

      do 130 index1=1,40
         do 120 index2=1,50
            lat(index1, index2)=latcnt
            lon(index1, index2)=loncnt
            twodtime(index1,index2)=tmcnt
            loncnt=loncnt-.1
            tmcnt=tmcnt+5.0
  120    continue
         onedtime(index1)=tmcnt
         latcnt=latcnt-0.1
         loncnt = 78.0
  130 continue

      do 150 index1=1,30
         do 140 index2=1,30
            idxlat(index1, index2)=idxlatcnt
            idxlon(index1, index2)=idxloncnt
            idxloncnt=idxloncnt-.1
  140    continue
         idxlatcnt=idxlatcnt-.1
         idxloncnt=78.0
  150 continue


      do 170 index1=1,40
         do 160 index2=1,40
            ray3(index1, index2)=raycnt
            raycnt = raycnt+1.25
  160    continue
  170 continue


      do 987 index1=1,30
         idxmap(index1)=zero
         upidxmap(index1)=zero
  987 continue

      open(unit=1, file="testswath_f.txtout", status = "NEW")

      write(*,*)'Testing Swath FORTRAN 77 interface'
      write(*,*)'=================================='
      write(1,*)'Testing Swath FORTRAN 77 interface'
      write(1,*)'=================================='
      write(*,*)' '
      write(1,*)' '

c Test Case -- swopen
c
      write(*,*)'Testing swopen '
      write(*,*)'================='
      write(1,*)'Testing swopen '
      write(1,*)'================='
      swfid=swopen("Swathf_Test.hdf", DFACC_CREATE)
      if (swfid .lt. zero) then
         write(*,*)'********Error unexpected**********'
         write(1,*)'********Error unexpected**********'
         call heprnt(0)
      else
         write(*,*)'  '
         write(*,*)'    ***********Passed Test*********'
         write(1,*)'  '
         write(1,*)'    ***********Passed Test*********'
         write(*,*)'	swfid=swopen("Swathf_Test.hdf", DFACC_CREATE)'
         write(*,*)'	Value returned by swopen ', swfid
         write(1,*)'	swfid=swopen("Swathf_Test.hdf", DFACC_CREATE)'
         write(1,*)'	Value returned by swopen ', swfid
      endif
      write(*,*)' '
      write(1,*)' '

c Test Case -- swcreate
c
      write(1,27)
      write(*,*)'Testing swcreate '
      write(*,*)'================='
      write(1,*)'Testing swcreate '
      write(1,*)'================='
      swid=swcreate(swfid, "Simplef")
      if (swid .lt. zero) then
         write(*,*)'********Error unexpected**********'
         write(1,*)'********Error unexpected**********'
         call heprnt(0)
      else
         write(*,*)'  '
         write(*,*)'    ***********Passed Test*********'
         write(1,*)'  '
         write(1,*)'    ***********Passed Test*********'
         write(*,*)'	swid=swcreate(swfid, "Simplef")'
         write(*,*)'	Value returned by swcreate ', swid
         write(1,*)'	swid=swcreate(swfid, "Simplef")'
         write(1,*)'	Value returned by swcreate ', swid
      endif
      write(*,*)' '
      write(1,*)' '

      swid2=swcreate(swfid, "Indexedf")
      if (swid2 .lt. zero) then
         write(*,*)'********Error unexpected**********'
         write(1,*)'********Error unexpected**********'
         call heprnt(0)
      else
         write(*,*)'  '
         write(*,*)'    ***********Passed Test*********'
         write(1,*)'  '
         write(1,*)'    ***********Passed Test*********'
         write(*,*)'	swid2=swcreate(swfid, "Indexedf")'
         write(*,*)'	Value returned by swcreate ', swid2
         write(1,*)'	swid2=swcreate(swfid, "Indexedf")'
         write(1,*)'	Value returned by swcreate ', swid2
      endif
      write(*,*)' '
      write(1,*)' '


c Test Case -- swdefdim
c
      write(1,27)
      write(*,*)'Testing swdefdim '
      write(*,*)'================='
      write(1,*)'Testing swdefdim '
      write(1,*)'================='
      status=swdefdim(swid, "DataTrack", 100)
      if (status .lt. zero) then
         write(*,*)'********Error unexpected**********'
         write(1,*)'********Error unexpected**********'
         call heprnt(0)
      else
         write(*,*)'  '
         write(*,*)'    ***********Passed Test*********'
         write(1,*)'  '
         write(1,*)'    ***********Passed Test*********'
         write(*,*)'	status=swdefdim(swid, "DataTrack", 100)'
         write(*,*)'	Value returned by swdefdim ',status
         write(1,*)'	status=swdefdim(swid, "DataTrack", 100)'
         write(1,*)'	Value returned by swdefdim ',status
      endif
      write(*,*)' '
      write(1,*)' '

      status=swdefdim(swid, "DataXtrack", 40)
      if (status .lt. zero) then
         write(*,*)'********Error unexpected**********'
         write(1,*)'********Error unexpected**********'
         call heprnt(0)
      else
         write(*,*)'  '
         write(*,*)'    ***********Passed Test*********'
         write(1,*)'  '
         write(1,*)'    ***********Passed Test*********'
         write(*,*)'	status=swdefdim(swid, "DataXtrack", 40)'
         write(*,*)'	Value returned by swdefdim ',status
         write(1,*)'	status=swdefdim(swid, "DataXtrack", 40)'
         write(1,*)'	Value returned by swdefdim ',status
      endif
      write(*,*)' '
      write(1,*)' '

      status=swdefdim(swid, "GeoTrack", 50) 
      if (status .lt. zero) then
         write(*,*)'********Error unexpected**********'
         write(1,*)'********Error unexpected**********'
         call heprnt(0)
      else
         write(*,*)'  '
         write(*,*)'    ***********Passed Test*********'
         write(1,*)'  '
         write(1,*)'    ***********Passed Test*********'
         write(*,*)'	status=swdefdim(swid, "GeoTrack", 50)'
         write(*,*)'	Value returned by swdefdim ',status
         write(1,*)'	status=swdefdim(swid, "GeoTrack", 50)'
         write(1,*)'	Value returned by swdefdim ',status
      endif
      write(*,*)' '
      write(1,*)' '

      status=swdefdim(swid, "GeoXtrack", 40)
      if (status .lt. zero) then
         write(*,*)'********Error unexpected**********'
         write(1,*)'********Error unexpected**********'
         call heprnt(0)
      else
         write(*,*)'  '
         write(*,*)'    ***********Passed Test*********'
         write(1,*)'  '
         write(1,*)'    ***********Passed Test*********'
         write(*,*)'	status=swdefdim(swid, "GeoXtrack", 40)'
         write(*,*)'	Value returned by swdefdim ',status
         write(1,*)'	status=swdefdim(swid, "GeoXtrack", 40)'
         write(1,*)'	Value returned by swdefdim ',status
      endif
      write(*,*)' '
      write(1,*)' '

      status=swdefdim(swid2, "DataTrack", 40)
      if (status .lt. zero) then
         write(*,*)'********Error unexpected**********'
         write(1,*)'********Error unexpected**********'
         call heprnt(0)
      else
         write(*,*)'  '
         write(*,*)'    ***********Passed Test*********'
         write(1,*)'  '
         write(1,*)'    ***********Passed Test*********'
         write(*,*)'	status=swdefdim(swid2, "DataTrack", 40)'
         write(*,*)'	Value returned by swdefdim ', status
         write(1,*)'	status=swdefdim(swid2, "DataTrack", 40)'
         write(1,*)'	Value returned by swdefdim ', status
      endif
      write(*,*)' '
      write(1,*)' '

      status=swdefdim(swid2, "DataXtrack", 40)
      if (status .lt. zero) then
         write(*,*)'********Error unexpected**********'
         write(1,*)'********Error unexpected**********'
         call heprnt(0)
      else
         write(*,*)'  '
         write(*,*)'    ***********Passed Test*********'
         write(1,*)'  '
         write(1,*)'    ***********Passed Test*********'
         write(*,*)'	status=swdefdim(swid2, "DataXtrack", 40)'
         write(*,*)'	Value returned by swdefdim ', status
         write(1,*)'	status=swdefdim(swid2, "DataXtrack", 40)'
         write(1,*)'	Value returned by swdefdim ', status
      endif
      write(*,*)' '
      write(1,*)' '

      status=swdefdim(swid2, "GeoTrack", 30)
      if (status .lt. zero) then
         write(*,*)'********Error unexpected**********'
         write(1,*)'********Error unexpected**********'
         call heprnt(0)
      else
         write(*,*)'  '
         write(*,*)'    ***********Passed Test*********'
         write(1,*)'  '
         write(1,*)'    ***********Passed Test*********'
         write(*,*)'	status=swdefdim(swid2, "GeoTrack", 30)'
         write(*,*)'	Value returned by swdefdim ', status
         write(1,*)'	status=swdefdim(swid2, "GeoTrack", 30)'
         write(1,*)'	Value returned by swdefdim ', status
      endif
      write(*,*)' '
      write(1,*)' '

      status=swdefdim(swid2, "GeoXtrack", 30)
      if (status .lt. zero) then
         write(*,*)'********Error unexpected**********'
         write(1,*)'********Error unexpected**********'
         call heprnt(0)
      else
         write(*,*)'  '
         write(*,*)'    ***********Passed Test*********'
         write(1,*)'  '
         write(1,*)'    ***********Passed Test*********'
         write(*,*)'	status=swdefdim(swid2, "GeoXtrack", 30)'
         write(*,*)'	Value returned by swdefdim ', status
         write(1,*)'	status=swdefdim(swid2, "GeoXtrack", 30)'
         write(1,*)'	Value returned by swdefdim ', status
      endif
      write(*,*)' '
      write(1,*)' '

      status=swdefdim(swid2, "Timedim", 50)
      if (status .lt. zero) then
         write(*,*)'********Error unexpected**********'
         write(1,*)'********Error unexpected**********'
         call heprnt(0)
      else
         write(*,*)'  '
         write(*,*)'    ***********Passed Test*********'
         write(1,*)'  '
         write(1,*)'    ***********Passed Test*********'
         write(*,*)'Define dimension Timedim '
         write(*,*)'	Value returned by swdefdim ', status
         write(1,*)'Define dimension Timedim '
         write(1,*)'	Value returned by swdefdim ', status
      endif

      write(*,*)' '
      write(1,*)' '

c Test Case -- swdefgfld
c
      write(1,27)
      write(*,*)'Testing swdefgfld '
      write(*,*)'================='
      write(1,*)'Testing swdefgfld '
      write(1,*)'================='
      status=swdefgfld(swid, "Latitude","GeoXtrack,GeoTrack",                  &
     1DFNT_FLOAT32, HDFE_AUTOMERGE)
      if (status .lt. zero) then
         write(*,*)'********Error unexpected**********'
         write(1,*)'********Error unexpected**********'
         call heprnt(0)
      else
         write(*,*)'  '
         write(*,*)'    ***********Passed Test*********'
         write(1,*)'  '
         write(1,*)'    ***********Passed Test*********'
         write(*,*)'status=swdefgfld(swid, "Latitude","GeoXtrack,GeoTrac       &
     1k", DFNT_FLOAT32, HDFE_AUTOMERGE)'
         write(1,*)'status=swdefgfld(swid, "Latitude","GeoXtrack,GeoTrac       &
     1k", DFNT_FLOAT32, HDFE_AUTOMERGE)'
         write(1,*)'Value returned by swdefgfld ',status
         write(*,*)'Value returned by swdefgfld ',status
      endif
      write(*,*)' '
      write(1,*)' '

      status=swdefgfld(swid, "Longitude","GeoXtrack,GeoTrack",                 &
     1DFNT_FLOAT32,HDFE_AUTOMERGE)
      if (status .lt. zero) then
         write(*,*)'********Error unexpected**********'
         write(1,*)'********Error unexpected**********'
         call heprnt(0)
      else
         write(*,*)'  '
         write(*,*)'    ***********Passed Test*********'
         write(1,*)'  '
         write(1,*)'    ***********Passed Test*********'
         write(*,*)'Value returned by swdefgfld ',status
         write(1,*)'Value returned by swdefgfld ',status
      endif
      write(*,*)' '
      write(1,*)' '

      status=swdefgfld(swid2, "Latitude", "GeoXtrack,GeoTrack",                &
     1DFNT_FLOAT32,HDFE_NOMERGE)
      if (status .lt. zero) then
         write(*,*)'********Error unexpected**********'
         write(1,*)'********Error unexpected**********'
         call heprnt(0)
      else
         write(*,*)'  '
         write(*,*)'    ***********Passed Test*********'
         write(1,*)'  '
         write(1,*)'    ***********Passed Test*********'
         write(*,*)'Value returned by swdefgfld ', status
         write(1,*)'Value returned by swdefgfld ', status
      endif
      write(*,*)' '
      write(1,*)' '

      status=swdefgfld(swid2, "Longitude", "GeoXtrack,GeoTrack",               &
     1DFNT_FLOAT32,HDFE_NOMERGE)
      if (status .lt. zero) then
         write(*,*)'********Error unexpected**********'
         write(1,*)'********Error unexpected**********'
         call heprnt(0)
      else
         write(*,*)'  '
         write(*,*)'    ***********Passed Test*********'
         write(1,*)'  '
         write(1,*)'    ***********Passed Test*********'
         write(*,*)'Value returned by swdefgfld ', status
         write(1,*)'Value returned by swdefgfld ', status
      endif
      write(*,*)' '
      write(1,*)' '

      status=swdefgfld(swid2,'Time','Timedim',DFNT_FLOAT64,HDFE_NOMERGE)       
      if (status .lt. zero) then
         write(*,*)'********Error unexpected**********'
         write(1,*)'********Error unexpected**********'
         call heprnt(0)
      else
         write(*,*)'  '
         write(*,*)'    ***********Passed Test*********'
         write(1,*)'  '
         write(1,*)'    ***********Passed Test*********'
         write(*,*)'Define field Time for swath Indexedf '
         write(*,*)'Status returned from call to swdefgfld ',status
         write(1,*)'Define field Time for swath Indexedf '
         write(1,*)'Status returned from call to swdefgfld ',status
      endif
      write(*,*)' '
      write(1,*)' '

      status=swdefgfld(swid, "Time", "GeoXtrack,GeoTrack",                     &
     1DFNT_FLOAT64, HDFE_NOMERGE)
      if (status .lt. zero) then
         write(*,*)'********Error unexpected**********'
         write(1,*)'********Error unexpected**********'
         call heprnt(0)
      else
         write(*,*)'  '
         write(*,*)'    ***********Passed Test*********'
         write(1,*)'  '
         write(1,*)'    ***********Passed Test*********'
         write(*,*)'status=swdefgfld(swid, "Time","GeoXtrack,GeoTrack",D       &
     1FNT_FLOAT64, HDFE_NOMERGE)'
         write(*,*)'Value returned by swdefgfld ',status
         write(1,*)'status=swdefgfld(swid, "Time","GeoXtrack,GeoTrack",D       &
     1FNT_FLOAT64, HDFE_NOMERGE)'
         write(1,*)'Value returned by swdefgfld ',status
      endif
      write(*,*)' '
      write(1,*)' '

c Test Case -- swdefdfld
c
      write(1,27)
      write(*,*)'Testing swdefdfld '
      write(*,*)'================='
      write(1,*)'Testing swdefdfld '
      write(1,*)'================='

c Test Case -- swdefcomp
c
      write(1,27)
      write(*,*)'Testing swdefcomp '
      write(*,*)'================='
      write(1,*)'Testing swdefcomp '
      write(1,*)'================='

      status = swdefcomp(swid,HDFE_COMP_SKPHUFF,compparm)
      if (status .lt. zero) then
        write(*,*)'********Error unexpected**********'
        write(1,*)'********Error unexpected**********'
        call heprnt(0)
      else
         write(*,*)'  '
         write(*,*)'    ***********Passed Test*********'
         write(1,*)'  '
         write(1,*)'    ***********Passed Test*********'
         write(*,*)'Define compression '
         write(*,*)'Status returned by swdefcomp ',status
         write(1,*)'Define compression'
         write(1,*)'Status returned by swdefcomp ',status
         write(*,*)' '
         write(1,*)' '
      endif

      status=swdefdfld(swid, "SideA", "DataXtrack,DataTrack",                  &
     1DFNT_FLOAT32, HDFE_NOMERGE)
      if (status .lt. zero) then
        write(*,*)'********Error unexpected**********'
        write(1,*)'********Error unexpected**********'
        call heprnt(0)
      else
         write(*,*)'  '
         write(*,*)'    ***********Passed Test*********'
         write(1,*)'  '
         write(1,*)'    ***********Passed Test*********'
         write(*,*)'Define data field SideA '
         write(*,*)'Value returned by swdefdfld ',status
         write(1,*)'Define data field SideA '
         write(1,*)'Value returned by swdefdfld ',status
         write(*,*)' '
         write(1,*)' '
      endif

      status = swdefcomp(swid,HDFE_COMP_NONE,compparm)
      if (status .lt. zero) then
        write(*,*)'********Error unexpected**********'
        write(1,*)'********Error unexpected**********'
        call heprnt(0)
      else
         write(*,*)'  '
         write(*,*)'    ***********Passed Test*********'
         write(1,*)'  '
         write(1,*)'    ***********Passed Test*********'
         write(*,*)'Define compression '
         write(*,*)'Status returned by swdefcomp ',status
         write(1,*)'Define compression'
         write(1,*)'Status returned by swdefcomp ',status
         write(*,*)' '
         write(1,*)' '
      endif

      status=swdefdfld(swid, "Temperature", "DataXtrack,DataTrack",            &
     1DFNT_FLOAT32, HDFE_NOMERGE)
      if (status .lt. zero) then
        write(*,*)'********Error unexpected**********'
        write(1,*)'********Error unexpected**********'
        call heprnt(0)
      else
         write(*,*)'  '
         write(*,*)'    ***********Passed Test*********'
         write(1,*)'  '
         write(1,*)'    ***********Passed Test*********'
         write(*,*)'Define data field Temperature '
         write(*,*)'Value returned by swdefdfld ',status
         write(1,*)'Define data field Temperature '
         write(1,*)'Value returned by swdefdfld ',status
         write(*,*)' '
         write(1,*)' '
      endif

      status=swdefdfld(swid, "Conduction", "DataXtrack,DataTrack",             &
     1DFNT_FLOAT32, HDFE_NOMERGE)
      if (status .lt. zero) then
         write(*,*)'********Error unexpected**********'
         write(1,*)'********Error unexpected**********'
         call heprnt(0)
      else
         write(*,*)'  '
         write(*,*)'    ***********Passed Test*********'
         write(1,*)'  '
         write(1,*)'    ***********Passed Test*********'
         write(*,*)'status=swdefdfld(swid,"Conduction","DataXtrack,DataT       &
     1rack",DFNT_FLOAT32, HDFE_NOMERGE)'
         write(*,*)'Value returned by swdefdfld ',status
         write(1,*)'status=swdefdfld(swid,"Conduction","DataXtrack,DataT       &
     1rack",DFNT_FLOAT32, HDFE_NOMERGE)'
         write(1,*)'Value returned by swdefdfld ',status
      endif
      write(*,*)' '
      write(1,*)' '

      status=swdefdfld(swid2, "Sensor1", "DataXtrack,DataTrack",               &
     1DFNT_FLOAT32, HDFE_NOMERGE)
      if (status .lt. zero) then
         write(*,*)'********Error unexpected**********'
         write(1,*)'********Error unexpected**********'
         call heprnt(0)
      else
         write(*,*)'  '
         write(*,*)'    ***********Passed Test*********'
         write(1,*)'  '
         write(1,*)'    ***********Passed Test*********'
         write(*,*)'status=swdefdfld(swid2, "Sensor1","DataTrack,DataXtr       &
     1ack",DFNT_FLOAT32, HDFE_NOMERGE)'
         write(*,*)'Value returned by swdefdfld ',status
         write(1,*)'status=swdefdfld(swid2, "Sensor1","DataTrack,DataXtr       &
     1ack",DFNT_FLOAT32, HDFE_NOMERGE)'
         write(1,*)'Value returned by swdefdfld ',status
      endif
      write(*,*)' '
      write(1,*)' '

c Test Case -- swdetach
c
      write(1,27)
      write(*,*)'Testing swdetach '
      write(*,*)'================='
      write(1,*)'Testing swdetach '
      write(1,*)'================='
      status=swdetach(swid)
      if (status .lt. zero) then
         write(*,*)'********Error unexpected**********'
         write(1,*)'********Error unexpected**********'
         call heprnt(0)
      else
         write(*,*)'  '
         write(*,*)'    ***********Passed Test*********'
         write(1,*)'  '
         write(1,*)'    ***********Passed Test*********'
         write(*,*)'status=swdetach(swid)'
         write(*,*)'Value returned by swdetach ',status
         write(1,*)'status=swdetach(swid)'
         write(1,*)'Value returned by swdetach ',status
      endif
      write(*,*)' '
      write(1,*)' '

      status=swdetach(swid2)
      if (status .lt. zero) then
         write(*,*)'********Error unexpected**********'
         write(1,*)'********Error unexpected**********'
         call heprnt(0)
      else
         write(*,*)'  '
         write(*,*)'    ***********Passed Test*********'
         write(1,*)'  '
         write(1,*)'    ***********Passed Test*********'
         write(*,*)'status=swdetach(swid2)'
         write(*,*)'Value returned by swdetach ',status
         write(1,*)'status=swdetach(swid2)'
         write(1,*)'Value returned by swdetach ',status
      endif
      write(*,*)' '
      write(1,*)' '

      swid=swattach(swfid, "Simplef")
      if (swid .lt. zero) then
         write(*,*)'********Error unexpected**********'
         write(1,*)'********Error unexpected**********'
         call heprnt(0)
      else
         write(*,*)'  '
         write(*,*)'    ***********Passed Test*********'
         write(1,*)'  '
         write(1,*)'    ***********Passed Test*********'
         write(*,*)'swid=swattach(swfid, "Simplef")'
         write(*,*)'Value returned by swattach ',swid
         write(1,*)'swid=swattach(swfid, "Simplef")'
         write(1,*)'Value returned by swattach ',swid
      endif
      write(*,*)' '
      write(1,*)' '

      swid2=swattach(swfid, "Indexedf")
      if (swid2 .lt. zero) then
         write(*,*)'********Error unexpected**********'
         write(1,*)'********Error unexpected**********'
         call heprnt(0)
      else
         write(*,*)'  '
         write(*,*)'    ***********Passed Test*********'
         write(1,*)'  '
         write(1,*)'    ***********Passed Test*********'
         write(*,*)'swid2=swattach(swfid, "Indexedf")'
         write(*,*)'Value returned by swattach ',swid2
         write(1,*)'swid2=swattach(swfid, "Indexedf")'
         write(1,*)'Value returned by swattach ',swid2
      endif
      write(*,*)' '
      write(1,*)' '

c Test Case -- swdefmap
c
      write(1,27)
      write(*,*)'Testing swdefmap '
      write(*,*)'================='
      write(1,*)'Testing swdefmap '
      write(1,*)'================='
      status=swdefmap(swid, "GeoTrack", "DataTrack", 0, 2)
      if (status .lt. zero) then
         write(*,*)'********Error unexpected**********'
         write(1,*)'********Error unexpected**********'
         call heprnt(0)
      else
         write(*,*)'  '
         write(*,*)'    ***********Passed Test*********'
         write(1,*)'  '
         write(1,*)'    ***********Passed Test*********'
         write(*,*)'status=swdefmap(swid, "GeoTrack", "DataTrack", 0, 2)       &
     1'
         write(*,*)'Value returned by swdefmap ',status
         write(1,*)'status=swdefmap(swid, "GeoTrack", "DataTrack", 0, 2)       &
     1'
         write(1,*)'Value returned by swdefmap ',status
      endif
      write(*,*)' '
      write(1,*)' '

c Test Case -- swdefimap
c
      write(1,27)
      write(*,*)'Testing swdefimap '
      write(*,*)'================='
      write(1,*)'Testing swdefimap '
      write(1,*)'================='
      status=swdefimap(swid2, "GeoTrack", "DataTrack", indexmap)
      if (status .lt. zero) then
         write(*,*)'********Error unexpected**********'
         write(1,*)'********Error unexpected**********'
         call heprnt(0)
      else
         write(*,*)'  '
         write(*,*)'    ***********Passed Test*********'
         write(1,*)'  '
         write(1,*)'    ***********Passed Test*********'
         write(*,*)'status=swdefimap(swid2, "GeoTrack", "DataTrack",inde       &
     1xmap)'
         write(*,*)'Value returned by swdefimap ',status
         write(1,*)'status=swdefimap(swid2, "GeoTrack", "DataTrack",inde       &
     1xmap)'
         write(1,*)'Value returned by swdefimap ',status
      endif
      write(*,*)' '
      write(1,*)' '

      status=swdefimap(swid2, "GeoXtrack", "DataXtrack", indexmap)
      if (status .lt. zero) then
         write(*,*)'********Error unexpected**********'
         write(1,*)'********Error unexpected**********'
         call heprnt(0)
      else
         write(*,*)'  '
         write(*,*)'    ***********Passed Test*********'
         write(1,*)'  '
         write(1,*)'    ***********Passed Test*********'
         write(*,*)'status=swdefimap(swid2, "GeoXtrack", "DataXtrack",in       &
     1dexmap)'
         write(*,*)'Value returned by swdefimap ',status
         write(1,*)'status=swdefimap(swid2, "GeoXtrack", "DataXtrack",in       &
     1dexmap)'
         write(1,*)'Value returned by swdefimap ',status
      endif
      write(*,*)' '
      write(1,*)' '


c Test Case  -- swsetfill
c
      write(1,27)
      write(*,*)'Testing swsetfill '
      write(*,*)'================='
      write(1,*)'Testing swsetfill '
      write(1,*)'================='
      status=swsetfill(swid, "Temperature", fillvalue)
      if (status .lt. zero) then
         write(*,*)'********Error unexpected**********'
         write(1,*)'********Error unexpected**********'
         call heprnt(0)
      else
         write(*,*)'  '
         write(*,*)'    ***********Passed Test*********'
         write(1,*)'  '
         write(1,*)'    ***********Passed Test*********'
         write(*,*)'status=swsetfill(swid, "Temperature", fillvalue)'
         write(*,*)'Value returned by swsetfill ',status
         write(1,*)'status=swsetfill(swid, "Temperature", fillvalue)'
         write(1,*)'Value returned by swsetfill ',status
      endif
      write(*,*)' '
      write(1,*)' '

      status=swsetfill(swid, "Conduction", fillvalue)
      if (status .lt. zero) then
         write(*,*)'********Error unexpected**********'
         write(1,*)'********Error unexpected**********'
         call heprnt(0)
      else
         write(*,*)'  '
         write(*,*)'    ***********Passed Test*********'
         write(1,*)'  '
         write(1,*)'    ***********Passed Test*********'
         write(*,*)'status=swsetfill(swid, "Conduction", fillvalue)'
         write(*,*)'Value returned by swsetfill ',status
         write(1,*)'status=swsetfill(swid, "Conduction", fillvalue)'
         write(1,*)'Value returned by swsetfill ',status
      endif
      write(*,*)' '
      write(1,*)' '

c Test Case -- swdetach
c
      write(1,27)
      write(*,*)'Testing swdetach '
      write(*,*)'================='
      write(1,*)'Testing swdetach '
      write(1,*)'================='
      status=swdetach(swid)
      if (status .lt. zero) then
         write(*,*)'********Error unexpected**********'
         write(1,*)'********Error unexpected**********'
         call heprnt(0)
      else
         write(*,*)'  '
         write(*,*)'    ***********Passed Test*********'
         write(1,*)'  '
         write(1,*)'    ***********Passed Test*********'
         write(*,*)'status=swdetach(swid)'
         write(*,*)'Value returned by swdetach ',status
         write(1,*)'status=swdetach(swid)'
         write(1,*)'Value returned by swdetach ',status
      endif
      write(*,*)' '
      write(1,*)' '

      status=swdetach(swid2)
      if (status .lt. zero) then
         write(*,*)'********Error unexpected**********'
         write(1,*)'********Error unexpected**********'
         call heprnt(0)
      else
         write(*,*)'  '
         write(*,*)'    ***********Passed Test*********'
         write(1,*)'  '
         write(1,*)'    ***********Passed Test*********'
         write(*,*)'status=swdetach(swid2)'
         write(*,*)'Value returned by swdetach ',status
         write(1,*)'status=swdetach(swid2)'
         write(1,*)'Value returned by swdetach ',status
      endif
      write(*,*)' '
      write(1,*)' '

      status=swclose(swfid)
      if (status .lt. zero) then
         write(*,*)'********Error unexpected**********'
         write(1,*)'********Error unexpected**********'
         call heprnt(0)
      else
         write(*,*)'  '
         write(*,*)'    ***********Passed Test*********'
         write(1,*)'  '
         write(1,*)'    ***********Passed Test*********'
         write(*,*)'status=swclose(swfid)'
         write(*,*)'Value returned by swclose ',status
         write(1,*)'status=swclose(swfid)'
         write(1,*)'Value returned by swclose ',status
      endif
      write(*,*)' '
      write(1,*)' '

c Test Case -- swinqswath
c
      write(1,27)
      write(*,*)'Testing swinqswath '
      write(*,*)'================='
      write(1,*)'Testing swinqswath '
      write(1,*)'================='

      nswath=swinqswath('Swathf_Test.hdf', swathlist, strbufsize)
      if (swfid .lt. zero) then
         write(*,*)'********Error unexpected**********'
         write(1,*)'********Error unexpected**********'
         call heprnt(0)
      else
         write(*,*)'  '
         write(*,*)'    ***********Passed Test*********'
         write(1,*)'  '
         write(1,*)'    ***********Passed Test*********'
         write(*,*)'Retrieve information on swaths in file Swathf_Test.h       &
     1df'
         write(*,*)'Nunber of swaths in file ', nswath
         write(*,*)'List of swaths ',swathlist
         write(1,*)'Retrieve information on swaths in file Swathf_Test.h       &
     1df'
         write(1,*)'Nunber of swaths in file ', nswath
         write(1,*)'List of swaths ',swathlist
      endif
      write(*,*)' '
      write(1,*)' '

      swfid=swopen("Swathf_Test.hdf", DFACC_RDWR)
      if (swfid .lt. zero) then
         write(*,*)'********Error unexpected**********'
         write(1,*)'********Error unexpected**********'
         call heprnt(0)
      else
         write(*,*)'  '
         write(*,*)'    ***********Passed Test*********'
         write(1,*)'  '
         write(1,*)'    ***********Passed Test*********'
         write(*,*)'swfid=swopen("Swathf_Test.hdf", DFACC_RDWR)'
         write(*,*)'Value returned by swopen ',swfid
         write(1,*)'swfid=swopen("Swathf_Test.hdf", DFACC_RDWR)'
         write(1,*)'Value returned by swopen ',swfid
      endif
      write(*,*)' '
      write(1,*)' '
 
c Test Case -- swattach
c
      write(1,27)
      write(*,*)'Testing swattach '
      write(*,*)'================='
      write(1,*)'Testing swattach '
      write(1,*)'================='

      swid=swattach(swfid, "Simplef")
      if (swid .lt. zero) then
         write(*,*)'********Error unexpected**********'
         write(1,*)'********Error unexpected**********'
         call heprnt(0)
      else
         write(*,*)'  '
         write(*,*)'    ***********Passed Test*********'
         write(1,*)'  '
         write(1,*)'    ***********Passed Test*********'
         write(*,*)'swid=swattach(swfid, "Simplef")'
         write(*,*)'Value returned by swattach ',swid
         write(1,*)'swid=swattach(swfid, "Simplef")'
         write(1,*)'Value returned by swattach ',swid
      endif
      write(*,*)' '
      write(1,*)' '

      swid2=swattach(swfid, "Indexedf")
      if (swid2 .lt. zero) then
         write(*,*)'********Error unexpected**********'
         write(1,*)'********Error unexpected**********'
         call heprnt(0)
      else
         write(*,*)'  '
         write(*,*)'    ***********Passed Test*********'
         write(1,*)'  '
         write(1,*)'    ***********Passed Test*********'
         write(*,*)'swid2=swattach(swfid, "Indexedf")'
         write(*,*)'Value returned by swattach ',swid2
         write(1,*)'swid2=swattach(swfid, "Indexedf")'
         write(1,*)'Value returned by swattach ',swid2
      endif
      write(*,*)' '
      write(1,*)' '


c Test Case -- swwrfld
c
      write(1,27)
      write(*,*)'Testing swwrfld '
      write(*,*)'================='
      write(1,*)'Testing swwrfld '
      write(1,*)'================='

      status=swwrfld(swid, "SideA", sd_start, stride, rd_edge, ray4)
      if (status .lt. zero) then
         write(*,*)'********Error unexpected**********'
         write(1,*)'********Error unexpected**********'
         call heprnt(0)
      else
         write(*,*)'  '
         write(*,*)'    ***********Passed Test*********'
         write(1,*)'  '
         write(1,*)'    ***********Passed Test*********'
         write(*,*)'Write data field SideA '
         write(*,*)'Value returned by swwrfld ',status
         write(1,*)'Write data field SideA '
         write(1,*)'Value returned by swwrfld ',status
      endif
      write(*,*)' '
      write(1,*)' '

      status=swwrfld(swid, "Temperature", start, stride, dataedge, ray1)
      if (status .lt. zero) then
         write(*,*)'********Error unexpected**********'
         write(1,*)'********Error unexpected**********'
         call heprnt(0)
      else
         write(*,*)'  '
         write(*,*)'    ***********Passed Test*********'
         write(1,*)'  '
         write(1,*)'    ***********Passed Test*********'
         write(*,*)'status=swwrfld(swid, "Temperature", start, stride,da       &
     1taedge, ray1)'
         write(*,*)'Value returned by swwrfld ',status
         write(1,*)'status=swwrfld(swid, "Temperature", start, stride,da       &
     1taedge, ray1)'
         write(1,*)'Value returned by swwrfld ',status
      endif
      write(*,*)' '
      write(1,*)' '

      status=swwrfld(swid, "Conduction", start, stride, dataedge, ray2)
      if (status .lt. zero) then
         write(*,*)'********Error unexpected**********'
         write(1,*)'********Error unexpected**********'
         call heprnt(0)
      else
         write(*,*)'  '
         write(*,*)'    ***********Passed Test*********'
         write(1,*)'  '
         write(1,*)'    ***********Passed Test*********'
         write(*,*)'status=swwrfld(swid, "Conduction", start, stride,dat       &
     1aedge, ray2)'
         write(*,*)'Value returned by swwrfld ',status
         write(1,*)'status=swwrfld(swid, "Conduction", start, stride,dat       &
     1aedge, ray2)'
         write(1,*)'Value returned by swwrfld ',status
      endif
      write(*,*)' '
      write(1,*)' '

      status=swwrfld(swid, "Latitude", geostart, stride, geoedge, lat)
      if (status .lt. zero) then
         write(*,*)'********Error unexpected**********'
         write(1,*)'********Error unexpected**********'
         call heprnt(0)
      else
         write(*,*)'  '
         write(*,*)'    ***********Passed Test*********'
         write(1,*)'  '
         write(1,*)'    ***********Passed Test*********'
         write(*,*)'status=swwrfld(swid, "Latitude", geostart, stride, g       &
     1eoedge, lat)'
         write(*,*)'Value returned by swwrfld ',status
         write(1,*)'status=swwrfld(swid, "Latitude", geostart, stride, g       &
     1eoedge, lat)'
         write(1,*)'Value returned by swwrfld ',status
      endif
      write(*,*)' '
      write(1,*)' '

      status=swwrfld(swid, "Longitude", geostart, stride, geoedge, lon)
      if (status .lt. zero) then
         write(*,*)'********Error unexpected**********'
         write(1,*)'********Error unexpected**********'
         call heprnt(0)
      else
         write(*,*)'  '
         write(*,*)'    ***********Passed Test*********'
         write(1,*)'  '
         write(1,*)'    ***********Passed Test*********'
         write(*,*)'status=swwrfld(swid, "Longitude", geostart, stride,        &
     1geoedge, lon)'
         write(*,*)'Value returned by swwrfld ',status
         write(1,*)'status=swwrfld(swid, "Longitude", geostart, stride,        &
     1geoedge, lon)'
         write(1,*)'Value returned by swwrfld ',status
      endif
      write(*,*)' '
      write(1,*)' '

      status=swwrfld(swid,"Time",geostart,stride,geoedge,twodtime)
      if (status .lt. zero) then
         write(*,*)'********Error unexpected**********'
         write(1,*)'********Error unexpected**********'
         call heprnt(0)
      else
         write(*,*)'  '
         write(*,*)'    ***********Passed Test*********'
         write(1,*)'  '
         write(1,*)'    ***********Passed Test*********'
         write(*,*)'status=swwrfld(swid, "Time", geostart, stride, geoed       &
     1ge, twodtime)'
         write(*,*)'Value returned by swwrfld for Time ',status
         write(1,*)'status=swwrfld(swid, "Time", geostart, stride, geoed       &
     1ge, twodtime)'
         write(1,*)'Value returned by swwrfld for Time ',status
      endif
      write(*,*)' '
      write(1,*)' '

      status=swwrfld(swid2, "Latitude", istart, stride, iedge, idxlat)
      if (status .lt. zero) then
         write(*,*)'********Error unexpected**********'
         write(1,*)'********Error unexpected**********'
         call heprnt(0)
      else
         write(*,*)'  '
         write(*,*)'    ***********Passed Test*********'
         write(1,*)'  '
         write(1,*)'    ***********Passed Test*********'
         write(*,*)'status=swwrfld(swid2, "Latitude", istart, stride, i        &
     1edge, idxlat)'
         write(*,*)'Value returned by swwrfld ',status
         write(1,*)'status=swwrfld(swid2, "Latitude", istart, stride, i        &
     1edge, idxlat)'
         write(1,*)'Value returned by swwrfld ',status
      endif
      write(*,*)' '
      write(1,*)' '

      status=swwrfld(swid2, "Longitude", istart, stride, iedge, idxlon)
      if (status .lt. zero) then
         write(*,*)'********Error unexpected**********'
         write(1,*)'********Error unexpected**********'
         call heprnt(0)
      else
         write(*,*)'  '
         write(*,*)'    ***********Passed Test*********'
         write(1,*)'  '
         write(1,*)'    ***********Passed Test*********'
         write(*,*)'status=swwrfld(swid2, "Longitude", istart, stride, i       &
     1edge, idxlon)'
         write(*,*)'Value returned by swwrfld ',status
         write(1,*)'status=swwrfld(swid2, "Longitude", istart, stride, i       &
     1edge, idxlon)'
         write(1,*)'Value returned by swwrfld ',status
      endif
      write(*,*)' '
      write(1,*)' '

      status=swwrfld(swid2,'Time',tstart,tstride,tedge,onedtime)
      if (status .lt. zero) then
        write(*,*)'********Error unexpected**********'
        write(1,*)'********Error unexpected**********'
        call heprnt(0)
      else
         write(*,*)'  '
         write(*,*)'    ***********Passed Test*********'
         write(1,*)'  '
         write(1,*)'    ***********Passed Test*********'
         write(*,*)'Write field Time '
         write(*,*)'Status returned by swwrfld ',status
         write(1,*)'Write field Time '
         write(1,*)'Status returned by swwrfld ',status
         write(*,*)' '
         write(1,*)' '
      endif

      status=swwrfld(swid2, "Sensor1", istart, stride, iedge, ray3)
      if (status .lt. zero) then
         write(*,*)'********Error unexpected**********'
         write(1,*)'********Error unexpected**********'
         call heprnt(0)
      else
         write(*,*)'  '
         write(*,*)'    ***********Passed Test*********'
         write(1,*)'  '
         write(1,*)'    ***********Passed Test*********'
         write(*,*)'status=swwrfld(swid2, "Sensor1", istart, stride, ied       &
     1ge, ray3)'
         write(*,*)'Value returned by swwrfld ',status
         write(1,*)'status=swwrfld(swid2, "Sensor1", istart, stride, ied       &
     1ge, ray3)'
         write(1,*)'Value returned by swwrfld ',status
      endif
      write(*,*)' '
      write(1,*)' '


c Test Case -- swwrattr
c
      write(1,27)
      write(*,*)'Testing swwrattr '
      write(*,*)'================='
      write(1,*)'Testing swwrattr '
      write(1,*)'================='
      status=swwrattr(swid, "Drift", DFNT_INT32, 4, attr)
      if (status .lt. zero) then
         write(*,*)'********Error unexpected**********'
         write(1,*)'********Error unexpected**********'
         call heprnt(0)
      else
         write(*,*)'  '
         write(*,*)'    ***********Passed Test*********'
         write(1,*)'  '
         write(1,*)'    ***********Passed Test*********'
         write(*,*)'status=swwrattr(swid, "Drift", DFNT_INT32, 4, attr)'
         write(*,*)'Value returned by swwrattr ',status
         write(1,*)'status=swwrattr(swid, "Drift", DFNT_INT32, 4, attr)'
         write(1,*)'Value returned by swwrattr ',status
      endif
      write(*,*)' '
      write(1,*)' '

      status=swdetach(swid)
      if (status .lt. zero) then
         write(*,*)'********Error unexpected**********'
         write(1,*)'********Error unexpected**********'
         call heprnt(0)
      else
         write(*,*)'  '
         write(*,*)'    ***********Passed Test*********'
         write(1,*)'  '
         write(1,*)'    ***********Passed Test*********'
      write(*,*)'status=swdetach(swid)'
      write(*,*)'Value returned by swdetach ',status
      write(1,*)'status=swdetach(swid)'
      write(1,*)'Value returned by swdetach ',status
      endif
      write(*,*)' '
      write(1,*)' '

      status=swdetach(swid2)
      if (status .lt. zero) then
         write(*,*)'********Error unexpected**********'
         write(1,*)'********Error unexpected**********'
         call heprnt(0)
      else
         write(*,*)'  '
         write(*,*)'    ***********Passed Test*********'
         write(1,*)'  '
         write(1,*)'    ***********Passed Test*********'
         write(*,*)'status=swdetach(swid2)'
         write(*,*)'Value returned by swdetach ',status
         write(1,*)'status=swdetach(swid2)'
         write(1,*)'Value returned by swdetach ',status
      endif
      write(*,*)' '
      write(1,*)' '


c Test Case -- swclose
c
      write(1,27)
      write(*,*)'Testing swclose '
      write(*,*)'================='
      write(1,*)'Testing swclose '
      write(1,*)'================='
      status=swclose(swfid)
      if (status .lt. zero) then
         write(*,*)'********Error unexpected**********'
         write(1,*)'********Error unexpected**********'
         call heprnt(0)
      else
         write(*,*)'  '
         write(*,*)'    ***********Passed Test*********'
         write(1,*)'  '
         write(1,*)'    ***********Passed Test*********'
         write(*,*)'Value returned by swclose ',status
         write(1,*)'status=swclose(swfid)'
         write(1,*)'Value returned by swclose ',status
      endif
      write(*,*)' '
      write(1,*)' '


      sd_id=sfstart("Swathf_Test.hdf", DFACC_RDWR)
      if (sd_id .lt. zero) then
         write(*,*)'********Error unexpected**********'
         write(1,*)'********Error unexpected**********'
         call heprnt(0)
      else
         write(*,*)'  '
         write(*,*)'    ***********Passed Test*********'
         write(1,*)'  '
         write(1,*)'    ***********Passed Test*********'
         write(*,*)'sd_id=sfstart("Swathf_Test.hdf", DFACC_RDWR)'
         write(*,*)'Value returned by sfstart ',sd_id
         write(1,*)'sd_id=sfstart("Swathf_Test.hdf", DFACC_RDWR)'
         write(1,*)'Value returned by sfstart ',sd_id
      endif
      write(*,*)' '
      write(1,*)' '

      sds1_id=sfcreate(sd_id, "DataOne", DFNT_FLOAT32, rank,dimsizes)
      if (sds1_id .lt. zero) then
         write(*,*)'********Error unexpected**********'
         write(1,*)'********Error unexpected**********'
         call heprnt(0)
      else
         write(*,*)'  '
         write(*,*)'    ***********Passed Test*********'
         write(1,*)'  '
         write(1,*)'    ***********Passed Test*********'
         write(*,*)'sds1_id=sfcreate(sd_id, "DataOne", DFNT_FLOAT32, ran       &
     1k, dimsizes)'
         write(*,*)'Value returned by sfcreate ',sds1_id
         write(1,*)'sds1_id=sfcreate(sd_id, "DataOne", DFNT_FLOAT32, ran       &
     1k, dimsizes)'
         write(1,*)'Value returned by sfcreate ',sds1_id
      endif
      write(*,*)' '
      write(1,*)' '

      sds2_id=sfcreate(sd_id, "GeoOne", DFNT_FLOAT32, rank,dimsizes)
      if (sds2_id .lt. zero) then
         write(*,*)'********Error unexpected**********'
         write(1,*)'********Error unexpected**********'
         call heprnt(0)
      else
         write(*,*)'  '
         write(*,*)'    ***********Passed Test*********'
         write(1,*)'  '
         write(1,*)'    ***********Passed Test*********'
         write(*,*)'sds2_id=sfcreate(sd_id, "GeoOne", DFNT_FLOAT32, rank       &
     1, dimsizes)'
         write(*,*)'Value returned by sfcreate ',sds2_id
         write(1,*)'sds2_id=sfcreate(sd_id, "GeoOne", DFNT_FLOAT32, rank       &
     1, dimsizes)'
         write(1,*)'Value returned by sfcreate ',sds2_id
      endif
      write(*,*)' '
      write(1,*)' '

      dim_id=sfdimid(sds1_id, 0)
      if (dim_id .lt. zero) then
         write(*,*)'********Error unexpected**********'
         write(1,*)'********Error unexpected**********'
         call heprnt(0)
      else
         write(*,*)'  '
         write(*,*)'    ***********Passed Test*********'
         write(1,*)'  '
         write(1,*)'    ***********Passed Test*********'
         write(*,*)'dim_id=sfdimid(sds1_id, 0)'
         write(*,*)'Value returned by sfdimid ',dim_id
         write(1,*)'dim_id=sfdimid(sds1_id, 0)'
         write(1,*)'Value returned by sfdimid ',dim_id
      endif
      write(*,*)' '
      write(1,*)' '

      status=sfsdmname(dim_id, "DataTrack")
      if (status .lt. zero) then
         write(*,*)'********Error unexpected**********'
         write(1,*)'********Error unexpected**********'
         call heprnt(0)
      else
         write(*,*)'  '
         write(*,*)'    ***********Passed Test*********'
         write(1,*)'  '
         write(1,*)'    ***********Passed Test*********'
      write(*,*)'status=sfsdmname(dim_id, "DataTrack")'
      write(*,*)'Value returned by sfsdmname ',status
      write(1,*)'status=sfsdmname(dim_id, "DataTrack")'
      write(1,*)'Value returned by sfsdmname ',status
      endif
      write(*,*)' '
      write(1,*)' '

      dim_id=sfdimid(sds1_id, 1)
      if (dim_id .lt. zero) then
         write(*,*)'********Error unexpected**********'
         write(1,*)'********Error unexpected**********'
         call heprnt(0)
      else
         write(*,*)'  '
         write(*,*)'    ***********Passed Test*********'
         write(1,*)'  '
         write(1,*)'    ***********Passed Test*********'
         write(*,*)'dim_id=sfdimid(sds1_id, 1)'
         write(*,*)'Value returned by sfdimid ',dim_id
         write(1,*)'dim_id=sfdimid(sds1_id, 1)'
         write(1,*)'Value returned by sfdimid ',dim_id
      endif
      write(*,*)' '
      write(1,*)' '
 
      status=sfsdmname(dim_id, "DataXtrack")
      if (status .lt. zero) then
         write(*,*)'********Error unexpected**********'
         write(1,*)'********Error unexpected**********'
         call heprnt(0)
      else
         write(*,*)'  '
         write(*,*)'    ***********Passed Test*********'
         write(1,*)'  '
         write(1,*)'    ***********Passed Test*********'
         write(*,*)'status=sfsdmname(dim_id, "DataXtrack")'
         write(*,*)'Value returned by sfsdmname ',status
         write(1,*)'status=sfsdmname(dim_id, "DataXtrack")'
         write(1,*)'Value returned by sfsdmname ',status
      endif
      write(*,*)' '
      write(1,*)' '

      dim_id=sfdimid(sds2_id, 0)
      if (dim_id .lt. zero) then
         write(*,*)'********Error unexpected**********'
         write(1,*)'********Error unexpected**********'
         call heprnt(0)
      else
         write(*,*)'  '
         write(*,*)'    ***********Passed Test*********'
         write(1,*)'  '
         write(1,*)'    ***********Passed Test*********'
         write(*,*)'dim_id=sfdimid(sds2_id, 0)'
         write(*,*)'Value returned by sfdimid ',dim_id
         write(1,*)'dim_id=sfdimid(sds2_id, 0)'
         write(1,*)'Value returned by sfdimid ',dim_id
      endif
      write(*,*)' '
      write(1,*)' '

      status=sfsdmname(dim_id, "GeoTrack")
      if (status .lt. zero) then
         write(*,*)'********Error unexpected**********'
         write(1,*)'********Error unexpected**********'
         call heprnt(0)
      else
         write(*,*)'  '
         write(*,*)'    ***********Passed Test*********'
         write(1,*)'  '
         write(1,*)'    ***********Passed Test*********'
         write(*,*)'status=sfsdmname(dim_id, "GeoTrack")'
         write(*,*)'Value returned by sfsdmname ',status
         write(1,*)'status=sfsdmname(dim_id, "GeoTrack")'
         write(1,*)'Value returned by sfsdmname ',status
      endif
      write(*,*)' '
      write(1,*)' '

      dim_id=sfdimid(sds2_id, 1)
      if (dim_id .lt. zero) then
         write(*,*)'********Error unexpected**********'
         write(1,*)'********Error unexpected**********'
         call heprnt(0)
      else
         write(*,*)'  '
         write(*,*)'    ***********Passed Test*********'
         write(1,*)'  '
         write(1,*)'    ***********Passed Test*********'
         write(*,*)'dim_id=sfdimid(sds2_id, 1)'
         write(*,*)'Value returned by sfdimid ',dim_id
         write(1,*)'dim_id=sfdimid(sds2_id, 1)'
         write(1,*)'Value returned by sfdimid ',dim_id
      endif
      write(*,*)' '
      write(1,*)' '

      status=sfsdmname(dim_id, "GeoXtrack")
      if (status .lt. zero) then
         write(*,*)'********Error unexpected**********'
         write(1,*)'********Error unexpected**********'
         call heprnt(0)
      else
         write(*,*)'  '
         write(*,*)'    ***********Passed Test*********'
         write(1,*)'  '
         write(1,*)'    ***********Passed Test*********'
         write(*,*)'status=sfsdmname(dim_id, "GeoXtrack")'
         write(*,*)'Value returned by sfsdmname ',status
         write(1,*)'status=sfsdmname(dim_id, "GeoXtrack")'
         write(1,*)'Value returned by sfsdmname ',status
      endif
      write(*,*)' '
      write(1,*)' '

      status=sfwdata(sds1_id, sd_start, sd_stride, sd_edge, ray1)
      if (status .lt. zero) then
         write(*,*)'********Error unexpected**********'
         write(1,*)'********Error unexpected**********'
         call heprnt(0)
      else
         write(*,*)'  '
         write(*,*)'    ***********Passed Test*********'
         write(1,*)'  '
         write(1,*)'    ***********Passed Test*********'
         write(*,*)'status=sfwdata(sds1_id, sd_start, sd_stride, sd_edge       &
     1, ray1)'
         write(*,*)'Value returned by sfwdata ',status
         write(1,*)'status=sfwdata(sds1_id, sd_start, sd_stride, sd_edge       &
     1, ray1)'
         write(1,*)'Value returned by sfwdata ',status
      endif
      write(*,*)' '
      write(1,*)' '

      status=sfwdata(sds2_id, sd_start, sd_stride, sd_edge, ray2)
      if (status .lt. zero) then
         write(*,*)'********Error unexpected**********'
         write(1,*)'********Error unexpected**********'
         call heprnt(0)
      else
         write(*,*)'  '
         write(*,*)'    ***********Passed Test*********'
         write(1,*)'  '
         write(1,*)'    ***********Passed Test*********'
         write(*,*)'status=sfwdata(sds2_id, sd_start, sd_stride, sd_edge       &
     1, ray2)'
         write(*,*)'Value returned by sfwdata ',status
         write(1,*)'status=sfwdata(sds2_id, sd_start, sd_stride, sd_edge       &
     1, ray2)'
         write(1,*)'Value returned by sfwdata ',status
      endif
      write(*,*)' '
      write(1,*)' '

      status=sfendacc(sds1_id)
      if (status .lt. zero) then
         write(*,*)'********Error unexpected**********'
         write(1,*)'********Error unexpected**********'
         call heprnt(0)
      else
         write(*,*)'  '
         write(*,*)'    ***********Passed Test*********'
         write(1,*)'  '
         write(1,*)'    ***********Passed Test*********'
         write(*,*)'status=sfendacc(sds1_id)'
         write(*,*)'Value returned by sfendacc ',status
         write(1,*)'status=sfendacc(sds1_id)'
         write(1,*)'Value returned by sfendacc ',status
      endif
      write(*,*)' '
      write(1,*)' '

      status=sfendacc(sds2_id)
      if (status .lt. zero) then
         write(*,*)'********Error unexpected**********'
         write(1,*)'********Error unexpected**********'
         call heprnt(0)
      else
         write(*,*)'  '
         write(*,*)'    ***********Passed Test*********'
         write(1,*)'  '
         write(1,*)'    ***********Passed Test*********'
         write(*,*)'status=sfendacc(sds2_id)'
         write(*,*)'Value returned by sfendacc ',status
         write(1,*)'status=sfendacc(sds2_id)'
         write(1,*)'Value returned by sfendacc ',status
      endif
      write(*,*)' '
      write(1,*)' '

      status=sfend(sd_id)
      if (status .lt. zero) then
         write(*,*)'********Error unexpected**********'
         write(1,*)'********Error unexpected**********'
         call heprnt(0)
      else
         write(*,*)'  '
         write(*,*)'    ***********Passed Test*********'
         write(1,*)'  '
         write(1,*)'    ***********Passed Test*********'
         write(*,*)'status=sfend(sd_id)'
         write(*,*)'Value returned by sfend ',status
         write(1,*)'status=sfend(sd_id)'
         write(1,*)'Value returned by sfend ',status
      endif
      write(*,*)' '
      write(1,*)' '

      swfid=swopen("Swathf_Test.hdf", DFACC_RDWR)
      if (swfid .lt. zero) then
         write(*,*)'********Error unexpected**********'
         write(1,*)'********Error unexpected**********'
         call heprnt(0)
      else
         write(*,*)'  '
         write(*,*)'    ***********Passed Test*********'
         write(1,*)'  '
         write(1,*)'    ***********Passed Test*********'
         write(*,*)'swfid=swopen("Swathf_Test.hdf", DFACC_RDWR)'
         write(*,*)'Value returned by swopen ', swfid
         write(1,*)'swfid=swopen("Swathf_Test.hdf", DFACC_RDWR)'
         write(1,*)'Value returned by swopen ', swfid
      endif
      write(*,*)' '
      write(1,*)' '

      swid=swattach(swfid, "Simplef")
      if (swid .lt. zero) then
         write(*,*)'********Error unexpected**********'
         write(1,*)'********Error unexpected**********'
         call heprnt(0)
      else
         write(*,*)'  '
         write(*,*)'    ***********Passed Test*********'
         write(1,*)'  '
         write(1,*)'    ***********Passed Test*********'
         write(*,*)'swid=swattach(swfid, "Simplef")'
         write(*,*)'Value returned by swattach ',swid
         write(1,*)'swid=swattach(swfid, "Simplef")'
         write(1,*)'Value returned by swattach ',swid
      endif
      write(*,*)' '
      write(1,*)' '

c Test Case -- swwrdmeta
c
      write(1,27)
      write(*,*)'Testing swwrdmeta '
      write(*,*)'================='
      write(1,*)'Testing swwrdmeta '
      write(1,*)'================='
      status=swwrdmeta(swid, "DataOne", "DataXtrack,DataTrack",                &
     1DFNT_FLOAT32)
      if (status .lt. zero) then
         write(*,*)'********Error unexpected**********'
         write(1,*)'********Error unexpected**********'
         call heprnt(0)
      else
         write(*,*)'  '
         write(*,*)'    ***********Passed Test*********'
         write(1,*)'  '
         write(1,*)'    ***********Passed Test*********'
         write(*,*)'status=swwrdmeta(swid, "DataOne", "DataXtrack,DataTr       &
     1ack",DFNT_FLOAT32)'
         write(*,*)'Value returned by swwrdmeta ',status
         write(1,*)'status=swwrdmeta(swid, "DataOne", "DataXtrack,DataTr       &
     1ack",DFNT_FLOAT32)'
         write(1,*)'Value returned by swwrdmeta ',status
      endif
      write(*,*)' '
      write(1,*)' '

c Test Case -- swwrgmeta
c
      write(1,27)
      write(*,*)'Testing swwrgmeta '
      write(*,*)'================='
      write(1,*)'Testing swwrgmeta '
      write(1,*)'================='
      status=swwrgmeta(swid, "GeoOne", "GeoXtrack,GeoTrack",                   &
     1DFNT_FLOAT32)
      if (status .lt. zero) then
         write(*,*)'********Error unexpected**********'
         write(1,*)'********Error unexpected**********'
         call heprnt(0)
      else
         write(*,*)'  '
         write(*,*)'    ***********Passed Test*********'
         write(1,*)'  '
         write(1,*)'    ***********Passed Test*********'
         write(*,*)'status=swwrgmeta(swid, "GeoOne", "GeoXtrack,GeoTrack       &
     1", DFNT_FLOAT32)'
         write(*,*)'Value returned by swwrdmeta ',status
         write(1,*)'status=swwrgmeta(swid, "GeoOne", "GeoXtrack,GeoTrack       &
     1", DFNT_FLOAT32)'
         write(1,*)'Value returned by swwrdmeta ',status
      endif
      write(*,*)' '
      write(1,*)' '

      status=swdetach(swid)
      if (status .lt. zero) then
         write(*,*)'********Error unexpected**********'
         write(1,*)'********Error unexpected**********'
         call heprnt(0)
      else
         write(*,*)'  '
         write(*,*)'    ***********Passed Test*********'
         write(1,*)'  '
         write(1,*)'    ***********Passed Test*********'
         write(*,*)'status=swdetach(swid)'
         write(*,*)'Value returned by swdetach ',status
         write(1,*)'status=swdetach(swid)'
         write(1,*)'Value returned by swdetach ',status
      endif
      write(*,*)' '
      write(1,*)' '

      status=swclose(swfid)
      if (status .lt. zero) then
         write(*,*)'********Error unexpected**********'
         write(1,*)'********Error unexpected**********'
         call heprnt(0)
      else
         write(*,*)'  '
         write(*,*)'    ***********Passed Test*********'
         write(1,*)'  '
         write(1,*)'    ***********Passed Test*********'
         write(*,*)'status=swclose(swfid)'
         write(*,*)'Value returned by swclose ',status
         write(1,*)'status=swclose(swfid)'
         write(1,*)'Value returned by swclose ',status
      endif
      write(*,*)' '
      write(1,*)' '


      swfid=swopen("Swathf_Test.hdf", DFACC_RDWR)
      if (swfid .lt. zero) then
         write(*,*)'********Error unexpected**********'
         write(1,*)'********Error unexpected**********'
         call heprnt(0)
      else
         write(*,*)'  '
         write(*,*)'    ***********Passed Test*********'
         write(1,*)'  '
         write(1,*)'    ***********Passed Test*********'
         write(*,*)'swfid=swopen("Swathf_Test.hdf", DFACC_RDWR)'
         write(*,*)'Value returned by swopen ',swfid
         write(1,*)'swfid=swopen("Swathf_Test.hdf", DFACC_RDWR)'
         write(1,*)'Value returned by swopen ',swfid
      endif
      write(*,*)' '
      write(1,*)' '

      swid=swattach(swfid, "Simplef")
      if (swid .lt. zero) then
         write(*,*)'********Error unexpected**********'
         write(1,*)'********Error unexpected**********'
         call heprnt(0)
      else
         write(*,*)'  '
         write(*,*)'    ***********Passed Test*********'
         write(1,*)'  '
         write(1,*)'    ***********Passed Test*********'
         write(*,*)'swid=swattach(swfid, "Simplef")'
         write(*,*)'Value returned by swattach ',swid
         write(1,*)'swid=swattach(swfid, "Simplef")'
         write(1,*)'Value returned by swattach ',swid
      endif
      write(*,*)' '
      write(1,*)' '

      swid2=swattach(swfid, "Indexedf")
      if (swid2 .lt. zero) then
         write(*,*)'********Error unexpected**********'
         write(1,*)'********Error unexpected**********'
         call heprnt(0)
      else
         write(*,*)'  '
         write(*,*)'    ***********Passed Test*********'
         write(1,*)'  '
         write(1,*)'    ***********Passed Test*********'
         write(*,*)'swid2=swattach(swfid, "Indexedf")'
         write(*,*)'Value returned by swattach ',swid2
         write(1,*)'swid2=swattach(swfid, "Indexedf")'
         write(1,*)'Value returned by swattach ',swid2
      endif
      write(*,*)' '
      write(1,*)' '

c Test Case --swdefvrtreg
c
      write(1,27)
      write(*,*)'Testing swdefvrtreg '
      write(*,*)'================='
      write(1,*)'Testing swdefvrtreg '
      write(1,*)'================='

      regionid=swdefvrtreg(swid2,HDFE_NOPREVSUB,'Time',range)
      if (regionid .lt. zero) then
         write(*,*)'********Error unexpected**********'
         write(1,*)'********Error unexpected**********'
         call heprnt(0)
      else
         write(*,*)'  '
         write(*,*)'    ***********Passed Test*********'
         write(1,*)'  '
         write(1,*)'    ***********Passed Test*********'
         write(*,*)'Define region id for field Time '
         write(*,*)'Region id returned by swdefvrtreg ',regionid
         write(1,*)'Define region id for field Time '
         write(1,*)'Region id returned by swdefvrtreg ',regionid
      endif
      write(*,*)' '
      write(1,*)' '

c Test Case -- swnentries
c
      write(1,27)
      write(*,*)'Testing swnentries '
      write(*,*)'================='
      write(1,*)'Testing swnentries '
      write(1,*)'================='

      nmaps=swnentries(swid, 1, strbufsize)
      if (nmaps .lt. zero) then
         write(*,*)'********Error unexpected**********'
         write(1,*)'********Error unexpected**********'
         call heprnt(0)
      else
         write(*,*)'  '
         write(*,*)'    ***********Passed Test*********'
         write(1,*)'  '
         write(1,*)'    ***********Passed Test*********'
         write(*,*)'nmaps=swnentries(swid, 1, strbufsize)'
         write(*,*)'Number of dimension mappings ',nmaps
         write(*,*)'Size of strbufsize ',strbufsize
         write(1,*)'nmaps=swnentries(swid, 1, strbufsize)'
         write(1,*)'Number of dimension mappings ',nmaps
         write(1,*)'Size of strbufsize ',strbufsize
      endif
      write(*,*)' '
      write(1,*)' '

c Test Case -- swinqmaps
c
      write(1,27)
      write(*,*)'Testing swinqmaps '
      write(*,*)'================='
      write(1,*)'Testing swinqmaps '
      write(1,*)'================='
      nmaps=swinqmaps(swid, dimmap, offset, inc)
      if (nmaps .lt. zero) then
         write(*,*)'********Error unexpected**********'
         write(1,*)'********Error unexpected**********'
         call heprnt(0)
      else
         write(*,*)'  '
         write(*,*)'    ***********Passed Test*********'
         write(1,*)'  '
         write(1,*)'    ***********Passed Test*********'
         write(*,*)'nmaps=swinqmaps(swid, dimmap, offset, inc)'
         write(*,*)'Dimension mappings ',dimmap
         write(*,*)'offset ',offset
         write(*,*)'increment ',inc
         write(1,*)'nmaps=swinqmaps(swid, dimmap, offset, inc)'
         write(1,*)'Dimension mappings ',dimmap
         write(1,*)'offset ',offset
         write(1,*)'increment ',inc
      endif
      write(*,*)' '
      write(1,*)' '

c Test Case -- swgmapinfo
c
      write(1,27)
      write(*,*)'Testing swgmapinfo '
      write(*,*)'================='
      write(1,*)'Testing swgmapinfo '
      write(1,*)'================='
      status = swgmapinfo(swid2, "GeoTrack")
      if (status .lt. zero) then
         write(*,*)'********Error unexpected**********'
         write(1,*)'********Error unexpected**********'
         call heprnt(0)
      else
         write(*,*)'  '
         write(*,*)'    ***********Passed Test*********'
         write(1,*)'  '
         write(1,*)'    ***********Passed Test*********'
         write(*,*)'status = swgmapinfo(swid2, "GeoTrack")'
         write(1,*)'status = swgmapinfo(swid2, "GeoTrack")'
         write(*,*)'Status returned by swgmapinfo ',status
         write(1,*)'Status returned by swgmapinfo ',status
      endif

c Test Case -- swinqimaps
c
      write(1,27)
      write(*,*)'Testing swinqimaps '
      write(*,*)'================='
      write(1,*)'Testing swinqimaps '
      write(1,*)'================='
      nmaps=swinqimaps(swid2, idxdimmap, ndxmap)
      if (nmaps .lt. zero) then
         write(*,*)'********Error unexpected**********'
         write(1,*)'********Error unexpected**********'
         call heprnt(0)
      else
         write(*,*)'  '
         write(*,*)'    ***********Passed Test*********'
         write(1,*)'  '
         write(1,*)'    ***********Passed Test*********'
         write(*,*)'nmaps=swinqimaps(swid2, idxdimmap, ndxmap)'
         write(*,*)'Number of indexed mappings ',nmaps
         write(*,*)'Indexed Dimension mappings ',idxdimmap
         write(*,*)'Index size ',ndxmap
         write(1,*)'nmaps=swinqimaps(swid2, idxdimmap, ndxmap)'
         write(1,*)'Number of indexed mappings ',nmaps
         write(1,*)'Indexed Dimension mappings ',idxdimmap
         write(1,*)'Index size ',ndxmap
      endif
      write(*,*)' '
      write(1,*)' '

c Test Case -- swinqdims
c
c initialize dims

      dims(1) = 0
      dims(2) = 0
      dims(3) = 0
      dims(4) = 0
      dims(5) = 0

      write(1,27)
      write(*,*)'Testing swinqdims '
      write(*,*)'================='
      write(1,*)'Testing swinqdims '
      write(1,*)'================='
      ndims=swinqdims(swid, dimname, dims)
      if (ndims .lt. zero) then
         write(*,*)'********Error unexpected**********'
         write(1,*)'********Error unexpected**********'
         call heprnt(0)
      else
         write(*,*)'  '
         write(*,*)'    ***********Passed Test*********'
         write(1,*)'  '
         write(1,*)'    ***********Passed Test*********'
         write(*,*)'ndims=swinqdims(swid, dimname, dims)'
         write(*,*)'Number of dimesions ',ndims
         write(*,*)'Names of dimensions ',dimname
         write(*,*)'Size of dimensions ',dims
         write(1,*)'ndims=swinqdims(swid, dimname, dims)'
         write(1,*)'Number of dimesions ',ndims
         write(1,*)'Names of dimensions ',dimname
         write(1,*)'Size of dimensions ',dims
      endif
      write(*,*)' '
      write(1,*)' '


c initialize dims

      dims(1) = 0
      dims(2) = 0
      dims(3) = 0
      dims(4) = 0
      dims(5) = 0

      ndims=swinqdims(swid2, dimname, dims)
      if (ndims .lt. zero) then
         write(*,*)'********Error unexpected**********'
         write(1,*)'********Error unexpected**********'
         call heprnt(0)
      else
         write(*,*)'  '
         write(*,*)'    ***********Passed Test*********'
         write(1,*)'  '
         write(1,*)'    ***********Passed Test*********'
         write(*,*)'ndims=swinqdims(swid2, dimname, dims)'
         write(*,*)'Number of dimesions ',ndims
         write(*,*)'Names of dimensions ',dimname
         write(*,*)'Size of dimensions ',dims
         write(1,*)'ndims=swinqdims(swid2, dimname, dims)'
         write(1,*)'Number of dimesions ',ndims
         write(1,*)'Names of dimensions ',dimname
         write(1,*)'Size of dimensions ',dims
      endif
      write(*,*)' '
      write(1,*)' '

c Test Case -- swinqgflds
c
      write(1,27)
      write(*,*)'Testing swinqgflds '
      write(*,*)'================='
      write(1,*)'Testing swinqgflds '
      write(1,*)'================='

      ndims=swinqdims(swid, dimname, dims)
      if (ndims .lt. zero) then
         write(*,*)'********Error unexpected**********'
         write(1,*)'********Error unexpected**********'
         call heprnt(0)
      else
         write(*,*)'  '
         write(*,*)'    ***********Passed Test*********'
         write(1,*)'  '
         write(1,*)'    ***********Passed Test*********'
      endif

      nflds=swinqgflds(swid, fieldlist, rnk, ntype)
      if (nflds .lt. zero) then
         write(*,*)'********Error unexpected**********'
         write(1,*)'********Error unexpected**********'
         call heprnt(0)
      else
         write(*,*)'  '
         write(*,*)'    ***********Passed Test*********'
         write(1,*)'  '
         write(1,*)'    ***********Passed Test*********'
         write(*,*)'nflds=swinqgflds(swid, fieldlist, rnk, ntype)'
         write(*,*)'Number of geolocation fields in swath ',nflds
         write(*,*)'Names of geolocation fields ',fieldlist
         write(*,*)'Rank of fields ',rnk
         write(*,*)'Number type of fields ',ntype
         write(1,*)'nflds=swinqgflds(swid, fieldlist, rnk, ntype)'
         write(1,*)'Number of geolocation fields in swath ',nflds
         write(1,*)'Names of geolocation fields ',fieldlist
         write(1,*)'Rank of fields ',rnk
         write(1,*)'Number type of fields ',ntype
      endif
      write(*,*)' '
      write(1,*)' '

c Test Case -- swinqdflds
c
      write(1,27)
      write(*,*)'Testing swinqdflds '
      write(*,*)'================='
      write(1,*)'Testing swinqdflds '
      write(1,*)'================='
      nflds=swinqdflds(swid, fieldlist, rnkd, ntyped)
      if (nflds .lt. zero) then
         write(*,*)'********Error unexpected**********'
         write(1,*)'********Error unexpected**********'
         call heprnt(0)
      else
         write(*,*)'  '
         write(*,*)'    ***********Passed Test*********'
         write(1,*)'  '
         write(1,*)'    ***********Passed Test*********'
         write(*,*)'nflds=swinqdflds(swid, fieldlist, rnkd, ntyped)'
         write(*,*)'Number of data fields in swath ',nflds
         write(*,*)'Names of data fields ',fieldlist
         write(*,*)'Rank of fields ',rnkd
         write(*,*)'Number type of fields ',ntyped
         write(1,*)'nflds=swinqdflds(swid, fieldlist, rnkd, ntyped)'
         write(1,*)'Number of data fields in swath ',nflds
         write(1,*)'Names of data fields ',fieldlist
         write(1,*)'Rank of fields ',rnkd
         write(1,*)'Number type of fields ',ntyped
      endif
      write(*,*)' '
      write(1,*)' '

c Test Case -- swdiminfo
c
      write(1,27)
      write(*,*)'Testing swdiminfo '
      write(*,*)'================='
      write(1,*)'Testing swdiminfo '
      write(1,*)'================='
      dimsize=swdiminfo(swid, "DataTrack")
      if (dimsize .lt. zero) then
         write(*,*)'********Error unexpected**********'
         write(1,*)'********Error unexpected**********'
         call heprnt(0)
      else
         write(*,*)'  '
         write(*,*)'    ***********Passed Test*********'
         write(1,*)'  '
         write(1,*)'    ***********Passed Test*********'
         write(*,*)'dimsize=swdiminfo(swid, "DataTrack")'
         write(*,*)'Size of dimension DataTrack ',dimsize
         write(1,*)'dimsize=swdiminfo(swid, "DataTrack")'
         write(1,*)'Size of dimension DataTrack ',dimsize
         write(*,*)' '
         write(1,*)' '
      endif

c Test Case -- swcompinfo
c
      write(1,27)
      write(*,*)'Testing swcompinfo '
      write(*,*)'================='
      write(1,*)'Testing swcompinfo '
      write(1,*)'================='

      status = swcompinfo(swid,'SideA',compcode,compparm)
      if (status .lt. zero) then
         write(*,*)'********Error unexpected**********'
         write(1,*)'********Error unexpected**********'
         call heprnt(0)
      else
         write(*,*)'  '
         write(*,*)'    ***********Passed Test*********'
         write(1,*)'  '
         write(1,*)'    ***********Passed Test*********'
         write(*,*)'Retrieve compression information for field SideA'
         write(*,*)'The compression code for field SideA = ',compcode          
         write(*,*)'The compression parameter is ',compparm(1)
         write(1,*)'Retrieve compression information for field SideA'
         write(1,*)'The compression code for field SideA = ',compcode          
         write(1,*)'The compression parameter is ',compparm(1)
         write(*,*)' '
         write(1,*)' '
      endif

c Test Case -- swrdfld
c
      write(1,27)
      write(*,*)'Testing swrdfld '
      write(*,*)'================='
      write(1,*)'Testing swrdfld '
      write(1,*)'================='

      status=swrdfld(swid, "Conduction", rd_start,rd_stride,                   &
     1rd_edge, temp)
      if (status .lt. zero) then
         write(*,*)'********Error unexpected**********'
         write(1,*)'********Error unexpected**********'
         call heprnt(0)
      else
         write(*,*)'  '
         write(*,*)'    ***********Passed Test*********'
         write(1,*)'  '
         write(1,*)'    ***********Passed Test*********'
         write(*,*)'Value returned by swrdfld ',status
         write(*,*)'status=swrdfld(swid, "Conduction", rd_start,rd_strid       &
     1e, rd_edge, temp)'
         write(1,*)'status=swrdfld(swid, "Conduction", rd_start,rd_strid       &
     1e, rd_edge, temp)'
         write(1,*)'Value returned by swrdfld ',status
         do 190 index1=10,15
            do 180 index2=10,15
               write(*,*)'value of conduction ',temp(index1, index2)
               write(1,*)'value of conduction ',temp(index1, index2)
  180       continue
  190    continue
      endif

      write(*,*)' '
      write(1,*)' '

c Test Case -- swfldinfo
C
      write(1,27)
      write(*,*)'Testing swfldinfo '
      write(*,*)'================='
      write(1,*)'Testing swfldinfo '
      write(1,*)'================='
      status=swfldinfo(swid, "Latitude", rank, latdims, nt, dimens)
      if (status .lt. zero) then
         write(*,*)'********Error unexpected**********'
         write(1,*)'********Error unexpected**********'
         call heprnt(0)
      else
         write(*,*)'  '
         write(*,*)'    ***********Passed Test*********'
         write(1,*)'  '
         write(1,*)'    ***********Passed Test*********'
         write(*,*)'status=swfldinfo(swid, "Latitude", rank, latdims, nt       &
     1, dimens)'
         write(*,*)'Value returned by swfldinfo ',status
         write(*,*)'Rank of field latitude ',rank
         write(*,*)'dimension list of field latitude ',dimens
         write(*,*)'Size of latitude dimensions ',latdims
         write(*,*)'number type of field latitude ',nt
         write(1,*)'status=swfldinfo(swid, "Latitude", rank, latdims, nt       &
     1, dimens)'
         write(1,*)'Value returned by swfldinfo ',status
         write(1,*)'Rank of field latitude ',rank
         write(1,*)'dimension list of field latitude ',dimens
         write(1,*)'Size of latitude dimensions ',latdims
         write(1,*)'number type of field latitude ',nt
      endif
      write(*,*)' '
      write(1,*)' '

c Test Case -- swmapinfo
c
      write(1,27)
      write(*,*)'Testing swmapinfo '
      write(*,*)'================='
      write(1,*)'Testing swmapinfo '
      write(1,*)'================='
      status=swmapinfo(swid, "GeoTrack", "DataTrack", offset, inc)
      if (status .lt. zero) then
         write(*,*)'********Error unexpected**********'
         write(1,*)'********Error unexpected**********'
         call heprnt(0)
      else
         write(*,*)'  '
         write(*,*)'    ***********Passed Test*********'
         write(1,*)'  '
         write(1,*)'    ***********Passed Test*********'
         write(*,*)'status=swmapinfo(swid, "GeoTrack", "DataTrack", offs       &
     1et, inc)'
         write(*,*)'Value returned by swmapinfo ',status
         write(*,*)'Offset ',offset,' Increment ',inc
         write(1,*)'status=swmapinfo(swid, "GeoTrack", "DataTrack", offs       &
     1et, inc)'
         write(1,*)'Value returned by swmapinfo ',status
         write(1,*)'Offset ',offset,' Increment ',inc
      endif
      write(*,*)' '
      write(1,*)' '

c Test Case -- swimapinfo
c
      write(1,27)
      write(*,*)'Testing swimapinfo '
      write(*,*)'================='
      write(1,*)'Testing swimapinfo '
      write(1,*)'================='
      status4=swimapinfo(swid2,"GeoXtrack","DataXtrack",idxmap)
      if (status4 .lt. zero) then
         write(*,*)'********Error unexpected**********'
         write(1,*)'********Error unexpected**********'
         call heprnt(0)
      else
         write(*,*)'  '
         write(*,*)'    ***********Passed Test*********'
         write(1,*)'  '
         write(1,*)'    ***********Passed Test*********'
         write(*,*)'status4=swimapinfo(swid2,"GeoXtrack","DataXtrack",         &
     1idxmap)'
         write(*,*)'Value returned by swimapinfo ',status4
         do 980 index1=1,30
            write(*,*)' Value of index array ',idxmap(index1)
            write(1,*)' Value of index array ',idxmap(index1)
  980    continue
         write(1,*)'status4=swimapinfo(swid2, "GeoXtrack", "DataXtrack",       &
     1idxmap)'
         write(1,*)'Value returned by swimapinfo ',status4
         write(*,*)'Indexed map values ',idxmap
         write(1,*)'Indexed map values ',idxmap
      endif
      write(*,*)' '
      write(1,*)' '
 
c Test Case -- swattrinfo
c
      write(1,27)
      write(*,*)'Testing swattrinfo '
      write(*,*)'================='
      write(1,*)'Testing swattrinfo '
      write(1,*)'================='
      status=swattrinfo(swid, "Drift", n, size)
      if (status .lt. zero) then
         write(*,*)'********Error unexpected**********'
         write(1,*)'********Error unexpected**********'
         call heprnt(0)
      else
         write(*,*)'  '
         write(*,*)'    ***********Passed Test*********'
         write(1,*)'  '
         write(1,*)'    ***********Passed Test*********'
         write(*,*)'status=swattrinfo(swid, "Drift", n, size)'
         write(*,*)'Value returned by swattrinfo ',status
         write(*,*)'Number of attributes ',n,' Size ',size
         write(1,*)'status=swattrinfo(swid, "Drift", n, size)'
         write(1,*)'Value returned by swattrinfo ',status
         write(1,*)'Number of attributes ',n,' Size ',size
      endif
      write(*,*)' '
      write(1,*)' '

c Test Case -- swinqattrs
c
      write(1,27)
      write(*,*)'Testing swinqattrs '
      write(*,*)'================='
      write(1,*)'Testing swinqattrs '
      write(1,*)'================='

      nattr = swinqattrs(swid,attrlist,strbufsize)
      if (nattr .lt. zero) then
         write(*,*)'********Error unexpected**********'
         write(1,*)'********Error unexpected**********'
         call heprnt(0)
      else
         write(*,*)'  '
         write(*,*)'    ***********Passed Test*********'
         write(1,*)'  '
         write(1,*)'    ***********Passed Test*********'
         write(*,*)'Number of attributres in swath ',nattr
         write(*,*)'Attribute list of swath ',attrlist
         write(1,*)'Number of attributres in swath ',nattr
         write(1,*)'Attribute list of swath ',attrlist
         write(*,*)' '
         write(1,*)' '
      endif


c Test Case -- swrdattr
c
      write(1,27)
      write(*,*)'Testing swrdattr '
      write(*,*)'================='
      write(1,*)'Testing swrdattr '
      write(1,*)'================='

      status=swrdattr(swid,"Drift", rdattr)
      if (status .lt. zero) then
         write(*,*)'********Error unexpected**********'
         write(1,*)'********Error unexpected**********'
         call heprnt(0)
      else
         write(*,*)'  '
         write(*,*)'    ***********Passed Test*********'
         write(1,*)'  '
         write(1,*)'    ***********Passed Test*********'
         write(*,*)'status=swrdattr(swid,"Drift", rdattr)'
         write(*,*)'Value returned by swrdattr ',status
         write(*,*)'attribute ',rdattr
         write(1,*)'status=swrdattr(swid,"Drift", rdattr)'
         write(1,*)'Value returned by swrdattr ',status
         write(1,*)'attribute ',rdattr
      endif
      write(*,*)' '
      write(1,*)' '

c Test Case -- swgetfill
c
      write(1,27)
      write(*,*)'Testing swgetfill '
      write(*,*)'================='
      write(1,*)'Testing swgetfill '
      write(1,*)'================='
      status=swgetfill(swid, "Conduction", rdfilval)
      if (status .lt. zero) then
         write(*,*)'********Error unexpected**********'
         write(1,*)'********Error unexpected**********'
         call heprnt(0)
      else
         write(*,*)'  '
         write(*,*)'    ***********Passed Test*********'
         write(1,*)'  '
         write(1,*)'    ***********Passed Test*********'
         write(*,*)'status=swgetfill(swid, "Conduction", rdfilval)'
         write(*,*)'Value returned by swgetfill ',status
         write(*,*)'Value of fill ',rdfilval
         write(1,*)'status=swgetfill(swid, "Conduction", rdfilval)'
         write(1,*)'Value returned by swgetfill ',status
         write(1,*)'Value of fill ',rdfilval
      endif
      write(*,*)' '
      write(1,*)' '

c Test Case -- swdefboxreg
c
      write(1,27)
      write(*,*)'Testing swdefboxreg '
      write(*,*)'================='
      write(1,*)'Testing swdefboxreg '
      write(1,*)'================='

      regionid=swdefboxreg(swid, cornerlon, cornerlat,HDFE_ENDPOINT)
      if (regionid .lt. zero) then
         write(*,*)'********Error unexpected**********'
         write(1,*)'********Error unexpected**********'
         call heprnt(0)
      else
         write(*,*)'  '
         write(*,*)'    ***********Passed Test*********'
         write(1,*)'  '
         write(1,*)'    ***********Passed Test*********'
         write(*,*)'regionid=swdefboxreg(swid, cornerlon, cornerlat, HDF       &
     1E_ENDPOINT)'
         write(*,*)'Value returned by swdefboxreg ',regionid
         write(1,*)'regionid=swdefboxreg(swid, cornerlon, cornerlat, HDF       &
     1E_ENDPOINT)'
         write(1,*)'Value returned by swdefboxreg ',regionid
      endif
      write(*,*)' '
      write(1,*)' '

c Test Case -- swidxinfo
c
      write(1,27)
      write(*,*)'Testing swidxinfo '
      write(*,*)'================='
      write(1,*)'Testing swidxinfo '
      write(1,*)'================='

      status4=swidxinfo(regionid, "Longitude", rank, dimlist, idx)

      if (status4 .lt. zero) then
         write(*,*)'********Error unexpected**********'
         write(1,*)'********Error unexpected**********'
         call heprnt(0)
      else
         write(*,*)'  '
         write(*,*)'    ***********Passed Test*********'
         write(1,*)'  '
         write(1,*)'    ***********Passed Test*********'
         write(*,*)'status4=swidxinfo(regionid, "Longitude", rank, dimli       &
     1st, idx)'
         write(1,*)'status4=swidxinfo(regionid, "Longitude", rank, dimli       &
     1st, idx)'
         write(*,*)'Value returned by swidxinfo ',status4
         write(1,*)'Value returned by swidxinfo ',status4
         write(*,*)'Value of dimlist is ',dimlist
         write(1,*)'Value of dimlist is ',dimlist
         do 555 i=1,4
           write(*,535)i,idx(i)
           write(1,535)i,idx(i)
  535      format (' Value of idx(',I2,') is ', I2)
  555 continue
      endif
      write(*,*)' '
      write(1,*)' '

c Test Case -- swdefboxreg
c
      cornerlon(1)=75.0
      cornerlon(2)=78.0
      cornerlat(1)=38.0
      cornerlat(2)=39.8

      write(1,27)
      write(*,*)'Testing swdefboxreg '
      write(*,*)'================='
      write(1,*)'Testing swdefboxreg '
      write(1,*)'================='

      regionid=swdefboxreg(swid, cornerlon, cornerlat,HDFE_ENDPOINT)
      if (regionid .lt. zero) then
         write(*,*)'********Error unexpected**********'
         write(1,*)'********Error unexpected**********'
         call heprnt(0)
      else
         write(*,*)'  '
         write(*,*)'    ***********Passed Test*********'
         write(1,*)'  '
         write(1,*)'    ***********Passed Test*********'
         write(*,*)'regionid=swdefboxreg(swid, cornerlon, cornerlat, HDF       &
     1E_ENDPOINT)'
         write(*,*)'Value returned by swdefboxreg ',regionid
         write(1,*)'regionid=swdefboxreg(swid, cornerlon, cornerlat, HDF       &
     1E_ENDPOINT)'
         write(1,*)'Value returned by swdefboxreg ',regionid
      endif
      write(*,*)' '
      write(1,*)' '

c Test Case -- swdupreg
c
      write(1,27)
      write(*,*)'Testing swdupreg '
      write(*,*)'================='
      write(1,*)'Testing swdupreg '
      write(1,*)'================='

      regionid2=swdupreg(regionid)
      if (regionid2 .lt. zero) then
         write(*,*)'********Error unexpected**********'
         write(1,*)'********Error unexpected**********'
         call heprnt(0)
      else
         write(*,*)'  '
         write(*,*)'    ***********Passed Test*********'
         write(1,*)'  '
         write(1,*)'    ***********Passed Test*********'
         write(*,*)'Duplicate region id information '
         write(*,*)'Region ID returned by swdupreg ',regionid2
         write(1,*)'Duplicate region id information '
         write(1,*)'Region ID returned by swdupreg ',regionid2
         write(*,*)' '
         write(1,*)' '
      endif

c Test Case -- swreginfo
c
      write(1,27)
      write(*,*)'Testing swreginfo '
      write(*,*)'================='
      write(1,*)'Testing swreginfo '
      write(1,*)'================='
      status = swreginfo(swid, regionid, "Temperature", nt, rank, dims,        &
     1size)      
      if (status .lt. zero) then
         write(*,*)'********Error unexpected**********'
         write(1,*)'********Error unexpected**********'
         call heprnt(0)
      else
         write(*,*)'  '
         write(*,*)'    ***********Passed Test*********'
         write(1,*)'  '
         write(1,*)'    ***********Passed Test*********'
         write(*,*)'status = swreginfo(swid, regionid, "Temperature", nt       &
     1, rank, dims, size)'
         write(*,*)'Value returned by swreginfo ',status
         write(*,*)'Number type of region ',nt,' Rank of region ',rank
         write(*,*)'Dimensions of region ',dims(1),' ',dims(2)
         write(*,*)'Value of size ',size
         write(1,*)'status = swreginfo(swid, regionid, "Temperature", nt       &
     1, rank, dims, size)'
         write(1,*)'Value returned by swreginfo ',status
         write(1,*)'Number type of region ',nt,' Rank of region ',rank
         write(1,*)'Value of size ',size
         write(1,*)'Dimensions of region ',dims(1),' ',dims(2)
      endif
      write(*,*)' '
      write(1,*)' '

c Test Case -- swextreg
c
      write(1,27)
      write(*,*)'Testing swextreg '
      write(*,*)'================='
      write(1,*)'Testing swextreg '
      write(1,*)'================='
      status = swextreg(swid, regionid, "Temperature", HDFE_INTERNAL,          &
     1tempbuf) 
      if (status .lt. zero) then
         write(*,*)'********Error unexpected**********'
         write(1,*)'********Error unexpected**********'
         call heprnt(0)
      else
         write(*,*)'  '
         write(*,*)'    ***********Passed Test*********'
         write(1,*)'  '
         write(1,*)'    ***********Passed Test*********'
         write(*,*)'status = swextreg(swid, regionid, "Temperature", HDF       &
     1E_INTERNAL, tempbuf)'
         write(*,*)'Value returned by swextreg ', status
         write(1,*)'status = swextreg(swid, regionid, "Temperature", HDF       &
     1E_INTERNAL,tempbuf)'
         write(1,*)'Value returned by swextreg ', status
         do 210 index1=10,15
            write(*,*)'region value at position ',tempbuf(index1)
            write(1,*)'region value at position ',tempbuf(index1)
  210    continue
      endif

      write(*,*)' '
      write(1,*)' '

c Test Case -- swdeftmeper
c
      write(1,27)
      write(*,*)'Testing swdeftmeper '
      write(*,*)'================='
      write(1,*)'Testing swdeftmeper '
      write(1,*)'================='
      regionid=swdeftmeper(swid, starttime, endtime,HDFE_ENDPOINT)
      if (regionid .lt. zero) then
         write(*,*)'********Error unexpected**********'
         write(1,*)'********Error unexpected**********'
         call heprnt(0)
      else
         write(*,*)'  '
         write(*,*)'    ***********Passed Test*********'
         write(1,*)'  '
         write(1,*)'    ***********Passed Test*********'
         write(*,*)'regionid=swdeftmeper(swid, starttime, endtime, HDFE        &
     1_ENDPOINT)'
         write(*,*)'Value returned by swdeftmeper ',regionid
         write(1,*)'regionid=swdeftmeper(swid, starttime, endtime, HDFE        &
     1_ENDPOINT)'
         write(1,*)'Value returned by swdeftmeper ',regionid
      endif
      write(*,*)' '
      write(1,*)' '

c Test Case -- swperinfo
c
      write(1,27)
      write(*,*)'Testing swperinfo '
      write(*,*)'================='
      write(1,*)'Testing swperinfo '
      write(1,*)'================='
      status = swperinfo(swid, regionid, "Temperature", nt, rank,              &
     1dims,size)
      if (status .lt. zero) then
         write(*,*)'********Error unexpected**********'
         write(1,*)'********Error unexpected**********'
         call heprnt(0)
      else
         write(*,*)'  '
         write(*,*)'    ***********Passed Test*********'
         write(1,*)'  '
         write(1,*)'    ***********Passed Test*********'
         write(*,*)'status = swperinfo(swid, regionid, "Temperature", nt       &
     1, rank, dims, size)'
         write(*,*)'Value returned by swperinfo ',status
         write(*,*)'Rank of field ',rank,' Number type of region ',nt
         write(*,*)'Dimensions of region ',dims(1),' ',dims(2)
         write(1,*)'status = swperinfo(swid, regionid, "Temperature", nt       &
     1, rank, dims, size)'
         write(1,*)'Value returned by swperinfo ',status
         write(1,*)'Rank of field ',rank,' Number type of region ',nt
         write(1,*)'Dimensions of region ',dims(1),' ',dims(2)
      endif
      write(*,*)' '
      write(1,*)' '

c Test Case -- swextper
c
      write(1,27)
      write(*,*)'Testing swextper '
      write(*,*)'================='
      write(1,*)'Testing swextper '
      write(1,*)'================='
      status=swextper(swid, regionid, "Temperature",HDFE_INTERNAL,             &
     1tempbuf)
      if (status .lt. zero) then
         write(*,*)'********Error unexpected**********'
         write(1,*)'********Error unexpected**********'
         call heprnt(0)
      else
         write(*,*)'  '
         write(*,*)'    ***********Passed Test*********'
         write(1,*)'  '
         write(1,*)'    ***********Passed Test*********'
         write(*,*)'status=swextper(swid, regionid, "Temperature", HDFE_       &
     1INTERNAL, tempbuf)'
         write(*,*)'Value returned by swextper swath ',status
         write(1,*)'status=swextper(swid, regionid, "Temperature", HDFE_       &
     1INTERNAL, tempbuf) '
         write(1,*)'Value returned by swextper swath ',status
         do 220 index1=10,15
            write(*,*)'region value at position ',tempbuf(index1)
            write(1,*)'region value at position ',tempbuf(index1)
  220    continue
      endif
      write(*,*)' '
      write(1,*)' '

c Test Case -- swupimap
c

      write(1,27)
      write(*,*)'Testing swupimap '
      write(*,*)'================='
      write(1,*)'Testing swupimap '
      write(1,*)'================='
      regionid=swdefboxreg(swid2, cornerlon, cornerlat,HDFE_ENDPOINT)
      idxsz=swupimap(swid2,regionid,idxmap,upidxmap,indicies)
      if (idxsz .lt. zero) then
         write(*,*)'********Error unexpected**********'
         write(1,*)'********Error unexpected**********'
         call heprnt(0)
      else
         write(*,*)'  '
         write(*,*)'    ***********Passed Test*********'
         write(1,*)'  '
         write(1,*)'    ***********Passed Test*********'
         write(*,*)'Size of index array in region ',idxsz
         write(1,*)'Size of index array in region ',idxsz
         do 380 index1=1,idxsz
            write(*,*)' Value of index array ',upidxmap(index1)
            write(1,*)' Value of index array ',upidxmap(index1)
  380    continue
      endif



      status=swdetach(swid)
      if (status .lt. zero) then
         write(*,*)'********Error unexpected**********'
         write(1,*)'********Error unexpected**********'
         call heprnt(0)
      else
         write(*,*)'  '
         write(*,*)'    ***********Passed Test*********'
         write(1,*)'  '
         write(1,*)'    ***********Passed Test*********'
         write(*,*)'status=swdetach(swid)'
         write(*,*)'Value returned by swdetach ',status
         write(1,*)'status=swdetach(swid)'
         write(1,*)'Value returned by swdetach ',status
      endif
      write(*,*)' '
      write(1,*)' '

      status=swdetach(swid2)
      if (status .lt. zero) then
         write(*,*)'********Error unexpected**********'
         write(1,*)'********Error unexpected**********'
         call heprnt(0)
      else
         write(*,*)'  '
         write(*,*)'    ***********Passed Test*********'
         write(1,*)'  '
         write(1,*)'    ***********Passed Test*********'
         write(*,*)'status=swdetach(swid2)'
         write(*,*)'Value returned by swdetach ',status
         write(1,*)'status=swdetach(swid2)'
         write(1,*)'Value returned by swdetach ',status
      endif
      write(*,*)' '
      write(1,*)' '

      status=swclose(swfid)
      if (status .lt. zero) then
         write(*,*)'********Error unexpected**********'
         write(1,*)'********Error unexpected**********'
         call heprnt(0)
      else
         write(*,*)'  '
         write(*,*)'    ***********Passed Test*********'
         write(1,*)'  '
         write(1,*)'    ***********Passed Test*********'
         write(*,*)'status=swclose(swfid)'
         write(*,*)'Value returned by swclose ',status
         write(1,*)'status=swclose(swfid)'
         write(1,*)'Value returned by swclose ',status
      endif
      write(*,*)' '
      write(1,*)' '

      close(unit=1)
   27 format('')
      stop
      end

c
c  In this example we will write to an appendable field.
c


      program appendfield

      integer            status, i, swfldinfo, swdetach, swclose
      integer            swwrfld, swrdfld
      integer*2          inarray(5), outarray(20)
      integer*4          swfid, swid, rank, dims(1), ntype
      integer*4          start(1), stride(1), count(1)
      integer*4          swopen, swattach
      character*72       dimlist
      
      integer*4          DFACC_RDWR
      parameter (DFACC_RDWR=3)
      
      
      do i=1,5
         inarray(i) = i
      enddo
      
      swfid = swopen("SwathFile_created_with_hadeos_sample_file_writer_o
     1f_HDFEOS2_version_219_or_higher_release.hdf", DFACC_RDWR)
      swid = swattach(swfid, "Swath1")


c     Write 5 records to field
c     ------------------------
      start(1) = 0
      stride(1) = 1
      count(1) = 5
      status = swwrfld(swid, "Count", start, stride, count, inarray)

      status = swfldinfo(swid, "Count", rank, dims, ntype, dimlist)
      write(*,*) 'Number of elements after first write:' ,dims(1)



c     Append 1 record to field
c     ------------------------
      start(1) = dims(1)
      count(1) = 1
      status = swwrfld(swid, "Count", start, stride, count, inarray)
      status = swfldinfo(swid, "Count", rank, dims, ntype, dimlist)
      write(*,*) 'Number of elements after append:' ,dims(1)

      start(1) = 0
      count(1) = dims(1)
      status = swrdfld(swid, "Count", start, stride, dims, outarray)    
      do i=1,dims(1)
         write(*,*) 'Data Element:', outarray(i)
      enddo

      status = swdetach(swid)
      status = swclose(swfid)

      stop
      end

c23456789012345678901234567890123456789012345678901234567890123456789012
c testgrid.f
c In this program we create, define and write a simple grid hdfeos file
c using the grid interface
c

      program testgrid
      
      integer*4		index1
      integer*4		index2
      integer*4		dimsizes(2)
      integer*4		regionid, regionid2
      integer*4		tiledims(2), tilecords(2)
      integer*4		tileray(16,15)
      integer*4		tilebuffer(240)
      integer*4		tilecode, tilerank
      integer*4		itiledims(2)
      integer*4		tileinit
      real*4		ray3(250)
      real*4		utmray(60,80), georay(60,80)
      real*4		utmhght(80)
      real*4		hghtinit
      real*8		utmtmeray(4800)
      real*8		tmeinit
      real*4		utmcnt, geocnt
      real*4		fillvalue, ifillv
      real*4		raycnt, ray3cnt
      real*4		tempray(60,80)
      real*4		datbuf(4800)
      
      integer   	status, i, ii
      integer		compparm(5)
      integer*4		lstatus, n, one
      integer*4 	gdfid, gdfid2, gdid_utm, gdid2
      integer*4 	zonecode, compcode
      integer*4		attr(4), iattr(4)
      integer*4 	spherecode, xdim, ydim, zero
      integer*4		tmpvar1, nt, rk, size, tmpvar2
      integer*4 	start(2)
      integer*4 	stride(2)
      integer*4 	edge(2)
      integer*4 	start1d, stride1d, edge1d
      integer*4		periodid
      real*8		starttime, stoptime
      real*8		range(2)
      real*8		projparm(16), pparm(16)
      real*8		uplft(2), lowrgt(2)
      real*8		iuplft(2), ilrgt(2)
      real*8		interval(5,2)
      real*8		lonval(5), latval(5)
      integer*4		rowval(5), colval(5)
      real*4		fldval(5)

      integer*4		lat(40,50)
      integer*4		latcnt
      integer*4		lon(40,50)
      integer*4		loncnt

      integer   	gddefproj, gddefdim, gddeffld, gddetach 
      integer		gdclose, gdgetfill, gdreginfo
      integer   	gdwrfld, gdwrattr, gdsetfill, gddeforigin
      integer		gdgridinfo, gdprojinfo,gdfldinfo
      integer		gdrdfld, gddefpreg,gdrdattr, gdextreg
      integer		gdattrinfo, gdwrmeta, gddefcomp
      integer		gdcompinfo, gddeftle, gdrdtle
      integer		gdsettleche, gdtleinfo, gdwrtle
      integer		gddupreg, gdgetpix
      integer*4 	gdopen, gdcreate, gdattach, gdinqgrid
      integer*4		gdinqdims, gddiminfo, gdinqflds
      integer*4		gdnentries, gdinqattrs, gddefboxreg
      integer*4		gdorginfo, gdpreginfo
      integer*4		gdinterpolate, gddeftmeper
      integer*4		gddefvrtreg, gdgetpixval

      integer*4		strbufsize, pcode,nflds
      integer		zcode, scode
      character*80	grdnames, dimname, fldlist, attrlist
      integer*4		dims(8), rnk(8), numtype(8)
      real*8		upleftpt(2), lowrtpt(2),corlon(2),corlat(2)
      integer*4		xdimsize, ydimsize
      
      integer DFACC_CREATE
      parameter (DFACC_CREATE=4)
      integer DFACC_RDWR
      parameter (DFACC_RDWR=3)
      integer DFACC_READ
      parameter (DFACC_READ=1)      
      integer GCTP_UTM
      parameter (GCTP_UTM=1)

      integer DFNT_FLOAT32
      parameter (DFNT_FLOAT32=5)
      integer DFNT_FLOAT64
      parameter (DFNT_FLOAT64=6)
      integer DFNT_INT32
      parameter (DFNT_INT32=24)      
      
      integer HDFE_NOMERGE
      parameter (HDFE_NOMERGE=0)
      integer HDFE_AUTOMERGE
      parameter (HDFE_AUTOMERGE=1)
      
      integer HDFE_CORNER
      parameter (HDFE_CORNER=1)
      integer HDFE_GD_UL
      parameter (HDFE_GD_UL=0)
      integer HDFE_NENTDIM
      parameter(HDFE_NENTDIM=0)
      integer HDFE_NENTDFLD
      parameter (HDFE_NENTDFLD=4)

      integer HDFE_COMP_SKPHUFF
      parameter (HDFE_COMP_SKPHUFF=3)
      integer HDFE_COMP_NONE
      parameter (HDFE_COMP_NONE=0)

      integer HDFE_NOPREVSUB
      parameter (HDFE_NOPREVSUB=-1)
 
      integer HDFE_NOTILE
      parameter (HDFE_NOTILE=0)
      integer HDFE_TILE
      parameter (HDFE_TILE=1)

      index1 = 0
      index2 = 0
      dimsizes(1) = 40
      dimsizes(2) = 100
      compparm(1) = 0
      compparm(2) = 0
      compparm(3) = 0
      compparm(4) = 0
      compparm(5) = 0
      fillvalue = 1996.0
      raycnt = -799.0
      ray3cnt = -19.5
      attr(1) = 11
      attr(2) = 33
      attr(3) = 66
      attr(4) = 99
      utmcnt=-799.0
      geocnt=2001.0
      hghtinit = 323.0
      tmeinit = 35232487.2d0
      starttime = 35233000.8d0
      stoptime = 35435050.9d0
      range(1) = 352.8d0
      range(2) = 400.9d0
      lonval(1) = -122.0d0
      latval(1) = -68.0d0
      lonval(2) = -122.5d0
      latval(2) = -68.0d0
      lonval(3) = -123.0d0
      latval(3) = -68.0d0
      lonval(4) = -123.5d0
      latval(4) = -68.0d0
      lonval(5) = -124.0d0
      latval(5) = -68.0d0
      tileinit = -299.5
      tiledims(1) = 16
      tiledims(2) = 15
      tilecords(1) = 0
      tilecords(2) = 0

      latcnt = 38.0
      loncnt = 78.0
      zero = 0
      one = 1
      
c
c This section of the program just fills some arrays with data that we will
c use later in the program
c
      do 70 index1=1,60
         do 80 index2=1,80
            utmray(index2,index1) = utmcnt
            georay(index2,index1) = geocnt
            utmcnt = utmcnt + .4
            geocnt = geocnt + .2
   80   continue
   70 continue
  
      
      do 30 index1=1,250
            ray3(index1) = ray3cnt
            ray3cnt = ray3cnt + .1
   30 continue
      
      do 32 index1=1,80
            utmhght(index1) = hghtinit
            hghtinit = hghtinit + 2.75
   32 continue

      do 34 index1=1,4800
            utmtmeray(index1) = tmeinit
            tmeinit = tmeinit + 70.7
   34 continue

      do 50 index1=1,50
         do 60 index2=1,40      
            lat(index2,index1) = latcnt
            lon(index2,index1) = loncnt
            loncnt = loncnt - 0.1
   60    continue
         latcnt = latcnt + 0.1
         loncnt = 78.0
   50 continue

      do 51 index1=1,16
         do 52 index2=1,15
            tileray(index1,index2) = tileinit
            tileinit = tileinit + 0.5
   52    continue
   51 continue
      
  230 format('********Error unexpected**********')
  231 format('********Error Expected************')
  240 format('***********Passed Test*********')


      open(unit=10, file='testgridf.txt', status = "NEW")

      write(*,*)'Testing Grid FORTRAN 77 interface '
      write(*,*)'=================================='
      write(10,*)'Testing Grid FORTRAN 77 interface '
      write(10,*)'=================================='
      write(10,*)' '
      write(*,*)' '

c Test Case -- gdopen
c
      write(10,*)'Testing gdopen... '
      write(10,*)'=================='
      write(*,*)'Testing gdopen... '
      write(*,*)'=================='
      write(*,*)'Opening non-existing file Gridf_Test2.hdf for reading'
      write(10,*)'Opening non-existing file Gridf_Test2.hdf for reading'
      gdfid2 = gdopen("Gridf_Test2.hdf", DFACC_READ)
      if (gdfid2 .lt. zero) then
         write(*,240)
         write(10,240)
         write(*,231)
         write(10,231)
         call heprnt(0)
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(10,*)'gdfid2 = gdopen("Gridf_Test2.hdf", DFACC_READ)'
         write(10,*)'Value returned by gdopen ', gdfid2
         write(*,*)'gdfid2 = gdopen("Gridf_Test2.hdf", DFACC_READ)'
         write(*,*)'Value returned by gdopen ', gdfid2
      endif
      write(*,*)' '
      write(10,*)' '

      gdfid = gdopen('Gridf_Test.hdf', DFACC_CREATE)
      if (gdfid .lt. zero) then
         write(*,230)
         write(10,230)
         call heprnt(0)
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(*,*)'Opening file Gridf_Test.hdf'
         write(10,*)'Opening file Gridf_Test.hdf'
         write(10,*) 'gdfid = gdopen("Gridf_Test.hdf", DFACC_CREATE)'
         write(10,*) 'File id returned from gdopen ', gdfid
         write(*,*) 'gdfid = gdopen("Gridf_Test.hdf", DFACC_CREATE)'
         write(*,*) 'File id returned from gdopen ', gdfid
      endif
      write(10,*)' '
      write(*,*)' '


c Test Case -- gdcreate
c
      write(10,27)
      write(10,*)'Testing gdcreate... '
      write(10,*)'=================='
      write(*,*)'Testing gdcreate... '
      write(*,*)'=================='

      xdim = 60
      ydim = 80
      uplft(1) = 353299.39125d0
      uplft(2) = -7100284.64348d0
      lowrgt(1) = 603434.52148d0
      lowrgt(2) = -7991341.17870d0


      gdid2 = gdcreate(gdfid2, 'UTMGrid2', xdim, ydim, uplft, lowrgt)
      if (gdid2 .lt. zero) then
         write(*,231)
         write(10,231)
         call heprnt(0)
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(10,*) 'Create UTMGrid2'
         write(*,*)'gdid2 = gdcreate(gdfid2, "UTMGrid2", xdim, ydim, upl       &
     1ft, lowrgt)'
         write(10,*) 'Value returned by gdcreate ', gdid2
         write(*,*) 'Create UTMGrid2'
         write(10,*)'gdid2 = gdcreate(gdfid2, "UTMGrid2", xdim, ydim, up       &
     1lft, lowrgt)'
         write(*,*) 'Value returned by gdcreate ', gdid2
      endif
      
    
      gdid_utm = gdcreate(gdfid, 'UTMGrid', xdim, ydim, uplft, lowrgt)
      if (gdid_utm .lt. zero) then
         write(*,230)
         write(10,230)
         call heprnt(0)
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(10,*)'Creating UTMGrid'
         write(*,*)'Creating UTMGrid'
         write(*,*)'gdid_utm=gdcreate(gdfid,"UTMGrid",xdim,ydim,uplft,lo       &
     1wrgt)'
         write(10,*)'gdid_utm=gdcreate(gdfid,"UTMGrid",xdim,ydim,uplft,l       &
     1owrgt)'
         write(10,*)'UTM grid id returned from gdcreate ', gdid_utm
         write(*,*)'UTM grid id returned from gdcreate ', gdid_utm
      endif 
      write(10,*)' '
      write(*,*)' '

c Test Case -- gddefproj
c
      write(10,27)
      write(10,*)'Testing gddefproj... '
      write(10,*)'=================='
      write(*,*)'Testing gddefproj... '
      write(*,*)'=================='

      zonecode = 10
      spherecode = 0

      do 120 index1=1,16
         projparm(index1)=0
 120  continue
  
      status = gddefproj(gdid_utm,GCTP_UTM,zonecode,spherecode,projparm)
      if (status .lt. zero) then
         write(*,230)
         write(10,230)
         call heprnt(0)
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(10,*)'Defining UTM projection'
         write(*,*)'Defining UTM projection'
         write(*,*)'status=gddefproj(gdid_utm,GCTP_UTM,zonecode,sphereco       &
     1de, projparm)'
         write(10,*)'status=gddefproj(gdid_utm,GCTP_UTM,zonecode,spherec       &
     1ode, projparm)'
         write(10,*)'Returned value from gddefproj ', status
         write(*,*)'Returned value from gddefproj ', status
      endif 
      write(10,*)' '
      write(*,*)' '

      status = gddefproj(gdid2,GCTP_UTM,zonecode,spherecode,projparm)
      if (status .lt. zero) then
         write(*,231)
         write(10,231)
         call heprnt(0)
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(10,*)'Defining UTM'
         write(10,*)'status = gddefproj(gdid2,GCTP_UTM,zonecode,sphereco       &
     1de,projparm)'
         write(10,*)'Value returned by gddefproj ', status
         write(*,*)'Defining UTM'
         write(*,*)'status = gddefproj(gdid2,GCTP_UTM,zonecode,spherecod       &
     1e,projparm)'
         write(*,*)'Value returned by gddefproj ', status
      endif
      write(10,*)' '
      write(*,*)' '


c Test Case -- gddefpreg
c
      write(10,27)
      write(10,*)'Testing gddefpreg... '
      write(10,*)'=================='
      write(*,*)'Testing gddefpreg... '
      write(*,*)'=================='
      status = gddefpreg(gdid_utm, HDFE_CORNER)
      if (status .lt. zero) then
         write(*,230)
         write(10,230)
         call heprnt(0)
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(*,*)'status = gddefpreg(gdid_utm, HDFE_CORNER)'
         write(10,*)'status = gddefpreg(gdid_utm, HDFE_CORNER)'
         write(10,*)'Returned from gddefpreg ', status
         write(*,*)'Returned from gddefpreg ', status
      endif
      write(10,*)' '
      write(*,*)' '

c Test Case -- gddeforigin
c
      write(10,27)
      write(10,*)'Testing gddeforigin... '
      write(10,*)'=================='
      write(*,*)'Testing gddeforigin... '
      write(*,*)'=================='
      status = gddeforigin(gdid_utm, HDFE_GD_UL)
      if (status .lt. zero) then
         write(*,230)
         write(10,230)
         call heprnt(0)
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(*,*)'status = gddeforigin(gdid_utm, HDFE_GD_UL)'
         write(*,*)'Value of status from gddeforigin ',status
         write(10,*)'status = gddeforigin(gdid_utm, HDFE_GD_UL)'
         write(10,*)'Value of status from gddeforigin ',status
      endif
      write(10,*)' '
      write(*,*)' '

c Test Case -- gddefdim
c
      write(10,27)
      write(10,*)'Testing gddefdim... '
      write(10,*)'=================='
      write(*,*)'Testing gddefdim... '
      write(*,*)'=================='
      status = gddefdim(gdid2, 'TestDim1', 40)
      if (status .lt. zero) then
         write(*,231)
         write(10,231)
         call heprnt(0)
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(10,*)'status = gddefdim(gdid2, "TestDim1", 40)'
         write(10,*)'Value returned by gddefdim ', status
         write(*,*)'status = gddefdim(gdid2, "TestDim1", 40)'
         write(*,*)'Value returned by gddefdim ', status
      endif
      write(10,*)' '
      write(*,*)' '

      status = gddefdim(gdid2, 'TestDim2', 25)
      if (status .lt. zero) then
         write(*,231)
         write(10,231)
         call heprnt(0)
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(10,*)'status = gddefdim(gdid2, "TestDim2", 25)'
         write(10,*)'Value returned by gddefdim ', status
         write(*,*)'status = gddefdim(gdid2, "TestDim2", 25)'
         write(*,*)'Value returned by gddefdim ', status
      endif
      write(10,*)' '
      write(*,*)' '


      status = gddefdim(gdid_utm, 'Conduction', 250)
      if (status .lt. zero) then
         write(*,230)
         write(10,230)
         call heprnt(0)
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(10,*)'status = gddefdim(gdid_utm, "Conduction", 250)'
         write(10,*)'Returned value from gddefdim ', status
         write(*,*)'status = gddefdim(gdid_utm, "Conduction", 250)'
         write(*,*)'Returned value from gddefdim ', status
      endif
      write(10,*)' '
      write(*,*)' '

      status = gddefdim(gdid_utm,'Timedim',4800)
      if(status .lt. zero) then
         write(*,230)
         write(10,230)
         call heprnt(0)
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(10,*)'status = gddefdim(gdid_utm,"Timedim",4800)'
         write(10,*)'Status returned by call to gddefdim ',status
         write(*,*)'status = gddefdim(gdid_utm,"Timedim",4800)'
         write(*,*)'Status returned by call to gddefdim ',status
      endif
      write(10,*)' '
      write(*,*)' '

      status = gddefdim(gdid_utm,'Hghtdim',80)
      if(status .lt. zero) then
         write(*,230)
         write(10,230)
        call heprnt(0)
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
        write(10,*)'status = gddefdim(gdid_utm,"Hghtdim",80)'
        write(10,*)'Status returned by call to gddefdim ',status
        write(*,*)'status = gddefdim(gdid_utm,"Hghtdim",80)'
        write(*,*)'Status returned by call to gddefdim ',status
      endif
      write(10,*)' '
      write(*,*)' '

      status = gddefdim(gdid_utm,'Convection',60)
      if(status .lt. zero) then
         write(*,230)
         write(10,230)
        call heprnt(0)
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
        write(10,*)'Define dimension Convection '
        write(10,*)'status = gddefdim(gdid_utm,"Convection",60)'
        write(10,*)'Status returned by call to gddefdim ',status
        write(*,*)'Define dimension Convection '
        write(*,*)'status = gddefdim(gdid_utm,"Convection",60)'
        write(*,*)'Status returned by call to gddefdim ',status
      endif
      write(10,*)' '
      write(*,*)' '

c Test Case -- gddetach
c
      write(10,27)
      write(10,*)'Testing gddetach... '
      write(10,*)'=================='
      write(*,*)'Testing gddetach... '
      write(*,*)'=================='
      status = gddetach(gdid2)
      if(status .lt. zero) then
         write(*,231)
         write(10,231)
        call heprnt(0)
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(10,*)'status = gddetach(gdid2)'
         write(10,*)'Value returned by gddetach ', status
         write(*,*)'status = gddetach(gdid2)'
         write(*,*)'Value returned by gddetach ', status
      endif
      write(10,*)' '
      write(*,*)' '

      status = gddetach(gdid_utm)
      if(status .lt. zero) then
         write(*,230)
         write(10,230)
        call heprnt(0)
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(10,*)'status = gddetach(gdid_utm)'
         write(10,*)'Returned value from gddetach ', status
         write(*,*)'status = gddetach(gdid_utm)'
         write(*,*)'Returned value from gddetach ', status
      endif
      write(10,*)' '
      write(*,*)' '
 
c Test Case -- gdattach
c
      write(10,27)
      write(10,*)'Testing gdattach... '
      write(10,*)'=================='
      write(*,*)'Testing gdattach... '
      write(*,*)'=================='
      gdid_utm = gdattach(gdfid, 'UTMGrid')
      if(gdid_utm .lt. zero) then
         write(*,230)
         write(10,230)
        call heprnt(0)
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(10,*)'gdid_utm = gdattach(gdfid, "UTMGrid")'
         write(10,*)'Handle returned from gdattach ', gdid_utm
         write(*,*)'gdid_utm = gdattach(gdfid, "UTMGrid")'
         write(*,*)'Handle returned from gdattach ', gdid_utm
      endif
      write(10,*)' '
      write(*,*)' '

      gdid2 = gdattach(gdfid2, 'UTMGrid2')
      if(gdid_utm .lt. zero) then
         write(*,230)
         write(10,230)
        call heprnt(0)
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(10,*)'gdid2 = gdattach(gdfid2, "UTMGrid2")'
         write(10,*)'Value returned by gdattach ', status
         write(*,*)'gdid2 = gdattach(gdfid2, "UTMGrid2")'
         write(*,*)'Value returned by gdattach ', status
      endif
      write(10,*)' '
      write(*,*)' '

c Test Case -- gddeffld
c
      write(10,27)
      write(10,*)'Testing gddeffld... '
      write(10,*)'=================='
      write(*,*)'Testing gddeffld... '
      write(*,*)'=================='

      status=gddeffld(gdid2,'tempfield','TestDim2,TestDim1',DFNT_FLOAT32       &
     1,HDFE_NOMERGE)
      if(status .lt. zero) then
         write(*,231)
         write(10,231)
        call heprnt(0)
      else 
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
        write(10,*)'Define: "tempfield"'
        write(10,*)'status=gddeffld(gdid2,"tempfield","TestDim2,TestDim1       &
     1",DFNT_FLOAT32,HDFE_NOMERGE)'
        write(10,*)'Value returned by gddeffld ', status
        write(*,*)'Define: "tempfield"'
        write(*,*)'status=gddeffld(gdid2,"tempfield","TestDim2,TestDim1"       &
     1",DFNT_FLOAT32,HDFE_NOMERGE)'
        write(*,*)'Value returned by gddeffld ', status
      endif
      write(10,*)' '
      write(*,*)' '

      status=gddeffld(gdid_utm,'Time','Timedim',DFNT_FLOAT64,HDFE_NOMERG       &
     1E)
      if(status .lt. zero) then
         write(*,230)
         write(10,230)
        call heprnt(0)
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
        write(10,*)' Define field Time'
        write(10,*)'status=gddeffld(gdid_utm,"Time","Timedim",DFNT_FLOAT       &
     164,HDFE_NOMERGE)'
        write(10,*)'Status returned by call to gddeffld ',status
        write(*,*)' Define field Time'
        write(*,*)'status=gddeffld(gdid_utm,"Time","Timedim",DFNT_FLOAT6       &
     14,HDFE_NOMERGE)'
        write(*,*)'Status returned by call to gddeffld ',status
      endif
      write(10,*)' '
      write(*,*)' '

c23456789012345678901234567890123456789012345678901234567890123456789012
      status=gddeffld(gdid_utm,'Height','Hghtdim',DFNT_FLOAT32,HDFE_NOME       &
     1RGE)
      if(status .lt. zero) then
         write(*,230)
         write(10,230)
        call heprnt(0)
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
        write(10,*)' Define field Height'
        write(10,*)'status=gddeffld(gdid_utm,"Height","Hghtdim",DFNT_FLO       &
     1AT32,HDFE_NOMERGE)'
        write(10,*)'Status returned by call to gddeffld ',status
        write(*,*)' Define field Height'
        write(*,*)'status=gddeffld(gdid_utm,"Height","Hghtdim",DFNT_FLOA       &
     1T32,HDFE_NOMERGE)'
        write(*,*)'Status returned by call to gddeffld ',status
      endif
      write(10,*)' '
      write(*,*)' '

c Test Case -- gddeftle
c
      write(10,27)
      write(10,*)'Testing gddeftle... '
      write(10,*)'=================='
      write(*,*)'Testing gddeftle... '
      write(*,*)'=================='

      status = gddeftle(gdid_utm,HDFE_TILE,2,tiledims)
      if (status .lt. zero) then
         write(*,230)
         write(10,230)
        call heprnt(0)
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
        write(10,*)'Define tiling dimensions '
        write(10,*)'status = gddeftle(gdid_utm,HDFE_TILE,2,tiledims)'
        write(10,*)'Status returned by call to gddeftle ',status
        write(*,*)'Status returned by call to gddeftle ',status
        write(*,*)'status = gddeftle(gdid_utm,HDFE_TILE,2,tiledims)'
        write(*,*)'Define tiling dimensions '
      endif
      write(10,*)' '
      write(*,*)' '

      status=gddeffld(gdid_utm,'SideB','YDim,Convection',DFNT_INT32,HDFE       &
     1_NOMERGE)
      if (status .lt. zero) then
         write(*,230)
         write(10,230)
        call heprnt(0)
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
        write(10,*)'Define field that will be tiled '
        write(10,*)'status=gddeffld(gdid_utm,"SideB","YDim,Convection",D       &
     1FNT_INT32,HDFE_NOMERGE)'
        write(10,*)'Status returned by call to gddeffld ',status
        write(*,*)'Define field that will be tiled '
        write(*,*)'status=gddeffld(gdid_utm,"SideB","YDim,Convection",DF       &
     1NT_INT32,HDFE_NOMERGE)'
        write(*,*)'Status returned by call to gddeffld ',status
      endif
      write(10,*)' '
      write(*,*)' '

      status = gddeftle(gdid_utm,HDFE_NOTILE,0,tiledims)
      if (status .lt. zero) then
         write(*,230)
         write(10,230)
        call heprnt(0)
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
        write(10,*)'Turn off tiling '
        write(10,*)'status = gddeftle(gdid_utm,HDFE_NOTILE,0,tiledims)'
        write(10,*)'Status returned by call to gddeftle ',status
        write(*,*)'Turn off tiling '
        write(*,*)'status = gddeftle(gdid_utm,HDFE_NOTILE,0,tiledims)'
        write(*,*)'Status returned by call to gddeftle ',status
      endif
      write(10,*)' '
      write(*,*)' '

      status = gddetach(gdid_utm)
      if (status .lt. zero) then 
         write(*,230)
         write(10,230)
        call heprnt(0)
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(10,*)'status = gddetach(gdid_utm)'
         write(10,*)'Returned value from gddetach ', status
         write(*,*)'status = gddetach(gdid_utm)'
         write(*,*)'Returned value from gddetach ', status
      endif
      write(10,*)' '
      write(*,*)' '

      gdid_utm = gdattach(gdfid, 'UTMGrid')
      if (gdid_utm .lt. zero) then
         write(*,230)
         write(10,230)
        call heprnt(0)
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(10,*)'status = gdattach(gdfid,"UTMGrid")'
         write(10,*)'Returned value from gdattach ', status
         write(*,*)'status = gddetach(gdfid,"UTMGrid")'
         write(*,*)'Returned value from gdattach ', status
      endif
      write(10,*)' '
      write(*,*)' '

c Test Case -- gddefcomp
c
      write(10,27)
      write(10,*)'Testing gddefcomp... '
      write(10,*)'=================='
      write(*,*)'Testing gddefcomp... '
      write(*,*)'=================='

      status = gddefcomp(gdid_utm,HDFE_COMP_SKPHUFF, compparm)
      if(status .lt. zero) then
         write(*,230)
         write(10,230)
        call heprnt(0)
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
        write(10,*)'Setup compression mode'
        write(10,*)'status = gddefcomp(gdid_utm,HDFE_COMP_SKPHUFF, compp       &
     1arm)'
        write(10,*)'Status returned by call to gddefcomp ',status
        write(*,*)'Setup compression mode'
        write(*,*)'status = gddefcomp(gdid_utm,HDFE_COMP_SKPHUFF, comppa       &
     1rm)'
        write(*,*)'Status returned by call to gddefcomp ',status
      endif
      write(10,*)' '
      write(*,*)' '

      status = gddeffld(gdid_utm,'Voltage','XDim,YDim',DFNT_FLOAT32,HDFE       &
     1_AUTOMERGE)
      if(status .lt. zero) then
         write(*,230)
         write(10,230)
        call heprnt(0)
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
        write(10,*)'Define: "Voltage"'
        write(10,*)'status = gddeffld(gdid_utm,"Voltage","XDim,YDim",DFN       &
     1T_FLOAT32,HDFE_AUTOMERGE)'
        write(10,*)'Value returned from gddeffld ', status
        write(*,*)'Define: "Voltage"'
        write(*,*)'status = gddeffld(gdid_utm,"Voltage","XDim,YDim",DFNT       &
     1_FLOAT32,HDFE_AUTOMERGE)'
        write(*,*)'Value returned from gddeffld ', status
      endif
      write(10,*)' '
      write(*,*)' '

      status = gddefcomp(gdid_utm,HDFE_COMP_NONE, compparm)
      if(status .lt. zero) then
         write(*,230)
         write(10,230)
        call heprnt(0)
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
        write(10,*)'Turn off compression'
        write(10,*)'status=gddefcomp(gdid_utm,HDFE_COMP_NONE,compparm)'
        write(10,*)'Status returned by call to gddefcomp ',status
        write(*,*)'Turn off compression'
        write(*,*)'status=gddefcomp(gdid_utm,HDFE_COMP_NONE,compparm)'
        write(*,*)'Status returned by call to gddefcomp ',status
      endif
      write(10,*)' '
      write(*,*)' '

      status=gddeffld(gdid_utm,'Drift','XDim,YDim',DFNT_FLOAT32,HDFE_AUT       &
     1OMERGE)
      if(status .lt. zero) then
         write(*,230)
         write(10,230)
        call heprnt(0)
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
        write(10,*)'Define: "Drift"'      
        write(10,*)'status=gddeffld(gdid_utm,"Drift","XDim,YDim",DFNT_FL       &
     1OAT32,HDFE_AUTOMERGE)'
        write(10,*)'Value returned from gddeffld ', status
        write(*,*)'Define: "Drift"'      
        write(*,*)'status=gddeffld(gdid_utm,"Drift","XDim,YDim",DFNT_FLO       &
     1OAT32,HDFE_AUTOMERGE)'
        write(*,*)'Value returned from gddeffld ', status
      endif
      write(10,*)' '
      write(*,*)' '

      status=gddeffld(gdid_utm,'Impedance','XDim,YDim',DFNT_FLOAT32,HDF       &
     1E_AUTOMERGE)
      if(status .lt. zero) then
         write(*,230)
         write(10,230)
        call heprnt(0)
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(10,*)'Define: "Impedance"'            
         write(10,*)'status=gddeffld(gdid_utm,"Impedance","XDim,YDim",DF       &
     1NT_FLOAT32,HDFE_AUTOMERGE)'
         write(10,*)'Value returned from gddeffld ', status
         write(*,*)'Define: "Impedance"'            
         write(*,*)'status=gddeffld(gdid_utm,"Impedance","XDim,YDim",DFN       &
     1T_FLOAT32,HDFE_AUTOMERGE)'
         write(*,*)'Value returned from gddeffld ', status
      endif
      write(10,*)' '
      write(*,*)' '

      status=gddeffld(gdid_utm,'Grounding','Conduction',DFNT_FLOAT32,HDF       &
     1_NOMERGE)
      if(status .lt. zero) then
         write(*,230)
         write(10,230)
        call heprnt(0)
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(10,*)'Define: "Grounding"'                  
         write(10,*)'status=gddeffld(gdid_utm,"Grounding","Conduction",D       &
     1FNT_FLOAT32,HDF_NOMERGE)'
         write(10,*)'Value returned by gddeffld ', status
         write(*,*)'Define: "Grounding"'                  
         write(*,*)'status=gddeffld(gdid_utm,"Grounding","Conduction",DF       &
     1NT_FLOAT32,HDF_NOMERGE)'
         write(*,*)'Value returned by gddeffld ', status
      endif
      write(10,*)' '
      write(*,*)' '

c Test Case -- gdwrmeta
c
      write(10,27)
      write(10,*)'Testing gdwrmeta... '
      write(10,*)'=================='
      write(*,*)'Testing gdwrmeta... '
      write(*,*)'=================='

      status = gdwrmeta(gdid_utm,'Extern','XDim,YDim',DFNT_FLOAT32)
      if(status .lt. zero) then
         write(*,230)
         write(10,230)
        call heprnt(0)
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(*,*)'status = gdwrmeta(gdid_utm,"Extern","XDim,YDim",DFNT       &
     1_FLOAT32)'
         write(*,*)'Value returned by gdwrmeta ',status
         write(10,*)'status = gdwrmeta(gdid_utm,"Extern","XDim,YDim",DFN       &
     1T_FLOAT32)'
         write(10,*)'Value returned by gdwrmeta ',status
      endif
      write(10,*)' '
      write(*,*)' '

c Test Case -- gdsetfill
c
      write(10,27)
      write(10,*)'Testing gdsetfill... '
      write(10,*)'=================='
      write(*,*)'Testing gdsetfill... '
      write(*,*)'=================='

      status = gdsetfill(gdid_utm, 'Drift', fillvalue)
      if(status .lt. zero) then
         write(*,230)
         write(10,230)
        call heprnt(0)
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(10,*)'Testing gdsetfill'
         write(10,*)'status = gdsetfill(gdid_utm, "Drift", fillvalue)'
         write(10,*)'Returned from gdsetfill ', status
         write(*,*)'Testing gdsetfill'
         write(*,*)'status = gdsetfill(gdid_utm, "Drift", fillvalue)'
         write(*,*)'Returned from gdsetfill ', status
      endif
      write(10,*)' '
      write(*,*)' '

      status = gddetach(gdid_utm)
      if(status .lt. zero) then
         write(*,230)
         write(10,230)
        call heprnt(0)
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(10,*)'status = gddetach(gdid_utm)'
         write(*,*)'status = gddetach(gdid_utm)'
         write(10,*)'Returned value from gddetach ', status
         write(*,*)'Returned value from gddetach ', status
      endif
      write(10,*)' '
      write(*,*)' '

      gdid_utm = gdattach(gdfid, 'UTMGrid')
      if(gdid_utm .lt. zero) then
         write(*,230)
         write(10,230)
        call heprnt(0)
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(10,*)'gdid_utm = gdattach(gdfid, "UTMGrid")'
         write(10,*)'Handle returned from gdattach ', gdid_utm
         write(*,*)'gdid_utm = gdattach(gdfid, "UTMGrid")'
         write(*,*)'Handle returned from gdattach ', gdid_utm
      endif
      write(10,*)' '
      write(*,*)' '

c Test Case -- gdwrfld
c
      write(10,27)
      write(10,*)'Testing gdwrfld... '
      write(10,*)'=================='
      write(*,*)'Testing gdwrfld... '
      write(*,*)'=================='

      start(1) = 0
      start(2) = 0
      stride(1) = 1
      stride(2) = 1
      edge(1) = 60
      edge(2) = 80
      
      status = gdwrfld(gdid_utm, 'Voltage', start, stride, edge, utmray)
      if (status .lt. zero) then
         write(*,230)
         write(10,230)
        call heprnt(0)
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
        write(10,*)'Write to field Voltage '
        write(10,*)'status=gdwrfld(gdid_utm,"Voltage",start,stride,edge,       &
     1utmray)'
        write(10,*)'Status returned by gdwrfield ', status
        write(*,*)'Write to field Voltage '
        write(*,*)'status=gdwrfld(gdid_utm,"Voltage",start,stride,edge,u       &
     1tmray)'
        write(*,*)'Status returned by gdwrfield ', status
      endif
      write(10,*)' '
      write(*,*)' '


      start(1) = 10
      start(2) = 10
      edge(1) = 10
      edge(2) = 10
      status = gdwrfld(gdid_utm, 'Drift', start,stride,edge,utmray)
      if (status .lt. zero) then
         write(*,230)
         write(10,230)
        call heprnt(0)
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
        write(10,*)'Write to field Drift '
        write(10,*)'status = gdwrfld(gdid_utm,"Drift",start,stride,edge,       &
     1utmray)'
        write(10,*)'Status returned from gdwrfld ', status
        write(*,*)'Write to field Drift '
        write(*,*)'status = gdwrfld(gdid_utm,"Drift",start,stride,edge,u       &
     1tmray)'
        write(*,*)'Status returned from gdwrfld ', status
      endif
      write(10,*)' '
      write(*,*)' '

      start(1) = 0
      start(2) = 0
      edge(1) = 60
      edge(2) = 80
      status = gdwrfld(gdid_utm, 'Impedance', start,stride,edge,utmray)
      if (status .lt. zero) then
         write(*,230)
         write(10,230)
        call heprnt(0)
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
        write(10,*)'Write to field Impedance '
        write(10,*)'status=gdwrfld(gdid_utm,"Impedance",start,stride,edg       &
     1e,utmray)'
        write(10,*)'Returned from gdwrfld ', status
        write(*,*)'Write to field Impedance '
        write(*,*)'status=gdwrfld(gdid_utm,"Impedance",start,stride,edge       &
     1,utmray)'
        write(*,*)'Returned from gdwrfld ', status
      endif
      write(10,*)' '
      write(*,*)' '

      start1d=0
      stride1d=1
      edge1d=4800
      status=gdwrfld(gdid_utm,'Time',start1d,stride1d,edge1d,utmtmeray)
      if (status .lt. zero) then
         write(*,230)
         write(10,230)
        call heprnt(0)
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
        write(10,*)'Write to field Time '
        write(10,*)'status=gdwrfld(gdid_utm,"Time",start1d,stride1d,edge       &
     11d,utmtmeray)'
        write(10,*)'Status returned by call to gdwrfld ',status
        write(*,*)'Write to field Time '
        write(*,*)'status=gdwrfld(gdid_utm,"Time",start1d,stride1d,edge1       &
     1d,utmtmeray)'
        write(*,*)'Status returned by call to gdwrfld ',status
      endif
      write(10,*)' '
      write(*,*)' '

      start1d=0
      stride1d=1
      edge1d=80
      status=gdwrfld(gdid_utm,'Height',start1d,stride1d,edge1d,utmhght)
      if (status .lt. zero) then
         write(*,230)
         write(10,230)
        call heprnt(0)
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
        write(10,*)'Write to field Height '
        write(10,*)'status=gdwrfld(gdid_utm,"Height",start1d,stride1d,ed       &
     1ge1d,utmhght)'
        write(10,*)'Status returned by call to gdwrfld ',status
        write(*,*)'Write to field Height '
        write(*,*)'status=gdwrfld(gdid_utm,"Height",start1d,stride1d,edg       &
     1e1d,utmhght)'
        write(*,*)'Status returned by call to gdwrfld ',status
      endif
      write(10,*)' '
      write(*,*)' '

      start1d=0
      stride1d=1
      edge1d=250
      status=gdwrfld(gdid_utm,'Grounding',start1d,stride1d,edge1d,ray3)
      if (status .lt. zero) then
         write(*,230)
         write(10,230)
        call heprnt(0)
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
        write(10,*)'Write to field Grounding '
        write(10,*)'status=gdwrfld(gdid_utm,"Grounding",start1d,stride1d       &
     1,edge1d,ray3)'
        write(10,*)'Value returned by gdwrfld ', status
        write(*,*)'Write to field Grounding '
        write(*,*)'status=gdwrfld(gdid_utm,"Grounding",start1d,stride1d,       &
     1edge1d,ray3)'
        write(*,*)'Value returned by gdwrfld ', status
      endif
        write(10,*)' '
        write(*,*)' '

c Test Case -- gdsettleche
c
      write(10,27)
      write(10,*)'Testing gdsettleche... '
      write(10,*)'=================='
      write(*,*)'Testing gdsettleche... '
      write(*,*)'=================='

      status = gdsettleche(gdid_utm,'SideB',5,0)
      if (status .lt. zero) then
         write(*,230)
         write(10,230)
        call heprnt(0)
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
        write(10,*)'Set tile cache parameters '
        write(10,*)'status = gdsettleche(gdid_utm,"SideB",5,0)'
        write(10,*)'Status returned by call to gdsettleche ',status
        write(*,*)'Set tile cache parameters '
        write(*,*)'status = gdsettleche(gdid_utm,"SideB",5,0)'
        write(*,*)'Status returned by call to gdsettleche ',status
      endif
        write(10,*)' '
        write(*,*)' '

c Test Case -- gdwrtle
c
      write(10,27)
      write(10,*)'Testing gdwrtle... '
      write(10,*)'=================='
      write(*,*)'Testing gdwrtle... '
      write(*,*)'=================='

      do 53 ii=1,5
         do 54 i=1,4
            status = gdwrtle(gdid_utm,'SideB',tilecords,tileray)
            if (status .lt. zero) then
               write(*,230)
               write(10,230)
               call heprnt(0)
            else
               write(*,*)' '
               write(*,240)
               write(10,*)' '
               write(10,240)
              write(10,*)'Writing tiled field '
              write(10,*)'Writing tile section ',tilecords(1),' ',tileco       &
     1rds(2)
              write(*,*)'Writing tiled field '
              write(*,*)'Status returned by gdwrtle ',status
              write(*,*)'Writing tile section ',tilecords(1),' ',tilecor       &
     1ds(2)
            endif
            tilecords(2) = tilecords(2) + 1
   54    continue
         tilecords(2) = 0
         tilecords(1) = tilecords(1) + 1
   53 continue

      status = gddetach(gdid_utm)
      if (status .lt. zero) then
         write(*,230)
         write(10,230)
         call heprnt(0)
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(10,*)'status = gddetach(gdid_utm)'
         write(10,*)'Value of status returned by gddetach ',status
         write(*,*)'status = gddetach(gdid_utm)'
         write(*,*)'Value of status returned by gddetach ',status
      endif
      write(10,*)' '
      write(*,*)' '

      gdid_utm = gdattach(gdfid, 'UTMGrid')
      if (status .lt. zero) then
         write(*,230)
         write(10,230)
         call heprnt(0)
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(10,*)'gdid_utm = gdattach(gdfid, "UTMGrid")'
         write(10,*)'Grid id returned by gdattach ',gdid_utm
         write(*,*)'gdid_utm = gdattach(gdfid, "UTMGrid")'
         write(*,*)'Grid id returned by gdattach ',gdid_utm
      endif
      write(10,*)' '
      write(*,*)' '

c Test Case -- gdwrattr
c
      write(10,27)
      write(10,*)'Testing gdwrattr... '
      write(10,*)'=================='
      write(*,*)'Testing gdwrattr... '
      write(*,*)'=================='

      status = gdwrattr(gdid_utm, 'Resistance', DFNT_INT32, 4, attr)
      if (status .lt. zero) then
         write(*,230)
         write(10,230)
         call heprnt(0)
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(10,*)'status=gdwrattr(gdid_utm,"Resistance",DFNT_INT32,4,       &
     1attr)'
         write(10,*)'Returned from gdwrattr ', status
         write(*,*)'status=gdwrattr(gdid_utm,"Resistance",DFNT_INT32,4,a       &
     1ttr)'
         write(*,*)'Returned from gdwrattr ', status
      endif
      write(10,*)' '
      write(*,*)' '

      status = gddetach(gdid_utm)
      if (status .lt. zero) then
         write(*,230)
         write(10,230)
         call heprnt(0)
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(10,*)'status = gddetach(gdid_utm)'
         write(10,*)'Returned from gddetach ', status
         write(*,*)'status = gddetach(gdid_utm)'
         write(*,*)'Returned from gddetach ', status
      endif
      write(10,*)' '
      write(*,*)' '

      status = gddetach(gdid2)
      if (status .lt. zero) then
         write(*,231)
         write(10,231)
         call heprnt(0)
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(10,*)'status = gddetach(gdid2)'
         write(10,*)'Value returned by gddetach ', status
         write(*,*)'status = gddetach(gdid2)'
         write(*,*)'Value returned by gddetach ', status
      endif
      write(10,*)' '
      write(*,*)' '

c Test Case -- gdclose
c
      write(10,27)
      write(10,*)'Testing gdclose... '
      write(10,*)'=================='
      write(*,*)'Testing gdclose... '
      write(*,*)'=================='

      status = gdclose(gdfid2)
      if (status .lt. zero) then
         write(*,231)
         write(10,231)
         call heprnt(0)
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(10,*)'status = gdclose(gdfid2)'
         write(10,*)'Value returned by gdclose ', status
         write(*,*)'status = gdclose(gdfid2)'
         write(*,*)'Value returned by gdclose ', status
      endif
      write(10,*)' '
      write(*,*)' '

      status = gdclose(gdfid)
      if (status .lt. zero) then
         write(*,230)
         write(10,230)
         call heprnt(0)
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(10,*)'status = gdclose(gdfid)'
         write(10,*)'Returned from gdclose ', status
         write(*,*)'status = gdclose(gdfid)'
         write(*,*)'Returned from gdclose ', status
      endif
      write(10,*)' '
      write(*,*)' '

      
      gdfid = gdopen('Gridf_Test.hdf', DFACC_RDWR)
      if (gdfid .lt. zero) then
         write(*,230)
         write(10,230)
         call heprnt(0)
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(*,*)'gdfid = gdopen("Gridf_Test.hdf", DFACC_RDWR)'
         write(10,*)'gdfid = gdopen("Gridf_Test.hdf", DFACC_RDWR)'
         write(*,*)'Grid file id returned by gdopen ',gdfid
         write(10,*)'Grid file id returned by gdopen ',gdfid
      endif
      write(10,*)' '
      write(*,*)' '

      gdid_utm = gdattach(gdfid, 'UTMGrid')
      if (gdid_utm .lt. zero) then
         write(*,230)
         write(10,230)
         call heprnt(0)
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(*,*)'gdid_utm = gdattach(gdfid, "UTMGrid")'
         write(10,*)'gdid_utm = gdattach(gdfid, "UTMGrid")'
         write(*,*)'Grid id returned by gdattach ',gdid_utm
         write(10,*)'Grid id returned by gdattach ',gdid_utm
      endif
      write(10,*)' '
      write(*,*)' '

c Test Case -- gdinqgrid
c
      write(10,27)
      write(10,*)'Testing gdinqgrid... '
      write(10,*)'=================='
      write(*,*)'Testing gdinqgrid... '
      write(*,*)'=================='

      lstatus = gdinqgrid('Gridf_Test.hdf',grdnames,strbufsize)
      if (lstatus .lt. zero) then
         write(*,230)
         write(10,230)
         call heprnt(0)
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(*,*)'lstatus = gdinqgrid("Gridf_Test.hdf",grdnames,strbuf       &
     1size)'
         write(*,*)'Names of grids ',grdnames
         write(*,*)'Number of grids ',lstatus
         write(*,*)'Size of names of grids ',strbufsize
         write(10,*)'lstatus = gdinqgrid("Gridf_Test.hdf",grdnames,strbu       &
     1fsize)'
         write(10,*)'Names of grids ',grdnames
         write(10,*)'Number of grids ',lstatus
         write(10,*)'Size of names of grids ',strbufsize
      endif
      write(10,*)' '
      write(*,*)' '

c Test Case -- gdorginfo
c
      write(10,27)
      write(10,*)'Testing gdorginfo... '
      write(10,*)'=================='
      write(*,*)'Testing gdorginfo... '
      write(*,*)'=================='

      lstatus = gdorginfo(gdid_utm, tmpvar1)
      if (lstatus .lt. zero) then
         write(*,230)
         write(10,230)
         call heprnt(0)
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(*,*)'lstatus = gdorginfo(gdid_utm, tmpvar1)'
         write(10,*)'lstatus = gdorginfo(gdid_utm, tmpvar1)'
         write(*,*)'Value returned by gdorginfo ',lstatus
         write(10,*)'Value returned by gdorginfo ',lstatus
      endif
      write(10,*)' '
      write(*,*)' '

c Test Case -- gdpreginfo
c
      write(10,27)
      write(10,*)'Testing gdpreginfo... '
      write(10,*)'=================='
      write(*,*)'Testing gdpreginfo... '
      write(*,*)'=================='

      lstatus = gdpreginfo(gdid_utm, tmpvar1)
      if (lstatus .lt. zero) then
         write(*,230)
         write(10,230)
         call heprnt(0)
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(*,*)'lstatus = gdpreginfo(gdid_utm, tmpvar1)'
         write(10,*)'lstatus = gdpreginfo(gdid_utm, tmpvar1)'
         write(*,*)'Value returned by gdpreginfo ',lstatus
         write(10,*)'Value returned by gdpreginfo ',lstatus
      endif
      write(10,*)' '
      write(*,*)' '

c Test Case -- gdinqdims
c
      write(10,27)
      write(10,*)'Testing gdinqdims... '
      write(10,*)'=================='
      write(*,*)'Testing gdinqdims... '
      write(*,*)'=================='

      lstatus = gdinqdims(gdid_utm, dimname, dims)
      if (lstatus .lt. zero) then
         write(*,230)
         write(10,230)
         call heprnt(0)
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(*,*)'lstatus = gdinqdims(gdid_utm, dimname, dims)'
         write(*,*)'Number of dimensions ',lstatus
         write(*,*)'Dimensions in grid UTM ',dimname
         write(*,*)'Size of dimensions '
         write(10,*)'lstatus = gdinqdims(gdid_utm, dimname, dims)'
         write(10,*)'Number of dimensions ',lstatus
         write(10,*)'Dimensions in grid UTM ',dimname
         write(10,*)'Size of dimensions '
         do 130 i=1,lstatus
            write(*,*)' ',dims(i)
            write(10,*)' ',dims(i)
 130     continue
      endif
      write(10,*)' '
      write(*,*)' '

c Test Case -- gddiminfo
c
      write(10,27)
      write(10,*)'Testing gddiminfo... '
      write(10,*)'=================='
      write(*,*)'Testing gddiminfo... '
      write(*,*)'=================='

      lstatus = gddiminfo(gdid_utm, 'Conduction')
      if (lstatus .lt. zero) then
         write(*,230)
         write(10,230)
         call heprnt(0)
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(*,*)'lstatus = gddiminfo(gdid_utm, "Conduction")'
         write(*,*)'Size of dimension Conduction ',lstatus
         write(10,*)'lstatus = gddiminfo(gdid_utm, "Conduction")'
         write(10,*)'Size of dimension Conduction ',lstatus
      endif
      write(10,*)' '
      write(*,*)' '

c Test Case -- gdgridinfo
c
      write(10,27)
      write(10,*)'Testing gdgridinfo... '
      write(10,*)'=================='
      write(*,*)'Testing gdgridinfo... '
      write(*,*)'=================='

      status=gdgridinfo(gdid_utm,xdimsize,ydimsize,upleftpt,lowrtpt)
      if (status .lt. zero) then
         write(*,230)
         write(10,230)
         call heprnt(0)
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(*,*)'status=gdgridinfo(gdid_utm,xdimsize,ydimsize,upleftp       &
     1t,lowrtpt)'
         write(*,*)'Status returned by gdgridinfo ',status
         write(*,11)'X dim size ',xdimsize, ' Y dim size ',ydimsize
         write(*,12)'Upper left pt ',upleftpt(1),' ',upleftpt(2)
         write(*,12)'Lower right pt ',lowrtpt(1),' ',lowrtpt(2)
         write(10,*)'status=gdgridinfo(gdid_utm,xdimsize,ydimsize,upleft       &
     1pt,lowrtpt)'
         write(10,*)'Value returned by gdgridinfo ',status
         write(10,*)'X dim size ',xdimsize, ' Y dim size ',ydimsize
         write(10,*)'Upper left pt ',upleftpt(1),upleftpt(2)
         write(10,*)'Lower right pt ',lowrtpt(1),lowrtpt(2)
      endif
      write(10,*)' '
      write(*,*)' '
   11 format(a,i2,a,i2)
   12 format(a,f14.5,a,f14.5)

c Test Case -- gdprojinfo
c
      write(10,27)
      write(10,*)'Testing gdprojinfo... '
      write(10,*)'=================='
      write(*,*)'Testing gdprojinfo... '
      write(*,*)'=================='

      status = gdprojinfo(gdid_utm,pcode,zcode,scode,pparm)
      if (status .lt. zero) then
         write(*,230)
         write(10,230)
         call heprnt(0)
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(*,*)'status = gdprojinfo(gdid_utm,pcode,zcode,scode,pparm       &
     1)'
         write(*,*)'Status returned by gdprojinfo ',status
         write(*,*)'Projection code ',pcode, ' Zone code ',zcode
         write(*,*)'Sphere code ',scode
         write(10,*)'status = gdprojinfo(gdid_utm,pcode,zcode,scode,ppar       &
     1m)'
         write(10,*)'Value returned by gdprojinfo ',status
         write(10,*)'Projection code ',pcode, ' Zone code ',zcode
         write(10,*)'Sphere code ',scode
         do 140 i=1,16
            write(*,55)' ',pparm(i)
            write(10,55)' ',pparm(i)
 140     continue
      endif
   55 format(a,f5.2)
      write(10,*)' '
      write(*,*)' '

c Test Case -- gdcompinfo
c
      write(10,27)
      write(10,*)'Testing gdcompinfo... '
      write(10,*)'=================='
      write(*,*)'Testing gdcompinfo... '
      write(*,*)'=================='

      status = gdcompinfo(gdid_utm,'Voltage',compcode,compparm)
      if (status .lt. zero) then
         call heprnt(0)
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
        write(10,*)'status = gdcompinfo(gdid_utm,"Voltage",compcode,comp       &
     1parm)'
        write(10,*)'Compression info for field Voltage'
        write(10,*)'Comp code ',compcode
        write(10,*)'Compression parameters ',compparm
        write(*,*)'status = gdcompinfo(gdid_utm,"Voltage",compcode,compp       &
     1arm)'
        write(*,*)'Compression info for field Voltage'
        write(*,*)'Comp code ',compcode
        write(*,*)'Compression parameters ',compparm
      endif

c Test Case -- gdtleinfo
c
      write(10,27)
      write(10,*)'Testing gdtleinfo... '
      write(10,*)'=================='
      write(*,*)'Testing gdtleinfo... '
      write(*,*)'=================='

      status = gdtleinfo(gdid_utm,'SideB',tilecode,tilerank,itiledims)
      if (status .lt. zero) then
        write(10,*)'**********Error unexpected***********'
        write(*,*)'**********Error unexpected***********'
        call heprnt(0)
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
        write(10,*)'status = gdtleinfo(gdid_utm,"SideB",tilecode,tileran       &
     1k,itiledims)'
        write(10,*)'Retrieve tile information '
        write(10,*)'Tile info for field SideB '
        write(10,*)'Tile code ',tilecode,' rank ',tilerank,' dims ',itil       &
     1edims(1),' ',itiledims(2)
        write(*,*)'status = gdtleinfo(gdid_utm,"SideB",tilecode,tilerank       &
     1,itiledims)'
        write(*,*)'Retrieve tile information '
        write(*,*)'Tile info for field SideB '
        write(*,*)'Tile code ',tilecode, ' rank ',tilerank,' dims ',itil       &
     1edims(1),' ',itiledims(2)
      endif
      write(10,*)' '
      write(*,*)' '

c Test Case -- gdrdtle
c
      write(10,27)
      write(10,*)'Testing gdrdtle... '
      write(10,*)'=================='
      write(*,*)'Testing gdrdtle... '
      write(*,*)'=================='

      tilecords(1) = 0
      tilecords(2) = 0
      status = gdrdtle(gdid_utm,'SideB',tilecords,tilebuffer)
      if (status .lt. zero) then
        write(10,*)'**********Error unexpected***********'
        write(*,*)'**********Error unexpected***********'
        call heprnt(0)
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(10,*)'Read a tile from field SideB'
         write(*,*)'Read a tile from field SideB'
         write(*,*)'status = gdrdtle(gdid_utm,"SideB",tilecords,tilebuff       &
     1er)'
         write(10,*)'status = gdrdtle(gdid_utm,"SideB",tilecords,tilebuf       &
     1fer)'
        do 62 ii=1,6
           do 63 i=1,5
              write(10,*)'SideB value at ',ii,' ',i,'  ',tilebuffer(ii+i       &
     1)
              write(*,2)'SideB value at ',ii,' ',i,'  ',tilebuffer(ii+i)       &
   63      continue
   62   continue
      endif
    2 format(a,i2,a,i2,a,i4)
      write(10,*)' '
      write(*,*)' '
        

c Test Case -- gdinqflds
c
      write(10,27)
      write(10,*)'Testing gdinqflds... '
      write(10,*)'=================='
      write(*,*)'Testing gdinqflds... '
      write(*,*)'=================='

      nflds = gdinqflds(gdid_utm,fldlist,rnk,numtype)
      if (nflds .lt. zero) then
        write(10,*)'**********Error unexpected***********'
        write(*,*)'**********Error unexpected***********'
        call heprnt(0)
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(*,*)'nflds = gdinqflds(gdid_utm,fldlist,rnk,numtype)'
         write(*,*)'Number of fields ',nflds
         write(10,*)'nflds = gdinqflds(gdid_utm,fldlist,rnk,numtype)'
         write(10,*)'Number of fields ',nflds
         if (nflds .ne. 0) then
            write(*,*)'Fields ',fldlist
            write(10,*)'Fields ',fldlist
            do 150 i=1,nflds
               write(*,*)'Rank and type ',rnk(i), ' ', numtype(i)
               write(10,*)'Rank and type ',rnk(i), ' ', numtype(i)
  150       continue
         endif
      endif
      write(10,*)' '
      write(*,*)' '

c Test Case -- gdfldinfo
c
      write(10,27)
      write(10,*)'Testing gdfldinfo... '
      write(10,*)'=================='
      write(*,*)'Testing gdfldinfo... '
      write(*,*)'=================='

      status = gdfldinfo(gdid_utm,'Drift',rnk,dims,numtype,dimname)
      if (status .lt. zero) then
        write(10,*)'**********Error unexpected***********'
        write(*,*)'**********Error unexpected***********'
        call heprnt(0)
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(*,*)'status = gdfldinfo(gdid_utm,"Drift",rnk,dims,numtype       &
     1,dimname)'
         write(*,*)'Value returned by gdfldinfo for field Drift ',status
         write(*,*)'Drift rank ',rnk(1)
         write(*,*)'Dimensions  ',dims(1),' ',dims(2)
         write(*,*)'Number type of field ',numtype(1)
         write(*,*)'Dimension names ',dimname
         write(10,*)'status = gdfldinfo(gdid_utm,"Drift",rnk,dims,numtyp       &
     1e,dimname)'
         write(10,*)'Value returned by gdfldinfo for field Drift ',statu       &     1s
         write(10,*)'Drift rank ',rnk(1)
      endif
      write(10,*)' '
      write(*,*)' '

c Test Case -- gdrdfld
c
      write(10,27)
      write(10,*)'Testing gdrdfld... '
      write(10,*)'=================='
      write(*,*)'Testing gdrdfld... '
      write(*,*)'=================='

      start(1) = 0
      start(2) = 0
      stride(1) = 1
      stride(2) = 1
      edge(1) = 60
      edge(2) = 80
      status = gdrdfld(gdid_utm,'Drift',start,stride,edge,tempray)
      if (status .lt. zero) then
        write(10,*)'**********Error unexpected***********'
        write(*,*)'**********Error unexpected***********'
        call heprnt(0)
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(*,*)'status = gdrdfld(gdid_utm,"Drift",start,stride,edge,       &
     1tempray)'
         write(*,*)'Value returned by gdrdfld ',status
         write(10,*)'status = gdrdfld(gdid_utm,"Drift",start,stride,edge       &
     1,tempray)'
         write(10,*)'Value returned by gdrdfld ',status
      endif
      write(10,*)' '
      write(*,*)' '

c Test Case -- gdnentries
c
      write(10,27)
      write(10,*)'Testing gdnentries... '
      write(10,*)'=================='
      write(*,*)'Testing gdnentries... '
      write(*,*)'=================='

      n = gdnentries(gdid_utm, HDFE_NENTDIM, strbufsize)
      if (n .lt. zero) then
        write(10,*)'**********Error unexpected***********'
        write(*,*)'**********Error unexpected***********'
        call heprnt(0)
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(*,*)'n = gdnentries(gdid_utm, HDFE_NENTDIM, strbufsize)'
         write(*,*)'Number of dimensions ', n
         write(*,*)'Size of Dimension string ',strbufsize
         write(10,*)'n = gdnentries(gdid_utm, HDFE_NENTDIM, strbufsize)'
         write(10,*)'Number of dimensions ', n
         write(10,*)'Size of Dimension string ',strbufsize
      endif

      n = gdnentries(gdid_utm,HDFE_NENTDFLD,strbufsize)
      if (n .lt. zero) then
        write(10,*)'**********Error unexpected***********'
        write(*,*)'**********Error unexpected***********'
        call heprnt(0)
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(*,*)'n = gdnentries(gdid_utm,HDFE_NENTDFLD,strbufsize)'
         write(*,*)'Number of data fields ',n
         write(10,*)'n = gdnentries(gdid_utm,HDFE_NENTDFLD,strbufsize)'
         write(10,*)'Number of data fields ',n
      endif
      write(10,*)' '
      write(*,*)' '

c Test Case -- gdattrinfo
c
      write(10,27)
      write(10,*)'Testing gdattrinfo... '
      write(10,*)'=================='
      write(*,*)'Testing gdattrinfo... '
      write(*,*)'=================='

      status = gdattrinfo(gdid_utm,'Resistance',tmpvar1,tmpvar2)
      if (status .lt. zero) then
        write(10,*)'**********Error unexpected***********'
        write(*,*)'**********Error unexpected***********'
        call heprnt(0)
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(*,*)'status = gdattrinfo(gdid_utm,"Resistance",tmpvar1,tm       &
     1pvar2)'
         write(*,*)'Value returned by gdattrinfo ',status
         write(*,*)'Number type of attribute ',tmpvar1
         write(*,*)'Number of total bytes in attribute ',tmpvar2
         write(10,*)'status = gdattrinfo(gdid_utm,"Resistance",tmpvar1,t       &
     1mpvar2)'
         write(10,*)'Value returned by gdattrinfo ',status
         write(10,*)'Number type of attribute ',tmpvar1
         write(10,*)'Number of total bytes in attribute ',tmpvar2
      endif
      write(10,*)' '
      write(*,*)' '

c Test Case -- gdrdattr
c
      write(10,27)
      write(10,*)'Testing gdrdattr... '
      write(10,*)'=================='
      write(*,*)'Testing gdrdattr... '
      write(*,*)'=================='

      status = gdrdattr(gdid_utm,'Resistance',iattr)
      if (status .lt. zero) then
        write(10,*)'**********Error unexpected***********'
        write(*,*)'**********Error unexpected***********'
        call heprnt(0)
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
        write(*,*)'status = gdrdattr(gdid_utm,"Resistance",iattr)'
        write(*,*)'Value returned by gdrdattr ',status
        write(10,*)'status = gdrdattr(gdid_utm,"Resistance",iattr)'
        write(10,*)'Value returned by gdrdattr ',status
      endif
      write(10,*)' '
      write(*,*)' '
  
c Test Case -- gdinqattrs
c
      write(10,27)
      write(10,*)'Testing gdinqattrs... '
      write(10,*)'=================='
      write(*,*)'Testing gdinqattrs... '
      write(*,*)'=================='

      lstatus = gdinqattrs(gdid_utm, attrlist,tmpvar1)
      if (lstatus .lt. zero) then
        write(10,*)'**********Error unexpected***********'
        write(*,*)'**********Error unexpected***********'
        call heprnt(0)
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
        write(*,*)'lstatus = gdinqattrs(gdid_utm, attrlist,tmpvar1)'
        write(*,*)'Value returned by gdinqattrs ',lstatus
        write(*,*)'List of attributes ',attrlist
        write(10,*)'lstatus = gdinqattrs(gdid_utm, attrlist,tmpvar1)'
        write(10,*)'Value returned by gdinqattrs ',lstatus
        write(10,*)'List of attributes ',attrlist
      endif
      write(10,*)' '
      write(*,*)' '

c Test Case -- gdgetfill
c
      write(10,27)
      write(10,*)'Testing gdgetfill... '
      write(10,*)'=================='
      write(*,*)'Testing gdgetfill... '
      write(*,*)'=================='

      status = gdgetfill(gdid_utm,'Drift',ifillv)
      if (status .lt. zero) then
        write(10,*)'**********Error unexpected***********'
        write(*,*)'**********Error unexpected***********'
        call heprnt(0)
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(*,*)'status = gdgetfill(gdid_utm,"Drift",ifillv)'
         write(*,*)'Value returned by gdgetfill ',status
         write(*,*)'Fill value ',ifillv
         write(10,*)'status = gdgetfill(gdid_utm,"Drift",ifillv)'
         write(10,*)'Value returned by gdgetfill ',status
         write(10,*)'Fill value ',ifillv
      endif
      write(10,*)' '
      write(*,*)' '

c Test Case -- gddefboxreg
c
      write(10,27)
      write(10,*)'Testing gddefboxreg... '
      write(10,*)'=================='
      write(*,*)'Testing gddefboxreg... '
      write(*,*)'=================='

      corlon(1)=-126.0
      corlon(2)=-121.5
      corlat(1)=-70.0
      corlat(2)=-65.0

      regionid = gddefboxreg(gdid_utm,corlon,corlat)
      if (regionid .lt. zero) then
        write(10,*)'**********Error unexpected***********'
        write(*,*)'**********Error unexpected***********'
        call heprnt(0)
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(*,*)'regionid = gddefboxreg(gdid_utm,corlon,corlat)'
         write(*,*)'Region id returned by gddefboxreg ',regionid
         write(10,*)'regionid = gddefboxreg(gdid_utm,corlon,corlat)'
         write(10,*)'Region id returned by gddefboxreg ',regionid
      endif
      write(10,*)' '
      write(*,*)' '

c Test Case -- gdreginfo
c
      write(10,27)
      write(10,*)'Testing gdreginfo... '
      write(10,*)'=================='
      write(*,*)'Testing gdreginfo... '
      write(*,*)'=================='

      status = gdreginfo(gdid_utm,regionid,'Impedance',nt,rk,dims,size,i       &
     1uplft,ilrgt)
      if (status .lt. zero) then
        write(10,*)'**********Error unexpected***********'
        write(*,*)'**********Error unexpected***********'
        call heprnt(0)
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(*,*)'status = gdreginfo(gdid_utm,regionid,"Impedance",nt,       &
     1rk,dims,size,iuplft,ilrgt)'
         write(*,*)'Value returned by gdreginfo ',status
         write(*,*)'Number type of region ',nt
         write(*,*)'Rank of region ',rk
         write(*,*)'Size of region ',size
         write(*,11)'Dimensions of region',dims(1),' ',dims(2)
         write(*,12)'Upper left point of region ',iuplft(1),' ',iuplft(2       &
     1)
         write(*,12)'Lower right point of region ',ilrgt(1),' ',ilrgt(2)
         write(10,*)'status = gdreginfo(gdid_utm,regionid,"Impedance",nt       &
     1,rk,dims,size,iuplft,ilrgt)'
         write(10,*)'Value returned by gdreginfo ',status
         write(10,*)'Number type of region ',nt
         write(10,*)'Rank of region ',rk
         write(10,*)'Size of region ',size
         write(10,11)'Dimensions of region',dims(1),' ',dims(2)
         write(10,12)'Upper left point of region ',iuplft(1),' ',iuplft(       &
     12)
         write(10,12)'Lower right point of region ',ilrgt(1),' ',ilrgt(2       &
     1)
      endif
      write(10,*)' '
      write(*,*)' '

c Test Case -- gdextreg
c
      write(10,27)
      write(10,*)'Testing gdextreg... '
      write(10,*)'=================='
      write(*,*)'Testing gdextreg... '
      write(*,*)'=================='

      status = gdextreg(gdid_utm,regionid,'Impedance',datbuf)
      if (status .lt. zero) then
        write(10,*)'**********Error unexpected***********'
        write(*,*)'**********Error unexpected***********'
        call heprnt(0)
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(*,*)'status = gdextreg(gdid_utm,regionid,"Impedance",datb       &
     1uf)'
         write(*,*)'Value returned by gdextreg ',status
         write(10,*)'status = gdextreg(gdid_utm,regionid,"Impedance",dat       &
     1buf)'
         write(10,*)'Value returned by gdextreg ',status
         do 175 i=100,150
            write(*,*)'Value of region ',datbuf(i)
            write(10,*)'Value of region ',datbuf(i)
  175    continue
      endif
      write(10,*)' '
      write(*,*)' '

c Test Case -- gddeftmeper
c
      write(10,27)
      write(10,*)'Testing gddeftmeper... '
      write(10,*)'=================='
      write(*,*)'Testing gddeftmeper... '
      write(*,*)'=================='

      periodid = gddeftmeper(gdid_utm,HDFE_NOPREVSUB,starttime,stoptime)
      if (periodid .lt. zero) then
        write(10,*)'**********Error unexpected***********'
        write(*,*)'**********Error unexpected***********'
        call heprnt(0)
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
        write(10,*)'periodid = gddeftmeper(gdid_utm,HDFE_NOPREVSUB,start       &
     1time,stoptime)'
        write(10,*)'Define a time period '
        write(10,*)'Period id returned by gddeftmeper ',periodid
        write(*,*)'periodid = gddeftmeper(gdid_utm,HDFE_NOPREVSUB,startt       &
     1ime,stoptime)'
        write(*,*)'Define a time period '
        write(*,*)'Period id returned by gddeftmeper ',periodid
      endif
      write(10,*)' '
      write(*,*)' '

c Test Case -- gddefvrtreg
c
      write(10,27)
      write(10,*)'Testing gddefvrtreg... '
      write(10,*)'=================='
      write(*,*)'Testing gddefvrtreg... '
      write(*,*)'=================='

      regionid = gddefvrtreg(gdid_utm,HDFE_NOPREVSUB,'Height',range)
      if (regionid .lt. zero) then
        write(10,*)'**********Error unexpected***********'
        write(*,*)'**********Error unexpected***********'
        call heprnt(0)
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
        write(10,*)'regionid = gddefvrtreg(gdid_utm,HDFE_NOPREVSUB,"Heig       &
     1ht",range)'
        write(10,*)'Define a vertical region '
        write(10,*)'Region id returned by gddefvrtreg ',regionid
        write(*,*)'regionid = gddefvrtreg(gdid_utm,HDFE_NOPREVSUB,"Heigh       &
     1t",range)'
        write(*,*)'Define a vertical region '
        write(*,*)'Region id returned by gddefvrtreg ',regionid
      endif
      write(10,*)' '
      write(*,*)' '

c Test Case -- gddupreg
c
      write(10,27)
      write(10,*)'Testing gddupreg... '
      write(10,*)'=================='
      write(*,*)'Testing gddupreg... '
      write(*,*)'=================='

      regionid2 = gddupreg(regionid)
      if (regionid2 .lt. zero) then
        write(10,*)'**********Error unexpected***********'
        write(*,*)'**********Error unexpected***********'
        call heprnt(0)
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
        write(10,*)'regionid2 = gddupreg(regionid)'
        write(10,*)'Generate a new region id '
        write(10,*)'New region id ',regionid2
        write(*,*)'regionid2 = gddupreg(regionid)'
        write(*,*)'Generate a new region id '
        write(*,*)'New region id ',regionid2
      endif
      write(10,*)' '
      write(*,*)' '

c Test Case -- gdgetpix
c
      write(10,27)
      write(10,*)'Testing gdgetpix... '
      write(10,*)'=================='
      write(*,*)'Testing gdgetpix... '
      write(*,*)'=================='

      status = gdgetpix(gdid_utm,5,lonval,latval,rowval,colval)             
      if (status .lt. zero) then
        write(10,*)'**********Error unexpected***********'
        write(*,*)'**********Error unexpected***********'
        call heprnt(0)
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
        write(10,*)'status = gdgetpix(gdid_utm,5,lonval,latval,rowval,co       &
     1lval)'
        write(10,*)'Retrieve pixel row. column values '
        write(*,*)'status = gdgetpix(gdid_utm,5,lonval,latval,rowval,col       &
     1val)'
        write(*,*)'Retrieve pixel row. column values '
        do 37 i=1,5
           write(10,5)'Pixel position lon lat ',lonval(i),' ',                 &
     1latval(i),' ','Row Column ',rowval(i),' ',colval(i) 
           write(*,5)'Pixel position lon lat ',lonval(i),' ',                  &
     1latval(i),' ','Row Column ',rowval(i),' ',colval(i) 
   37   continue
      endif
    5 format(a,f6.1,a,f6.1,a,a,i2,a,i2)
      write(10,*)' '
      write(*,*)' '

c Test Case -- gdgetpixval
c
      write(10,27)
      write(10,*)'Testing gdgetpixval... '
      write(10,*)'=================='
      write(*,*)'Testing gdgetpixval... '
      write(*,*)'=================='

      lstatus = gdgetpixval(gdid_utm,5,rowval,colval,"Voltage",fldval)
      if (lstatus .lt. zero) then
        write(10,*)'**********Error unexpected***********'
        write(*,*)'**********Error unexpected***********'
        call heprnt(0)
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
        write(10,*)'lstatus = gdgetpixval(gdid_utm,5,rowval,colval,"Volt       &
     1age",fldval)'
        write(10,*)'Retrieve pixel values for specific locations '
        write(*,*)'lstatus = gdgetpixval(gdid_utm,5,rowval,colval,"Volta       &
     1ge",fldval)'
        write(*,*)'Retrieve pixel values for specific locations '
        do 42 i=1,5
           write(10,17)'Row Col ',rowval(i),' ',colval(i),' ','Pixel Val       &
     1ue ',fldval(i)
           write(*,17)'Row Col ',rowval(i),' ',colval(i),' ','Pixel Valu       &
     1e ',fldval(i)
   42   continue
      endif
   17 format(a8,i2,a1,i2,a1,a12,f9.3)
      write(10,*)' '
      write(*,*)' '


c Test Case -- gdinterpolate
c
      write(10,27)
      write(10,*)'Testing gdinterpolate... '
      write(10,*)'=================='
      write(*,*)'Testing gdinterpolate... '
      write(*,*)'=================='

      lstatus=gdinterpolate(gdid_utm,5,lonval,latval,'Voltage',interval)
      if (lstatus .lt. zero) then
        write(10,*)'**********Error unexpected***********'
        write(*,*)'**********Error unexpected***********'
        call heprnt(0)
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
        write(10,*)'lstatus=gdinterpolate(gdid_utm,5,lonval,latval,"Volt       &
     1age",interval)'
        write(10,*)'Interpolate 5 values for field Voltage '
        write(*,*)'lstatus=gdinterpolate(gdid_utm,5,lonval,latval,"Volta       &
     1ge",interval)'
        write(*,*)'Interpolate 5 values for field Voltage '
        write(*,*)'Status returned by call to gdinterpolate ',lstatus
        do 38 index1=1,5
           write(*,4)'Interpolated value ',interval(index1,1)
           write(10,4)'Interpolated value ',interval(index1,1)
   38   continue
      endif
    4 format(a,f9.3)
      write(10,*)' '
      write(*,*)' '


      status = gddetach(gdid_utm)
      if (status .lt. zero) then
        write(10,*)'**********Error unexpected***********'
        write(*,*)'**********Error unexpected***********'
        call heprnt(0)
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(*,*)'status = gddetach(gdid_utm)'
         write(*,*)'Value returned by gddetach ',status
         write(10,*)'status = gddetach(gdid_utm)'
         write(10,*)'Value returned by gddetach ',status
      endif

      status = gdclose(gdfid)
      if (status .lt. zero) then
        write(10,*)'**********Error unexpected***********'
        write(*,*)'**********Error unexpected***********'
        call heprnt(0)
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(*,*)'status = gdclose(gdfid)'
         write(*,*)'Returned from gdclose ', status
         write(10,*)'status = gdclose(gdfid)'
         write(10,*)'Returned from gdclose ', status
      endif

      close(unit=10)
  27  format('')
      stop
      end

c
c	In this example we will retrieve (1) information about the
c	dimensions, (2) the dimension mappings (geolocation relations), 
c	and (3) the swath fields.
c 

	program inquireswath

	integer         i, swmapinfo, swfldinfo, status
	integer         swdetach, swclose
	integer*4       swinqdims, swinqmaps, swinqdflds, swinqgflds
	integer*4       swdiminfo, offset, incr, rk, nt
	integer*4       swimapinfo, swinqimaps
	integer*4       swfid, swid, ndims, nmaps, nflds
	integer*4       swopen, swattach
	integer*4       dims(32), off(32), inc(32), rank(32), ntype(32)
	integer*4       sizes(8), indx(32), dimsize
	character*72    dimname, dimmap, fieldlist, dimlist
	integer         DFACC_READ
	parameter        (DFACC_READ=1)

c
c	Open the Swath File for read only access
c

	swfid = swopen("SwathFile_created_with_hadeos_sample_file_writer
     1_of_HDFEOS2_version_219_or_higher_release.hdf", DFACC_READ)

    
	if (swfid .NE. -1) then

c	   Attach the swath

	   swid = swattach(swfid, "Swath1")
	
	   if (swid .NE. -1) then


c	    Inquire Dimensions

	      ndims = swinqdims(swid, dimname, dims)

	      write(*,*) 'Dimension list: ', dimname
	      do i = 1,ndims
		 write(*,*) 'dim size: ', dims(i)
	      enddo
	      write(*,*)	      


c           Inquire Dimension Mappings

	      nmaps = swinqmaps(swid, dimmap, off, inc)

	      write(*,*) 'Dimension map: ', dimmap
	      do i = 1,nmaps
		 write(*,*) 'offset increment: ', off(i), inc(i)
	      enddo
	      write(*,*)

	      
	      
c	    Inquire Indexed Dimension Mappings

	      nmaps = swinqimaps(swid, dimmap, sizes)

	      write(*,*) 'Index Dimension map: ', dimmap
	      do i=1,nmaps
		 write(*,*) 'sizes: ', sizes(i)
	      enddo
	      write(*,*)	      

	     
c         Inquire Geolocation Fields
	    
	      nflds = swinqgflds(swid, fieldlist, rank, ntype)
	      write(*,*) 'Geolocation fieldlist: ', fieldlist
	      do i=1,nflds
		 write(*,*) 'field rank & datatype: ', rank(i), ntype(i)
	      enddo
	      write(*,*) 
	    
	      
c         Inquire Data Fields	      

	      nflds = swinqdflds(swid, fieldlist, rank, ntype)
	      write(*,*) 'Data Fieldlist: ', fieldlist
	      do i=1,nflds
		 write(*,*) 'field rank & datatype: ', rank(i), ntype(i)
	      enddo
	      write(*,*) 
	    



c	  Get info on "GeoTrack" dim

	      dimsize = swdiminfo(swid, "GeoTrack")
	      write(*,*) 'Size of GeoTrack: ', dimsize
	      write(*,*)
	      

c	  Get info on "GeoTrack/Res2tr" mapping

	      status = swmapinfo(swid, "GeoTrack", "Res2tr", offset,
     1                           incr)	      
	      write(*,*) 'Mapping Offset: ', offset
	      write(*,*) 'Mapping Increment: ', incr
	      write(*,*)


c	  Get info on "IndxTrack/Res2tr" indexed mapping

	      n = swimapinfo(swid, "IndxTrack", "Res2tr", indx)
	      do i=1,n
		 write(*,*) 'Index Mapping Entry ', i, indx(i)
	      enddo
	      write(*,*)
	      

c	  Get info on "Longitude" Field

	      status = swfldinfo(swid, "Longitude", rk, dims, nt, dimlist)
	      write(*,*) 'Longitude Rank: ', rk
	      write(*,*) 'Longitude NumberType: ', nt
	      write(*,*) 'Longitude Dimlist: ', dimlist
	      do i=1,rk
		 write(*,*) 'Dimension ',i,dims(i)
	      enddo
	     
	  endif
	endif
	
	status = swdetach(swid)
	status = swclose(swfid)
	stop
	end

c
c  In this example we will (1) open an HDF file, (2) create the swath
c  interface within the file and (3) define the swath field dimensions.
c

      program setupswath

      integer            status, swdefdim, swdefmap, swdefimap
      integer            swdetach, swclose
      integer*4          swfid, swid, swopen, swcreate
      integer*4          indx(12) /0,1,3,6,7,8,11,12,14,24,32,39/

      integer DFACC_CREATE
      parameter (DFACC_CREATE=4)
      integer SD_UNLIMITED
      parameter (SD_UNLIMITED=0)      

c   
c      We first open the HDF swath file, "SwathFile.hdf".  Because this
c      file does not already exist, we use the DFACC_CREATE access
c      code in the open statement.  The SWopen routine returns the swath
c      file id, swfid, which is used to identify the file in subsequent
c      routines in the library.
c
      swfid = swopen("SwathFile_created_with_hadeos_sample_file_write"//
     1"r_of_HDFEOS2_version_219_or_higher_release.hdf",DFACC_CREATE)

c    
c     The first of these, SWcreate, creates the swath, "Swath1", within the
c     file designated by the file id, swfid.  It returns the swath id, SWid,
c     which identifies the swath in subsequent routines.  We will show how
c     to define, write and read field swaths in later programs.
c     
      swid = swcreate(swfid, "Swath1")


c    
c     Typically, many fields within a swath share the same dimension. The
c     swath interface therefore provides a way of defining dimensions that
c     will then be used to define swath fields.  A dimension is defined with
c     a name and a size and is connected to the particular swath through the
c     swath id.  In this example, we define the geo- location track and
c     cross track dimensions with size 20 and 10 respectively and two
c     dimensions corresponding to these but with twice the resolution.
c     We also define a dimension corresponding to a number of spectral
c     bands.

      status = swdefdim(swid, "GeoTrack", 20)
      status = swdefdim(swid, "GeoXtrack", 10)

      status = swdefdim(swid, "Res2tr", 40)
      status = swdefdim(swid, "Res2xtr", 20)
      status = swdefdim(swid, "Bands", 15)
      status = swdefdim(swid, "IndxTrack", 12)
      
c     Define Unlimited (appendable) dimension
      status = swdefdim(swid, "Unlim", SD_UNLIMITED)
      
c   
c     Once the dimensions are defined, the relationship (mapping)between the
c     geolocation dimensions, such as track and cross track, and the data
c     dimensions, must be established.  This is done through the SWdefdimmap
c     routine.  It takes as input the swath id, the names of the dimensions
c     designating the geolocation and data dimensions, respectively, and the
c     offset and increment defining the relation.
c     
c     In the first example we relate the "GeoTrack" and "Res2tr" dimensions
c     with an offset of 0 and an increment of 2.  Thus the ith element of
c     "Geotrack" corresponds to the 2 * ith element of "Res2tr".
c   
c     In the second example, the ith element of "GeoXtrack" corresponds to the
c     2 * ith + 1 element of "Res2xtr".
c     

      status = swdefmap(swid, "GeoTrack", "Res2tr", 0, 2)
      status = swdefmap(swid, "GeoXtrack", "Res2xt", 1, 2)

      status = swdefimap(swid, "IndxTrack", "Res2tr", indx)

c    
c     We now close the swath interface with the SWdetach routine.  This step
c     is necessary to properly store the swath information within the file.
c     
      status = swdetach(swid)


c    
c     Finally, we close the swath file using the SWclose routine.  This will
c     release the swath file handles established by SWopen.
c     

      status = swclose(swfid)

      stop
      end

	
!/*
! * In this example we will (1) open the "SwathFile" HDF file, (2) attach to
! * the "swid" swath, and (3) set dimension scale for a dimension in a filed.
! */

	program writedimscaleswath

	integer       j, status, swdetach, swclose
	integer*4     swfid, swid, swopen, swattach
	integer*4     swsetdimscale, swsetdimstrs
	real*8        BuffGeoTrack(20)
	real*4        BuffGeoTrack2(10)
	integer*4     GTdim,GTdim1,GTdim2,GTdim3
	integer*4     bands(15)
	integer*4     IBuffGeoTrack(40)
	integer*4     IBuffGeoTrack2(20)
	integer DFACC_RDWR
	parameter (DFACC_RDWR=3)
	integer DFNT_FLOAT32
	parameter (DFNT_FLOAT32=5)
	integer DFNT_FLOAT64
	parameter (DFNT_FLOAT64=6)
	integer DFNT_INT32
	parameter (DFNT_INT32=24)

!    /*
!     * We first open the HDF swath file, "SwathFile.hdf".  Because this file
!     * already exist and we wish to write to it, we use the DFACC_RDWR access
!     * code in the open statement.  The swopen routine returns the swath file
!     * id, swfid, which is used to identify the file in subsequent routines.
!     */

	swfid = swopen("SwathFile_created_with_hadeos_sample_file_write"//
     1"r_of_HDFEOS2_version_219_or_higher_release.hdf", DFACC_RDWR)

!    /*
!     * If the swath file cannot be found, swopen will return -1 for the file
!     * handle (swfid).  We there check that this is not the case before
!     * proceeding with the other routines.
!     * 
!     * The swattach routine returns the handle to the existing swath "swid",
!     * swid.  If the swath is not found, swattach returns -1 for the handle.
!     */
	      write(*,*) '=================================='
	if (swfid .ne. -1) then

!	/* the field Density has GeoTrack dimensions.
!	   the field Spectra has Res2xtr,Res2tr,Bands dimensions.
!	   see setupswath.f and defineflds.f
!	   nbands = 15;
!	   GeoTrack = 20;
!	*/
	  swid = swattach(swfid, "Swath1")
	  
	  if (swid .ne. -1) then
	    GTdim = 20
	    GTdim1 = 40
	    GTdim2 = 20
	    GTdim3 = 10
	    
	    do j=1,GTdim1
	       IBuffGeoTrack(j) = j
	    enddo
	    do j=1,GTdim
	       BuffGeoTrack(j) = j*2.5
	    enddo
	    status = swsetdimscale(swid,"Pressure","Res2tr",GTdim1,
     1	    DFNT_INT32, IBuffGeoTrack)
	    write(*,*) 'status swsetdimscale:Pressure:Res2tr=',status
	    status = swsetdimstrs(swid, "Pressure", "Res2tr", 
     1	    "Res2tr", "degrees", "I2")
	     
	     
	    status = swsetdimscale(swid,"Pressure","Res2xtr",GTdim2,
     1	    DFNT_INT32, IBuffGeoTrack2)
	    write(*,*) 'status swsetdimscale:Pressure:Res2xtr=',status

	    status = swsetdimscale(swid,"Density","GeoTrack",GTdim,
     1	    DFNT_FLOAT64, BuffGeoTrack)
	    write(*,*) 'status swsetdimscale:Density=',status,
     1      '    Error expected. Field is 1-dimensional'
	    
	    status = swsetdimscale(swid,"Temperature","GeoTrack",GTdim,
     1	    DFNT_FLOAT64, BuffGeoTrack)
	    write(*,*) 'status swsetdimscale:Temperature:GeoTrack=',
     1	    status
	    status = swsetdimstrs(swid, "Temperature", "GeoTrack", 
     1	    "GeoTrack", "degrees", "F7.2")
	    write(*,*) 'status swsetdimstrs:Temperature:GeoTrack=',
     1      status
	    
	    status = swsetdimscale(swid, "Temperature", "GeoXtrack",
     1	    GTdim3,DFNT_FLAOT32, BuffGeoTrack2)
	    write(*,*) 'status swsetdimscale:Temperature:GeoXtrack=',
     1	    status
	    
	    nbands = 15;
	    do j=1,nbands
	       bands(j) = j*2+1
	    enddo
	    status = swsetdimscale(swid, "Spectra", "Bands", nbands, 
     1	    DFNT_INT32, bands);
	    write(*,*) 'status swsetdimscale:Spectra =',status
	    
	    status = swsetdimstrs(swid, "Spectra", "Bands", "BANDS", 
     1	    "None", "I2")
	    
	    status = swdetach(swid)
	 endif
	 status = swclose(swfid)
	endif
	
	stop
	end
	

	program readgdflds

	integer       status, gdrdfld, gdrdattr, gddetach, gdclose
	integer*4     gdfid, gdid, gdopen, gdattach
	integer*4     start(2), stride(2), count(2)
	real*4        f32, veg(120,200)
	integer DFACC_RDWR
	parameter (DFACC_RDWR=3)
	integer DFNT_FLOAT32
	parameter (DFNT_FLOAT32=5)

	gdfid = gdopen("GridFile_created_with_hadeos_sample_file_write"//
     1"r_of_HDFEOS2_version_219_or_higher_release.hdf", DFACC_RDWR)

	if (gdfid .ne. -1) then

	   gdid = gdattach(gdfid, "UTMGrid")

	   if (gdid .ne. -1) then
	
	      start(1) = 0
	      start(2) = 0
	      stride(1) = 1
	      stride(2) = 1
	      count(1) = 120
	      count(2) = 200
	      status = gdrdfld(gdid, "Vegetation", 
     1    	               start, stride, count, veg)
	      
	      

	      status = gdrdattr(gdid, "float32", f32)
	      write(*,*) 'f32: ', f32
	      
	   endif
	endif

	status = gddetach(gdid)
	status = gdclose(gdfid)

	stop
	end

c
 
      program testpoint
 
      integer*4       ptfid, ptid1, ptid2, ptid3, ptdetach, ptclose
      integer*4       ptopen, ptcreate
      integer         status
      integer*4       ptid, fldsz, nlevels, nflds, fldlevels(16)
      integer*4		npoint
      integer*4       fieldtype(8), fieldorder(8)
      character*72	fldlist, attrlist, ptlist
 
      integer*4       ptattach, ptinqpoint
      integer         ptdeflev, ptdeflink, ptwrattr
      integer         ptrdattr, ptattrinfo
      integer         i, j, k, pntr, strbufsize
      integer*2       wgt
      integer*4       n, date, nt, sz
 
      real*4          rain, temp, conc(4), f32, b32 
      real*8          lon, lat, time
 
      character       buffer*10000, id*2, desc*16, spc*8
      character       linkfield*8
      character       ctime*4, cconc*16, clon*8, clat*8
      character       cdate*4, crain*4, ctemp*4, cwgt*2

      integer         ptwrlev

      integer*4       recs(32)
      integer*4       fldtype(32), fldorder(32)
 
      integer         ptrdlev
      integer         ptlevinfo, ptblinkinfo, ptflinkinfo
      integer*4       ptnrecs, ptnlevs, ptsizeof, ptnflds
      integer*4		ptlevidx, ptinqattrs

      integer         ptuplev, ptgetrecnums
      integer*4       inlevel, outlevel, levndx
      integer*4       outrecs(32), outnrec
      real*8          f64
 
      character       datbuf*256, c8*8

      integer         ptextreg, ptreginfo
      integer         ptextper, ptperinfo
 
      integer*4       size, ptdefboxreg, ptdeftmeper
      integer*4       regionid, periodid
 
      real*8          cornerlon(2), cornerlat(2)
      real*8          dtbuf(128), starttime, stoptime
 
 
      integer DFACC_CREATE
      parameter (DFACC_CREATE=4)
 
      integer  DFACC_RDWR
      parameter (DFACC_RDWR=3)

      integer  DFNT_CHAR8, DFNT_INT16, DFNT_INT32
      parameter (DFNT_CHAR8=4)
      parameter (DFNT_INT16=22)
      parameter (DFNT_INT32=24)
 
      integer  DFNT_FLOAT32, DFNT_FLOAT64
      parameter (DFNT_FLOAT32=5)
      parameter (DFNT_FLOAT64=6)

      integer DFACC_READ
      parameter (DFACC_READ=1)


      open(unit=3, file='testpointf.txt')
 
      write(*,*)'Testing Point FORTRAN 77 interface'
      write(*,*)'=================================='
      write(3,*)'Testing Point FORTRAN 77 interface'
      write(3,*)'=================================='
      write(*,*)' '
      write(3,*)' '
 
c Test Case -- ptopen
c
      write(*,*)'Testing ptopen '
      write(*,*)'================='
      write(3,*)'Testing ptopen '
      write(3,*)'================='

      ptfid = ptopen("Pointf_Test.hdf", DFACC_CREATE)
      write(*,*)'       ptfid = ptopen("Pointf_Test.hdf", DFACC_CREATE)'
      write(*,*)'       File id  returned by ptopen ', ptfid
      write(3,*)'       ptfid = ptopen("Pointf_Test.hdf", DFACC_CREATE)'
      write(3,*)'       File id returned by ptopen ', ptfid
      write(*,*)' '
      write(3,*)' '


 
c Test Case -- ptcreate
c
      write(*,*)'Testing ptcreate '
      write(*,*)'================='
      write(3,*)'Testing ptcreate '
      write(3,*)'================='

      ptid1 = ptcreate(ptfid, "Simple Point")
      write(*,*)'      ptid1 = ptcreate(ptfid, "Simple Point")'
      write(*,*)'      Point id returned by ptcreate ',ptid1
      write(3,*)'      ptid1 = ptcreate(ptfid, "Simple Point")'
      write(3,*)'      Point id returned by ptcreate ',ptid1

      ptid2 = ptcreate(ptfid, "FixedBuoy Point")
      write(*,*)'      ptid2 = ptcreate(ptfid, "FixedBuoy Point")'
      write(*,*)'      Point id returned by ptcreate ',ptid2
      write(3,*)'      ptid2 = ptcreate(ptfid, "FixedBuoy Point")'
      write(3,*)'      Point id returned by ptcreate ',ptid2

      ptid3 = ptcreate(ptfid, "FloatBuoy Point")
      write(*,*)'      ptid3 = ptcreate(ptfid, "FloatBuoy Point")'
      write(*,*)'      Point id returned by ptcreate ',ptid3
      write(3,*)'      ptid3 = ptcreate(ptfid, "FloatBuoy Point")'
      write(3,*)'      Point id returned by ptcreate ',ptid3
 
 
      write(*,*)' '
      write(3,*)' '
c Test Case -- ptdetach
c  
      write(3,27)
      write(*,*)'Testing ptdetach '
      write(*,*)'================='
      write(3,*)'Testing ptdetach '
      write(3,*)'================='

      status = ptdetach(ptid1)
      write(*,*)'      status = ptdetach(ptid1)'
      write(*,*)'      Status returned by ptdetach ',status
      write(3,*)'      status = ptdetach(ptid1)'
      write(3,*)'      Status returned by ptdetach ',status

      status = ptdetach(ptid2)
      write(*,*)'      status = ptdetach(ptid2)'
      write(*,*)'      Status returned by ptdetach ',status
      write(3,*)'      status = ptdetach(ptid2)'
      write(3,*)'      Status returned by ptdetach ',status

      status = ptdetach(ptid3)
      write(*,*)'      status = ptdetach(ptid3)'
      write(*,*)'      Status returned by ptdetach ',status
      write(3,*)'      status = ptdetach(ptid3)'
      write(3,*)'      Status returned by ptdetach ',status

 
 
      write(*,*)' '
      write(3,*)' '
c Test Case -- ptclose
c  
      write(3,27)
      write(*,*)'Testing ptclose '
      write(*,*)'================='
      write(3,*)'Testing ptclose '
      write(3,*)'================='

      status = ptclose(ptfid)
      write(*,*)'      status = ptclose(ptfid)'
      write(*,*)'      Status returned by ptclose ',status
      write(3,*)'      status = ptclose(ptfid)'
      write(3,*)'      Status returned by ptclose ',status

      ptfid = ptopen("Pointf_Test.hdf", DFACC_RDWR)
      write(*,*)'      ptfid = ptopen("Pointf_Test.hdf", DFACC_RDWR)'
      write(*,*)'      Point file id returned by ptopen ',ptfid
      write(3,*)'      ptfid = ptopen("Pointf_Test.hdf", DFACC_RDWR)'
      write(3,*)'      Point file id returned by ptopen ',ptfid

 
      write(*,*)' '
      write(3,*)' '
c Test Case -- ptattach
c  
      write(3,27)
      write(*,*)'Testing ptattach '
      write(*,*)'================='
      write(3,*)'Testing ptattach '
      write(3,*)'================='

      ptid = ptattach(ptfid, "Simple Point")
      write(*,*)'      ptid = ptattach(ptfid, "Simple Point")'
      write(*,*)'      Point id returned by ptattach ',ptid
      write(3,*)'      ptid = ptattach(ptfid, "Simple Point")'
      write(3,*)'      Point id returned by ptattach ',ptid

      fldlist = "Time,Concentration,Species"
 
 
      fieldtype(1) = DFNT_FLOAT64
      fieldtype(2) = DFNT_FLOAT32
      fieldtype(3) = DFNT_CHAR8
 
      fieldorder(1) = 1
      fieldorder(2) = 4
      fieldorder(3) = 4
 
      write(*,*)' '
      write(3,*)' '
c Test Case -- ptdeflev
c  
      write(3,27)
      write(*,*)'Testing ptdeflev '
      write(*,*)'================='
      write(3,*)'Testing ptdeflev '
      write(3,*)'================='

      status = ptdeflev(ptid, "Sensor", fldlist, fieldtype,
     1fieldorder)
      write(*,*)'      status = ptdeflev(ptid, "Sensor", fldlist, 
     1fieldtype,fieldorder)'
      write(*,*)'      Status returned by ptdeflev ',status
      write(3,*)'      status = ptdeflev(ptid, "Sensor", fldlist, 
     1fieldtype,fieldorder)'
      write(3,*)'      Status returned by ptdeflev ',status
 
      status = ptdetach(ptid)
      write(*,*)'      status = ptdetach(ptid)'
      write(*,*)'      Status returned by ptdetach ',status
      write(3,*)'      status = ptdetach(ptid)'
      write(3,*)'      Status returned by ptdetach ',status
 
 
      ptid = ptattach(ptfid, "FixedBuoy Point")
      write(*,*)'      ptid = ptattach(ptfid, "FixedBuoy Point")'
      write(*,*)'      Point id returned by ptattach ',ptid
      write(3,*)'      ptid = ptattach(ptfid, "FixedBuoy Point")'
      write(3,*)'      Point id returned by ptattach ',ptid
 
 
 
      fldlist = "Label,Longitude,Latitude,DeployDate,ID"
 
      fieldtype(1) = DFNT_CHAR8
      fieldtype(2) = DFNT_FLOAT64
      fieldtype(3) = DFNT_FLOAT64
      fieldtype(4) = DFNT_INT32
      fieldtype(5) = DFNT_CHAR8
 
 
      fieldorder(1) = 8
      fieldorder(2) = 0
      fieldorder(3) = 0
      fieldorder(4) = 0
      fieldorder(5) = 1

      status = ptdeflev(ptid, "Desc-Loc", fldlist, fieldtype,
     1fieldorder)
      write(*,*)'      status = ptdeflev(ptid, "Desc-Loc", 
     1fldlist, fieldtype,fieldorder)'
      write(*,*)'      Status returned by ptdeflev ',status
      write(3,*)'      status = ptdeflev(ptid, "Desc-Loc", 
     1fldlist, fieldtype,fieldorder)'
      write(3,*)'      Status returned by ptdeflev ',status
 
 
 
      fldlist = "Time,Rainfall,Temperature,ID"
 
      fieldtype(1) = DFNT_FLOAT64
      fieldtype(2) = DFNT_FLOAT32
      fieldtype(3) = DFNT_FLOAT32
      fieldtype(4) = DFNT_CHAR8
 
      fieldorder(1) = 0
      fieldorder(2) = 0
      fieldorder(3) = 0
      fieldorder(4) = 1
 
      status = ptdeflev(ptid, "Observations", fldlist,
     1fieldtype, fieldorder)
      write(*,*)'       status = ptdeflev(ptid, "Observations", 
     1fldlist,fieldtype, fieldorder)'
      write(*,*)'       Status returned by ptdeflev ',status
      write(3,*)'       status = ptdeflev(ptid, "Observations", 
     1fldlist,fieldtype, fieldorder)'
      write(3,*)'       Status returned by ptdeflev ',status
 
      write(*,*)' '
      write(3,*)' '
c Test Case -- ptdeflink
c
      write(3,27)
      write(*,*)'Testing ptdeflink '
      write(*,*)'================='
      write(3,*)'Testing ptdeflink '
      write(3,*)'================='

      status = ptdeflink(ptid, "Desc-Loc", "Observations", "ID")
      write(*,*)'       status = ptdeflink(ptid, "Desc-Loc", 
     1"Observations", "ID")'
      write(*,*)'       Status returned by ptdeflink ',status
      write(3,*)'       status = ptdeflink(ptid, "Desc-Loc", 
     1"Observations", "ID")'
      write(3,*)'       Status returned by ptdeflink ',status

 
      status = ptdetach(ptid)
      write(*,*)'       status = ptdetach(ptid)'
      write(*,*)'       Status returned by ptdetach ',status
      write(3,*)'       status = ptdetach(ptid)'
      write(3,*)'       Status returned by ptdetach ',status
 

      ptid = ptattach(ptfid, "FloatBuoy Point")
      write(*,*)'       ptid = ptattach(ptfid, "FloatBuoy Point")'
      write(*,*)'       Point id returned by ptattach ',ptid
      write(3,*)'       ptid = ptattach(ptfid, "FloatBuoy Point")'
      write(3,*)'       Point id returned by ptattach ',ptid
 
 
c      Define Description Level */
 
      fldlist = "Label,DeployDate,Weight,ID"

      fieldtype(1) = DFNT_CHAR8
      fieldtype(2) = DFNT_INT32
      fieldtype(3) = DFNT_INT16
      fieldtype(4) = DFNT_CHAR8

      fieldorder(1) = 8
      fieldorder(2) = 0
      fieldorder(3) = 0
      fieldorder(4) = 1

 
      status = ptdeflev(ptid, "Description", fldlist,
     1fieldtype, fieldorder)
      write(*,*)'       status = ptdeflev(ptid, "Description", 
     1fldlist,fieldtype, fieldorder)'
      write(*,*)'       Status returned by ptdeflev ',status
      write(3,*)'       status = ptdeflev(ptid, "Description", 
     1fldlist,fieldtype, fieldorder)'
      write(3,*)'       Status returned by ptdeflev ',status
 
 
c       Define Data Level
 
      fldlist = "Time,Longitude,Latitude,Rainfall,Temperature,ID"
 
      fieldtype(1) = DFNT_FLOAT64
      fieldtype(2) = DFNT_FLOAT64
      fieldtype(3) = DFNT_FLOAT64
      fieldtype(4) = DFNT_FLOAT32
      fieldtype(5) = DFNT_FLOAT32
      fieldtype(6) = DFNT_CHAR8
 
      fieldorder(1) = 0
      fieldorder(2) = 0
      fieldorder(3) = 0
      fieldorder(4) = 0
      fieldorder(5) = 0
      fieldorder(6) = 1
 
      status = ptdeflev(ptid, "Measurements", fldlist,
     1fieldtype, fieldorder)
      write(*,*)'       status = ptdeflev(ptid, "Measurements", 
     1fldlist,fieldtype, fieldorder)'
      write(*,*)'       Status returned by ptdeflev ',status
      write(3,*)'       status = ptdeflev(ptid, "Measurements", 
     1fldlist,fieldtype, fieldorder)'
      write(3,*)'       Status returned by ptdeflev ',status
 

      status = ptdeflink(ptid, "Description", "Measurements", "ID")
      write(*,*)'       status = ptdeflink(ptid, "Description", 
     1"Measurements", "ID")'
      write(*,*)'       Status returned by ptdeflink ',status
      write(3,*)'       status = ptdeflink(ptid, "Description", 
     1"Measurements", "ID")'
      write(3,*)'       Status returned by ptdeflink ',status
 
      status = ptdetach(ptid)
      write(*,*)'       status = ptdetach(ptid)'
      write(*,*)'       Status returned by ptdetach ',status
      write(3,*)'       status = ptdetach(ptid)'
      write(3,*)'       Status returned by ptdetach ',status
 
 
      write(*,*)' '
      status = ptclose(ptfid)
      write(*,*)'       status = ptclose(ptfid)'
      write(*,*)'       Status returned by ptclose ',status
      write(3,*)'       status = ptclose(ptfid)'
      write(3,*)'       Status returned by ptclose ',status
 

 
      write(*,*)' '
      ptfid = ptopen("Pointf_Test.hdf", DFACC_RDWR)
      write(*,*)'       ptfid = ptopen("Pointf_Test.hdf", DFACC_RDWR)'
      write(*,*)'       Point file id returned by ptopen ',ptfid
      write(3,*)'       ptfid = ptopen("Pointf_Test.hdf", DFACC_RDWR)'
      write(3,*)'       Point file id returned by ptopen ',ptfid
 
      write(*,*)' '
      ptid = ptattach(ptfid, "Simple Point")
      write(*,*)'       ptid = ptattach(ptfid, "Simple Point")'
      write(*,*)'       Point id returned by ptattach ',ptid
      write(3,*)'       ptid = ptattach(ptfid, "Simple Point")'
      write(3,*)'       Point id returned by ptattach ',ptid

      open(unit=1, file='simple.txt',STATUS='OLD')

      n = 0
      pntr = 1

      do 10 i=1,1000
 
           read(1, *, end=100)  time, conc(1), conc(2), conc(3),
     1                            conc(4), spc
           n = n + 1

           ctime = transfer(time, ctime)
           cconc = transfer(conc, cconc)

 
           buffer(pntr:pntr+8) = ctime
           pntr = pntr + 8
           buffer(pntr:pntr+4*4) = cconc
           pntr = pntr + 4*4
           buffer(pntr:pntr+4) = spc
           pntr = pntr + 4
10      continue
 
100     close(unit=1)
 

      write(*,*)' '
      write(3,*)' '
c Test Case -- ptwrlev
c
      write(3,27)
      write(*,*)'Testing ptwrlev '
      write(*,*)'================='
      write(3,*)'Testing ptwrlev '
      write(3,*)'================='

      status = ptwrlev(ptid, 0, n, buffer)
      write(*,*)'         status = ptwrlev(ptid, 0, n, buffer)'
      write(*,*)'         Status returned by ptwrlev ',status
      write(3,*)'         status = ptwrlev(ptid, 0, n, buffer)'
      write(3,*)'         Status returned by ptwrlev ',status

      status = ptdetach(ptid)
      write(*,*)'         status = ptdetach(ptid)'
      write(*,*)'         Status returned by ptdetach ',status
      write(3,*)'         status = ptdetach(ptid)'
      write(3,*)'         Status returned by ptdetach ',status
   
 
      ptid = ptattach(ptfid, "FixedBuoy Point")
      write(*,*)'        ptid = ptattach(ptfid, "FixedBuoy Point")'
      write(*,*)'        Point id returned by ptattach ',ptid
      write(3,*)'        ptid = ptattach(ptfid, "FixedBuoy Point")'
      write(3,*)'        Point id returned by ptattach ',ptid

      open(unit=1, file='fixedBuoy0.txt', STATUS='OLD')
 
      n = 0
      pntr = 1
      do 20 i=1,1000
 
           read(1, *, end=200)  desc, lon, lat, date, id
 
           n = n + 1

           clon = transfer(lon, clon)
           clat = transfer(lat, clat)
           cdate = transfer(date, cdate)

 
           buffer(pntr:pntr+8) = desc
           pntr = pntr + 8
           buffer(pntr:pntr+8) = clon
           pntr = pntr + 8
           buffer(pntr:pntr+8) = clat
           pntr = pntr + 8
           buffer(pntr:pntr+4) = cdate
           pntr = pntr + 4
           buffer(pntr:pntr+1) = id
           pntr = pntr + 1
 20   continue
 
 200  close(unit=1)
 
   
      status = ptwrlev(ptid, 0, n, buffer)
      write(*,*)'        status = ptwrlev(ptid, 0, n, buffer)'
      write(*,*)'        Status returned by ptwrlev ',status
      write(3,*)'        status = ptwrlev(ptid, 0, n, buffer)'
      write(3,*)'        Status returned by ptwrlev ',status
 
 
      open(unit=1, file='fixedBuoy1.txt', STATUS='OLD')
 
      n = 0
      pntr = 1
      do 30 i=1,1000
 
           read(1, *, end=300) time, rain, temp, id
 
           n = n + 1

           ctime = transfer(time, ctime)
           crain = transfer(rain, crain)
           ctemp = transfer(temp, ctemp)

 
           buffer(pntr:pntr+8) = ctime
           pntr = pntr + 8
           buffer(pntr:pntr+4) = crain
           pntr = pntr + 4
           buffer(pntr:pntr+4) = ctemp
           pntr = pntr + 4
           buffer(pntr:pntr+1) = id
           pntr = pntr + 1
 30   continue
 
 300  close(unit=1)
 
      status = ptwrlev(ptid, 1, n, buffer)
      write(*,*)'          status = ptwrlev(ptid, 1, n, buffer)'
      write(*,*)'          Status returned by ptwrlev ',status
      write(3,*)'          status = ptwrlev(ptid, 1, n, buffer)'
      write(3,*)'          Status returned by ptwrlev ',status

      write(*,*)' '
      write(3,*)' '
c Test Case -- ptwrattr
c
      write(3,27)
      write(*,*)'Testing ptwrattr '
      write(*,*)'================='
      write(3,*)'Testing ptwrattr '
      write(3,*)'================='

      f32 = -7.5
      status = ptwrattr(ptid, "float32", 5, 1, f32)
      write(*,*)'         status = ptwrattr(ptid, "float32", 5, 1, f32)'
      write(*,*)'         Status returned by ptwrattr ', status
      write(3,*)'         status = ptwrattr(ptid, "float32", 5, 1, f32)'
      write(3,*)'         Status returned by ptwrattr ', status
 
      status = ptdetach(ptid)
      write(*,*)'       status = ptdetach(ptid)'
      write(*,*)'       Status returned by ptdetach ',status
      write(3,*)'       status = ptdetach(ptid)'
      write(3,*)'       Status returned by ptdetach ',status
 
 
      ptid = ptattach(ptfid, "FloatBuoy Point")
      write(*,*)'      ptid = ptattach(ptfid, "FloatBuoy Point")'
      write(*,*)'      Point id returned by ptattach ',ptid
      write(3,*)'      ptid = ptattach(ptfid, "FloatBuoy Point")'
      write(3,*)'      Point id returned by ptattach ',ptid
 
      open(unit=1, file='floatBuoy0.txt', STATUS='OLD')
 
      n = 0
      pntr = 1
      do 40 i=1,1000
 
         read(1, *, end=400)  desc, date, wgt, id
           write(*,*) desc,date,wgt,id
           n = n + 1

           cdate = transfer(date, cdate)
           cwgt = transfer(wgt, cwgt)

 
           buffer(pntr:pntr+8) = desc
           pntr = pntr + 8
           buffer(pntr:pntr+4) = cdate
           pntr = pntr + 4
           buffer(pntr:pntr+2) = cwgt
           pntr = pntr + 2
           buffer(pntr:pntr+1) = id
           pntr = pntr + 1
 40   continue
 
 400  close(unit=1)
 
   
      status = ptwrlev(ptid, 0, n, buffer)
      write(*,*)'      status = ptwrlev(ptid, 0, n, buffer)'
      write(*,*)'      Status returned by ptwrlev ',status
      write(3,*)'      status = ptwrlev(ptid, 0, n, buffer)'
      write(3,*)'      Status returned by ptwrlev ',status
 
      open(unit=1, file='floatBuoy1.txt', STATUS='OLD')
 
      n = 0
      pntr = 1
      do 50 i=1,1000
 
           read(1, *, end=500) time, lon, lat, rain, temp, id
 
           n = n + 1

           ctime = transfer(time, ctime)
           clon = transfer(lon, clon)
           clat = transfer(lat, clat)
           crain = transfer(rain, crain)
           ctemp = transfer(temp, ctemp)

 
           buffer(pntr:pntr+8) = ctime
           pntr = pntr + 8
           buffer(pntr:pntr+8) = clon
           pntr = pntr + 8
           buffer(pntr:pntr+8) = clat
           pntr = pntr + 8
           buffer(pntr:pntr+4) = crain
           pntr = pntr + 4
           buffer(pntr:pntr+4) = ctemp
           pntr = pntr + 4
           buffer(pntr:pntr+1) = id
           pntr = pntr + 1
 50   continue
 
 500  close(unit=1)
 
      status = ptwrlev(ptid, 1, n, buffer)
      write(*,*)'        status = ptwrlev(ptid, 1, n, buffer)'
      write(*,*)'        Status returned by ptwrlev ',status
      write(3,*)'        status = ptwrlev(ptid, 1, n, buffer)'
      write(3,*)'        Status returned by ptwrlev ',status

      status = ptdetach(ptid)
      write(*,*)'       status = ptdetach(ptid)'
      write(*,*)'      Status returned by ptdetach ',status
      write(3,*)'       status = ptdetach(ptid)'
      write(3,*)'      Status returned by ptdetach ',status
 
 
      status = ptclose(ptfid)
      write(*,*)'      status = ptclose(ptfid)'
      write(*,*)'      Status returned by ptclose ',status
      write(3,*)'      status = ptclose(ptfid)'
      write(3,*)'      Status returned by ptclose ',status

 
      ptfid = ptopen("Pointf_Test.hdf", DFACC_READ)
      write(*,*)'        ptfid = ptopen("Pointf_Test.hdf", DFACC_READ)'
      write(*,*)'        Point id returned by ptopen ',ptfid
      write(3,*)'        ptfid = ptopen("Pointf_Test.hdf", DFACC_READ)'
      write(3,*)'        Point id returned by ptopen ',ptfid

      ptid = ptattach(ptfid, "Simple Point")
      write(*,*)'       ptid = ptattach(ptfid, "Simple Point")'
      write(*,*)'       Point id returned by ptattach ',ptid
      write(3,*)'       ptid = ptattach(ptfid, "Simple Point")'
      write(3,*)'       Point id returned by ptattach ',ptid
 
      write(*,*)' '
      write(3,*)' '
c Test Case -- ptlevidx
c
      write(3,27)
      write(*,*)'Testing ptlevidx '
      write(*,*)'================='
      write(3,*)'Testing ptlevidx '
      write(3,*)'================='

      levndx = ptlevidx(ptid, "Sensor")
      write(*,*)'     levndx = ptlevidx(ptid, "Sensor")'
      write(*,*)'     Level index of Sensor ',levndx
      write(3,*)'     levndx = ptlevidx(ptid, "Sensor")'
      write(3,*)'     Level index of Sensor ',levndx

      write(*,*)' '
      write(3,*)' '
c Test Case -- ptlevinfo
c
      write(3,27)
      write(*,*)'Testing ptlevinfo '
      write(*,*)'================='
      write(3,*)'Testing ptlevinfo '
      write(3,*)'================='

      nlevels = ptlevinfo(ptid, 0, fldlist, fldtype, fldorder)
      write(*,*)'      nlevels = ptlevinfo(ptid, 0, fldlist, 
     1fldtype, fldorder)'
      write(*,*)'      Number of fields in level 0 ',status
      write(*,*)'      List of fields in level 0 ',fldlist
      write(3,*)'      Number of fields in level 0 ',status
      write(3,*)'      List of fields in level 0 ',fldlist
      do 7 i=1,nlevels
         write(*,*)' Number type of field ',fldtype(i)
         write(*,*)' Order of field ', fldorder(i)
         write(3,*)' Number type of field ',fldtype(i)
         write(3,*)' Order of field ', fldorder(i)
 7    continue

      write(3,*)'      status = ptlevinfo(ptid, 0, fldlist, 
     1fldtype, fldorder)'
      write(3,*)'      Status returned by ptlevinfo ',status

      write(*,*)' '
      write(3,*)' '
c Test Case -- ptnrecs
c
      write(3,27)
      write(*,*)'Testing ptnrecs '
      write(*,*)'================='
      write(3,*)'Testing ptnrecs '
      write(3,*)'================='

      n = ptnrecs(ptid, 0)
      write(*,*)'     n = ptnrecs(ptid, 0)'
      write(*,*)'     Number of records in level ',n
      write(3,*)'     n = ptnrecs(ptid, 0)'
      write(3,*)'     Number of records in level ',n
 
      do 5 i=1,n
         recs(i) = i - 1
 5    continue
 
      write(*,*)' '
      write(3,*)' '
c Test Case -- ptrdlev
c
      write(3,27)
      write(*,*)'Testing ptrdlev '
      write(*,*)'================='
      write(3,*)'Testing ptrdlev '
      write(3,*)'================='

      status = ptrdlev(ptid, 0, fldlist, n, recs, buffer)
      write(*,*)'      status = ptrdlev(ptid, 0, 
     1fldlist, n, recs, buffer)'
      write(*,*)'      Status returned by ptrdlev ',status
      write(3,*)'      status = ptrdlev(ptid, 0, 
     1fldlist, n, recs, buffer)'
      write(3,*)'      Status returned by ptrdlev ',status

      pntr = 1
      do 11 i=1,n
           ctime = buffer(pntr:pntr+8)
           pntr = pntr + 8
           cconc = buffer(pntr:pntr+4*4)
           pntr = pntr + 4*4
           spc = buffer(pntr:pntr+4)
           pntr = pntr + 4

           time = transfer(ctime, time)
           conc = transfer(cconc, conc)

           write(*,*) time, conc(1), conc(2), conc(3), conc(4), spc
           write(3,*) time, conc(1), conc(2), conc(3), conc(4), spc
11    continue
 
      status = ptdetach(ptid)
      write(*,*)'       status = ptdetach(ptid)'
      write(*,*)'       Status returned by ptdetach ',status
      write(3,*)'       status = ptdetach(ptid)'
      write(3,*)'       Status returned by ptdetach ',status
 
      ptid = ptattach(ptfid, "FixedBuoy Point")
      write(*,*)'       ptid = ptattach(ptfid, "FixedBuoy Point")'
      write(*,*)'       Point id returned by ptattach ',ptid
      write(3,*)'       ptid = ptattach(ptfid, "FixedBuoy Point")'
      write(3,*)'       Point id returned by ptattach ',ptid
 
      status = ptlevinfo(ptid, 0, fldlist, fldtype, fldorder)
      write(*,*)'    status = ptlevinfo(ptid, 0, fldlist, 
     1fldtype, fldorder)'
      write(*,*)'    Status returned by ptlevinfo ',status
      write(3,*)'    status = ptlevinfo(ptid, 0, fldlist, 
     1fldtype, fldorder)'
      write(3,*)'    Status returned by ptlevinfo ',status

      write(*,*)' '
      write(3,*)' '
c Test Case -- ptsizeof
c
      write(3,27)
      write(*,*)'Testing ptsizeof '
      write(*,*)'================='
      write(3,*)'Testing ptsizeof '
      write(3,*)'================='

      fldsz = ptsizeof(ptid, fldlist, fldlevels)
      write(*,*)'       fldsz = ptsizeof(ptid, fldlist, fldlevels)'
      write(*,*)'       fieldsize ', fldsz
      write(*,*)'       Field list ',fldlist
      write(*,*)'       Field levels ',fldlevels
      write(3,*)'       fldsz = ptsizeof(ptid, fldlist, fldlevels)'
      write(3,*)'       fieldsize ', fldsz
      write(3,*)'       Field list ',fldlist
      write(3,*)'       Field levels ',fldlevels

      write(*,*)' '
      write(3,*)' '
c Test Case -- ptflinkinfo
c
      write(3,27)
      write(*,*)'Testing ptflinkinfo '
      write(*,*)'================='
      write(3,*)'Testing ptflinkinfo '
      write(3,*)'================='

      status = ptflinkinfo(ptid, 0, linkfield)
      write(*,*)'       status = ptflinkinfo(ptid, 0, linkfield)'
      write(*,*)'       Status returned by ptflinkinfo ', status
      write(*,*)'The link field to the following level ',linkfield
      write(3,*)'       status = ptflinkinfo(ptid, 0, linkfield)'
      write(3,*)'       Status returned by ptflinkinfo ', status
      write(3,*)'The link field to the following level ',linkfield

      write(*,*)' '
      write(3,*)' '
c Test Case -- ptblinkinfo
c
      write(3,27)
      write(*,*)'Testing ptblinkinfo '
      write(*,*)'================='
      write(3,*)'Testing ptblinkinfo '
      write(3,*)'================='

      status = ptblinkinfo(ptid, 1, linkfield)
      write(*,*)'       status = ptblinkinfo(ptid, 1, linkfield)'
      write(*,*)'       Status returned by ptblinkinfo ', status
      write(*,*)'The link field to the previous level ',linkfield
      write(3,*)'       status = ptblinkinfo(ptid, 1, linkfield)'
      write(3,*)'       Status returned by ptblinkinfo ', status
      write(3,*)'The link field to the previous level ',linkfield

      write(*,*)' '
      write(3,*)' '
c Test Case -- ptnlevs
c
      write(3,27)
      write(*,*)'Testing ptnlevs '
      write(*,*)'================='
      write(3,*)'Testing ptnlevs '
      write(3,*)'================='

      nlevels = ptnlevs(ptid)
      write(*,*)'       nlevels = ptnlevs(ptid)'
      write(*,*)'       Number of levels ',nlevels
      write(3,*)'       nlevels = ptnlevs(ptid)'
      write(3,*)'       Number of levels ',nlevels

      write(*,*)' '
      write(3,*)' '
c Test Case -- ptnflds
c
      write(3,27)
      write(*,*)'Testing ptnflds '
      write(*,*)'================='
      write(3,*)'Testing ptnflds '
      write(3,*)'================='

      nflds = ptnflds(ptid,1, strbufsize)
      write(*,*)'       nflds = ptnflds(ptid,1, strbufsize)'
      write(*,*)'       Number of fields ',nflds
      write(*,*)'       Size in bytes of field list ',strbufsize
      write(3,*)'       nflds = ptnflds(ptid,1, strbufsize)'
      write(3,*)'       Number of fields ',nflds
      write(3,*)'       Size in bytes of field list ',strbufsize
  
      n = 2
      recs(1) = 0
      recs(2) = 2
 
      write(*,*)' '
      write(3,*)' '
c Test Case -- ptrdlev
c
      write(3,27)
      write(*,*)'Testing ptrdlev '
      write(*,*)'================='
      write(3,*)'Testing ptrdlev '
      write(3,*)'================='

      pntr = 1
      status = ptrdlev(ptid, 0, fldlist, n, recs, buffer)
      write(*,*)'     status = ptrdlev(ptid, 0, fldlist, 
     1n, recs, buffer)'
      write(*,*)'     Status returned by ptrdlev ',status
      write(3,*)'     status = ptrdlev(ptid, 0, fldlist, 
     1n, recs, buffer)'
      write(3,*)'     Status returned by ptrdlev ',status
 
      do 21 i=1,n
           desc = buffer(pntr:pntr+8)
           pntr = pntr + 8
           clon = buffer(pntr:pntr+8)
           pntr = pntr + 8
           clat = buffer(pntr:pntr+8)
           pntr = pntr + 8
           cdate = buffer(pntr:pntr+4)
           pntr = pntr + 4
           id = buffer(pntr:pntr+1)
           pntr = pntr + 1

           lon = transfer(clon, lon)
           lat = transfer(clat, lat)
           date = transfer(cdate, date)

           write(*,*) desc, lon, lat, date, id(1:1)
           write(3,*) desc, lon, lat, date, id(1:1)
 21   continue

      status = ptlevinfo(ptid, 1, fldlist, fldtype, fldorder)
      write(*,*)'      status = ptlevinfo(ptid, 1, fldlist, 
     1fldtype, fldorder)'
      write(*,*)'      Status returned by ptlevinfo ',status
      write(3,*)'      status = ptlevinfo(ptid, 1, fldlist, 
     1fldtype, fldorder)'
      write(3,*)'      Status returned by ptlevinfo ',status

      n = ptnrecs(ptid, 1)
      write(*,*)'      n = ptnrecs(ptid, 1)'
      write(*,*)'      Number of records ',n
      write(3,*)'      n = ptnrecs(ptid, 1)'
      write(3,*)'      Number of records ',n
 
 
      do 31 i=1,n
 
           recs(1) = i - 1
           status = ptrdlev(ptid, 1, fldlist, 1, recs, buffer)
 
           pntr = 1
 
           ctime = buffer(pntr:pntr+8)
           pntr = pntr + 8
           crain = buffer(pntr:pntr+4)
           pntr = pntr + 4
           ctemp = buffer(pntr:pntr+4)
           pntr = pntr + 4
           id = buffer(pntr:pntr+1)
           pntr = pntr + 1

           time = transfer(ctime, time)
           rain = transfer(crain, rain)
           temp = transfer(ctemp, temp)

           write(*,*) time, rain, temp, '  ', id(1:1)
           write(3,*) time, rain, temp, '  ', id(1:1)
 31   continue

      write(*,*)' '
      write(3,*)' '
c Test Case -- ptinqattrs
c
      write(3,27)
      write(*,*)'Testing ptinqattrs '
      write(*,*)'================='
      write(3,*)'Testing ptinqattrs '
      write(3,*)'================='

      nmattrs = ptinqattrs(ptid, attrlist,strbufsize)
      write(*,*)'   nmattrs = ptinqattrs(ptid, attrlist,strbufsize)'
      write(*,*)'   Number of attributes ',nmattrs
      write(*,*)'   Attribute list ',attrlist
      write(3,*)'   nmattrs = ptinqattrs(ptid, attrlist,strbufsize)'
      write(3,*)'   Number of attributes ',nmattrs
      write(3,*)'   Attribute list ',attrlist

c Test Case -- ptrdattr
c
      write(3,27)
      write(*,*)'Testing ptrdattr '
      write(*,*)'================='
      write(3,*)'Testing ptrdattr '
      write(3,*)'================='

      status = ptrdattr(ptid, "float32", b32)
      write(*,*)'      status = ptrdattr(ptid, "float32", b32)'
      write(*,*)'      Status returned by ptrdattr ',status
      write(*,*) 'b32 = ', b32
      write(3,*)'      status = ptrdattr(ptid, "float32", b32)'
      write(3,*)'      Status returned by ptrdattr ',status
      write(3,*) 'b32 = ', b32

c Test Case -- ptattrinfo
c
      write(3,27)
      write(*,*)'Testing ptattrinfo '
      write(*,*)'================='
      write(3,*)'Testing ptattrinfo '
      write(3,*)'================='

      status = ptattrinfo(ptid, "float32", nt, sz)
      write(*,*)'      status = ptattrinfo(ptid, "float32", nt, sz)'
      write(*,*)'      Status returned by ptattrinfo ',status
      write(*,*) 'nt = ', nt
      write(*,*) 'sz = ', sz
      write(3,*)'      status = ptattrinfo(ptid, "float32", nt, sz)'
      write(3,*)'      Status returned by ptattrinfo ',status
      write(3,*) 'nt = ', nt
      write(3,*) 'sz = ', sz
 
      status = ptdetach(ptid)
      write(*,*)'       status = ptdetach(ptid)'
      write(*,*)'       Status returned by ptdetach ',status
      write(3,*)'       status = ptdetach(ptid)'
      write(3,*)'       Status returned by ptdetach ',status

      status = ptclose(ptfid)
      write(*,*)'       status = ptclose(ptfid)'
      write(*,*)'       Status returned by ptclose ',status
      write(3,*)'       status = ptclose(ptfid)'
      write(3,*)'       Status returned by ptclose ',status


      ptfid = ptopen("Pointf_Test.hdf", DFACC_RDWR)
      write(*,*)'     ptfid = ptopen("Pointf_Test.hdf", DFACC_RDWR)'
      write(*,*)'     Point id returned by ptopen ',ptfid
      write(3,*)'     ptfid = ptopen("Pointf_Test.hdf", DFACC_RDWR)'
      write(3,*)'     Point id returned by ptopen ',ptfid

      ptid1 = ptattach(ptfid, "Simple Point")
      write(*,*)'      ptid1 = ptattach(ptfid, "Simple Point")'
      write(*,*)'      Point id returned by ptattach ',ptid1
      write(3,*)'      ptid1 = ptattach(ptfid, "Simple Point")'
      write(3,*)'      Point id returned by ptattach ',ptid1

      ptid2 = ptattach(ptfid, "FixedBuoy Point")
      write(*,*)'      ptid2 = ptattach(ptfid, "FixedBuoy Point")'
      write(*,*)'      Point id returned by ptattach ',ptid2
      write(3,*)'      ptid2 = ptattach(ptfid, "FixedBuoy Point")'
      write(3,*)'      Point id returned by ptattach ',ptid2

      f64 = 43.2
      c8 = transfer(f64, c8)
      datbuf(1:8) = c8
      recs(1) = 1

c Test Case -- ptuplev
c
      write(3,27)
      write(*,*)'Testing ptuplev '
      write(*,*)'================='
      write(3,*)'Testing ptuplev '
      write(3,*)'================='

      status = ptuplev(ptid2, 0, "Longitude", 1, recs, datbuf)
      write(*,*)'      status = ptuplev(ptid2, 0, "Longitude", 
     11, recs, datbuf)'
      write(*,*)'      Status returned by ptuplev ',status
      write(3,*)'      status = ptuplev(ptid2, 0, "Longitude", 
     11, recs, datbuf)'
      write(3,*)'      Status returned by ptuplev ',status

      datbuf(1:1) = 'F'
      recs(1) = 0
      status = ptuplev(ptid2, 0, "ID", 1, recs, datbuf)
      write(*,*)'     status = ptuplev(ptid2, 0, "ID", 1, 
     1recs, datbuf)'
      write(*,*)'     Status returned by ptuplev ',status
      write(3,*)'     status = ptuplev(ptid2, 0, "ID", 1, 
     1recs, datbuf)'
      write(3,*)'     Status returned by ptuplev ',status

c Test Case -- ptgetrecnums
c
      write(3,27)
      write(*,*)'Testing ptgetrecnums '
      write(*,*)'================='
      write(3,*)'Testing ptgetrecnums '
      write(3,*)'================='

      inlevel = 0
      outlevel = 1
      nrec = 1
      status = ptgetrecnums(ptid2, inlevel, outlevel, nrec, recs, 
     1outnrec, outrecs)
      write(*,*)'      status = ptgetrecnums(ptid2, inlevel, outlevel, 
     1nrec, recs,outnrec, outrecs)'
      write(*,*)'      Status returned by ptgetrecnums ',status
      write(3,*)'      status = ptgetrecnums(ptid2, inlevel, outlevel, 
     1nrec, recs,outnrec, outrecs)'
      write(3,*)'      Status returned by ptgetrecnums ',status

      write(*,*) outnrec
      write(3,*) outnrec

      do 71 i=1,outnrec
         datbuf(i:i) = 'F'
 71   continue

      status = ptuplev(ptid2, outlevel, "ID", outnrec, outrecs, 
     1datbuf)
      write(*,*)'       status = ptuplev(ptid2, outlevel, "ID", 
     1outnrec, outrecs,datbuf)'
      write(*,*)'       Status returned by ptuplev ',status
      write(3,*)'       status = ptuplev(ptid2, outlevel, "ID", 
     1outnrec, outrecs,datbuf)'
      write(3,*)'       Status returned by ptuplev ',status

      status = ptdetach(ptid1)
      write(*,*)'      status = ptdetach(ptid1)'
      write(*,*)'      Status returned by ptdetach ',status
      write(3,*)'      status = ptdetach(ptid1)'
      write(3,*)'      Status returned by ptdetach ',status

      status = ptdetach(ptid2)
      write(*,*)'      status = ptdetach(ptid2)'
      write(*,*)'      Status returned by ptdetach ',status
      write(3,*)'      status = ptdetach(ptid2)'
      write(3,*)'      Status returned by ptdetach ',status


      status = ptclose(ptfid)
      write(*,*)'      status = ptclose(ptfid)'
      write(*,*)'      Status returned by ptclose ',status
      write(3,*)'      status = ptclose(ptfid)'
      write(3,*)'      Status returned by ptclose ',status


      ptfid = ptopen("Pointf_Test.hdf", DFACC_READ)
      write(*,*)'    ptfid = ptopen("Pointf_Test.hdf", DFACC_READ)'
      write(*,*)'    Point id returned by ptopen ',ptfid
      write(3,*)'    ptfid = ptopen("Pointf_Test.hdf", DFACC_READ)'
      write(3,*)'    Point id returned by ptopen ',ptfid

c Test Case -- ptinqpoint
c
      write(3,27)
      write(*,*)'Testing ptinqpoint '
      write(*,*)'================='
      write(3,*)'Testing ptinqpoint '
      write(3,*)'================='

      npoint = ptinqpoint("Pointf_Test.hdf",ptlist,strbufsize)
      write(*,*)'  Number of points in file ',npoint
      write(*,*)'  List of points in file ',ptlist
      write(3,*)'  Number of points in file ',npoint
      write(3,*)'  List of points in file ',ptlist

      ptid = ptattach(ptfid, "FloatBuoy Point")
      write(*,*)'     ptid = ptattach(ptfid, "FloatBuoy Point")'
      write(*,*)'     Point id returned by ptattach ',ptid
      write(3,*)'     ptid = ptattach(ptfid, "FloatBuoy Point")'
      write(3,*)'     Point id returned by ptattach ',ptid

c Test Case -- ptdefboxreg
c
      write(3,27)
      write(*,*)'Testing ptdefboxreg '
      write(*,*)'================='
      write(3,*)'Testing ptdefboxreg '
      write(3,*)'================='

      cornerlon(1) = -145.
      cornerlat(1) = -15.
      cornerlon(2) = -135.
      cornerlat(2) = 8.

      regionid = ptdefboxreg(ptid, cornerlon, cornerlat)
      write(*,*)'      regionid = ptdefboxreg(ptid, 
     1cornerlon, cornerlat)'
      write(*,*)'      Region id returned by ptdefboxreg ',regionid
      write(3,*)'      regionid = ptdefboxreg(ptid, 
     1cornerlon, cornerlat)'
      write(3,*)'      Region id returned by ptdefboxreg ',regionid

c Test Case -- ptreginfo
c
      write(3,27)
      write(*,*)'Testing ptreginfo '
      write(*,*)'================='
      write(3,*)'Testing ptreginfo '
      write(3,*)'================='

      level = 1
      status = ptreginfo(ptid, regionid, level, 
     1"Longitude,Latitude", size)
      write(*,*)'       status = ptreginfo(ptid, regionid, level,
     1"Longitude,Latitude", size)'
      write(*,*)'       Status returned by ptreginfo ',status
      write(3,*)'       status = ptreginfo(ptid, regionid, level,
     1"Longitude,Latitude", size)'
      write(3,*)'       Status returned by ptreginfo ',status

c Test Case -- ptextreg
c
      write(3,27)
      write(*,*)'Testing ptextreg '
      write(*,*)'================='
      write(3,*)'Testing ptextreg '
      write(3,*)'================='

      status = ptextreg(ptid, regionid, level, 
     1"Longitude,Latitude", dtbuf)
      write(*,*)'    status = ptextreg(ptid, regionid, level,
     1"Longitude,Latitude", dtbuf)'
      write(*,*)'    Status returned by ptextreg ',status
      write(3,*)'    status = ptextreg(ptid, regionid, level,
     1"Longitude,Latitude", dtbuf)'
      write(3,*)'    Status returned by ptextreg ',status

      do 81 j = 1,size/16
         write(*,*) j, dtbuf(2*j-1),dtbuf(2*j)
         write(3,*) j, dtbuf(2*j-1),dtbuf(2*j)
 81   continue
      

c Test Case -- ptdeftmeper
c
      write(3,27)
      write(*,*)'Testing ptdeftmeper '
      write(*,*)'================='
      write(3,*)'Testing ptdeftmeper '
      write(3,*)'================='

      starttime = 35208757.6d0
      stoptime = 35984639.2d0
    
      periodid = ptdeftmeper(ptid, starttime, stoptime)
      write(*,*)'    periodid = ptdeftmeper(ptid, starttime, stoptime)'
      write(*,*)'    Period id returned by ptdeftmeper ',periodid
      write(3,*)'    periodid = ptdeftmeper(ptid, starttime, stoptime)'
      write(3,*)'    Period id returned by ptdeftmeper ',periodid

c Test Case -- ptperinfo
c
      write(3,27)
      write(*,*)'Testing ptperinfo '
      write(*,*)'================='
      write(3,*)'Testing ptperinfo '
      write(3,*)'================='

      level = 1
      status = ptperinfo(ptid, periodid, level, "Time", size)
      write(*,*)'    status = ptperinfo(ptid, periodid, level, 
     1"Time", size)'
      write(*,*)'    Status returned by ptperinfo ',status
      write(*,*)'    Size of region in bytes ',size
      write(3,*)'    status = ptperinfo(ptid, periodid, level, 
     1"Time", size)'
      write(3,*)'    Status returned by ptperinfo ',status
      write(3,*)'    Size of region in bytes ',size

c Test Case -- ptextper
c
      write(3,27)
      write(*,*)'Testing ptextper '
      write(*,*)'================='
      write(3,*)'Testing ptextper '
      write(3,*)'================='

      status = ptextper(ptid, periodid, level, "Time", dtbuf)
      write(*,*)'    status = ptextper(ptid, periodid, level, 
     1"Time", dtbuf)'
      write(*,*)'    Status returned by ptextper ',status
      write(3,*)'    status = ptextper(ptid, periodid, level, 
     1"Time", dtbuf)'
      write(3,*)'    Status returned by ptextper ',status
     
      do 91 k=1,size/8
         write(*,*) k, dtbuf(k)
         write(3,*) k, dtbuf(k)
 91   continue
     
 

      status = ptdetach(ptid)
      write(*,*)'      status = ptdetach(ptid)'
      write(*,*)'      Status returned by ptdetach ',status
      write(3,*)'      status = ptdetach(ptid)'
      write(3,*)'      Status returned by ptdetach ',status

      status = ptclose(ptfid)
      write(*,*)'      status = ptclose(ptfid)'
      write(*,*)'      Status returned by ptclose ',status
      write(3,*)'      status = ptclose(ptfid)'
      write(3,*)'      Status returned by ptclose ',status


      close(unit=3)
   27 format('')
      stop
      end

c
 
      program testpoint
 
      integer*4       ptfid, ptid1, ptid2, ptid3, ptdetach, ptclose
      integer*4       ptopen, ptcreate
      integer         status
      integer*4       ptid, fldsz, nlevels, nflds, fldlevels(5)
      integer*4	      npoint
      integer*4       fieldtype(8), fieldorder(8)
      character*72    fldlist, ptlist
      character*30    attrlist
 
      integer*4       ptattach, ptinqpoint
      integer         ptdeflev, ptdeflink, ptwrattr
      integer         ptrdattr, ptattrinfo
      integer         i, j, k, pntr, strbufsize
      integer*4	      strbufsize2
      integer*2       wgt
      integer*4       n, date, nt, sz, zero
      integer*4	      strbuf, nrec
      integer*4	      regrec
      integer*4	      regrecs(20)
 
      real*4          rain, temp, conc(4), f32, b32 
      real*8          lon, lat, time
      real*8          range(2)
 
      character       buffer*10000, id*2, desc*8, spc*4
      character       linkfield*8
      character       ctime*8, cconc*16, clon*8, clat*8
      character       cdate*4, crain*4, ctemp*4, cwgt*2
      equivalence     (time,ctime), (conc,cconc), (lon,clon)
      equivalence     (lat,clat), (rain,crain), (temp,ctemp)
      equivalence     (date,cdate), (wgt,cwgt)

      integer         ptwrlev, ptperrecs, ptregrecs

      integer*4       recs(32)
      integer*4       fldtype(32), fldorder(32)
 
      integer         ptrdlev
      integer         ptlevinfo, ptblinkinfo, ptflinkinfo
      integer	      ptgetlevname
      integer*4       ptnrecs, ptnlevs, ptsizeof, ptnflds
      integer*4	      ptlevidx, ptinqattrs

      integer         ptuplev, ptgetrecnums
      integer*4       inlevel, outlevel, levndx
      integer*4       outrecs(32), outnrec
      real*8          f64
 
      character       datbuf*256, c8*8
      character*(72)  levname
      equivalence     (f64,c8)

      integer         ptextreg, ptreginfo
      integer         ptextper, ptperinfo
 
      integer*4       size, ptdefboxreg, ptdeftmeper
      integer*4       ptdefvrtreg
      integer*4       regionid, periodid
 
      real*4          dtbuff32(25)
      real*8          cornerlon(2), cornerlat(2)
      real*8          dtbuf(128)
      real*8          starttime
      real*8          stoptime
 
 
      integer DFACC_CREATE
      parameter (DFACC_CREATE=4)
 
      integer  DFACC_RDWR
      parameter (DFACC_RDWR=3)

      integer  DFNT_CHAR8, DFNT_INT16, DFNT_INT32
      parameter (DFNT_CHAR8=4)
      parameter (DFNT_INT16=22)
      parameter (DFNT_INT32=24)
 
      integer  DFNT_FLOAT32, DFNT_FLOAT64
      parameter (DFNT_FLOAT32=5)
      parameter (DFNT_FLOAT64=6)

      integer DFACC_READ
      parameter (DFACC_READ=1)

      integer HDFE_NOPREVSUB
      parameter (HDFE_NOPREVSUB=-1)

      zero = 0

      open(unit=3, file='testpointf.txt', status = 'NEW')
 
      write(*,*)'Testing Point FORTRAN 77 interface'
      write(*,*)'=================================='
      write(3,*)'Testing Point FORTRAN 77 interface'
      write(3,*)'=================================='
      write(*,*)' '
      write(3,*)' '
 
c Test Case -- ptopen
c
      write(*,*)'Testing ptopen '
      write(*,*)'================='
      write(3,*)'Testing ptopen '
      write(3,*)'================='

      ptfid = ptopen("Pointf_Test.hdf", DFACC_CREATE)
      if (ptfid .lt. zero) then
         write(*,*)'********** Error unexpected **********'
         write(3,*)'********** Error unexpected **********'
         call heprnt(0)
      else
         write(*,*)'       ptfid = ptopen("Pointf_Test.hdf", DFACC_CREAT       &
     1E)'
         write(*,*)'       File id  returned by ptopen ', ptfid
         write(3,*)'       ptfid = ptopen("Pointf_Test.hdf", DFACC_CREAT       &
     1E)'
         write(3,*)'       File id returned by ptopen ', ptfid
         write(*,*)' '
         write(3,*)' '
      endif


 
c Test Case -- ptcreate
c
      write(*,*)'Testing ptcreate '
      write(*,*)'================='
      write(3,*)'Testing ptcreate '
      write(3,*)'================='

      ptid1 = ptcreate(ptfid, "Simple Point")
      if (ptid1 .lt. zero) then
         write(*,*)'********** Error unexpected **********'
         write(3,*)'********** Error unexpected **********'
         call heprnt(0)
      else
         write(*,*)'      ptid1 = ptcreate(ptfid, "Simple Point")'
         write(*,*)'      Point id returned by ptcreate ',ptid1
         write(3,*)'      ptid1 = ptcreate(ptfid, "Simple Point")'
         write(3,*)'      Point id returned by ptcreate ',ptid1
      endif

      ptid2 = ptcreate(ptfid, "FixedBuoy Point")
      if (ptid2 .lt. zero) then
         write(*,*)'********** Error unexpected **********'
         write(3,*)'********** Error unexpected **********'
         call heprnt(0)
      else
         write(*,*)'      ptid2 = ptcreate(ptfid, "FixedBuoy Point")'
         write(*,*)'      Point id returned by ptcreate ',ptid2
         write(3,*)'      ptid2 = ptcreate(ptfid, "FixedBuoy Point")'
         write(3,*)'      Point id returned by ptcreate ',ptid2
      endif

      ptid3 = ptcreate(ptfid, "FloatBuoy Point")
      if (ptid3 .lt. zero) then
         write(*,*)'********** Error unexpected **********'
         write(3,*)'********** Error unexpected **********'
         call heprnt(0)
      else
         write(*,*)'      ptid3 = ptcreate(ptfid, "FloatBuoy Point")'
         write(*,*)'      Point id returned by ptcreate ',ptid3
         write(3,*)'      ptid3 = ptcreate(ptfid, "FloatBuoy Point")'
         write(3,*)'      Point id returned by ptcreate ',ptid3
      endif
 
 
      write(*,*)' '
      write(3,*)' '
c Test Case -- ptdetach
c  
      write(3,27)
      write(*,*)'Testing ptdetach '
      write(*,*)'================='
      write(3,*)'Testing ptdetach '
      write(3,*)'================='

      status = ptdetach(ptid1)
      if (status .lt. zero) then
         write(*,*)'********** Error unexpected **********'
         write(3,*)'********** Error unexpected **********'
         call heprnt(0)
      else
         write(*,*)'      status = ptdetach(ptid1)'
         write(*,*)'      Status returned by ptdetach ',status
         write(3,*)'      status = ptdetach(ptid1)'
         write(3,*)'      Status returned by ptdetach ',status
      endif

      status = ptdetach(ptid2)
      if (status .lt. zero) then
         write(*,*)'********** Error unexpected **********'
         write(3,*)'********** Error unexpected **********'
         call heprnt(0)
      else
         write(*,*)'      status = ptdetach(ptid2)'
         write(*,*)'      Status returned by ptdetach ',status
         write(3,*)'      status = ptdetach(ptid2)'
         write(3,*)'      Status returned by ptdetach ',status
      endif

      status = ptdetach(ptid3)
      if (status .lt. zero) then
         write(*,*)'********** Error unexpected **********'
         write(3,*)'********** Error unexpected **********'
         call heprnt(0)
      else
         write(*,*)'      status = ptdetach(ptid3)'
         write(*,*)'      Status returned by ptdetach ',status
         write(3,*)'      status = ptdetach(ptid3)'
         write(3,*)'      Status returned by ptdetach ',status
      endif
 
 
      write(*,*)' '
      write(3,*)' '
c Test Case -- ptclose
c  
      write(3,27)
      write(*,*)'Testing ptclose '
      write(*,*)'================='
      write(3,*)'Testing ptclose '
      write(3,*)'================='

      status = ptclose(ptfid)
      if (status .lt. zero) then
         write(*,*)'********** Error unexpected **********'
         write(3,*)'********** Error unexpected **********'
         call heprnt(0)
      else
         write(*,*)'      status = ptclose(ptfid)'
         write(*,*)'      Status returned by ptclose ',status
         write(3,*)'      status = ptclose(ptfid)'
         write(3,*)'      Status returned by ptclose ',status
      endif

      ptfid = ptopen("Pointf_Test.hdf", DFACC_RDWR)
      if (ptfid .lt. zero) then
         write(*,*)'********** Error unexpected **********'
         write(3,*)'********** Error unexpected **********'
         call heprnt(0)
      else
         write(*,*)'      ptfid = ptopen("Pointf_Test.hdf", DFACC_RDWR)'
         write(*,*)'      Point file id returned by ptopen ',ptfid
         write(3,*)'      ptfid = ptopen("Pointf_Test.hdf", DFACC_RDWR)'
         write(3,*)'      Point file id returned by ptopen ',ptfid
      endif

 
      write(*,*)' '
      write(3,*)' '
c Test Case -- ptattach
c  
      write(3,27)
      write(*,*)'Testing ptattach '
      write(*,*)'================='
      write(3,*)'Testing ptattach '
      write(3,*)'================='

      ptid = ptattach(ptfid, "Simple Point")
      if (ptid .lt. zero) then
         write(*,*)'********** Error unexpected **********'
         write(3,*)'********** Error unexpected **********'
         call heprnt(0)
      else
         write(*,*)'      ptid = ptattach(ptfid, "Simple Point")'
         write(*,*)'      Point id returned by ptattach ',ptid
         write(3,*)'      ptid = ptattach(ptfid, "Simple Point")'
         write(3,*)'      Point id returned by ptattach ',ptid
      endif

      fldlist = "Time,Concentration,Species"
 
 
      fieldtype(1) = DFNT_FLOAT64
      fieldtype(2) = DFNT_FLOAT32
      fieldtype(3) = DFNT_CHAR8
 
      fieldorder(1) = 1
      fieldorder(2) = 4
      fieldorder(3) = 4
 
      write(*,*)' '
      write(3,*)' '
c Test Case -- ptdeflev
c  
      write(3,27)
      write(*,*)'Testing ptdeflev '
      write(*,*)'================='
      write(3,*)'Testing ptdeflev '
      write(3,*)'================='

      status = ptdeflev(ptid, "Sensor", fldlist, fieldtype, fieldorder         &
     1)
      if (status .lt. zero) then
         write(*,*)'********** Error unexpected **********'
         write(3,*)'********** Error unexpected **********'
         call heprnt(0)
      else
         write(*,*)'      status = ptdeflev(ptid, "Sensor", fldlist, f         &
     1ieldtype,fieldorder)'
         write(*,*)'      Status returned by ptdeflev ',status
         write(3,*)'      status = ptdeflev(ptid, "Sensor", fldlist, f         &
     1ieldtype,fieldorder)'
         write(3,*)'      Status returned by ptdeflev ',status
      endif
 
      status = ptdetach(ptid)
      if (status .lt. zero) then
         write(*,*)'********** Error unexpected **********'
         write(3,*)'********** Error unexpected **********'
         call heprnt(0)
      else
         write(*,*)'      status = ptdetach(ptid)'
         write(*,*)'      Status returned by ptdetach ',status
         write(3,*)'      status = ptdetach(ptid)'
         write(3,*)'      Status returned by ptdetach ',status
      endif
 
 
      ptid = ptattach(ptfid, "FixedBuoy Point")
      if (ptid .lt. zero) then
         write(*,*)'********** Error unexpected **********'
         write(3,*)'********** Error unexpected **********'
         call heprnt(0)
      else
         write(*,*)'      ptid = ptattach(ptfid, "FixedBuoy Point")'
         write(*,*)'      Point id returned by ptattach ',ptid
         write(3,*)'      ptid = ptattach(ptfid, "FixedBuoy Point")'
         write(3,*)'      Point id returned by ptattach ',ptid
      endif
 
 
 
      fldlist = "Label,Longitude,Latitude,DeployDate,ID"
 
      fieldtype(1) = DFNT_CHAR8
      fieldtype(2) = DFNT_FLOAT64
      fieldtype(3) = DFNT_FLOAT64
      fieldtype(4) = DFNT_INT32
      fieldtype(5) = DFNT_CHAR8
 
 
      fieldorder(1) = 8
      fieldorder(2) = 0
      fieldorder(3) = 0
      fieldorder(4) = 0
      fieldorder(5) = 1

      status = ptdeflev(ptid, "Desc-Loc", fldlist, fieldtype, fieldorde        &
     1r)
      if (status .lt. zero) then
         write(*,*)'********** Error unexpected **********'
         write(3,*)'********** Error unexpected **********'
         call heprnt(0)
      else
         write(*,*)'      status = ptdeflev(ptid, "Desc-Loc", fldlist,         &
     1fieldtype,fieldorder)'
         write(*,*)'      Status returned by ptdeflev ',status
         write(3,*)'      status = ptdeflev(ptid, "Desc-Loc", fldlist,         &
     1fieldtype,fieldorder)'
         write(3,*)'      Status returned by ptdeflev ',status
      endif
 
 
 
      fldlist = "Time,Rainfall,Temperature,ID"
 
      fieldtype(1) = DFNT_FLOAT64
      fieldtype(2) = DFNT_FLOAT32
      fieldtype(3) = DFNT_FLOAT32
      fieldtype(4) = DFNT_CHAR8
 
      fieldorder(1) = 0
      fieldorder(2) = 0
      fieldorder(3) = 0
      fieldorder(4) = 1
 
      status = ptdeflev(ptid, "Observations", fldlist,
     1fieldtype, fieldorder)
      if (status .lt. zero) then
         write(*,*)'********** Error unexpected **********'
         write(3,*)'********** Error unexpected **********'
         call heprnt(0)
      else
         write(*,*)'       status = ptdeflev(ptid, "Observations",             &
     1fldlist,fieldtype, fieldorder)'
         write(*,*)'       Status returned by ptdeflev ',status
         write(3,*)'       status = ptdeflev(ptid, "Observations",             &
     1fldlist,fieldtype, fieldorder)'
         write(3,*)'       Status returned by ptdeflev ',status
      endif
 
      write(*,*)' '
      write(3,*)' '
c Test Case -- ptdeflink
c
      write(3,27)
      write(*,*)'Testing ptdeflink '
      write(*,*)'================='
      write(3,*)'Testing ptdeflink '
      write(3,*)'================='

      status = ptdeflink(ptid, "Desc-Loc", "Observations", "ID")
      if (status .lt. zero) then
         write(*,*)'********** Error unexpected **********'
         write(3,*)'********** Error unexpected **********'
         call heprnt(0)
      else
         write(*,*)'       status = ptdeflink(ptid, "Desc-Loc",                &
     1"Observations", "ID")'
         write(*,*)'       Status returned by ptdeflink ',status
         write(3,*)'       status = ptdeflink(ptid, "Desc-Loc",                &
     1"Observations", "ID")'
         write(3,*)'       Status returned by ptdeflink ',status
      endif

 
      status = ptdetach(ptid)
      if (status .lt. zero) then
         write(*,*)'********** Error unexpected **********'
         write(3,*)'********** Error unexpected **********'
         call heprnt(0)
      else
         write(*,*)'       status = ptdetach(ptid)'
         write(*,*)'       Status returned by ptdetach ',status
         write(3,*)'       status = ptdetach(ptid)'
         write(3,*)'       Status returned by ptdetach ',status
      endif
 

      ptid = ptattach(ptfid, "FloatBuoy Point")
      if (status .lt. zero) then
         write(*,*)'********** Error unexpected **********'
         write(3,*)'********** Error unexpected **********'
         call heprnt(0)
      else
         write(*,*)'       ptid = ptattach(ptfid, "FloatBuoy Point")'
         write(*,*)'       Point id returned by ptattach ',ptid
         write(3,*)'       ptid = ptattach(ptfid, "FloatBuoy Point")'
         write(3,*)'       Point id returned by ptattach ',ptid
      endif
 
 
c      Define Description Level */
 
      fldlist = "Label,DeployDate,Weight,ID"

      fieldtype(1) = DFNT_CHAR8
      fieldtype(2) = DFNT_INT32
      fieldtype(3) = DFNT_INT16
      fieldtype(4) = DFNT_CHAR8

      fieldorder(1) = 8
      fieldorder(2) = 0
      fieldorder(3) = 0
      fieldorder(4) = 1

 
      status = ptdeflev(ptid, "Description", fldlist,
     1fieldtype, fieldorder)
      if (status .lt. zero) then
         write(*,*)'********** Error unexpected **********'
         write(3,*)'********** Error unexpected **********'
         call heprnt(0)
      else
         write(*,*)'       status = ptdeflev(ptid, "Description",              &
     1fldlist,fieldtype, fieldorder)'
         write(*,*)'       Status returned by ptdeflev ',status
         write(3,*)'       status = ptdeflev(ptid, "Description",              &
     1fldlist,fieldtype, fieldorder)'
         write(3,*)'       Status returned by ptdeflev ',status
      endif
 
 
c       Define Data Level
 
      fldlist = "Time,Longitude,Latitude,Rainfall,Temperature,ID"
 
      fieldtype(1) = DFNT_FLOAT64
      fieldtype(2) = DFNT_FLOAT64
      fieldtype(3) = DFNT_FLOAT64
      fieldtype(4) = DFNT_FLOAT32
      fieldtype(5) = DFNT_FLOAT32
      fieldtype(6) = DFNT_CHAR8
 
      fieldorder(1) = 0
      fieldorder(2) = 0
      fieldorder(3) = 0
      fieldorder(4) = 0
      fieldorder(5) = 0
      fieldorder(6) = 1
 
      status = ptdeflev(ptid, "Measurements", fldlist,
     1fieldtype, fieldorder)
      if (status .lt. zero) then
         write(*,*)'********** Error unexpected **********'
         write(3,*)'********** Error unexpected **********'
         call heprnt(0)
      else
         write(*,*)'       status = ptdeflev(ptid, "Measurements",             &
     1fldlist,fieldtype, fieldorder)'
         write(*,*)'       Status returned by ptdeflev ',status
         write(3,*)'       status = ptdeflev(ptid, "Measurements",             &
     1fldlist,fieldtype, fieldorder)'
         write(3,*)'       Status returned by ptdeflev ',status
      endif
 

      status = ptdeflink(ptid, "Description", "Measurements", "ID")
      if (status .lt. zero) then
         write(*,*)'********** Error unexpected **********'
         write(3,*)'********** Error unexpected **********'
         call heprnt(0)
      else
         write(*,*)'       status = ptdeflink(ptid, "Description",                &
     1"Measurements", "ID")'
         write(*,*)'       Status returned by ptdeflink ',status
         write(3,*)'       status = ptdeflink(ptid, "Description",                &
     1"Measurements", "ID")'
         write(3,*)'       Status returned by ptdeflink ',status
      endif
 
      status = ptdetach(ptid)
      if (status .lt. zero) then
         write(*,*)'********** Error unexpected **********'
         write(3,*)'********** Error unexpected **********'
         call heprnt(0)
      else
         write(*,*)'       status = ptdetach(ptid)'
         write(*,*)'       Status returned by ptdetach ',status
         write(3,*)'       status = ptdetach(ptid)'
         write(3,*)'       Status returned by ptdetach ',status
      endif
 
 
      write(*,*)' '
      status = ptclose(ptfid)
      if (status .lt. zero) then
         write(*,*)'********** Error unexpected **********'
         write(3,*)'********** Error unexpected **********'
         call heprnt(0)
      else
         write(*,*)'       status = ptclose(ptfid)'
         write(*,*)'       Status returned by ptclose ',status
         write(3,*)'       status = ptclose(ptfid)'
         write(3,*)'       Status returned by ptclose ',status
      endif

 

 
      write(*,*)' '
      ptfid = ptopen("Pointf_Test.hdf", DFACC_RDWR)
      if (ptfid .lt. zero) then
         write(*,*)'********** Error unexpected **********'
         write(3,*)'********** Error unexpected **********'
         call heprnt(0)
      else
         write(*,*)'       ptfid = ptopen("Pointf_Test.hdf", DFACC_RDWR        &
     1)'
         write(*,*)'       Point file id returned by ptopen ',ptfid
         write(3,*)'       ptfid = ptopen("Pointf_Test.hdf", DFACC_RDWR        &
     1)'
         write(3,*)'       Point file id returned by ptopen ',ptfid
      endif
 
      write(*,*)' '
      ptid = ptattach(ptfid, "Simple Point")
      if (ptfid .lt. zero) then
         write(*,*)'********** Error unexpected **********'
         write(3,*)'********** Error unexpected **********'
         call heprnt(0)
      else
         write(*,*)'       ptid = ptattach(ptfid, "Simple Point")'
         write(*,*)'       Point id returned by ptattach ',ptid
         write(3,*)'       ptid = ptattach(ptfid, "Simple Point")'
         write(3,*)'       Point id returned by ptattach ',ptid
      endif

      open(unit=1, file='simple.txt',STATUS='OLD')
      n = 0
      pntr = 1
      do 10 i=1,1000

           read(1,32,end=100)time,conc(1),conc(2),conc(3),conc(4),spc
           
           n = n + 1
           buffer(pntr:pntr+8) = ctime
           pntr = pntr + 8
           buffer(pntr:pntr+4*4) = cconc
           pntr = pntr + 4*4
           buffer(pntr:pntr+4) = spc
           pntr = pntr + 4
10      continue
 
100     close(unit=1)
   32  format(3x,f10.1,2x,f4.2,2x,f4.2,2x,f4.2,2x,f4.2,1x,a) 

      write(*,*)' '
      write(3,*)' '
c Test Case -- ptwrlev
c
      write(3,27)
      write(*,*)'Testing ptwrlev '
      write(*,*)'================='
      write(3,*)'Testing ptwrlev '
      write(3,*)'================='

      status = ptwrlev(ptid, 0, n, buffer)
      if (status .lt. zero) then
         write(*,*)'********** Error unexpected **********'
         write(3,*)'********** Error unexpected **********'
         call heprnt(0)
      else
         write(*,*)'         status = ptwrlev(ptid, 0, n, buffer)'
         write(*,*)'         Status returned by ptwrlev ',status
         write(3,*)'         status = ptwrlev(ptid, 0, n, buffer)'
         write(3,*)'         Status returned by ptwrlev ',status
      endif

      status = ptdetach(ptid)
      if (status .lt. zero) then
         write(*,*)'********** Error unexpected **********'
         write(3,*)'********** Error unexpected **********'
         call heprnt(0)
      else
         write(*,*)'         status = ptdetach(ptid)'
         write(*,*)'         Status returned by ptdetach ',status
         write(3,*)'         status = ptdetach(ptid)'
         write(3,*)'         Status returned by ptdetach ',status
      endif
   
 
      ptid = ptattach(ptfid, "FixedBuoy Point")
      if (ptid .lt. zero) then
         write(*,*)'********** Error unexpected **********'
         write(3,*)'********** Error unexpected **********'
         call heprnt(0)
      else
         write(*,*)'        ptid = ptattach(ptfid, "FixedBuoy Point")'
         write(*,*)'        Point id returned by ptattach ',ptid
         write(3,*)'        ptid = ptattach(ptfid, "FixedBuoy Point")'
         write(3,*)'        Point id returned by ptattach ',ptid
      endif

      open(unit=1, file='fixedBuoy0.txt', STATUS='OLD')
 
      n = 0
      pntr = 1
      do 20 i=1,1000
 
           read(1, 34, end=200)desc,lon,lat,date,id
           
           n = n + 1
           buffer(pntr:pntr+8) = desc
           pntr = pntr + 8
           buffer(pntr:pntr+8) = clon
           pntr = pntr + 8
           buffer(pntr:pntr+8) = clat
           pntr = pntr + 8
           buffer(pntr:pntr+4) = cdate
           pntr = pntr + 4
           buffer(pntr:pntr+1) = id
           pntr = pntr + 1
 20   continue
 
 200  close(unit=1)
   34 format(a8,1x,f12.7,1x,f12.7,1x,i6,1x,a)

      status = ptwrlev(ptid, 0, n, buffer)
      if (status .lt. zero) then
         write(*,*)'********** Error unexpected **********'
         write(3,*)'********** Error unexpected **********'
         call heprnt(0)
      else
         write(*,*)'        status = ptwrlev(ptid, 0, n, buffer)'
         write(*,*)'        Status returned by ptwrlev ',status
         write(3,*)'        status = ptwrlev(ptid, 0, n, buffer)'
         write(3,*)'        Status returned by ptwrlev ',status
      endif
 
 
      open(unit=1, file='fixedBuoy1.txt', STATUS='OLD')
 
      n = 0
      pntr = 1
      do 30 i=1,1000

           read(1, 35, end=300) time, rain, temp, id
           
           n = n + 1
 
           buffer(pntr:pntr+8) = ctime
           pntr = pntr + 8
           buffer(pntr:pntr+4) = crain
           pntr = pntr + 4
           buffer(pntr:pntr+4) = ctemp
           pntr = pntr + 4
           buffer(pntr:pntr+1) = id
           pntr = pntr + 1
 30   continue
 
 300  close(unit=1)
  35  format(3x,f10.1,5x,f3.1,3x,f5.2,3x,a)
      status = ptwrlev(ptid, 1, n, buffer)
      if (status .lt. zero) then
         write(*,*)'********** Error unexpected **********'
         write(3,*)'********** Error unexpected **********'
         call heprnt(0)
      else
         write(*,*)'          status = ptwrlev(ptid, 1, n, buffer)'
         write(*,*)'          Status returned by ptwrlev ',status
         write(3,*)'          status = ptwrlev(ptid, 1, n, buffer)'
         write(3,*)'          Status returned by ptwrlev ',status
      endif

      write(*,*)' '
      write(3,*)' '
c Test Case -- ptwrattr
c
      write(3,27)
      write(*,*)'Testing ptwrattr '
      write(*,*)'================='
      write(3,*)'Testing ptwrattr '
      write(3,*)'================='

      f32 = -7.5
      status = ptwrattr(ptid, "float32", 5, 1, f32)
      if (status .lt. zero) then
         write(*,*)'********** Error unexpected **********'
         write(3,*)'********** Error unexpected **********'
         call heprnt(0)
      else
         write(*,*)'         status = ptwrattr(ptid, "float32", 5, 1,          &
     1f32)'
         write(*,*)'         Status returned by ptwrattr ', status
         write(3,*)'         status = ptwrattr(ptid, "float32", 5, 1,          &
     1f32)'
         write(3,*)'         Status returned by ptwrattr ', status
      endif
 
      status = ptdetach(ptid)
      if (status .lt. zero) then
         write(*,*)'********** Error unexpected **********'
         write(3,*)'********** Error unexpected **********'
         call heprnt(0)
      else
         write(*,*)'       status = ptdetach(ptid)'
         write(*,*)'       Status returned by ptdetach ',status
         write(3,*)'       status = ptdetach(ptid)'
         write(3,*)'       Status returned by ptdetach ',status
      endif
 
 
      ptid = ptattach(ptfid, "FloatBuoy Point")
      if (ptid .lt. zero) then
         write(*,*)'********** Error unexpected **********'
         write(3,*)'********** Error unexpected **********'
         call heprnt(0)
      else
         write(*,*)'      ptid = ptattach(ptfid, "FloatBuoy Point")'
         write(*,*)'      Point id returned by ptattach ',ptid
         write(3,*)'      ptid = ptattach(ptfid, "FloatBuoy Point")'
         write(3,*)'      Point id returned by ptattach ',ptid
      endif
 
      open(unit=1, file='floatBuoy0.txt', STATUS='OLD')
 
      n = 0
      pntr = 1
      do 40 i=1,1000
 
           read(1, 36, end=400)  desc, date, wgt, id
           
           n = n + 1
 
           buffer(pntr:pntr+8) = desc
           pntr = pntr + 8
           buffer(pntr:pntr+4) = cdate
           pntr = pntr + 4
           buffer(pntr:pntr+2) = cwgt
           pntr = pntr + 2
           buffer(pntr:pntr+1) = id
           pntr = pntr + 1
 40   continue
 
 400  close(unit=1)
   36 format(a8,2x,i6,3x,i4,2x,a)
   
      status = ptwrlev(ptid, 0, n, buffer)
      if (status .lt. zero) then
         write(*,*)'********** Error unexpected **********'
         write(3,*)'********** Error unexpected **********'
         call heprnt(0)
      else
         write(*,*)'      status = ptwrlev(ptid, 0, n, buffer)'
         write(*,*)'      Status returned by ptwrlev ',status
         write(3,*)'      status = ptwrlev(ptid, 0, n, buffer)'
         write(3,*)'      Status returned by ptwrlev ',status
      endif
 
      open(unit=1, file='floatBuoy1.txt', STATUS='OLD')
 
      n = 0
      pntr = 1
      do 50 i=1,1000
 
           read(1, 37, end=500)time,lon,lat,rain,temp,id
           
           n = n + 1
 
           buffer(pntr:pntr+8) = ctime
           pntr = pntr + 8
           buffer(pntr:pntr+8) = clon
           pntr = pntr + 8
           buffer(pntr:pntr+8) = clat
           pntr = pntr + 8
           buffer(pntr:pntr+4) = crain
           pntr = pntr + 4
           buffer(pntr:pntr+4) = ctemp
           pntr = pntr + 4
           buffer(pntr:pntr+1) = id
           pntr = pntr + 1
 50   continue
 
 500  close(unit=1)
   37 format(3x,f10.1,2x,f11.6,2x,f11.6,5x,f3.1,3x,f5.2,3x,a)
 
      status = ptwrlev(ptid, 1, n, buffer)
      if (status .lt. zero) then
         write(*,*)'********** Error unexpected **********'
         write(3,*)'********** Error unexpected **********'
         call heprnt(0)
      else
         write(*,*)'        status = ptwrlev(ptid, 1, n, buffer)'
         write(*,*)'        Status returned by ptwrlev ',status
         write(3,*)'        status = ptwrlev(ptid, 1, n, buffer)'
         write(3,*)'        Status returned by ptwrlev ',status
      endif

      status = ptdetach(ptid)
      if (status .lt. zero) then
         write(*,*)'********** Error unexpected **********'
         write(3,*)'********** Error unexpected **********'
         call heprnt(0)
      else
         write(*,*)'       status = ptdetach(ptid)'
         write(*,*)'      Status returned by ptdetach ',status
         write(3,*)'       status = ptdetach(ptid)'
         write(3,*)'      Status returned by ptdetach ',status
      endif
 
 
      status = ptclose(ptfid)
      if (status .lt. zero) then
         write(*,*)'********** Error unexpected **********'
         write(3,*)'********** Error unexpected **********'
         call heprnt(0)
      else
         write(*,*)'      status = ptclose(ptfid)'
         write(*,*)'      Status returned by ptclose ',status
         write(3,*)'      status = ptclose(ptfid)'
         write(3,*)'      Status returned by ptclose ',status
      endif

 
      ptfid = ptopen("Pointf_Test.hdf", DFACC_READ)
      if (ptfid .lt. zero) then
         write(*,*)'********** Error unexpected **********'
         write(3,*)'********** Error unexpected **********'
         call heprnt(0)
      else
         write(*,*)'        ptfid = ptopen("Pointf_Test.hdf", DFACC_REA        &
     1D)'
         write(*,*)'        Point id returned by ptopen ',ptfid
         write(3,*)'        ptfid = ptopen("Pointf_Test.hdf", DFACC_REA        &
     1D)'
         write(3,*)'        Point id returned by ptopen ',ptfid
      endif

      ptid = ptattach(ptfid, "Simple Point")
      if (ptid .lt. zero) then
         write(*,*)'********** Error unexpected **********'
         write(3,*)'********** Error unexpected **********'
         call heprnt(0)
      else
         write(*,*)'       ptid = ptattach(ptfid, "Simple Point")'
         write(*,*)'       Point id returned by ptattach ',ptid
         write(3,*)'       ptid = ptattach(ptfid, "Simple Point")'
         write(3,*)'       Point id returned by ptattach ',ptid
      endif
 
      write(*,*)' '
      write(3,*)' '
c Test Case -- ptlevidx
c
      write(3,27)
      write(*,*)'Testing ptlevidx '
      write(*,*)'================='
      write(3,*)'Testing ptlevidx '
      write(3,*)'================='

      levndx = ptlevidx(ptid, "Sensor")
      if (levndx .lt. zero) then
         write(*,*)'********** Error unexpected **********'
         write(3,*)'********** Error unexpected **********'
         call heprnt(0)
      else
         write(*,*)'     levndx = ptlevidx(ptid, "Sensor")'
         write(*,*)'     Level index of Sensor ',levndx
         write(3,*)'     levndx = ptlevidx(ptid, "Sensor")'
         write(3,*)'     Level index of Sensor ',levndx
      endif

      write(*,*)' '
      write(3,*)' '
c Test Case -- ptlevinfo
c
      write(3,27)
      write(*,*)'Testing ptlevinfo '
      write(*,*)'================='
      write(3,*)'Testing ptlevinfo '
      write(3,*)'================='

      nlevels = ptlevinfo(ptid, 0, fldlist, fldtype, fldorder)
      if (nlevels .lt. zero) then
         write(*,*)'********** Error unexpected **********'
         write(3,*)'********** Error unexpected **********'
         call heprnt(0)
      else
         write(*,*)'      nlevels = ptlevinfo(ptid, 0, fldlist,                &
     1   fldtype, fldorder)'
         write(*,*)'      Number of fields in level 0 ',status
         write(*,*)'      List of fields in level 0 ',fldlist
         write(3,*)'      Number of fields in level 0 ',status
         write(3,*)'      List of fields in level 0 ',fldlist
         do 7 i=1,nlevels
            write(*,*)' Number type of field ',fldtype(i)
            write(*,*)' Order of field ', fldorder(i)
            write(3,*)' Number type of field ',fldtype(i)
            write(3,*)' Order of field ', fldorder(i)
 7       continue
         write(3,*)'      status = ptlevinfo(ptid, 0, fldlist,                 &
     1   fldtype, fldorder)'
         write(3,*)'      Status returned by ptlevinfo ',status
      endif

      write(*,*)' '
      write(3,*)' '
c Test Case -- ptnrecs
c
      write(3,27)
      write(*,*)'Testing ptnrecs '
      write(*,*)'================='
      write(3,*)'Testing ptnrecs '
      write(3,*)'================='

      n = ptnrecs(ptid, 0)
      if (n .lt. zero) then
         write(*,*)'********** Error unexpected **********'
         write(3,*)'********** Error unexpected **********'
         call heprnt(0)
      else
         write(*,*)'     n = ptnrecs(ptid, 0)'
         write(*,*)'     Number of records in level ',n
         write(3,*)'     n = ptnrecs(ptid, 0)'
         write(3,*)'     Number of records in level ',n
      endif
 
      do 5 i=1,n
         recs(i) = i - 1
 5    continue
 
      write(*,*)' '
      write(3,*)' '
c Test Case -- ptrdlev
c
      write(3,27)
      write(*,*)'Testing ptrdlev '
      write(*,*)'================='
      write(3,*)'Testing ptrdlev '
      write(3,*)'================='

      status = ptrdlev(ptid, 0, fldlist, n, recs, buffer)
      if (status .lt. zero) then
         write(*,*)'********** Error unexpected **********'
         write(3,*)'********** Error unexpected **********'
         call heprnt(0)
      else
         write(*,*)'      status = ptrdlev(ptid,0,fldlist,n,recs,buffer        &
     1)'
         write(*,*)'      Status returned by ptrdlev ',status
         write(3,*)'      status = ptrdlev(ptid,0,fldlist,n,recs,buffer        &
     1)'
         write(3,*)'      Status returned by ptrdlev ',status
      endif

      pntr = 1
      do 11 i=1,n
           ctime = buffer(pntr:pntr+8)
           pntr = pntr + 8
           cconc = buffer(pntr:pntr+4*4)
           pntr = pntr + 4*4
           spc = buffer(pntr:pntr+4)
           pntr = pntr + 4
           write(*,*)time,conc(1),conc(2),conc(3),conc(4),' ',spc
           write(3,*)time,conc(1),conc(2),conc(3),conc(4),' ',spc
11    continue
 
      status = ptdetach(ptid)
      if (status .lt. zero) then
         write(*,*)'********** Error unexpected **********'
         write(3,*)'********** Error unexpected **********'
         call heprnt(0)
      else
         write(*,*)'       status = ptdetach(ptid)'
         write(*,*)'       Status returned by ptdetach ',status
         write(3,*)'       status = ptdetach(ptid)'
         write(3,*)'       Status returned by ptdetach ',status
      endif
 
      ptid = ptattach(ptfid, "FixedBuoy Point")
      if (ptid .lt. zero) then
         write(*,*)'********** Error unexpected **********'
         write(3,*)'********** Error unexpected **********'
         call heprnt(0)
      else
         write(*,*)'       ptid = ptattach(ptfid, "FixedBuoy Point")'
         write(*,*)'       Point id returned by ptattach ',ptid
         write(3,*)'       ptid = ptattach(ptfid, "FixedBuoy Point")'
         write(3,*)'       Point id returned by ptattach ',ptid
      endif
 
      status = ptlevinfo(ptid, 0, fldlist, fldtype, fldorder)
      if (status .lt. zero) then
         write(*,*)'********** Error unexpected **********'
         write(3,*)'********** Error unexpected **********'
         call heprnt(0)
      else
         write(*,*)'    status = ptlevinfo(ptid, 0, fldlist,                   &
     1fldtype, fldorder)'
         write(*,*)'    Status returned by ptlevinfo ',status
         write(3,*)'    status = ptlevinfo(ptid, 0, fldlist,                   &
     1fldtype, fldorder)'
         write(3,*)'    Status returned by ptlevinfo ',status
      endif

      write(*,*)' '
      write(3,*)' '
c Test Case -- ptsizeof
c
      write(3,27)
      write(*,*)'Testing ptsizeof '
      write(*,*)'================='
      write(3,*)'Testing ptsizeof '
      write(3,*)'================='

      fldsz = ptsizeof(ptid, fldlist, fldlevels)
      if (fldsz .lt. zero) then
         write(*,*)'********** Error unexpected **********'
         write(3,*)'********** Error unexpected **********'
         call heprnt(0)
      else
         write(*,*)'       fldsz = ptsizeof(ptid, fldlist, fldlevels)'
         write(*,*)'       fieldsize ', fldsz
         write(*,*)'Field list'
         write(*,*)'  ',fldlist
         write(*,*)'       Field levels ',fldlevels
         write(3,*)'       fldsz = ptsizeof(ptid, fldlist, fldlevels)'
         write(3,*)'       fieldsize ', fldsz
         write(3,*)'Field list'
         write(3,*)'  ',fldlist
         write(3,*)'       Field levels ',fldlevels
      endif

      write(*,*)' '
      write(3,*)' '
c Test Case -- ptflinkinfo
c
      write(3,27)
      write(*,*)'Testing ptflinkinfo '
      write(*,*)'================='
      write(3,*)'Testing ptflinkinfo '
      write(3,*)'================='

      status = ptflinkinfo(ptid, 0, linkfield)
      if (status .lt. zero) then
         write(*,*)'********** Error unexpected **********'
         write(3,*)'********** Error unexpected **********'
         call heprnt(0)
      else
         write(*,*)'       status = ptflinkinfo(ptid, 0, linkfield)'
         write(*,*)'       Status returned by ptflinkinfo ', status
         write(*,57) linkfield
         write(3,*)'       status = ptflinkinfo(ptid, 0, linkfield)'
         write(3,*)'       Status returned by ptflinkinfo ', status
         write(3,57) linkfield
      endif
  57  format('        The link field to the following level is ',a8)

      write(*,*)' '
      write(3,*)' '
c Test Case -- ptblinkinfo
c
      write(3,27)
      write(*,*)'Testing ptblinkinfo '
      write(*,*)'================='
      write(3,*)'Testing ptblinkinfo '
      write(3,*)'================='

      status = ptblinkinfo(ptid, 1, linkfield)
      if (status .lt. zero) then
         write(*,*)'********** Error unexpected **********'
         write(3,*)'********** Error unexpected **********'
         call heprnt(0)
      else
         write(*,*)'       status = ptblinkinfo(ptid, 1, linkfield)'
         write(*,*)'       Status returned by ptblinkinfo ', status
         write(*,58) linkfield
         write(3,*)'       status = ptblinkinfo(ptid, 1, linkfield)'
         write(3,*)'       Status returned by ptblinkinfo ', status
         write(3,58) linkfield
      endif
   58 format('        The link field to the previous level ',a8)

      write(*,*)' '
      write(3,*)' '
c Test Case -- ptnlevs
c
      write(3,27)
      write(*,*)'Testing ptnlevs '
      write(*,*)'================='
      write(3,*)'Testing ptnlevs '
      write(3,*)'================='

      nlevels = ptnlevs(ptid)
      if (nlevels .lt. zero) then
         write(*,*)'********** Error unexpected **********'
         write(3,*)'********** Error unexpected **********'
         call heprnt(0)
      else
         write(*,*)'       nlevels = ptnlevs(ptid)'
         write(*,*)'       Number of levels ',nlevels
         write(3,*)'       nlevels = ptnlevs(ptid)'
         write(3,*)'       Number of levels ',nlevels
      endif

      write(*,*)' '
      write(3,*)' '
c Test Case -- ptnflds
c
      write(3,27)
      write(*,*)'Testing ptnflds '
      write(*,*)'================='
      write(3,*)'Testing ptnflds '
      write(3,*)'================='

      nflds = ptnflds(ptid,1, strbufsize)
      if (nflds .lt. zero) then
         write(*,*)'********** Error unexpected **********'
         write(3,*)'********** Error unexpected **********'
         call heprnt(0)
      else
         write(*,*)'       nflds = ptnflds(ptid,1, strbufsize)'
         write(*,*)'       Number of fields ',nflds
         write(*,*)'       Size in bytes of field list ',strbufsize
         write(3,*)'       nflds = ptnflds(ptid,1, strbufsize)'
         write(3,*)'       Number of fields ',nflds
         write(3,*)'       Size in bytes of field list ',strbufsize
       endif
  
      n = 2
      recs(1) = 0
      recs(2) = 2
 
      write(*,*)' '
      write(3,*)' '
c Test Case -- ptrdlev
c
      write(3,27)
      write(*,*)'Testing ptrdlev '
      write(*,*)'================='
      write(3,*)'Testing ptrdlev '
      write(3,*)'================='

      pntr = 1
      status = ptrdlev(ptid, 0, fldlist, n, recs, buffer)
      if (status .lt. zero) then
         write(*,*)'********** Error unexpected **********'
         write(3,*)'********** Error unexpected **********'
         call heprnt(0)
      else
         write(*,*)'     status = ptrdlev(ptid, 0, fldlist,                    &
     1n, recs, buffer)'
         write(*,*)'     Status returned by ptrdlev ',status
         write(3,*)'     status = ptrdlev(ptid, 0, fldlist,                    &
     1n, recs, buffer)'
         write(3,*)'     Status returned by ptrdlev ',status
      endif
 
      do 21 i=1,n
           desc = buffer(pntr:pntr+8)
           pntr = pntr + 8
           clon = buffer(pntr:pntr+8)
           pntr = pntr + 8
           clat = buffer(pntr:pntr+8)
           pntr = pntr + 8
           cdate = buffer(pntr:pntr+4)
           pntr = pntr + 4
           id = buffer(pntr:pntr+1)
           pntr = pntr + 1
           write(*,*) desc, lon, lat, date, id(1:1)
           write(3,*) desc, lon, lat, date, id(1:1)
 21   continue

      status = ptlevinfo(ptid, 1, fldlist, fldtype, fldorder)
      if (status .lt. zero) then
         write(*,*)'********** Error unexpected **********'
         write(3,*)'********** Error unexpected **********'
         call heprnt(0)
      else
         write(*,*)'      status = ptlevinfo(ptid, 1, fldlist,                 &
     1fldtype, fldorder)'
         write(*,*)'      Status returned by ptlevinfo ',status
         write(3,*)'      status = ptlevinfo(ptid, 1, fldlist,                 &
     1fldtype, fldorder)'
         write(3,*)'      Status returned by ptlevinfo ',status
      endif

      n = ptnrecs(ptid, 1)
      if (n .lt. zero) then
         write(*,*)'********** Error unexpected **********'
         write(3,*)'********** Error unexpected **********'
         call heprnt(0)
      else
         write(*,*)'      n = ptnrecs(ptid, 1)'
         write(*,*)'      Number of records ',n
         write(3,*)'      n = ptnrecs(ptid, 1)'
         write(3,*)'      Number of records ',n
      endif
 
 
      do 31 i=1,n
 
           recs(1) = i - 1
           status = ptrdlev(ptid, 1, fldlist, 1, recs, buffer)
           if (status .lt. zero) then
              write(*,*)'********** Error unexpected **********'
              write(3,*)'********** Error unexpected **********'
              call heprnt(0)
           else
           endif
 
           pntr = 1
 
           ctime = buffer(pntr:pntr+8)
           pntr = pntr + 8
           crain = buffer(pntr:pntr+4)
           pntr = pntr + 4
           ctemp = buffer(pntr:pntr+4)
           pntr = pntr + 4
           id = buffer(pntr:pntr+1)
           pntr = pntr + 1
           write(*,*) time, rain, temp, '  ', id(1:1)
           write(3,*) time, rain, temp, '  ', id(1:1)
 31   continue

      write(*,*)' '
      write(3,*)' '
c Test Case -- ptinqattrs
c
      write(3,27)
      write(*,*)'Testing ptinqattrs '
      write(*,*)'================='
      write(3,*)'Testing ptinqattrs '
      write(3,*)'================='

      nmattrs = ptinqattrs(ptid, attrlist,strbufsize)
      if (nmattrs .lt. zero) then
         write(*,*)'********** Error unexpected **********'
         write(3,*)'********** Error unexpected **********'
         call heprnt(0)
      else
         write(*,*)'   nmattrs = ptinqattrs(ptid, attrlist,strbufsize)'
         write(*,*)'   Number of attributes ',nmattrs
         write(*,*)'   Attribute list ',attrlist
         write(3,*)'   nmattrs = ptinqattrs(ptid, attrlist,strbufsize)'
         write(3,*)'   Number of attributes ',nmattrs
         write(3,*)'   Attribute list ',attrlist
      endif

c Test Case -- ptrdattr
c
      write(3,27)
      write(*,*)'Testing ptrdattr '
      write(*,*)'================='
      write(3,*)'Testing ptrdattr '
      write(3,*)'================='

      status = ptrdattr(ptid, "float32", b32)
      if (status .lt. zero) then
         write(*,*)'********** Error unexpected **********'
         write(3,*)'********** Error unexpected **********'
         call heprnt(0)
      else
         write(*,*)'      status = ptrdattr(ptid, "float32", b32)'
         write(*,*)'      Status returned by ptrdattr ',status
         write(*,*) 'b32 = ', b32
         write(3,*)'      status = ptrdattr(ptid, "float32", b32)'
         write(3,*)'      Status returned by ptrdattr ',status
         write(3,*) 'b32 = ', b32
      endif

c Test Case -- ptattrinfo
c
      write(3,27)
      write(*,*)'Testing ptattrinfo '
      write(*,*)'================='
      write(3,*)'Testing ptattrinfo '
      write(3,*)'================='

      status = ptattrinfo(ptid, "float32", nt, sz)
      if (status .lt. zero) then
         write(*,*)'********** Error unexpected **********'
         write(3,*)'********** Error unexpected **********'
         call heprnt(0)
      else
         write(*,*)'      status = ptattrinfo(ptid, "float32", nt, sz)'
         write(*,*)'      Status returned by ptattrinfo ',status
         write(*,*) 'nt = ', nt
         write(*,*) 'sz = ', sz
         write(3,*)'      status = ptattrinfo(ptid, "float32", nt, sz)'
         write(3,*)'      Status returned by ptattrinfo ',status
         write(3,*) 'nt = ', nt
         write(3,*) 'sz = ', sz
      endif
 
      status = ptdetach(ptid)
      if (status .lt. zero) then
         write(*,*)'********** Error unexpected **********'
         write(3,*)'********** Error unexpected **********'
         call heprnt(0)
      else
         write(*,*)'       status = ptdetach(ptid)'
         write(*,*)'       Status returned by ptdetach ',status
         write(3,*)'       status = ptdetach(ptid)'
         write(3,*)'       Status returned by ptdetach ',status
      endif

      status = ptclose(ptfid)
      if (status .lt. zero) then
         write(*,*)'********** Error unexpected **********'
         write(3,*)'********** Error unexpected **********'
         call heprnt(0)
      else
         write(*,*)'       status = ptclose(ptfid)'
         write(*,*)'       Status returned by ptclose ',status
         write(3,*)'       status = ptclose(ptfid)'
         write(3,*)'       Status returned by ptclose ',status
      endif


      ptfid = ptopen("Pointf_Test.hdf", DFACC_RDWR)
      if (ptfid .lt. zero) then
         write(*,*)'********** Error unexpected **********'
         write(3,*)'********** Error unexpected **********'
         call heprnt(0)
      else
         write(*,*)'     ptfid = ptopen("Pointf_Test.hdf", DFACC_RDWR)'
         write(*,*)'     Point id returned by ptopen ',ptfid
         write(3,*)'     ptfid = ptopen("Pointf_Test.hdf", DFACC_RDWR)'
         write(3,*)'     Point id returned by ptopen ',ptfid
      endif

      ptid1 = ptattach(ptfid, "Simple Point")
      if (ptid1 .lt. zero) then
         write(*,*)'********** Error unexpected **********'
         write(3,*)'********** Error unexpected **********'
         call heprnt(0)
      else
         write(*,*)'      ptid1 = ptattach(ptfid, "Simple Point")'
         write(*,*)'      Point id returned by ptattach ',ptid1
         write(3,*)'      ptid1 = ptattach(ptfid, "Simple Point")'
         write(3,*)'      Point id returned by ptattach ',ptid1
      endif

      ptid2 = ptattach(ptfid, "FixedBuoy Point")
      if (ptid2 .lt. zero) then
         write(*,*)'********** Error unexpected **********'
         write(3,*)'********** Error unexpected **********'
         call heprnt(0)
      else
         write(*,*)'      ptid2 = ptattach(ptfid, "FixedBuoy Point")'
         write(*,*)'      Point id returned by ptattach ',ptid2
         write(3,*)'      ptid2 = ptattach(ptfid, "FixedBuoy Point")'
         write(3,*)'      Point id returned by ptattach ',ptid2
      endif

      f64 = 43.2
      datbuf(1:8) = c8
      recs(1) = 1

c Test Case -- ptuplev
c
      write(3,27)
      write(*,*)'Testing ptuplev '
      write(*,*)'================='
      write(3,*)'Testing ptuplev '
      write(3,*)'================='

      status = ptuplev(ptid2, 0, "Longitude", 1, recs, datbuf)
      if (status .lt. zero) then
         write(*,*)'********** Error unexpected **********'
         write(3,*)'********** Error unexpected **********'
         call heprnt(0)
      else
         write(*,*)'      status = ptuplev(ptid2, 0, "Longitude",              &
     11, recs, datbuf)'
         write(*,*)'      Status returned by ptuplev ',status
         write(3,*)'      status = ptuplev(ptid2, 0, "Longitude",              &
     11, recs, datbuf)'
         write(3,*)'      Status returned by ptuplev ',status
      endif

      datbuf(1:1) = 'F'
      recs(1) = 0
      status = ptuplev(ptid2, 0, "ID", 1, recs, datbuf)
      if (status .lt. zero) then
         write(*,*)'********** Error unexpected **********'
         write(3,*)'********** Error unexpected **********'
         call heprnt(0)
      else
         write(*,*)'     status = ptuplev(ptid2, 0, "ID", 1,                   &
     1recs, datbuf)'
         write(*,*)'     Status returned by ptuplev ',status
         write(3,*)'     status = ptuplev(ptid2, 0, "ID", 1,                   &
     1recs, datbuf)'
         write(3,*)'     Status returned by ptuplev ',status
      endif

c Test Case -- ptgetrecnums
c
      write(3,27)
      write(*,*)'Testing ptgetrecnums '
      write(*,*)'================='
      write(3,*)'Testing ptgetrecnums '
      write(3,*)'================='

      inlevel = 0
      outlevel = 1
      nrec = 1
      status = ptgetrecnums(ptid2, inlevel, outlevel, nrec, recs, 
     1outnrec, outrecs)
      if (status .lt. zero) then
         write(*,*)'********** Error unexpected **********'
         write(3,*)'********** Error unexpected **********'
         call heprnt(0)
      else
         write(*,*)'      status = ptgetrecnums(ptid2, inlevel, outlevel       &
     1,nrec, recs,outnrec, outrecs)'
         write(*,*)'      Status returned by ptgetrecnums ',status
         write(*,59) outnrec
         write(3,*)'      status = ptgetrecnums(ptid2, inlevel, outlevel       &
     1,nrec, recs,outnrec, outrecs)'
         write(3,*)'      Status returned by ptgetrecnums ',status
         write(3,59) outnrec
   59 format('      Number of related records in next level ',I4)

         do 71 i=1,outnrec
            datbuf(i:i) = 'F'
 71      continue
      endif

      status = ptuplev(ptid2, outlevel, "ID", outnrec, outrecs, 
     1datbuf)
      if (status .lt. zero) then
         write(*,*)'********** Error unexpected **********'
         write(3,*)'********** Error unexpected **********'
         call heprnt(0)
      else
         write(*,*)'       status = ptuplev(ptid2, outlevel, "ID",             &
     1outnrec, outrecs,datbuf)'
         write(*,*)'       Status returned by ptuplev ',status
         write(3,*)'       status = ptuplev(ptid2, outlevel, "ID",             &
     1outnrec, outrecs,datbuf)'
         write(3,*)'       Status returned by ptuplev ',status
      endif

c Test Case -- ptgetlevname
c
      write(3,27)
      write(*,*)'Testing ptgetlevname '
      write(*,*)'================='
      write(3,*)'Testing ptgetlevname '
      write(3,*)'================='

      status=ptgetlevname(ptid2,0,levname,strbuf)
      if (status .lt. zero) then
        write(*,*)'**********Error unexpected******'
        write(3,*)'**********Error unexpected******'
        call heprnt(0)
      else
        write(*,*)'Get level name '
        write(*,*)'Level name ',levname
        write(*,*)'Size of level name ',strbuf
        write(3,*)'Get level name '
        write(3,*)'Level name ',levname
        write(3,*)'Size of level name ',strbuf
        write(*,*)' '
        write(3,*)' '
      endif

      status = ptdetach(ptid1)
      if (status .lt. zero) then
        write(*,*)'**********Error unexpected******'
        write(3,*)'**********Error unexpected******'
        call heprnt(0)
      else
         write(*,*)'      status = ptdetach(ptid1)'
         write(*,*)'      Status returned by ptdetach ',status
         write(3,*)'      status = ptdetach(ptid1)'
         write(3,*)'      Status returned by ptdetach ',status
      endif

      status = ptdetach(ptid2)
      if (status .lt. zero) then
        write(*,*)'**********Error unexpected******'
        write(3,*)'**********Error unexpected******'
        call heprnt(0)
      else
         write(*,*)'      status = ptdetach(ptid2)'
         write(*,*)'      Status returned by ptdetach ',status
         write(3,*)'      status = ptdetach(ptid2)'
         write(3,*)'      Status returned by ptdetach ',status
      endif


      status = ptclose(ptfid)
      if (status .lt. zero) then
        write(*,*)'**********Error unexpected******'
        write(3,*)'**********Error unexpected******'
        call heprnt(0)
      else
         write(*,*)'      status = ptclose(ptfid)'
         write(*,*)'      Status returned by ptclose ',status
         write(3,*)'      status = ptclose(ptfid)'
         write(3,*)'      Status returned by ptclose ',status
      endif


      ptfid = ptopen("Pointf_Test.hdf", DFACC_READ)
      if (ptfid .lt. zero) then
        write(*,*)'**********Error unexpected******'
        write(3,*)'**********Error unexpected******'
        call heprnt(0)
      else
         write(*,*)'    ptfid = ptopen("Pointf_Test.hdf", DFACC_READ)'
         write(*,*)'    Point id returned by ptopen ',ptfid
         write(3,*)'    ptfid = ptopen("Pointf_Test.hdf", DFACC_READ)'
         write(3,*)'    Point id returned by ptopen ',ptfid
      endif

c Test Case -- ptinqpoint
c
      write(3,27)
      write(*,*)'Testing ptinqpoint '
      write(*,*)'================='
      write(3,*)'Testing ptinqpoint '
      write(3,*)'================='

      npoint = ptinqpoint("Pointf_Test.hdf",ptlist,strbufsize2)
      if (npoint .lt. zero) then
        write(*,*)'**********Error unexpected******'
        write(3,*)'**********Error unexpected******'
        call heprnt(0)
      else
         write(*,*)'  Number of points in file ',npoint
         write(*,*)'  List of points in file ',ptlist
         write(3,*)'  Number of points in file ',npoint
         write(3,*)'  List of points in file ',ptlist
      endif

      ptid = ptattach(ptfid, "FloatBuoy Point")
      if (ptid .lt. zero) then
        write(*,*)'**********Error unexpected******'
        write(3,*)'**********Error unexpected******'
        call heprnt(0)
      else
         write(*,*)'     ptid = ptattach(ptfid, "FloatBuoy Point")'
         write(*,*)'     Point id returned by ptattach ',ptid
         write(3,*)'     ptid = ptattach(ptfid, "FloatBuoy Point")'
         write(3,*)'     Point id returned by ptattach ',ptid
      endif

c Test Case -- ptdefboxreg
c
      write(3,27)
      write(*,*)'Testing ptdefboxreg '
      write(*,*)'===================='
      write(3,*)'Testing ptdefboxreg '
      write(3,*)'===================='

      cornerlon(1) = -75.0d0
      cornerlat(1) = -25.0d0
      cornerlon(2) = 75.0d0
      cornerlat(2) = 25.0d0

      regionid = ptdefboxreg(ptid, cornerlon, cornerlat)
      if (regionid .lt. zero) then
        write(*,*)'**********Error unexpected******'
        write(3,*)'**********Error unexpected******'
        call heprnt(0)
      else
         write(*,*)'      regionid = ptdefboxreg(ptid,cornerlon, cornerlat     &
     1)'
         write(*,*)'      Region id returned by ptdefboxreg ',regionid
         write(3,*)'      regionid = ptdefboxreg(ptid,cornerlon, cornerlat     &
     1)'
         write(3,*)'      Region id returned by ptdefboxreg ',regionid
      endif

c Test Case -- ptregrecs
c
      write(3,27)
      write(*,*)'Testing ptregrecs '
      write(*,*)'================='
      write(3,*)'Testing ptregrecs '
      write(3,*)'================='

      status=ptregrecs(ptid,regionid,0,regrec,regrecs)
      if (status .lt. zero) then
         write(*,*)'*********Error unexpected********'
         write(3,*)'*********Error unexpected********'
         call heprnt(0)
      else
        write(*,*)'status=ptregrecs(ptid,regionid,0,regrec,regrecs)'
        write(*,*)'Status returned by call to ptregrecs ',status
        write(*,38) regrec
        write(3,*)'status=ptregrecs(ptid,regionid,0,regrec,regrecs)'
        write(3,*)'Status returned by call to ptregrecs ',status
        write(3,38) regrec
        do 26 i=1,regrec
           write(*,*)'Record number of subsetted records ',regrecs(i)
           write(3,*)'Record number of subsetted records ',regrecs(i)
   26   continue
      endif
        write(*,*)' '
        write(3,*)' '
   38 format('Number of records in region ',I4)

      status=ptregrecs(ptid,regionid,1,regrec,regrecs)
      if (status .lt. zero) then
         write(*,*)'*********Error unexpected********'
         write(3,*)'*********Error unexpected********'
         call heprnt(0)
      else
        write(*,*)'status=ptregrecs(ptid,regionid,1,regrec,regrecs)'
        write(*,*)'Status returned by call to ptregrecs ',status
        write(*,38) regrec
        write(3,*)'status=ptregrecs(ptid,regionid,1,regrec,regrecs)'
        write(3,*)'Status returned by call to ptregrecs ',status
        write(3,38) regrec
        do 28 i=1,regrec
           write(*,*)'Record number of subsetted records ',regrecs(i)
           write(3,*)'Record number of subsetted records ',regrecs(i)
   28   continue
      endif
        write(*,*)' '
        write(3,*)' '

c Test Case -- ptreginfo
c
      write(3,27)
      write(*,*)'Testing ptreginfo '
      write(*,*)'================='
      write(3,*)'Testing ptreginfo '
      write(3,*)'================='

      level = 1
      status = ptreginfo(ptid, regionid, level, "Longitude,Latitude",          &
     1size)
      if (status .lt. zero) then
         write(*,*)'*********Error unexpected********'
         write(3,*)'*********Error unexpected********'
         call heprnt(0)
      else
         write(*,*)'       status = ptreginfo(ptid, regionid, level,           &
     1"Longitude,Latitude", size)'
         write(*,*)'       Status returned by ptreginfo ',status
         write(3,*)'       status = ptreginfo(ptid, regionid, level,           &
     1"Longitude,Latitude", size)'
         write(3,*)'       Status returned by ptreginfo ',status
      endif

c Test Case -- ptextreg
c
      write(3,27)
      write(*,*)'Testing ptextreg '
      write(*,*)'================='
      write(3,*)'Testing ptextreg '
      write(3,*)'================='

      call heprnt(0)
      status = ptextreg(ptid, regionid, level, "Longitude,Latitude", d         &
     1tbuf)
      if (status .lt. zero) then
         write(*,*)'*********Error unexpected********'
         write(3,*)'*********Error unexpected********'
         call heprnt(0)
      else
         write(*,*)'    status = ptextreg(ptid, regionid, level,               &
     1"Longitude,Latitude", dtbuf)'
         write(*,*)'    Status returned by ptextreg ',status
         write(3,*)'    status = ptextreg(ptid, regionid, level,               &
     1"Longitude,Latitude", dtbuf)'
         write(3,*)'    Status returned by ptextreg ',status

         do 81 j = 1,size/16
            write(*,17) j, dtbuf(2*j-1),dtbuf(2*j)
            write(3,17) j, dtbuf(2*j-1),dtbuf(2*j)
 81      continue
   17    format(i2,3x,f14.5,3x,f14.5)
      endif
      

c Test Case -- ptdeftmeper
c
      write(3,27)
      write(*,*)'Testing ptdeftmeper '
      write(*,*)'================='
      write(3,*)'Testing ptdeftmeper '
      write(3,*)'================='

      starttime=35000000.0d0
      stoptime=36500000.0d0
      write(*,*)' Start time ',starttime,  '  Stop time ',stoptime
    
      periodid = ptdeftmeper(ptid, starttime, stoptime)
      write(*,*)' Start time ',starttime,  '  Stop time ',stoptime
      if (periodid .lt. zero) then
         write(*,*)'*********Error unexpected********'
         write(3,*)'*********Error unexpected********'
         call heprnt(0)
      else
         write(*,*)'    periodid = ptdeftmeper(ptid, starttime, stoptim        &
     1e)'
         write(*,*)'    Period id returned by ptdeftmeper ',periodid
         write(3,*)'    periodid = ptdeftmeper(ptid, starttime, stoptim        &
     1e)'
         write(3,*)'    Period id returned by ptdeftmeper ',periodid
      endif

c Test Case -- ptperrecs
c
      write(3,27)
      write(*,*)'Testing ptperrecs '
      write(*,*)'================='
      write(3,*)'Testing ptperrecs '
      write(3,*)'================='

      status=ptperrecs(ptid,periodid,0,regrec,regrecs)
      if (status .lt. zero) then
         write(*,*)'*********Error unexpected********'
         write(3,*)'*********Error unexpected********'
         call heprnt(0)
      else
        write(*,*)'status=ptperrecs(ptid,periodid,0,regrec,regrecs)'
        write(*,*)'Status returned by call to ptperrecs ',status
        write(*,*)'Number of records in period ',regrec
        write(3,*)'status=ptperrecs(ptid,periodid,0,regrec,regrecs)'
        write(3,*)'Status returned by call to ptperrecs ',status
        write(3,*)'Number of records in period ',regrec
        do 22 i=1,regrec
           write(*,*)'Record number of subsetted records ',regrecs(i)
           write(3,*)'Record number of subsetted records ',regrecs(i)
   22   continue
      endif

      status=ptperrecs(ptid,periodid,1,regrec,regrecs)
      if (status .lt. zero) then
         write(*,*)'*********Error unexpected********'
         write(3,*)'*********Error unexpected********'
         call heprnt(0)
      else
        write(*,*)'status=ptperrecs(ptid,periodid,1,regrec,regrecs)'
        write(*,*)'Status returned by call to ptperrecs ',status
        write(*,*)'Number of records in period ',regrec
        write(3,*)'status=ptperrecs(ptid,periodid,1,regrec,regrecs)'
        write(3,*)'Status returned by call to ptperrecs ',status
        write(3,*)'Number of records in period ',regrec
        do 23 i=1,regrec
           write(*,*)'Record number of subsetted records ',regrecs(i)
           write(3,*)'Record number of subsetted records ',regrecs(i)
   23   continue
      endif
        write(*,*)' '
        write(3,*)' '

c Test Case -- ptperinfo
c
      write(3,27)
      write(*,*)'Testing ptperinfo '
      write(*,*)'================='
      write(3,*)'Testing ptperinfo '
      write(3,*)'================='

      level = 1
      status = ptperinfo(ptid, periodid, level, "Time", size)
      if (status .lt. zero) then
         write(*,*)'*********Error unexpected********'
         write(3,*)'*********Error unexpected********'
         call heprnt(0)
      else
         write(*,*)'    status = ptperinfo(ptid, periodid, level,              &
     1"Time", size)'
         write(*,*)'    Status returned by ptperinfo ',status
         write(*,*)'    Size of region in bytes ',size
         write(3,*)'    status = ptperinfo(ptid, periodid, level,              &
     1"Time", size)'
         write(3,*)'    Status returned by ptperinfo ',status
         write(3,*)'    Size of region in bytes ',size
      endif

c Test Case -- ptextper
c
      write(3,27)
      write(*,*)'Testing ptextper '
      write(*,*)'================='
      write(3,*)'Testing ptextper '
      write(3,*)'================='

      status = ptextper(ptid, periodid, level, "Time", dtbuf)
      if (status .lt. zero) then
         write(*,*)'*********Error unexpected********'
         write(3,*)'*********Error unexpected********'
         call heprnt(0)
      else
         write(*,*)'    status = ptextper(ptid, periodid, level,               &
     1"Time", dtbuf)'
         write(*,*)'    Status returned by ptextper ',status
         write(3,*)'    status = ptextper(ptid, periodid, level,               &
     1"Time", dtbuf)'
         write(3,*)'    Status returned by ptextper ',status
     
         do 91 k=1,size/8
            write(*,42) k, dtbuf(k)
            write(3,42) k, dtbuf(k)
   91    continue
   42    format(i2,3x,f10.1)
      endif
     
c Test Case -- ptdefvrtreg
c
      write(3,27)
      write(*,*)'Testing ptdefvrtreg and NCRs 6598 & 8827'
      write(*,*)'========================================='
      write(3,*)'Testing ptdefvrtreg and NCRs 6598 & 8827'
      write(3,*)'========================================='

      range(1)=0.0d0
      range(2)=2.0d0
      regionid=ptdefvrtreg(ptid,HDFE_NOPREVSUB,"Rainfall",range)
      if (regionid .lt. zero) then
         write(*,*)'*********Error unexpected********'
         write(3,*)'*********Error unexpected********'
         call heprnt(0)
      else
         write(*,*)'      regionid=ptdefvrtreg(ptid,HDFE_NOPREVSUB,"Rai        &
     1nfall",range)'
         write(*,*)'      Region ID  returned by ptdefvrtreg ',regionid
         write(3,*)'      regionid=ptdefvrtreg(ptid,HDFE_NOPREVSUB,"Rai        &
     1nfall",range)'
         write(3,*)'      Region ID  returned by ptdefvrtreg ',regionid
      endif

      status=ptreginfo(ptid,regionid,1,"Rainfall",size)
      if (status .lt. zero) then
         write(*,*)'*********Error unexpected********'
         write(3,*)'*********Error unexpected********'
         call heprnt(0)
      else
         write(*,*)'      status=ptreginfo(ptid,regionid,1,"Rainfall",si       &
     1ze)'
         write(*,*)'      Status returned by ptreginfo ',status
         write(*,*)'    Size of region ',size
         write(3,*)'      status=ptreginfo(ptid,regionid,1,"Rainfall",si       &
     1ze)'
         write(3,*)'      Status returned by ptreginfo ',status
         write(3,*)'    Size of region ',size
      endif

      status=ptextreg(ptid,regionid,1,"Rainfall",dtbuff32)
      if (status .lt. zero) then
         write(*,*)'*********Error unexpected********'
         write(3,*)'*********Error unexpected********'
         call heprnt(0)
      else
         write(*,*)'      status=ptextreg(ptid,regionid,1,"Rainfall",dtb       &
     1uff32)'
         write(*,*)'      Status returned by ptreginfo ',status
         write(*,*)'      status=ptextreg(ptid,regionid,1,"Rainfall",dtb       &
     1uff32)'
         write(3,*)'      Status returned by ptreginfo ',status
         write(*,*)'  Data from region'
         write(3,*)'  Data from region'
         do 92 k=1,size/4
            write(*,43) k, dtbuff32(k)
            write(3,43) k, dtbuff32(k)
   92    continue
   43    format(i2,3x,f10.1)
      endif


      status = ptdetach(ptid)
      if (status .lt. zero) then
         write(*,*)'*********Error unexpected********'
         write(3,*)'*********Error unexpected********'
         call heprnt(0)
      else
         write(*,*)'      status = ptdetach(ptid)'
         write(*,*)'      Status returned by ptdetach ',status
         write(3,*)'      status = ptdetach(ptid)'
         write(3,*)'      Status returned by ptdetach ',status
      endif

      status = ptclose(ptfid)
      if (status .lt. zero) then
         write(*,*)'*********Error unexpected********'
         write(3,*)'*********Error unexpected********'
         call heprnt(0)
      else
         write(*,*)'      status = ptclose(ptfid)'
         write(*,*)'      Status returned by ptclose ',status
         write(3,*)'      status = ptclose(ptfid)'
         write(3,*)'      Status returned by ptclose ',status
      endif


      close(unit=3)
   27 format('')
      stop
      end

!/*
! * In this example we will (1) open the "GridFile" HDF file, (2) attach to
! * the "gdid" grid, and (3) set dimension scale for a dimension in a filed.
! */

	program readdimscalegrid
	
	integer       j, status, gddetach, gdclose
	integer*4     gdfid, gdid1, gdid2, gdopen, gdattach
	integer*4     gdgetdimscale, gdgetdimstrs
	real*8        veg1(120),veg2(200)
	real*8        temp1(100),temp2(100)
	integer*4     bands(3)
	integer*4     xdimsize, ydimsize,dimsize
	integer*4     xdimsize1, ydimsize1,dimsize1
	real*8        upleftpt(2), lowrightpt(2)
	integer*4     ntype(32)
	character*16  label, unit, format
	integer*4     len
	integer*4     nbands
	integer DFACC_RDWR
	parameter (DFACC_RDWR=3)
	integer DFNT_FLOAT32
	parameter (DFNT_FLOAT32=5)
	integer DFNT_FLOAT64
	parameter (DFNT_FLOAT64=6)
	integer DFNT_INT32
	parameter (DFNT_INT32=24)

!    /*
!     * We first open the HDF grid file, "GridFile.hdf".  Because this file
!     * already exist and we wish to write to it, we use the DFACC_RDWR access
!     * code in the open statement.  The gdopen routine returns the grid file
!     * id, gdfid, which is used to identify the file in subsequent routines.
!     */

	gdfid = gdopen("GridFile_created_with_hadeos_sample_file_write"//
     1"r_of_HDFEOS2_version_219_or_higher_release.hdf", DFACC_RDWR)

!    /*
!     * If the grid file cannot be found, gdopen will return -1 for the file
!     * handle (gdfid).  We there check that this is not the case before
!     * proceeding with the other routines.
!     * 
!     * The GDattach routine returns the handle to the existing grid "gdid",
!     * gdid.  If the grid is not found, gdattach returns -1 for the handle.
!     */	
	if (gdfid .ne. -1) then
	   
	   gdid1 = gdattach(gdfid, "UTMGrid")
	   
	   if (gdid1 .ne. -1) then
	      
	      status = gdgridinfo(gdid1, xdimsize, ydimsize,
     1	      upleftpt, lowrightpt)
	      
	      write(*,*) 'X dim size, Y dim size (PolarGrid): ', 
     1	      xdimsize, ydimsize
	      write(*,*) 'Up left pt (UTMGrid): ', 
     1	      upleftpt(1), upleftpt(2)
	      write(*,*) 'Low right pt (UTMGrid): ', 
     1	      lowrightpt(1), lowrightpt(2)
	      
	      buffsize = gdgetdimscale(gdid1, "Vegetation",
     1         "XDim", xdimsize1, ntype,veg1)
	      if (buffsize .eq. -1) then	   
		 write(*,*) 'Error:Cannot get Dim Scale for XDim',
     1                      ' in field Vegetation'
		 stop  
	      else
		 write(*,*) 'For Vegetation field XDim: xdimsize1 = ', 
     1                      xdimsize1
		 write(*,*) 'For Vegetation field XDim: buffsize = ', 
     1                      buffsize
	      endif
	      
	      write(*,*) 'First 10 elements for Vegetation field XDim',
     1                   ' dimension scale values:'
	      do j=1,10
		 write(*,*) 'j =',j,'         veg1 = ',veg1(j)
	      enddo
	      write(*,*) '  '
	      
	      buffsize = gdgetdimscale(gdid1, "Vegetation", "YDim",
     1                                  ydimsize1,ntype,veg2)
	      if (buffsize .eq. -1) then	   
		 write(*,*) 'Error:Cannot get Dim Scale for YDim',
     1                      ' in field Vegetation"'
		 stop  
	      else
		 write(*,*) 'For Vegetation field YDim: ydimsize1 = ', 
     1                      ydimsize1
		 write(*,*) 'For Vegetation field YDim: buffsize = ', 
     1                      buffsize
	      endif
	      
	      write(*,*) 'First 10 elements for Vegetation field YDim',
     1                   ' dimension scale values:'
	      do j=1,10
		 write(*,*) 'j =',j,'         veg2 = ',veg2(j)
	      enddo
	      write(*,*) '  '
	      label = ''
	      unit = ''
	      format = ''
	      len = 15
	      status = gdgetdimstrs(gdid1, "Vegetation", "YDim", 
     1	      label, unit, format, len)
	      
	      
	      if(status .eq. 0) then	  
		 write(*,*) 'For Vegetation field YDim',
     1                      ' dimension scale attr. strings:'
		 write(*,*) 'label =',label,'  unit =',
     1                      unit,'  format = ',format
	      endif
	      write(*,*) ' '
	      status = gddetach(gdid1)
	   endif

	   gdid2 = gdattach(gdfid, "PolarGrid")
	   if (gdid2 .ne. -1) then
	      
!	/* we should get
!       ydim = 100	
!       nbands = 3;	
!	*/		
!        /* get YDim */	
	   
	      status = gdgridinfo(gdid2, xdimsize, ydimsize,
     1	      upleftpt, lowrightpt)
	      
	      write(*,*) 'X dim size, Y dim size (PolarGrid): ', 
     1	      xdimsize, ydimsize
	      write(*,*) 'Up left pt (PolarGrid): ', 
     1	      upleftpt(1), upleftpt(2)
	      write(*,*) 'Low right pt (PolarGrid): ', 
     1	      lowrightpt(1), lowrightpt(2)
	      
	      buffsize = gdgetdimscale(gdid2, "Spectra", "YDim",
     1	                               ydimsize1,ntype, temp2)
	      if (buffsize .eq. -1) then	   
		 write(*,*) 'Error:Cannot get Dim Scale for YDim',
     1                      ' in field Spectra'
		 stop  
	      else
		 write(*,*) 'For Spectra field YDim: ydimsize1 = ', 
     1                      ydimsize1
		 write(*,*) 'For Spectra field YDim: buffsize = ', 
     1                       buffsize
	      endif
	      
	      write(*,*) 'First 10 elements for Spectra field YDim',
     1                   ' dimension scale values:'
	      do j=1,10
		 write(*,*) 'j =',j,'         temp2 = ',temp2(j)
	      enddo
	      write(*,*) '  '
	      
!	/* get str attributes */
	      len = 15
	      status = gdgetdimstrs(gdid2, "Spectra", "YDim", 
     1	      label, unit, format, len)
	      
	      
	      if(status .eq. 0) then	  
		 write(*,*) 'For Spectra field YDim',
     1                      ' dimension scale attr. strings:'
		 write(*,*) 'label =',label,'  unit =',
     1                      unit,'  format = ',format
	      endif
	      write(*,*) ' '
	      
	      dimsize = gddiminfo(gdid2, "Bands");
	      status = gdgetdimscale(gdid2, "Spectra", "Bands", 
     1                               nbands,ntype, bands)
	      write(*,*) 'For Spectra field Bands: nbands = ', 
     1	                  nbands
	      write(*,*) 'For Spectra field Bands',
     1	                 'dimension scale values:'

	      do j=1,nbands
		 write(*,*) 'j =',j,'         Bnads = ',bands(j)
	      enddo
	      write(*,*) '  '
	      
	      status = gdgetdimstrs(gdid2, "Spectra", "Bands", 
     1	      label, unit, format, len)
	      
	      if(status .eq. 0) then
		 write(*,*) 'For Spectra field Bands',
     1                      ' dimension scale attr. strings:'
		 write(*,*) 'label =',label,'  unit =',
     1                      unit,'  format = ',format
	      endif
	      
	      status = gddetach(gdid2)
	   endif
	   status = gdclose(gdfid)
	endif
	stop
	end

!/*
! * In this example we will (1) open the "GridFile" HDF file, (2) attach to
! * the "gdid" grid, and (3) set dimension scale for a dimension in a filed.
! */

	program writedimscalegrid

	integer       j, status, gddetach, gdclose
	integer*4     gdfid, gdid, gdopen, gdattach
	integer*4     gdsetdimscale, gdsetdimstrs
	real*8        veg1(120),veg2(200)
	real*8        temp1(100),temp2(100)
	integer*4     bands(3)
	integer*4     xdim,ydim,nbands

	integer DFACC_RDWR
	parameter (DFACC_RDWR=3)
	integer DFNT_FLOAT32
	parameter (DFNT_FLOAT32=5)
	integer DFNT_FLOAT64
	parameter (DFNT_FLOAT64=6)
	integer DFNT_INT32
	parameter (DFNT_INT32=24)

!    /*
!     * We first open the HDF grid file, "GridFile.hdf".  Because this file
!     * already exist and we wish to write to it, we use the DFACC_RDWR access
!     * code in the open statement.  The gdopen routine returns the grid file
!     * id, gdfid, which is used to identify the file in subsequent routines.
!     */

	gdfid = gdopen("GridFile_created_with_hadeos_sample_file_writer_
     1of_HDFEOS2_version_219_or_higher_release.hdf", DFACC_RDWR)

!    /*
!     * If the grid file cannot be found, gdopen will return -1 for the file
!     * handle (gdfid).  We there check that this is not the case before
!     * proceeding with the other routines.
!     * 
!     * The gdattach routine returns the handle to the existing grid "gdid",
!     * gdid.  If the grid is not found, gdattach returns -1 for the handle.
!     */
	
	if (gdfid .ne. -1) then
	   
	   gdid = gdattach(gdfid, "UTMGrid")
	   
	   if (gdid .ne. -1) then
	      
              xdim = 120;
              ydim = 200;
	      
              status = gdsetdimscale(gdid, "Vegetation", "XDim", xdim,
     1	      DFNT_FLOAT64, veg1)
	      write(*,*) 'status: gdsetdimscale Vegetation:XDim',status
              status = gdsetdimscale(gdid, "Vegetation", "YDim", ydim,
     1	      DFNT_FLOAT64, veg2)
	      write(*,*) 'status: gdsetdimscale Vegetation:YDim',status

!	label, = 'X Dimension'
!	unit, = 'meters'
!	format, = 'F7.2'

              status = gdsetdimstrs(gdid, "Vegetation", "YDim", 
     1	      "Y Dimension", "meters", "F7.2")

	   endif

	   status = gddetach(gdid)

	   gdid = gdattach(gdfid, "PolarGrid")
	   if (gdid .ne. -1) then
	      
	      xdim = 100
	      ydim = 100
	      
	      status = gdsetdimscale(gdid, "Temperature", "XDim", xdim,
     1	      DFNT_FLOAT64, temp1)
	      write(*,*) 'status: gdsetdimscale Temperature:XDim',status
	      write(*,*) 'this -1 was expected for Temperature:XDim'
	      status = gdsetdimscale(gdid, "Temperature", "YDim", ydim,
     1	      DFNT_FLOAT64, temp2)
	      write(*,*) 'status: gdsetdimscale Temperature:YDim',status
	      write(*,*) 'this -1 was expected for Temperature:YDim'
	      nbands = 3;
	      do j=1,nbands
		 bands(j) = j*2+1
	      enddo
	      status = gdsetdimscale(gdid, "Spectra", "YDim", ydim, 
     1	      DFNT_FLOAT64, temp2)
	      write(*,*) 'status: gdsetdimscale Spectra:YDim',status

 	      status = gdsetdimscale(gdid, "Spectra", "Bands", nbands,
     1	      DFNT_INT32, bands);
	      write(*,*) 'status: gdsetdimscale Spectra:Bands',status
	      
	      status = gdsetdimstrs(gdid, "Spectra", "YDim", "YDim Dim",
     1	      "meters", "F7.2")
	      
	      status = gdsetdimstrs(gdid, "Spectra", "Bands", "BANDS",
     1	      "None", "I2")
	      
	      status = gddetach(gdid)
	   endif
	   
	   status = gdclose(gdfid)
	endif
	stop
	end

!/*
! * In this example we will (1) open the "SwathFile" HDF file, (2) attach to
! * the "swid" swath, and (3) set dimension scale for a dimension in a filed.
! */

	program readdimscaleswath
	
	integer       j, status, swdetach, swclose
	integer*4     swfid, swid, swopen, swattach
	integer*4     swdiminfo
	integer*4     swgetdimscale, swgetdimstrs
	real*8        BuffGeoTrack(20)
	integer*4     dimsize
	integer*4     dimsize1
 	integer*4     nbands
	integer*4     bands(15)
	integer*4     ntype(32)
	character*16  label, unit, format
	integer*4     len
	integer DFACC_RDWR
	parameter (DFACC_RDWR=3)
	integer DFNT_FLOAT32
	parameter (DFNT_FLOAT32=5)
	integer DFNT_FLOAT64
	parameter (DFNT_FLOAT64=6)
	integer DFNT_INT32
	parameter (DFNT_INT32=24)

!    /*
!     * We first open the HDF swath file, "SwathFile.hdf".  Because this file
!     * already exist and we wish to write to it, we use the DFACC_RDWR access
!     * code in the open statement.  The swopen routine returns the swath file
!     * id, swfid, which is used to identify the file in subsequent routines.
!     */

	swfid = swopen("SwathFile_created_with_hadeos_sample_file_writer
     1_of_HDFEOS2_version_219_or_higher_release.hdf", DFACC_RDWR)

!    /*
!     * If the swath file cannot be found, swopen will return -1 for the file
!     * handle (swfid).  We there check that this is not the case before
!     * proceeding with the other routines.
!     * 
!     * The swattach routine returns the handle to the existing swath "swid",
!     * swid.  If the swath is not found, swattach returns -1 for the handle.
!     */

	if (swfid .ne. -1) then
	   
	   swid = swattach(swfid, "Swath1")
	   
	   if (swid .ne. -1) then
	      
	      dimsize = swdiminfo(swid, "GeoTrack")
	      
	      write(*,*) 'GeoTrack dim size (Swath1): ', dimsize
	      
	      buffsize = swgetdimscale(swid, "Temperature", "GeoTrack", 
     1	   dimsize1, ntype,BuffGeoTrack)
	      if (buffsize .eq. -1) then	   
		 write(*,*) 'Error:Cannot get Dim Scale for',
     1	      ' GeoTrack in field Density'
		 stop  
	      else
		 write(*,*) 'For Density field GeoTrack: buffsize = ',
     1	      buffsize
	      write(*,*) 'GeoTrack dimsize1 (Swath1): ', dimsize1
	      endif
	      
	      write(*,*) 'For Density field GeoTrack',
     1                   ' dimension scale values:'
	      do j=1,dimsize
		 write(*,*) 'j =',j,'  BuffGeoTrack = ',BuffGeoTrack(j)
	      enddo
	      write(*,*) '  '
	      
	      len = 15
	      
	      status = swgetdimstrs(swid, "Temperature", "GeoTrack", 
     1	   label, unit, format, len)
	      
	      
	      if(status .eq. 0) then	  
	       write(*,*) 'For Density field GeoTrack dimension scale',
     1                      ' attr. strings:'
	       write(*,*) 'label =',label,
     1	      '  unit =',unit,'  format = ',format
	      endif
	      write(*,*) ' '
	      
				!         nbands = 15
	      
	      dimsize = swdiminfo(swid, "Bands");
	      status = swgetdimscale(swid, "Spectra", "Bands", 
     1	   nbands, ntype, bands)
	      write(*,*) 'For nbands for Spectra field = ',nbands
	      write(*,*) 'For Spectra field Bands dim scale values:'
	      do j=1,nbands
		 write(*,*) 'j =',j,'         Bnads = ',bands(j)
	      enddo
	      write(*,*) '  '
	      
	      status = swgetdimstrs(swid, "Spectra", "Bands", 
     1	   label, unit, format, len)
	      
	      if(status .eq. 0) then
		 write(*,*) 'For Spectra field Bands dim scale',
     1		 ' attr. strings:'
		 write(*,*) 'label =',label,'  unit =',
     1	      unit,'  format = ',format
	      endif
	      status = swdetach(swid)
	   endif
	   status = swclose(swfid)
	endif 
	stop
	end
	

c
c	In this example we will (1) open the "PointFile" HDF file,
c	(2) attach to the three point structures, and (3) define
c	the fields within each point.
c
	program definelevels

	integer         status
	integer*4       ptfid, ptid
	integer*4       fieldtype(8), fieldorder(8)
	character*255   fldlist

	integer*4       ptopen, ptattach
	integer         ptdeflev, ptdeflink, ptdetach, ptclose
	
	integer  DFACC_RDWR
	parameter (DFACC_RDWR=3)

	integer  DFNT_CHAR8, DFNT_INT16, DFNT_INT32
	parameter (DFNT_CHAR8=4)
	parameter (DFNT_INT16=22)
	parameter (DFNT_INT32=24)
	
	integer  DFNT_FLOAT32, DFNT_FLOAT64
	parameter (DFNT_FLOAT32=5)
	parameter (DFNT_FLOAT64=6)
	
c
c	We first open the HDF point file, "PointFile.hdf".  Because this
c	file already exist and we wish to write to it, we use the
c	DFACC_RDWR access code in the open statement.  The ptopen
c	routine returns the point fileid, ptfid, which is used to
c	identify the file in subsequent routines.

	ptfid = ptopen("PointFile_created_with_hadeos_sample_file_writer
     1_of_HDFEOS2_version_219_or_higher_release.hdf", DFACC_RDWR)


c
c	We next attach to the three point structures within the file
c       using the ptattach routine, identifying each point by its
c       name defined by the ptcreate routine previously.
c

	if (ptfid .ne. -1) then
	   
c
c      Define "Simple" point
c
	   
	   ptid = ptattach(ptfid, "Simple Point")
	   fldlist = "Time,Concentration,Species"


	   fieldtype(1) = DFNT_FLOAT64
	   fieldtype(2) = DFNT_FLOAT32
	   fieldtype(3) = DFNT_CHAR8
	   
	   fieldorder(1) = 1
	   fieldorder(2) = 4
	   fieldorder(3) = 4
	
	   status = ptdeflev(ptid, "Sensor", fldlist, fieldtype,
     1                       fieldorder)
	
	   status = ptdetach(ptid)
	   goto 5000
c
c      Define Fixed Buoy Point 
c	      

	   ptid = ptattach(ptfid, "FixedBuoy Point")


c     Define Description/Location Level

	   fldlist = "Label,Longitude,Latitude,DeployDate,ID"
	
	   fieldtype(1) = DFNT_CHAR8
	   fieldtype(2) = DFNT_FLOAT64
	   fieldtype(3) = DFNT_FLOAT64
	   fieldtype(4) = DFNT_INT32
	   fieldtype(5) = DFNT_CHAR8
	   
c   Note: order = 0 same as order = 1 for numeric scalars

	   fieldorder(1) = 8
	   fieldorder(2) = 0
	   fieldorder(3) = 0
	   fieldorder(4) = 0
	   fieldorder(5) = 1

	   status = ptdeflev(ptid, "Desc-Loc", fldlist, fieldtype, 
     1                       fieldorder)


c     Define Data Level

	   fldlist = "Time,Rainfall,Temperature,ID"
	
	   fieldtype(1) = DFNT_FLOAT64
	   fieldtype(2) = DFNT_FLOAT32
	   fieldtype(3) = DFNT_FLOAT32
	   fieldtype(4) = DFNT_CHAR8
	   
	   fieldorder(1) = 0
	   fieldorder(2) = 0
	   fieldorder(3) = 0
	   fieldorder(4) = 1

	   status = ptdeflev(ptid, "Observations", fldlist, 
     1			     fieldtype, fieldorder)

	   status = ptdeflink(ptid, "Desc-Loc", "Observations", "ID")

	   status = ptdetach(ptid)



c
c
c	Floating Buoy Point
c
	   ptid = ptattach(ptfid, "FloatBuoy Point")


c      Define Description Level */

	   fldlist = "Label,DeployDate,Weight,ID"
	
	   fieldtype(1) = DFNT_CHAR8
	   fieldtype(2) = DFNT_INT32
	   fieldtype(3) = DFNT_INT16
	   fieldtype(4) = DFNT_CHAR8
	   
	   fieldorder(1) = 8
	   fieldorder(2) = 0
	   fieldorder(3) = 0
	   fieldorder(4) = 1


	   status = ptdeflev(ptid, "Description", fldlist, 
     1                       fieldtype, fieldorder)


c	Define Data Level

	   fldlist = "Time,Longitude,Latitude,Rainfall,Temperature,ID"

	   fieldtype(1) = DFNT_FLOAT64
	   fieldtype(2) = DFNT_FLOAT64
	   fieldtype(3) = DFNT_FLOAT64
	   fieldtype(4) = DFNT_FLOAT32
	   fieldtype(5) = DFNT_FLOAT32
	   fieldtype(6) = DFNT_CHAR8
	   
	   fieldorder(1) = 0
	   fieldorder(2) = 0
	   fieldorder(3) = 0
	   fieldorder(4) = 0
	   fieldorder(5) = 0
	   fieldorder(6) = 1	

	   status = ptdeflev(ptid, "Measurements", fldlist, 
     1                       fieldtype, fieldorder)

	   status = ptdeflink(ptid, "Description", "Measurements", "ID")

	   status = ptdetach(ptid)
	
 5000	   continue
c
c      Close HDF file
c	
	   status = ptclose(swfid)

	   write(*,*) 'status close ', status
	endif
		   
	stop
	end

	program writegdflds

	integer       i, j, status, gdwrfld, gdwrattr, gddetach, gdclose
	integer*4     gdfid, gdid, gdopen, gdattach
	integer*4     start(2), stride(2), count(2)
	real*4        f32, veg(120,200), temp(100,100)
	integer DFACC_RDWR
	parameter (DFACC_RDWR=3)
	integer DFNT_FLOAT32
	parameter (DFNT_FLOAT32=5)


	do i=1,200
	   do j=1,120
	      veg(j,i) = 10 + i
	   enddo
	enddo
	
	do i=1,100
	   do j=1,100
	      temp(j,i) = 100*(i-1) + j
	   enddo
	enddo


	gdfid = gdopen("GridFile_created_with_hadeos_sample_file_writer_
     1of_HDFEOS2_version_219_or_higher_release.hdf", DFACC_RDWR)

	if (gdfid .ne. -1) then

	   gdid = gdattach(gdfid, "UTMGrid")

	   if (gdid .ne. -1) then
	
	      start(1) = 0
	      start(2) = 0
	      stride(1) = 1
	      stride(2) = 1
	      count(1) = 120
	      count(2) = 200
	      status = gdwrfld(gdid, "Vegetation", 
     1                  	   start, stride, count, veg)
	      
	      f32 = 1
	      status = gdwrattr(gdid, "float32", DFNT_FLOAT32, 1, f32)
	   endif
	endif

	status = gddetach(gdid)

	gdid = gdattach(gdfid, "PolarGrid")
	if (gdid .ne. -1) then
	   start(1) = 0
	   start(2) = 0
	   stride(1) = 1
	   stride(2) = 1
	   count(1) = 100
	   count(2) = 100
	   status = gdwrfld(gdid, "Temperature", 
     1	                    start, stride, count, temp)

	endif
	status = gddetach(gdid)
	
	status = gdclose(gdfid)

	stop
	end

c
c  In this example we will (1) open the "SwathFile" HDF file, (2) attach to
c  the "Swath1" swath, and (3) write data to the "Longitude", 
c  "Longitude" and "Spectra" fields.
c 


	program writefields

	integer            status, swwrfld, swwrattr, swdetach, swclose
	integer            track, start(3),stride(3),count(3)
	integer*4          swfid, SWid, swopen, swattach, attr(4)

	real*4         lng(10), lat(10)
	real*8         plane(800), tme(20)
	
	integer DFACC_RDWR
	parameter (DFACC_RDWR=3)
	integer DFNT_INT32
	parameter (DFNT_INT32=24)
	
c     Define longitude values along the cross track

	do i=1,10
	   lng(i) = i-1.0
	enddo
	

c    
c     Open the HDF swath file, "SwathFile.hdf"
c 

	swfid = swopen("SwathFile_created_with_hadeos_sample_file_writer
     1_of_HDFEOS2_version_219_or_higher_release.hdf", DFACC_RDWR)


	if (swfid .NE. -1) then

	   SWid = swattach(swfid, "Swath1")

	   if (swid .NE. -1) then


c     Write data starting at the beginning of each cross track

	      start(1) = 0
	      stride(1) = 1
	      stride(2) = 1
	      count(1) = 10
	      count(2) = 1

c
c      Loop through all the tracks, incrementing the track starting
c      position by one each time.
c

	      do track = 1,20
		 start(2) = track - 1
		 status = swwrfld(swid, "Longitude", start, stride,
     1                            count, lng)

		 do xtrack = 1,10
		    lat(xtrack) = track
		 enddo
		 
		 status = swwrfld(swid, "Latitude", start, stride,
     1                            count, lat)
		 
						  
	      enddo


	      do i = 1,20
 		 tme(i) = 34574087.3 + 84893.2*(i-1)
	      enddo

	      start(1) = 0
	      stride(1) = 1
	      count(1) = 20
	      status = swwrfld(swid, "Time", start, stride, count, tme)

c
c	     Write Spectra one plane at a time 
c	     Value is 100 * track index + band index (0-based)
c
	    start(1) = 0
	    start(2) = 0
	    count(1) = 20
	    count(2) = 40
	    count(3) = 1
	    stride(3) = 1
	    
	    do i=1,15
	       start(3) = i - 1
	       do j=1,40
		  do k=1,20
		     plane((j-1)*20+k) = (j-1)*100 + i-1
		  enddo
	       enddo
	       
	       status = swwrfld(swid, "Spectra", start, stride,
     1	                        count, plane)

	    enddo


c      Write User Attribute
	      attr(1) = 3
	      attr(2) = 5
	      attr(3) = 7
	      attr(4) = 11
	      status = swwrattr(swid, "TestAttr", DFNT_INT32, 4, attr)
	      
	   endif
	 endif

	 status =  swdetach(swid)
	 status = swclose(swfid)

	 stop
	 end

c
c  In this example we will (1) open the "PointFile" HDF file, (2) attach to
c  the points, and (3) read data from each level of the points.
c 
	program readlevels
	

	integer*4         ptfid, ptid, recs(32)
	integer*4         fldtype(32), fldorder(32)

        integer            status, i, pntr
	integer*2          wgt
	integer*4          n, date
	
	real*4             rain, temp, conc(4)
	real*8             lon, lat, time
				
	character         fldlist*256, buffer*100000, id*2
	character          spc*4, desc*8
        character          ctime*8, cconc*16, clon*8, clat*8
	character          cdate*4, crain*4, ctemp*4, cwgt*2
	equivalence        (time,ctime), (conc,cconc), (lon,clon)
	equivalence        (lat,clat), (rain,crain), (temp,ctemp)
	equivalence        (date,cdate), (wgt,cwgt)
			
	integer           ptrdlev
	integer           ptdetach, ptclose, ptlevinfo
	integer*4         ptopen, ptattach, ptnrecs
	
	
	integer DFACC_READ
	parameter (DFACC_READ=1)

	
c
c     Open the HDF swath file, "PointFile.hdf".
c

	ptfid = ptopen("PointFile_created_with_hadeos_sample_file_writer
     1_of_HDFEOS2_version_219_or_higher_release.hdf", DFACC_READ)

c
c    Read Simple Point
c
	ptid = ptattach(ptfid, "Simple Point")

	status = ptlevinfo(ptid, 0, fldlist, fldtype, fldorder)
	n = ptnrecs(ptid, 0)

	do 5 i=1,n
	   recs(i) = i - 1
 5	continue
	   
	status = ptrdlev(ptid, 0, fldlist, n, recs, buffer)
	pntr = 1

	do 10 i=1,n
	   ctime = buffer(pntr:pntr+8)
	   pntr = pntr + 8
	   cconc = buffer(pntr:pntr+4*4)
	   pntr = pntr + 4*4
	   spc = buffer(pntr:pntr+4)
	   pntr = pntr + 4
	   write(*,*) time, conc(1), conc(2), conc(3), conc(4), spc
10	continue
    
	status = ptdetach(ptid)
    

c
c    Read Fixed Buoy Point
c
	ptid = ptattach(ptfid, "FixedBuoy Point")

c
c       Read First (0th) Level
c
	status = ptlevinfo(ptid, 0, fldlist, fldtype, fldorder)

	n = 2
	recs(1) = 0
	recs(2) = 2
    
	pntr = 1
	status = ptrdlev(ptid, 0, fldlist, n, recs, buffer)

	do 20 i=1,n
	   desc = buffer(pntr:pntr+8)
	   pntr = pntr + 8
	   clon = buffer(pntr:pntr+8)
	   pntr = pntr + 8
	   clat = buffer(pntr:pntr+8)
	   pntr = pntr + 8
	   cdate = buffer(pntr:pntr+4)
	   pntr = pntr + 4
	   id = buffer(pntr:pntr+1)
	   pntr = pntr + 1
	   write(*,*) desc, lon, lat, date, id(1:1)
 20	continue
	
c
c    Read Second (1th) Level
c
	status = ptlevinfo(ptid, 1, fldlist, fldtype, fldorder)
	n = ptnrecs(ptid, 1)


	do 30 i=1,n

	   recs(1) = i - 1
	   status = ptrdlev(ptid, 1, fldlist, 1, recs, buffer)

	   pntr = 1
	   
	   ctime = buffer(pntr:pntr+8)
	   pntr = pntr + 8
	   crain = buffer(pntr:pntr+4)
	   pntr = pntr + 4
	   ctemp = buffer(pntr:pntr+4)
	   pntr = pntr + 4
	   id = buffer(pntr:pntr+1)
	   pntr = pntr + 1
	   write(*,*) time, rain, temp, '  ', id(1:1)
 30	continue	

	status = ptdetach(ptid)
	status = ptclose(ptfid)

	stop
	end

c
c  In this example we will write to an appendable field.
c


      program appendfield

      integer            status, i, swfldinfo, swdetach, swclose
      integer            swwrfld, swrdfld
      integer*2          inarray(5), outarray(20)
      integer*4          swfid, swid, rank, dims(1), ntype
      integer*4          start(1), stride(1), count(1)
      integer*4          swopen, swattach
      character*72       dimlist
      
      integer*4          DFACC_RDWR
      parameter (DFACC_RDWR=3)
      
      
      do i=1,5
         inarray(i) = i
      enddo
      
      swfid = swopen("SwathFile_created_with_hadeos_sample_file_write"//
     1"r_of_HDFEOS2_version_219_or_higher_release.hdf", DFACC_RDWR)
      swid = swattach(swfid, "Swath1")


c     Write 5 records to field
c     ------------------------
      start(1) = 0
      stride(1) = 1
      count(1) = 5
      status = swwrfld(swid, "Count", start, stride, count, inarray)

      status = swfldinfo(swid, "Count", rank, dims, ntype, dimlist)
      write(*,*) 'Number of elements after first write:' ,dims(1)



c     Append 1 record to field
c     ------------------------
      start(1) = dims(1)
      count(1) = 1
      status = swwrfld(swid, "Count", start, stride, count, inarray)
      status = swfldinfo(swid, "Count", rank, dims, ntype, dimlist)
      write(*,*) 'Number of elements after append:' ,dims(1)

      start(1) = 0
      count(1) = dims(1)
      status = swrdfld(swid, "Count", start, stride, dims, outarray)    
      do i=1,dims(1)
         write(*,*) 'Data Element:', outarray(i)
      enddo

      status = swdetach(swid)
      status = swclose(swfid)

      stop
      end

c23456789012345678901234567890123456789012345678901234567890123456789012
c testgrid.f
c In this program we create, define and write a simple grid hdfeos file
c using the grid interface
c

      program testgrid
      
      integer*4		index1
      integer*4		index2
      integer*4		dimsizes(2)
      integer*4		regionid, regionid2
      integer*4		tiledims(2), tilecords(2)
      integer*4		tileray(16,15)
      integer*4		tilebuffer(240)
      integer*4		tilecode, tilerank
      integer*4		itiledims(2)
      integer*4		tileinit
      real*4		ray3(250)
      real*4		utmray(60,80), georay(60,80)
      real*4		utmray1010(10,10)
      real*4		utmhght(80)
      real*4		hghtinit
      real*8		utmtmeray(4800)
      real*8		tmeinit
      real*4		utmcnt, geocnt
      real*4		fillvalue, ifillv, fillvalue0
      real*4		raycnt, ray3cnt
      real*4		tempray(60,80)
      real*4		datbuf(4800)
      
      integer   	status, i, ii
      integer		compparm(5)
      integer*4		lstatus, n, one
      integer*4 	gdfid, gdfid2, gdid_utm, gdid2
      integer*4 	zonecode, compcode
      integer*4		attr(4), iattr(4)
      integer*4 	spherecode, xdim, ydim, zero
      integer*4		tmpvar1, nt, rk, size, tmpvar2
      integer*4 	start(2)
      integer*4 	stride(2)
      integer*4 	edge(2)
      integer*4 	start1d, stride1d, edge1d
      integer*4		periodid
      real*8		starttime, stoptime
      real*8		range(2)
      real*8		projparm(16), pparm(16)
      real*8		uplft(2), lowrgt(2)
      real*8		iuplft(2), ilrgt(2)
      real*8		interval(5,2)
      real*8		lonval(5), latval(5)
      integer*4		rowval(5), colval(5)
      real*4		fldval(5)

      integer*4		lat(40,50)
      integer*4		latcnt
      integer*4		lon(40,50)
      integer*4		loncnt

      integer   	gddefproj, gddefdim, gddeffld, gddetach 
      integer		gdclose, gdgetfill, gdreginfo
      integer   	gdwrfld, gdwrattr, gdsetfill, gddeforigin
      integer		gdgridinfo, gdprojinfo,gdfldinfo
      integer		gdrdfld, gddefpreg,gdrdattr, gdextreg
      integer		gdattrinfo, gdwrmeta, gddefcomp
      integer		gdcompinfo, gddeftle, gdrdtle
      integer		gdsettleche, gdtleinfo, gdwrtle
      integer		gddupreg, gdgetpix
      integer*4 	gdopen, gdcreate, gdattach, gdinqgrid
      integer*4		gdinqdims, gddiminfo, gdinqflds
      integer*4		gdnentries, gdinqattrs, gddefboxreg
      integer*4		gdorginfo, gdpreginfo
      integer*4		gdinterpolate, gddeftmeper
      integer*4		gddefvrtreg, gdgetpixval

      integer*4		strbufsize, pcode,nflds
      integer		zcode, scode
      character*80	grdnames, dimname, fldlist, attrlist
      integer*4		dims(8), rnk(8), numtype(8)
      real*8		upleftpt(2), lowrtpt(2),corlon(2),corlat(2)
      integer*4		xdimsize, ydimsize
      
      integer DFACC_CREATE
      parameter (DFACC_CREATE=4)
      integer DFACC_RDWR
      parameter (DFACC_RDWR=3)
      integer DFACC_READ
      parameter (DFACC_READ=1)      
      integer GCTP_UTM
      parameter (GCTP_UTM=1)

      integer DFNT_FLOAT32
      parameter (DFNT_FLOAT32=5)
      integer DFNT_FLOAT64
      parameter (DFNT_FLOAT64=6)
      integer DFNT_INT32
      parameter (DFNT_INT32=24)      
      
      integer HDFE_NOMERGE
      parameter (HDFE_NOMERGE=0)
      integer HDFE_AUTOMERGE
      parameter (HDFE_AUTOMERGE=1)
      
      integer HDFE_CORNER
      parameter (HDFE_CORNER=1)
      integer HDFE_GD_UL
      parameter (HDFE_GD_UL=0)
      integer HDFE_NENTDIM
      parameter(HDFE_NENTDIM=0)
      integer HDFE_NENTDFLD
      parameter (HDFE_NENTDFLD=4)

      integer HDFE_COMP_SKPHUFF
      parameter (HDFE_COMP_SKPHUFF=3)
      integer HDFE_COMP_NONE
      parameter (HDFE_COMP_NONE=0)

      integer HDFE_NOPREVSUB
      parameter (HDFE_NOPREVSUB=-1)
 
      integer HDFE_NOTILE
      parameter (HDFE_NOTILE=0)
      integer HDFE_TILE
      parameter (HDFE_TILE=1)

      index1 = 0
      index2 = 0
      dimsizes(1) = 40
      dimsizes(2) = 100
      compparm(1) = 0
      compparm(2) = 0
      compparm(3) = 0
      compparm(4) = 0
      compparm(5) = 0
      fillvalue = 1996.0
      fillvalue0 = 0.0
      raycnt = -799.0
      ray3cnt = -19.5
      attr(1) = 11
      attr(2) = 33
      attr(3) = 66
      attr(4) = 99
      utmcnt=-799.0
      geocnt=2001.0
      hghtinit = 323.0
      tmeinit = 35232487.2d0
      starttime = 35233000.8d0
      stoptime = 35435050.9d0
      range(1) = 352.8d0
      range(2) = 400.9d0
      lonval(1) = -122.0d0
      latval(1) = -68.0d0
      lonval(2) = -122.5d0
      latval(2) = -68.0d0
      lonval(3) = -123.0d0
      latval(3) = -68.0d0
      lonval(4) = -123.5d0
      latval(4) = -68.0d0
      lonval(5) = -124.0d0
      latval(5) = -68.0d0
      tileinit = -299.5
      tiledims(1) = 16
      tiledims(2) = 15
      tilecords(1) = 0
      tilecords(2) = 0

      latcnt = 38.0
      loncnt = 78.0
      zero = 0
      one = 1
      
c
c This section of the program just fills some arrays with data that we will
c use later in the program
c
      do 70 index1=1,80
      utmcnt=-799.00
      geocnt=2001.00
         do 80 index2=1,60
            utmray(index2,index1) = utmcnt
            georay(index2,index1) = geocnt
            utmcnt = utmcnt + .400000 *index1
            geocnt = geocnt + .200000 *index1
   80   continue
   70 continue
        do 700 index1=1,10
      utmcnt=-799.00
         do 800 index2=1,10
            utmray1010(index2,index1) = utmcnt
             utmcnt = utmcnt + .400000 *index1
 800     continue
 700  continue
  
      
      do 30 index1=1,250
            ray3(index1) = ray3cnt
            ray3cnt = ray3cnt + .1
   30 continue
      
      do 32 index1=1,80
            utmhght(index1) = hghtinit
            hghtinit = hghtinit + 2.75
   32 continue

      do 34 index1=1,4800
            utmtmeray(index1) = tmeinit
            tmeinit = tmeinit + 70.7
   34 continue

      do 50 index1=1,50
         do 60 index2=1,40      
            lat(index2,index1) = latcnt
            lon(index2,index1) = loncnt
            loncnt = loncnt - 0.1
   60    continue
         latcnt = latcnt + 0.1
         loncnt = 78.0
   50 continue

      do 51 index1=1,16
         do 52 index2=1,15
            tileray(index1,index2) = tileinit
            tileinit = tileinit + 0.5
   52    continue
   51 continue
      
  230 format('********Error unexpected**********')
  231 format('********Error Expected************')
  240 format('***********Passed Test*********')


      open(unit=10, file='testgrid_f.txtout', status = "NEW")

      write(*,*)'Testing Grid FORTRAN 77 interface '
      write(*,*)'=================================='
      write(10,*)'Testing Grid FORTRAN 77 interface '
      write(10,*)'=================================='
      write(10,*)' '
      write(*,*)' '

c Test Case -- gdopen
c
      write(10,*)'Testing gdopen... '
      write(10,*)'=================='
      write(*,*)'Testing gdopen... '
      write(*,*)'=================='
      write(*,*)'Opening non-existing file Gridf_Test2.hdf for reading'
      write(10,*)'Opening non-existing file Gridf_Test2.hdf for reading'
      gdfid2 = gdopen("Gridf_Test2.hdf", DFACC_READ)
      if (gdfid2 .lt. zero) then
         write(*,240)
         write(10,240)
         write(*,231)
         write(10,231)
         call heprnt(0)
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(10,*)'gdfid2 = gdopen("Gridf_Test2.hdf", DFACC_READ)'
         write(10,*)'Value returned by gdopen ', gdfid2
         write(*,*)'gdfid2 = gdopen("Gridf_Test2.hdf", DFACC_READ)'
         write(*,*)'Value returned by gdopen ', gdfid2
      endif
      write(*,*)' '
      write(10,*)' '

      gdfid = gdopen('Gridf_Test.hdf', DFACC_CREATE)
      if (gdfid .lt. zero) then
         write(*,230)
         write(10,230)
         call heprnt(0)
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(*,*)'Opening file Gridf_Test.hdf'
         write(10,*)'Opening file Gridf_Test.hdf'
         write(10,*) 'gdfid = gdopen("Gridf_Test.hdf", DFACC_CREATE)'
         write(10,*) 'File id returned from gdopen ', gdfid
         write(*,*) 'gdfid = gdopen("Gridf_Test.hdf", DFACC_CREATE)'
         write(*,*) 'File id returned from gdopen ', gdfid
      endif
      write(10,*)' '
      write(*,*)' '


c Test Case -- gdcreate
c
      write(10,27)
      write(10,*)'Testing gdcreate... '
      write(10,*)'=================='
      write(*,*)'Testing gdcreate... '
      write(*,*)'=================='

      xdim = 60
      ydim = 80
      uplft(1) = 353299.39125d0
      uplft(2) = -7100284.64348d0
      lowrgt(1) = 603434.52148d0
      lowrgt(2) = -7991341.17870d0


      gdid2 = gdcreate(gdfid2, 'UTMGrid2', xdim, ydim, uplft, lowrgt)
      if (gdid2 .lt. zero) then
         write(*,231)
         write(10,231)
         call heprnt(0)
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(10,*) 'Create UTMGrid2'
         write(*,*)'gdid2 = gdcreate(gdfid2, "UTMGrid2", xdim, ydim, upl       &
     1ft, lowrgt)'
         write(10,*) 'Value returned by gdcreate ', gdid2
         write(*,*) 'Create UTMGrid2'
         write(10,*)'gdid2 = gdcreate(gdfid2, "UTMGrid2", xdim, ydim, up       &
     1lft, lowrgt)'
         write(*,*) 'Value returned by gdcreate ', gdid2
      endif
      
    
      gdid_utm = gdcreate(gdfid, 'UTMGrid', xdim, ydim, uplft, lowrgt)
      if (gdid_utm .lt. zero) then
         write(*,230)
         write(10,230)
         call heprnt(0)
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(10,*)'Creating UTMGrid'
         write(*,*)'Creating UTMGrid'
         write(*,*)'gdid_utm=gdcreate(gdfid,"UTMGrid",xdim,ydim,uplft,lo       &
     1wrgt)'
         write(10,*)'gdid_utm=gdcreate(gdfid,"UTMGrid",xdim,ydim,uplft,l       &
     1owrgt)'
         write(10,*)'UTM grid id returned from gdcreate ', gdid_utm
         write(*,*)'UTM grid id returned from gdcreate ', gdid_utm
      endif 
      write(10,*)' '
      write(*,*)' '

c Test Case -- gddefproj
c
      write(10,27)
      write(10,*)'Testing gddefproj... '
      write(10,*)'=================='
      write(*,*)'Testing gddefproj... '
      write(*,*)'=================='

      zonecode = 10
      spherecode = 0

      do 120 index1=1,16
         projparm(index1)=0
 120  continue
  
      status = gddefproj(gdid_utm,GCTP_UTM,zonecode,spherecode,projparm)
      if (status .lt. zero) then
         write(*,230)
         write(10,230)
         call heprnt(0)
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(10,*)'Defining UTM projection'
         write(*,*)'Defining UTM projection'
         write(*,*)'status=gddefproj(gdid_utm,GCTP_UTM,zonecode,sphereco       &
     1de, projparm)'
         write(10,*)'status=gddefproj(gdid_utm,GCTP_UTM,zonecode,spherec       &
     1ode, projparm)'
         write(10,*)'Returned value from gddefproj ', status
         write(*,*)'Returned value from gddefproj ', status
      endif 
      write(10,*)' '
      write(*,*)' '

      status = gddefproj(gdid2,GCTP_UTM,zonecode,spherecode,projparm)
      if (status .lt. zero) then
         write(*,231)
         write(10,231)
         call heprnt(0)
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(10,*)'Defining UTM'
         write(10,*)'status = gddefproj(gdid2,GCTP_UTM,zonecode,sphereco       &
     1de,projparm)'
         write(10,*)'Value returned by gddefproj ', status
         write(*,*)'Defining UTM'
         write(*,*)'status = gddefproj(gdid2,GCTP_UTM,zonecode,spherecod       &
     1e,projparm)'
         write(*,*)'Value returned by gddefproj ', status
      endif
      write(10,*)' '
      write(*,*)' '


c Test Case -- gddefpreg
c
      write(10,27)
      write(10,*)'Testing gddefpreg... '
      write(10,*)'=================='
      write(*,*)'Testing gddefpreg... '
      write(*,*)'=================='
      status = gddefpreg(gdid_utm, HDFE_CORNER)
      if (status .lt. zero) then
         write(*,230)
         write(10,230)
         call heprnt(0)
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(*,*)'status = gddefpreg(gdid_utm, HDFE_CORNER)'
         write(10,*)'status = gddefpreg(gdid_utm, HDFE_CORNER)'
         write(10,*)'Returned from gddefpreg ', status
         write(*,*)'Returned from gddefpreg ', status
      endif
      write(10,*)' '
      write(*,*)' '

c Test Case -- gddeforigin
c
      write(10,27)
      write(10,*)'Testing gddeforigin... '
      write(10,*)'=================='
      write(*,*)'Testing gddeforigin... '
      write(*,*)'=================='
      status = gddeforigin(gdid_utm, HDFE_GD_UL)
      if (status .lt. zero) then
         write(*,230)
         write(10,230)
         call heprnt(0)
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(*,*)'status = gddeforigin(gdid_utm, HDFE_GD_UL)'
         write(*,*)'Value of status from gddeforigin ',status
         write(10,*)'status = gddeforigin(gdid_utm, HDFE_GD_UL)'
         write(10,*)'Value of status from gddeforigin ',status
      endif
      write(10,*)' '
      write(*,*)' '

c Test Case -- gddefdim
c
      write(10,27)
      write(10,*)'Testing gddefdim... '
      write(10,*)'=================='
      write(*,*)'Testing gddefdim... '
      write(*,*)'=================='
      status = gddefdim(gdid2, 'TestDim1', 40)
      if (status .lt. zero) then
         write(*,231)
         write(10,231)
         call heprnt(0)
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(10,*)'status = gddefdim(gdid2, "TestDim1", 40)'
         write(10,*)'Value returned by gddefdim ', status
         write(*,*)'status = gddefdim(gdid2, "TestDim1", 40)'
         write(*,*)'Value returned by gddefdim ', status
      endif
      write(10,*)' '
      write(*,*)' '

      status = gddefdim(gdid2, 'TestDim2', 25)
      if (status .lt. zero) then
         write(*,231)
         write(10,231)
         call heprnt(0)
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(10,*)'status = gddefdim(gdid2, "TestDim2", 25)'
         write(10,*)'Value returned by gddefdim ', status
         write(*,*)'status = gddefdim(gdid2, "TestDim2", 25)'
         write(*,*)'Value returned by gddefdim ', status
      endif
      write(10,*)' '
      write(*,*)' '


      status = gddefdim(gdid_utm, 'Conduction', 250)
      if (status .lt. zero) then
         write(*,230)
         write(10,230)
         call heprnt(0)
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(10,*)'status = gddefdim(gdid_utm, "Conduction", 250)'
         write(10,*)'Returned value from gddefdim ', status
         write(*,*)'status = gddefdim(gdid_utm, "Conduction", 250)'
         write(*,*)'Returned value from gddefdim ', status
      endif
      write(10,*)' '
      write(*,*)' '

      status = gddefdim(gdid_utm,'Timedim',4800)
      if(status .lt. zero) then
         write(*,230)
         write(10,230)
         call heprnt(0)
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(10,*)'status = gddefdim(gdid_utm,"Timedim",4800)'
         write(10,*)'Status returned by call to gddefdim ',status
         write(*,*)'status = gddefdim(gdid_utm,"Timedim",4800)'
         write(*,*)'Status returned by call to gddefdim ',status
      endif
      write(10,*)' '
      write(*,*)' '

      status = gddefdim(gdid_utm,'Hghtdim',80)
      if(status .lt. zero) then
         write(*,230)
         write(10,230)
        call heprnt(0)
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
        write(10,*)'status = gddefdim(gdid_utm,"Hghtdim",80)'
        write(10,*)'Status returned by call to gddefdim ',status
        write(*,*)'status = gddefdim(gdid_utm,"Hghtdim",80)'
        write(*,*)'Status returned by call to gddefdim ',status
      endif
      write(10,*)' '
      write(*,*)' '

      status = gddefdim(gdid_utm,'Convection',60)
      if(status .lt. zero) then
         write(*,230)
         write(10,230)
        call heprnt(0)
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
        write(10,*)'Define dimension Convection '
        write(10,*)'status = gddefdim(gdid_utm,"Convection",60)'
        write(10,*)'Status returned by call to gddefdim ',status
        write(*,*)'Define dimension Convection '
        write(*,*)'status = gddefdim(gdid_utm,"Convection",60)'
        write(*,*)'Status returned by call to gddefdim ',status
      endif
      write(10,*)' '
      write(*,*)' '

c Test Case -- gddetach
c
      write(10,27)
      write(10,*)'Testing gddetach... '
      write(10,*)'=================='
      write(*,*)'Testing gddetach... '
      write(*,*)'=================='
      status = gddetach(gdid2)
      if(status .lt. zero) then
         write(*,231)
         write(10,231)
        call heprnt(0)
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(10,*)'status = gddetach(gdid2)'
         write(10,*)'Value returned by gddetach ', status
         write(*,*)'status = gddetach(gdid2)'
         write(*,*)'Value returned by gddetach ', status
      endif
      write(10,*)' '
      write(*,*)' '

      status = gddetach(gdid_utm)
      if(status .lt. zero) then
         write(*,230)
         write(10,230)
        call heprnt(0)
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(10,*)'status = gddetach(gdid_utm)'
         write(10,*)'Returned value from gddetach ', status
         write(*,*)'status = gddetach(gdid_utm)'
         write(*,*)'Returned value from gddetach ', status
      endif
      write(10,*)' '
      write(*,*)' '
 
c Test Case -- gdattach
c
      write(10,27)
      write(10,*)'Testing gdattach... '
      write(10,*)'=================='
      write(*,*)'Testing gdattach... '
      write(*,*)'=================='
      gdid_utm = gdattach(gdfid, 'UTMGrid')
      if(gdid_utm .lt. zero) then
         write(*,230)
         write(10,230)
        call heprnt(0)
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(10,*)'gdid_utm = gdattach(gdfid, "UTMGrid")'
         write(10,*)'Handle returned from gdattach ', gdid_utm
         write(*,*)'gdid_utm = gdattach(gdfid, "UTMGrid")'
         write(*,*)'Handle returned from gdattach ', gdid_utm
      endif
      write(10,*)' '
      write(*,*)' '

      gdid2 = gdattach(gdfid2, 'UTMGrid2')
      if(gdid_utm .lt. zero) then
         write(*,230)
         write(10,230)
        call heprnt(0)
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(10,*)'gdid2 = gdattach(gdfid2, "UTMGrid2")'
         write(10,*)'Value returned by gdattach ', status
         write(*,*)'gdid2 = gdattach(gdfid2, "UTMGrid2")'
         write(*,*)'Value returned by gdattach ', status
      endif
      write(10,*)' '
      write(*,*)' '

c Test Case -- gddeffld
c
      write(10,27)
      write(10,*)'Testing gddeffld... '
      write(10,*)'=================='
      write(*,*)'Testing gddeffld... '
      write(*,*)'=================='

      status=gddeffld(gdid2,'tempfield','TestDim2,TestDim1',DFNT_FLOAT32       &
     1,HDFE_NOMERGE)
      if(status .lt. zero) then
         write(*,231)
         write(10,231)
        call heprnt(0)
      else 
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
        write(10,*)'Define: "tempfield"'
        write(10,*)'status=gddeffld(gdid2,"tempfield","TestDim2,TestDim1       &
     1",DFNT_FLOAT32,HDFE_NOMERGE)'
        write(10,*)'Value returned by gddeffld ', status
        write(*,*)'Define: "tempfield"'
        write(*,*)'status=gddeffld(gdid2,"tempfield","TestDim2,TestDim1"       &
     1",DFNT_FLOAT32,HDFE_NOMERGE)'
        write(*,*)'Value returned by gddeffld ', status
      endif
      write(10,*)' '
      write(*,*)' '

      status=gddeffld(gdid_utm,'Time','Timedim',DFNT_FLOAT64,HDFE_NOMERG       &
     1E)
      if(status .lt. zero) then
         write(*,230)
         write(10,230)
        call heprnt(0)
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
        write(10,*)' Define field Time'
        write(10,*)'status=gddeffld(gdid_utm,"Time","Timedim",DFNT_FLOAT       &
     164,HDFE_NOMERGE)'
        write(10,*)'Status returned by call to gddeffld ',status
        write(*,*)' Define field Time'
        write(*,*)'status=gddeffld(gdid_utm,"Time","Timedim",DFNT_FLOAT6       &
     14,HDFE_NOMERGE)'
        write(*,*)'Status returned by call to gddeffld ',status
      endif
      write(10,*)' '
      write(*,*)' '

c23456789012345678901234567890123456789012345678901234567890123456789012
      status=gddeffld(gdid_utm,'Height','Hghtdim',DFNT_FLOAT32,HDFE_NOME       &
     1RGE)
      if(status .lt. zero) then
         write(*,230)
         write(10,230)
        call heprnt(0)
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
        write(10,*)' Define field Height'
        write(10,*)'status=gddeffld(gdid_utm,"Height","Hghtdim",DFNT_FLO       &
     1AT32,HDFE_NOMERGE)'
        write(10,*)'Status returned by call to gddeffld ',status
        write(*,*)' Define field Height'
        write(*,*)'status=gddeffld(gdid_utm,"Height","Hghtdim",DFNT_FLOA       &
     1T32,HDFE_NOMERGE)'
        write(*,*)'Status returned by call to gddeffld ',status
      endif
      write(10,*)' '
      write(*,*)' '

c Test Case -- gddeftle
c
      write(10,27)
      write(10,*)'Testing gddeftle... '
      write(10,*)'=================='
      write(*,*)'Testing gddeftle... '
      write(*,*)'=================='

      status = gddeftle(gdid_utm,HDFE_TILE,2,tiledims)
      if (status .lt. zero) then
         write(*,230)
         write(10,230)
        call heprnt(0)
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
        write(10,*)'Define tiling dimensions '
        write(10,*)'status = gddeftle(gdid_utm,HDFE_TILE,2,tiledims)'
        write(10,*)'Status returned by call to gddeftle ',status
        write(*,*)'Status returned by call to gddeftle ',status
        write(*,*)'status = gddeftle(gdid_utm,HDFE_TILE,2,tiledims)'
        write(*,*)'Define tiling dimensions '
      endif
      write(10,*)' '
      write(*,*)' '

      status=gddeffld(gdid_utm,'SideB','YDim,Convection',DFNT_INT32,HDFE       &
     1_NOMERGE)
      if (status .lt. zero) then
         write(*,230)
         write(10,230)
        call heprnt(0)
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
        write(10,*)'Define field that will be tiled '
        write(10,*)'status=gddeffld(gdid_utm,"SideB","YDim,Convection",D       &
     1FNT_INT32,HDFE_NOMERGE)'
        write(10,*)'Status returned by call to gddeffld ',status
        write(*,*)'Define field that will be tiled '
        write(*,*)'status=gddeffld(gdid_utm,"SideB","YDim,Convection",DF       &
     1NT_INT32,HDFE_NOMERGE)'
        write(*,*)'Status returned by call to gddeffld ',status
      endif
      write(10,*)' '
      write(*,*)' '

      status = gddeftle(gdid_utm,HDFE_NOTILE,0,tiledims)
      if (status .lt. zero) then
         write(*,230)
         write(10,230)
        call heprnt(0)
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
        write(10,*)'Turn off tiling '
        write(10,*)'status = gddeftle(gdid_utm,HDFE_NOTILE,0,tiledims)'
        write(10,*)'Status returned by call to gddeftle ',status
        write(*,*)'Turn off tiling '
        write(*,*)'status = gddeftle(gdid_utm,HDFE_NOTILE,0,tiledims)'
        write(*,*)'Status returned by call to gddeftle ',status
      endif
      write(10,*)' '
      write(*,*)' '

      status = gddetach(gdid_utm)
      if (status .lt. zero) then 
         write(*,230)
         write(10,230)
        call heprnt(0)
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(10,*)'status = gddetach(gdid_utm)'
         write(10,*)'Returned value from gddetach ', status
         write(*,*)'status = gddetach(gdid_utm)'
         write(*,*)'Returned value from gddetach ', status
      endif
      write(10,*)' '
      write(*,*)' '

      gdid_utm = gdattach(gdfid, 'UTMGrid')
      if (gdid_utm .lt. zero) then
         write(*,230)
         write(10,230)
        call heprnt(0)
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(10,*)'status = gdattach(gdfid,"UTMGrid")'
         write(10,*)'Returned value from gdattach ', status
         write(*,*)'status = gddetach(gdfid,"UTMGrid")'
         write(*,*)'Returned value from gdattach ', status
      endif
      write(10,*)' '
      write(*,*)' '

c Test Case -- gddefcomp
c
      write(10,27)
      write(10,*)'Testing gddefcomp... '
      write(10,*)'=================='
      write(*,*)'Testing gddefcomp... '
      write(*,*)'=================='

      status = gddefcomp(gdid_utm,HDFE_COMP_SKPHUFF, compparm)
      if(status .lt. zero) then
         write(*,230)
         write(10,230)
        call heprnt(0)
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
        write(10,*)'Setup compression mode'
        write(10,*)'status = gddefcomp(gdid_utm,HDFE_COMP_SKPHUFF, compp       &
     1arm)'
        write(10,*)'Status returned by call to gddefcomp ',status
        write(*,*)'Setup compression mode'
        write(*,*)'status = gddefcomp(gdid_utm,HDFE_COMP_SKPHUFF, comppa       &
     1rm)'
        write(*,*)'Status returned by call to gddefcomp ',status
      endif
      write(10,*)' '
      write(*,*)' '

      status = gddeffld(gdid_utm,'Voltage','XDim,YDim',DFNT_FLOAT32,HDFE       &
     1_AUTOMERGE)
      if(status .lt. zero) then
         write(*,230)
         write(10,230)
        call heprnt(0)
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
        write(10,*)'Define: "Voltage"'
        write(10,*)'status = gddeffld(gdid_utm,"Voltage","XDim,YDim",DFN       &
     1T_FLOAT32,HDFE_AUTOMERGE)'
        write(10,*)'Value returned from gddeffld ', status
        write(*,*)'Define: "Voltage"'
        write(*,*)'status = gddeffld(gdid_utm,"Voltage","XDim,YDim",DFNT       &
     1_FLOAT32,HDFE_AUTOMERGE)'
        write(*,*)'Value returned from gddeffld ', status
      endif
      write(10,*)' '
      write(*,*)' '

      status = gddefcomp(gdid_utm,HDFE_COMP_NONE, compparm)
      if(status .lt. zero) then
         write(*,230)
         write(10,230)
        call heprnt(0)
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
        write(10,*)'Turn off compression'
        write(10,*)'status=gddefcomp(gdid_utm,HDFE_COMP_NONE,compparm)'
        write(10,*)'Status returned by call to gddefcomp ',status
        write(*,*)'Turn off compression'
        write(*,*)'status=gddefcomp(gdid_utm,HDFE_COMP_NONE,compparm)'
        write(*,*)'Status returned by call to gddefcomp ',status
      endif
      write(10,*)' '
      write(*,*)' '

      status=gddeffld(gdid_utm,'Drift','XDim,YDim',DFNT_FLOAT32,HDFE_AUT       &
     1OMERGE)
      if(status .lt. zero) then
         write(*,230)
         write(10,230)
        call heprnt(0)
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
        write(10,*)'Define: "Drift"'      
        write(10,*)'status=gddeffld(gdid_utm,"Drift","XDim,YDim",DFNT_FL       &
     1OAT32,HDFE_AUTOMERGE)'
        write(10,*)'Value returned from gddeffld ', status
        write(*,*)'Define: "Drift"'      
        write(*,*)'status=gddeffld(gdid_utm,"Drift","XDim,YDim",DFNT_FLO       &
     1OAT32,HDFE_AUTOMERGE)'
        write(*,*)'Value returned from gddeffld ', status
      endif
      write(10,*)' '
      write(*,*)' '

      status=gddeffld(gdid_utm,'Impedance','XDim,YDim',DFNT_FLOAT32,HDF       &
     1E_AUTOMERGE)
      if(status .lt. zero) then
         write(*,230)
         write(10,230)
        call heprnt(0)
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(10,*)'Define: "Impedance"'            
         write(10,*)'status=gddeffld(gdid_utm,"Impedance","XDim,YDim",DF       &
     1NT_FLOAT32,HDFE_AUTOMERGE)'
         write(10,*)'Value returned from gddeffld ', status
         write(*,*)'Define: "Impedance"'            
         write(*,*)'status=gddeffld(gdid_utm,"Impedance","XDim,YDim",DFN       &
     1T_FLOAT32,HDFE_AUTOMERGE)'
         write(*,*)'Value returned from gddeffld ', status
      endif
      write(10,*)' '
      write(*,*)' '

      status=gddeffld(gdid_utm,'Grounding','Conduction',DFNT_FLOAT32,HDF       &
     1_NOMERGE)
      if(status .lt. zero) then
         write(*,230)
         write(10,230)
        call heprnt(0)
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(10,*)'Define: "Grounding"'                  
         write(10,*)'status=gddeffld(gdid_utm,"Grounding","Conduction",D       &
     1FNT_FLOAT32,HDF_NOMERGE)'
         write(10,*)'Value returned by gddeffld ', status
         write(*,*)'Define: "Grounding"'                  
         write(*,*)'status=gddeffld(gdid_utm,"Grounding","Conduction",DF       &
     1NT_FLOAT32,HDF_NOMERGE)'
         write(*,*)'Value returned by gddeffld ', status
      endif
      write(10,*)' '
      write(*,*)' '

c Test Case -- gdwrmeta
c
      write(10,27)
      write(10,*)'Testing gdwrmeta... '
      write(10,*)'=================='
      write(*,*)'Testing gdwrmeta... '
      write(*,*)'=================='

      status = gdwrmeta(gdid_utm,'Extern','XDim,YDim',DFNT_FLOAT32)
      if(status .lt. zero) then
         write(*,230)
         write(10,230)
        call heprnt(0)
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(*,*)'status = gdwrmeta(gdid_utm,"Extern","XDim,YDim",DFNT       &
     1_FLOAT32)'
         write(*,*)'Value returned by gdwrmeta ',status
         write(10,*)'status = gdwrmeta(gdid_utm,"Extern","XDim,YDim",DFN       &
     1T_FLOAT32)'
         write(10,*)'Value returned by gdwrmeta ',status
      endif
      write(10,*)' '
      write(*,*)' '

c Test Case -- gdsetfill
c
      write(10,27)
      write(10,*)'Testing gdsetfill... '
      write(10,*)'=================='
      write(*,*)'Testing gdsetfill... '
      write(*,*)'=================='

      status = gdsetfill(gdid_utm, 'Voltage', fillvalue0)
      status = gdsetfill(gdid_utm, 'Impedance', fillvalue0)
      status = gdsetfill(gdid_utm, 'Grounding', fillvalue0)



      status = gdsetfill(gdid_utm, 'Drift', fillvalue)
      if(status .lt. zero) then
         write(*,230)
         write(10,230)
        call heprnt(0)
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(10,*)'Testing gdsetfill'
         write(10,*)'status = gdsetfill(gdid_utm, "Drift", fillvalue)'
         write(10,*)'Returned from gdsetfill ', status
         write(*,*)'Testing gdsetfill'
         write(*,*)'status = gdsetfill(gdid_utm, "Drift", fillvalue)'
         write(*,*)'Returned from gdsetfill ', status
      endif
      write(10,*)' '
      write(*,*)' '

      status = gddetach(gdid_utm)
      if(status .lt. zero) then
         write(*,230)
         write(10,230)
        call heprnt(0)
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(10,*)'status = gddetach(gdid_utm)'
         write(*,*)'status = gddetach(gdid_utm)'
         write(10,*)'Returned value from gddetach ', status
         write(*,*)'Returned value from gddetach ', status
      endif
      write(10,*)' '
      write(*,*)' '

      gdid_utm = gdattach(gdfid, 'UTMGrid')
      if(gdid_utm .lt. zero) then
         write(*,230)
         write(10,230)
        call heprnt(0)
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(10,*)'gdid_utm = gdattach(gdfid, "UTMGrid")'
         write(10,*)'Handle returned from gdattach ', gdid_utm
         write(*,*)'gdid_utm = gdattach(gdfid, "UTMGrid")'
         write(*,*)'Handle returned from gdattach ', gdid_utm
      endif
      write(10,*)' '
      write(*,*)' '

c Test Case -- gdwrfld
c
      write(10,27)
      write(10,*)'Testing gdwrfld... '
      write(10,*)'=================='
      write(*,*)'Testing gdwrfld... '
      write(*,*)'=================='

      start(1) = 0
      start(2) = 0
      stride(1) = 1
      stride(2) = 1
      edge(1) = 60
      edge(2) = 80
      
      status = gdwrfld(gdid_utm, 'Voltage', start, stride, edge, utmray)
      if (status .lt. zero) then
         write(*,230)
         write(10,230)
        call heprnt(0)
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
        write(10,*)'Write to field Voltage '
        write(10,*)'status=gdwrfld(gdid_utm,"Voltage",start,stride,edge,       &
     1utmray)'
        write(10,*)'Status returned by gdwrfield ', status
        write(*,*)'Write to field Voltage '
        write(*,*)'status=gdwrfld(gdid_utm,"Voltage",start,stride,edge,u       &
     1tmray)'
        write(*,*)'Status returned by gdwrfield ', status
      endif
      write(10,*)' '
      write(*,*)' '


      start(1) = 10
      start(2) = 10
      edge(1) = 10
      edge(2) = 10
      status = gdwrfld(gdid_utm, 'Drift', start,stride,edge,utmray1010)
      if (status .lt. zero) then
         write(*,230)
         write(10,230)
        call heprnt(0)
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
        write(10,*)'Write to field Drift '
        write(10,*)'status = gdwrfld(gdid_utm,"Drift",start,stride,edge,       &
     1utmray)'
        write(10,*)'Status returned from gdwrfld ', status
        write(*,*)'Write to field Drift '
        write(*,*)'status = gdwrfld(gdid_utm,"Drift",start,stride,edge,u       &
     1tmray)'
        write(*,*)'Status returned from gdwrfld ', status
      endif
      write(10,*)' '
      write(*,*)' '

      start(1) = 0
      start(2) = 0
      edge(1) = 60
      edge(2) = 80
      status = gdwrfld(gdid_utm, 'Impedance', start,stride,edge,utmray)
      if (status .lt. zero) then
         write(*,230)
         write(10,230)
        call heprnt(0)
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
        write(10,*)'Write to field Impedance '
        write(10,*)'status=gdwrfld(gdid_utm,"Impedance",start,stride,edg       &
     1e,utmray)'
        write(10,*)'Returned from gdwrfld ', status
        write(*,*)'Write to field Impedance '
        write(*,*)'status=gdwrfld(gdid_utm,"Impedance",start,stride,edge       &
     1,utmray)'
        write(*,*)'Returned from gdwrfld ', status
      endif
      write(10,*)' '
      write(*,*)' '

      start1d=0
      stride1d=1
      edge1d=4800
      status=gdwrfld(gdid_utm,'Time',start1d,stride1d,edge1d,utmtmeray)
      if (status .lt. zero) then
         write(*,230)
         write(10,230)
        call heprnt(0)
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
        write(10,*)'Write to field Time '
        write(10,*)'status=gdwrfld(gdid_utm,"Time",start1d,stride1d,edge       &
     11d,utmtmeray)'
        write(10,*)'Status returned by call to gdwrfld ',status
        write(*,*)'Write to field Time '
        write(*,*)'status=gdwrfld(gdid_utm,"Time",start1d,stride1d,edge1       &
     1d,utmtmeray)'
        write(*,*)'Status returned by call to gdwrfld ',status
      endif
      write(10,*)' '
      write(*,*)' '

      start1d=0
      stride1d=1
      edge1d=80
      status=gdwrfld(gdid_utm,'Height',start1d,stride1d,edge1d,utmhght)
      if (status .lt. zero) then
         write(*,230)
         write(10,230)
        call heprnt(0)
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
        write(10,*)'Write to field Height '
        write(10,*)'status=gdwrfld(gdid_utm,"Height",start1d,stride1d,ed       &
     1ge1d,utmhght)'
        write(10,*)'Status returned by call to gdwrfld ',status
        write(*,*)'Write to field Height '
        write(*,*)'status=gdwrfld(gdid_utm,"Height",start1d,stride1d,edg       &
     1e1d,utmhght)'
        write(*,*)'Status returned by call to gdwrfld ',status
      endif
      write(10,*)' '
      write(*,*)' '

      start1d=0
      stride1d=1
      edge1d=250
      status=gdwrfld(gdid_utm,'Grounding',start1d,stride1d,edge1d,ray3)
      if (status .lt. zero) then
         write(*,230)
         write(10,230)
        call heprnt(0)
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
        write(10,*)'Write to field Grounding '
        write(10,*)'status=gdwrfld(gdid_utm,"Grounding",start1d,stride1d       &
     1,edge1d,ray3)'
        write(10,*)'Value returned by gdwrfld ', status
        write(*,*)'Write to field Grounding '
        write(*,*)'status=gdwrfld(gdid_utm,"Grounding",start1d,stride1d,       &
     1edge1d,ray3)'
        write(*,*)'Value returned by gdwrfld ', status
      endif
        write(10,*)' '
        write(*,*)' '

c Test Case -- gdsettleche
c
      write(10,27)
      write(10,*)'Testing gdsettleche... '
      write(10,*)'=================='
      write(*,*)'Testing gdsettleche... '
      write(*,*)'=================='

      status = gdsettleche(gdid_utm,'SideB',5,0)
      if (status .lt. zero) then
         write(*,230)
         write(10,230)
        call heprnt(0)
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
        write(10,*)'Set tile cache parameters '
        write(10,*)'status = gdsettleche(gdid_utm,"SideB",5,0)'
        write(10,*)'Status returned by call to gdsettleche ',status
        write(*,*)'Set tile cache parameters '
        write(*,*)'status = gdsettleche(gdid_utm,"SideB",5,0)'
        write(*,*)'Status returned by call to gdsettleche ',status
      endif
        write(10,*)' '
        write(*,*)' '

c Test Case -- gdwrtle
c
      write(10,27)
      write(10,*)'Testing gdwrtle... '
      write(10,*)'=================='
      write(*,*)'Testing gdwrtle... '
      write(*,*)'=================='

      do 53 ii=1,5
         do 54 i=1,4
            status = gdwrtle(gdid_utm,'SideB',tilecords,tileray)
            if (status .lt. zero) then
               write(*,230)
               write(10,230)
               call heprnt(0)
            else
               write(*,*)' '
               write(*,240)
               write(10,*)' '
               write(10,240)
              write(10,*)'Writing tiled field '
              write(10,*)'Writing tile section ',tilecords(1),' ',tileco       &
     1rds(2)
              write(*,*)'Writing tiled field '
              write(*,*)'Status returned by gdwrtle ',status
              write(*,*)'Writing tile section ',tilecords(1),' ',tilecor       &
     1ds(2)
            endif
            tilecords(2) = tilecords(2) + 1
   54    continue
         tilecords(2) = 0
         tilecords(1) = tilecords(1) + 1
   53 continue

      status = gddetach(gdid_utm)
      if (status .lt. zero) then
         write(*,230)
         write(10,230)
         call heprnt(0)
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(10,*)'status = gddetach(gdid_utm)'
         write(10,*)'Value of status returned by gddetach ',status
         write(*,*)'status = gddetach(gdid_utm)'
         write(*,*)'Value of status returned by gddetach ',status
      endif
      write(10,*)' '
      write(*,*)' '

      gdid_utm = gdattach(gdfid, 'UTMGrid')
      if (status .lt. zero) then
         write(*,230)
         write(10,230)
         call heprnt(0)
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(10,*)'gdid_utm = gdattach(gdfid, "UTMGrid")'
         write(10,*)'Grid id returned by gdattach ',gdid_utm
         write(*,*)'gdid_utm = gdattach(gdfid, "UTMGrid")'
         write(*,*)'Grid id returned by gdattach ',gdid_utm
      endif
      write(10,*)' '
      write(*,*)' '

c Test Case -- gdwrattr
c
      write(10,27)
      write(10,*)'Testing gdwrattr... '
      write(10,*)'=================='
      write(*,*)'Testing gdwrattr... '
      write(*,*)'=================='

      status = gdwrattr(gdid_utm, 'Resistance', DFNT_INT32, 4, attr)
      if (status .lt. zero) then
         write(*,230)
         write(10,230)
         call heprnt(0)
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(10,*)'status=gdwrattr(gdid_utm,"Resistance",DFNT_INT32,4,       &
     1attr)'
         write(10,*)'Returned from gdwrattr ', status
         write(*,*)'status=gdwrattr(gdid_utm,"Resistance",DFNT_INT32,4,a       &
     1ttr)'
         write(*,*)'Returned from gdwrattr ', status
      endif
      write(10,*)' '
      write(*,*)' '

      status = gddetach(gdid_utm)
      if (status .lt. zero) then
         write(*,230)
         write(10,230)
         call heprnt(0)
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(10,*)'status = gddetach(gdid_utm)'
         write(10,*)'Returned from gddetach ', status
         write(*,*)'status = gddetach(gdid_utm)'
         write(*,*)'Returned from gddetach ', status
      endif
      write(10,*)' '
      write(*,*)' '

      status = gddetach(gdid2)
      if (status .lt. zero) then
         write(*,231)
         write(10,231)
         call heprnt(0)
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(10,*)'status = gddetach(gdid2)'
         write(10,*)'Value returned by gddetach ', status
         write(*,*)'status = gddetach(gdid2)'
         write(*,*)'Value returned by gddetach ', status
      endif
      write(10,*)' '
      write(*,*)' '

c Test Case -- gdclose
c
      write(10,27)
      write(10,*)'Testing gdclose... '
      write(10,*)'=================='
      write(*,*)'Testing gdclose... '
      write(*,*)'=================='

      status = gdclose(gdfid2)
      if (status .lt. zero) then
         write(*,231)
         write(10,231)
         call heprnt(0)
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(10,*)'status = gdclose(gdfid2)'
         write(10,*)'Value returned by gdclose ', status
         write(*,*)'status = gdclose(gdfid2)'
         write(*,*)'Value returned by gdclose ', status
      endif
      write(10,*)' '
      write(*,*)' '

      status = gdclose(gdfid)
      if (status .lt. zero) then
         write(*,230)
         write(10,230)
         call heprnt(0)
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(10,*)'status = gdclose(gdfid)'
         write(10,*)'Returned from gdclose ', status
         write(*,*)'status = gdclose(gdfid)'
         write(*,*)'Returned from gdclose ', status
      endif
      write(10,*)' '
      write(*,*)' '

      
      gdfid = gdopen('Gridf_Test.hdf', DFACC_RDWR)
      if (gdfid .lt. zero) then
         write(*,230)
         write(10,230)
         call heprnt(0)
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(*,*)'gdfid = gdopen("Gridf_Test.hdf", DFACC_RDWR)'
         write(10,*)'gdfid = gdopen("Gridf_Test.hdf", DFACC_RDWR)'
         write(*,*)'Grid file id returned by gdopen ',gdfid
         write(10,*)'Grid file id returned by gdopen ',gdfid
      endif
      write(10,*)' '
      write(*,*)' '

      gdid_utm = gdattach(gdfid, 'UTMGrid')
      if (gdid_utm .lt. zero) then
         write(*,230)
         write(10,230)
         call heprnt(0)
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(*,*)'gdid_utm = gdattach(gdfid, "UTMGrid")'
         write(10,*)'gdid_utm = gdattach(gdfid, "UTMGrid")'
         write(*,*)'Grid id returned by gdattach ',gdid_utm
         write(10,*)'Grid id returned by gdattach ',gdid_utm
      endif
      write(10,*)' '
      write(*,*)' '

c Test Case -- gdinqgrid
c
      write(10,27)
      write(10,*)'Testing gdinqgrid... '
      write(10,*)'=================='
      write(*,*)'Testing gdinqgrid... '
      write(*,*)'=================='

      lstatus = gdinqgrid('Gridf_Test.hdf',grdnames,strbufsize)
      if (lstatus .lt. zero) then
         write(*,230)
         write(10,230)
         call heprnt(0)
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(*,*)'lstatus = gdinqgrid("Gridf_Test.hdf",grdnames,strbuf       &
     1size)'
         write(*,*)'Names of grids ',grdnames
         write(*,*)'Number of grids ',lstatus
         write(*,*)'Size of names of grids ',strbufsize
         write(10,*)'lstatus = gdinqgrid("Gridf_Test.hdf",grdnames,strbu       &
     1fsize)'
         write(10,*)'Names of grids ',grdnames
         write(10,*)'Number of grids ',lstatus
         write(10,*)'Size of names of grids ',strbufsize
      endif
      write(10,*)' '
      write(*,*)' '

c Test Case -- gdorginfo
c
      write(10,27)
      write(10,*)'Testing gdorginfo... '
      write(10,*)'=================='
      write(*,*)'Testing gdorginfo... '
      write(*,*)'=================='

      lstatus = gdorginfo(gdid_utm, tmpvar1)
      if (lstatus .lt. zero) then
         write(*,230)
         write(10,230)
         call heprnt(0)
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(*,*)'lstatus = gdorginfo(gdid_utm, tmpvar1)'
         write(10,*)'lstatus = gdorginfo(gdid_utm, tmpvar1)'
         write(*,*)'Value returned by gdorginfo ',lstatus
         write(10,*)'Value returned by gdorginfo ',lstatus
      endif
      write(10,*)' '
      write(*,*)' '

c Test Case -- gdpreginfo
c
      write(10,27)
      write(10,*)'Testing gdpreginfo... '
      write(10,*)'=================='
      write(*,*)'Testing gdpreginfo... '
      write(*,*)'=================='

      lstatus = gdpreginfo(gdid_utm, tmpvar1)
      if (lstatus .lt. zero) then
         write(*,230)
         write(10,230)
         call heprnt(0)
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(*,*)'lstatus = gdpreginfo(gdid_utm, tmpvar1)'
         write(10,*)'lstatus = gdpreginfo(gdid_utm, tmpvar1)'
         write(*,*)'Value returned by gdpreginfo ',lstatus
         write(10,*)'Value returned by gdpreginfo ',lstatus
      endif
      write(10,*)' '
      write(*,*)' '

c Test Case -- gdinqdims
c
      write(10,27)
      write(10,*)'Testing gdinqdims... '
      write(10,*)'=================='
      write(*,*)'Testing gdinqdims... '
      write(*,*)'=================='

      lstatus = gdinqdims(gdid_utm, dimname, dims)
      if (lstatus .lt. zero) then
         write(*,230)
         write(10,230)
         call heprnt(0)
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(*,*)'lstatus = gdinqdims(gdid_utm, dimname, dims)'
         write(*,*)'Number of dimensions ',lstatus
         write(*,*)'Dimensions in grid UTM ',dimname
         write(*,*)'Size of dimensions '
         write(10,*)'lstatus = gdinqdims(gdid_utm, dimname, dims)'
         write(10,*)'Number of dimensions ',lstatus
         write(10,*)'Dimensions in grid UTM ',dimname
         write(10,*)'Size of dimensions '
         do 130 i=1,lstatus
            write(*,*)' ',dims(i)
            write(10,*)' ',dims(i)
 130     continue
      endif
      write(10,*)' '
      write(*,*)' '

c Test Case -- gddiminfo
c
      write(10,27)
      write(10,*)'Testing gddiminfo... '
      write(10,*)'=================='
      write(*,*)'Testing gddiminfo... '
      write(*,*)'=================='

      lstatus = gddiminfo(gdid_utm, 'Conduction')
      if (lstatus .lt. zero) then
         write(*,230)
         write(10,230)
         call heprnt(0)
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(*,*)'lstatus = gddiminfo(gdid_utm, "Conduction")'
         write(*,*)'Size of dimension Conduction ',lstatus
         write(10,*)'lstatus = gddiminfo(gdid_utm, "Conduction")'
         write(10,*)'Size of dimension Conduction ',lstatus
      endif
      write(10,*)' '
      write(*,*)' '

c Test Case -- gdgridinfo
c
      write(10,27)
      write(10,*)'Testing gdgridinfo... '
      write(10,*)'=================='
      write(*,*)'Testing gdgridinfo... '
      write(*,*)'=================='

      status=gdgridinfo(gdid_utm,xdimsize,ydimsize,upleftpt,lowrtpt)
      if (status .lt. zero) then
         write(*,230)
         write(10,230)
         call heprnt(0)
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(*,*)'status=gdgridinfo(gdid_utm,xdimsize,ydimsize,upleftp       &
     1t,lowrtpt)'
         write(*,*)'Status returned by gdgridinfo ',status
         write(*,11)'X dim size ',xdimsize, ' Y dim size ',ydimsize
         write(*,12)'Upper left pt ',upleftpt(1),' ',upleftpt(2)
         write(*,12)'Lower right pt ',lowrtpt(1),' ',lowrtpt(2)
         write(10,*)'status=gdgridinfo(gdid_utm,xdimsize,ydimsize,upleft       &
     1pt,lowrtpt)'
         write(10,*)'Value returned by gdgridinfo ',status
         write(10,*)'X dim size ',xdimsize, ' Y dim size ',ydimsize
         write(10,*)'Upper left pt ',upleftpt(1),upleftpt(2)
         write(10,*)'Lower right pt ',lowrtpt(1),lowrtpt(2)
      endif
      write(10,*)' '
      write(*,*)' '
   11 format(a,i2,a,i2)
   12 format(a,f14.5,a,f14.5)

c Test Case -- gdprojinfo
c
      write(10,27)
      write(10,*)'Testing gdprojinfo... '
      write(10,*)'=================='
      write(*,*)'Testing gdprojinfo... '
      write(*,*)'=================='

      status = gdprojinfo(gdid_utm,pcode,zcode,scode,pparm)
      if (status .lt. zero) then
         write(*,230)
         write(10,230)
         call heprnt(0)
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(*,*)'status = gdprojinfo(gdid_utm,pcode,zcode,scode,pparm       &
     1)'
         write(*,*)'Status returned by gdprojinfo ',status
         write(*,*)'Projection code ',pcode, ' Zone code ',zcode
         write(*,*)'Sphere code ',scode
         write(10,*)'status = gdprojinfo(gdid_utm,pcode,zcode,scode,ppar       &
     1m)'
         write(10,*)'Value returned by gdprojinfo ',status
         write(10,*)'Projection code ',pcode, ' Zone code ',zcode
         write(10,*)'Sphere code ',scode
         do 140 i=1,16
            write(*,55)' ',pparm(i)
            write(10,55)' ',pparm(i)
 140     continue
      endif
   55 format(a,f5.2)
      write(10,*)' '
      write(*,*)' '

c Test Case -- gdcompinfo
c
      write(10,27)
      write(10,*)'Testing gdcompinfo... '
      write(10,*)'=================='
      write(*,*)'Testing gdcompinfo... '
      write(*,*)'=================='

      status = gdcompinfo(gdid_utm,'Voltage',compcode,compparm)
      if (status .lt. zero) then
         call heprnt(0)
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
        write(10,*)'status = gdcompinfo(gdid_utm,"Voltage",compcode,comp       &
     1parm)'
        write(10,*)'Compression info for field Voltage'
        write(10,*)'Comp code ',compcode
        write(10,*)'Compression parameters ',compparm
        write(*,*)'status = gdcompinfo(gdid_utm,"Voltage",compcode,compp       &
     1arm)'
        write(*,*)'Compression info for field Voltage'
        write(*,*)'Comp code ',compcode
        write(*,*)'Compression parameters ',compparm
      endif

c Test Case -- gdtleinfo
c
      write(10,27)
      write(10,*)'Testing gdtleinfo... '
      write(10,*)'=================='
      write(*,*)'Testing gdtleinfo... '
      write(*,*)'=================='

      status = gdtleinfo(gdid_utm,'SideB',tilecode,tilerank,itiledims)
      if (status .lt. zero) then
        write(10,*)'**********Error unexpected***********'
        write(*,*)'**********Error unexpected***********'
        call heprnt(0)
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
        write(10,*)'status = gdtleinfo(gdid_utm,"SideB",tilecode,tileran       &
     1k,itiledims)'
        write(10,*)'Retrieve tile information '
        write(10,*)'Tile info for field SideB '
        write(10,*)'Tile code ',tilecode,' rank ',tilerank,' dims ',itil       &
     1edims(1),' ',itiledims(2)
        write(*,*)'status = gdtleinfo(gdid_utm,"SideB",tilecode,tilerank       &
     1,itiledims)'
        write(*,*)'Retrieve tile information '
        write(*,*)'Tile info for field SideB '
        write(*,*)'Tile code ',tilecode, ' rank ',tilerank,' dims ',itil       &
     1edims(1),' ',itiledims(2)
      endif
      write(10,*)' '
      write(*,*)' '

c Test Case -- gdrdtle
c
      write(10,27)
      write(10,*)'Testing gdrdtle... '
      write(10,*)'=================='
      write(*,*)'Testing gdrdtle... '
      write(*,*)'=================='

      tilecords(1) = 0
      tilecords(2) = 0
      status = gdrdtle(gdid_utm,'SideB',tilecords,tilebuffer)
      if (status .lt. zero) then
        write(10,*)'**********Error unexpected***********'
        write(*,*)'**********Error unexpected***********'
        call heprnt(0)
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(10,*)'Read a tile from field SideB'
         write(*,*)'Read a tile from field SideB'
         write(*,*)'status = gdrdtle(gdid_utm,"SideB",tilecords,tilebuff       &
     1er)'
         write(10,*)'status = gdrdtle(gdid_utm,"SideB",tilecords,tilebuf       &
     1fer)'
        do 62 ii=1,6
           do 63 i=1,5
              write(10,*)'SideB value at ',ii,' ',i,'  ',tilebuffer(ii+i       &
     1)
              write(*,2)'SideB value at ',ii,' ',i,'  ',tilebuffer(ii+i)       &
   63      continue
   62   continue
      endif
    2 format(a,i2,a,i2,a,i4)
      write(10,*)' '
      write(*,*)' '
        

c Test Case -- gdinqflds
c
      write(10,27)
      write(10,*)'Testing gdinqflds... '
      write(10,*)'=================='
      write(*,*)'Testing gdinqflds... '
      write(*,*)'=================='

      nflds = gdinqflds(gdid_utm,fldlist,rnk,numtype)
      if (nflds .lt. zero) then
        write(10,*)'**********Error unexpected***********'
        write(*,*)'**********Error unexpected***********'
        call heprnt(0)
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(*,*)'nflds = gdinqflds(gdid_utm,fldlist,rnk,numtype)'
         write(*,*)'Number of fields ',nflds
         write(10,*)'nflds = gdinqflds(gdid_utm,fldlist,rnk,numtype)'
         write(10,*)'Number of fields ',nflds
         if (nflds .ne. 0) then
            write(*,*)'Fields ',fldlist
            write(10,*)'Fields ',fldlist
            do 150 i=1,nflds
               write(*,*)'Rank and type ',rnk(i), ' ', numtype(i)
               write(10,*)'Rank and type ',rnk(i), ' ', numtype(i)
  150       continue
         endif
      endif
      write(10,*)' '
      write(*,*)' '

c Test Case -- gdfldinfo
c
      write(10,27)
      write(10,*)'Testing gdfldinfo... '
      write(10,*)'=================='
      write(*,*)'Testing gdfldinfo... '
      write(*,*)'=================='

      status = gdfldinfo(gdid_utm,'Drift',rnk,dims,numtype,dimname)
      if (status .lt. zero) then
        write(10,*)'**********Error unexpected***********'
        write(*,*)'**********Error unexpected***********'
        call heprnt(0)
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(*,*)'status = gdfldinfo(gdid_utm,"Drift",rnk,dims,numtype       &
     1,dimname)'
         write(*,*)'Value returned by gdfldinfo for field Drift ',status
         write(*,*)'Drift rank ',rnk(1)
         write(*,*)'Dimensions  ',dims(1),' ',dims(2)
         write(*,*)'Number type of field ',numtype(1)
         write(*,*)'Dimension names ',dimname
         write(10,*)'status = gdfldinfo(gdid_utm,"Drift",rnk,dims,numtyp       &
     1e,dimname)'
         write(10,*)'Value returned by gdfldinfo for field Drift ',statu       &     1s
         write(10,*)'Drift rank ',rnk(1)
      endif
      write(10,*)' '
      write(*,*)' '

c Test Case -- gdrdfld
c
      write(10,27)
      write(10,*)'Testing gdrdfld... '
      write(10,*)'=================='
      write(*,*)'Testing gdrdfld... '
      write(*,*)'=================='

      start(1) = 0
      start(2) = 0
      stride(1) = 1
      stride(2) = 1
      edge(1) = 60
      edge(2) = 80
      status = gdrdfld(gdid_utm,'Drift',start,stride,edge,tempray)
      if (status .lt. zero) then
        write(10,*)'**********Error unexpected***********'
        write(*,*)'**********Error unexpected***********'
        call heprnt(0)
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(*,*)'status = gdrdfld(gdid_utm,"Drift",start,stride,edge,       &
     1tempray)'
         write(*,*)'Value returned by gdrdfld ',status
         write(10,*)'status = gdrdfld(gdid_utm,"Drift",start,stride,edge       &
     1,tempray)'
         write(10,*)'Value returned by gdrdfld ',status
      endif
      write(10,*)' '
      write(*,*)' '

c Test Case -- gdnentries
c
      write(10,27)
      write(10,*)'Testing gdnentries... '
      write(10,*)'=================='
      write(*,*)'Testing gdnentries... '
      write(*,*)'=================='

      n = gdnentries(gdid_utm, HDFE_NENTDIM, strbufsize)
      if (n .lt. zero) then
        write(10,*)'**********Error unexpected***********'
        write(*,*)'**********Error unexpected***********'
        call heprnt(0)
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(*,*)'n = gdnentries(gdid_utm, HDFE_NENTDIM, strbufsize)'
         write(*,*)'Number of dimensions ', n
         write(*,*)'Size of Dimension string ',strbufsize
         write(10,*)'n = gdnentries(gdid_utm, HDFE_NENTDIM, strbufsize)'
         write(10,*)'Number of dimensions ', n
         write(10,*)'Size of Dimension string ',strbufsize
      endif

      n = gdnentries(gdid_utm,HDFE_NENTDFLD,strbufsize)
      if (n .lt. zero) then
        write(10,*)'**********Error unexpected***********'
        write(*,*)'**********Error unexpected***********'
        call heprnt(0)
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(*,*)'n = gdnentries(gdid_utm,HDFE_NENTDFLD,strbufsize)'
         write(*,*)'Number of data fields ',n
         write(10,*)'n = gdnentries(gdid_utm,HDFE_NENTDFLD,strbufsize)'
         write(10,*)'Number of data fields ',n
      endif
      write(10,*)' '
      write(*,*)' '

c Test Case -- gdattrinfo
c
      write(10,27)
      write(10,*)'Testing gdattrinfo... '
      write(10,*)'=================='
      write(*,*)'Testing gdattrinfo... '
      write(*,*)'=================='

      status = gdattrinfo(gdid_utm,'Resistance',tmpvar1,tmpvar2)
      if (status .lt. zero) then
        write(10,*)'**********Error unexpected***********'
        write(*,*)'**********Error unexpected***********'
        call heprnt(0)
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(*,*)'status = gdattrinfo(gdid_utm,"Resistance",tmpvar1,tm       &
     1pvar2)'
         write(*,*)'Value returned by gdattrinfo ',status
         write(*,*)'Number type of attribute ',tmpvar1
         write(*,*)'Number of total bytes in attribute ',tmpvar2
         write(10,*)'status = gdattrinfo(gdid_utm,"Resistance",tmpvar1,t       &
     1mpvar2)'
         write(10,*)'Value returned by gdattrinfo ',status
         write(10,*)'Number type of attribute ',tmpvar1
         write(10,*)'Number of total bytes in attribute ',tmpvar2
      endif
      write(10,*)' '
      write(*,*)' '

c Test Case -- gdrdattr
c
      write(10,27)
      write(10,*)'Testing gdrdattr... '
      write(10,*)'=================='
      write(*,*)'Testing gdrdattr... '
      write(*,*)'=================='

      status = gdrdattr(gdid_utm,'Resistance',iattr)
      if (status .lt. zero) then
        write(10,*)'**********Error unexpected***********'
        write(*,*)'**********Error unexpected***********'
        call heprnt(0)
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
        write(*,*)'status = gdrdattr(gdid_utm,"Resistance",iattr)'
        write(*,*)'Value returned by gdrdattr ',status
        write(10,*)'status = gdrdattr(gdid_utm,"Resistance",iattr)'
        write(10,*)'Value returned by gdrdattr ',status
      endif
      write(10,*)' '
      write(*,*)' '
  
c Test Case -- gdinqattrs
c
      write(10,27)
      write(10,*)'Testing gdinqattrs... '
      write(10,*)'=================='
      write(*,*)'Testing gdinqattrs... '
      write(*,*)'=================='

      lstatus = gdinqattrs(gdid_utm, attrlist,tmpvar1)
      if (lstatus .lt. zero) then
        write(10,*)'**********Error unexpected***********'
        write(*,*)'**********Error unexpected***********'
        call heprnt(0)
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
        write(*,*)'lstatus = gdinqattrs(gdid_utm, attrlist,tmpvar1)'
        write(*,*)'Value returned by gdinqattrs ',lstatus
        write(*,*)'List of attributes ',attrlist
        write(10,*)'lstatus = gdinqattrs(gdid_utm, attrlist,tmpvar1)'
        write(10,*)'Value returned by gdinqattrs ',lstatus
        write(10,*)'List of attributes ',attrlist
      endif
      write(10,*)' '
      write(*,*)' '

c Test Case -- gdgetfill
c
      write(10,27)
      write(10,*)'Testing gdgetfill... '
      write(10,*)'=================='
      write(*,*)'Testing gdgetfill... '
      write(*,*)'=================='

      status = gdgetfill(gdid_utm,'Drift',ifillv)
      if (status .lt. zero) then
        write(10,*)'**********Error unexpected***********'
        write(*,*)'**********Error unexpected***********'
        call heprnt(0)
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(*,*)'status = gdgetfill(gdid_utm,"Drift",ifillv)'
         write(*,*)'Value returned by gdgetfill ',status
         write(*,*)'Fill value ',ifillv
         write(10,*)'status = gdgetfill(gdid_utm,"Drift",ifillv)'
         write(10,*)'Value returned by gdgetfill ',status
         write(10,*)'Fill value ',ifillv
      endif
      write(10,*)' '
      write(*,*)' '

c Test Case -- gddefboxreg
c
      write(10,27)
      write(10,*)'Testing gddefboxreg... '
      write(10,*)'=================='
      write(*,*)'Testing gddefboxreg... '
      write(*,*)'=================='

      corlon(1)=-126.0
      corlon(2)=-121.5
      corlat(1)=-70.0
      corlat(2)=-65.0

      regionid = gddefboxreg(gdid_utm,corlon,corlat)
      if (regionid .lt. zero) then
        write(10,*)'**********Error unexpected***********'
        write(*,*)'**********Error unexpected***********'
        call heprnt(0)
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(*,*)'regionid = gddefboxreg(gdid_utm,corlon,corlat)'
         write(*,*)'Region id returned by gddefboxreg ',regionid
         write(10,*)'regionid = gddefboxreg(gdid_utm,corlon,corlat)'
         write(10,*)'Region id returned by gddefboxreg ',regionid
      endif
      write(10,*)' '
      write(*,*)' '

c Test Case -- gdreginfo
c
      write(10,27)
      write(10,*)'Testing gdreginfo... '
      write(10,*)'=================='
      write(*,*)'Testing gdreginfo... '
      write(*,*)'=================='

      status = gdreginfo(gdid_utm,regionid,'Impedance',nt,rk,dims,size,i       &
     1uplft,ilrgt)
      if (status .lt. zero) then
        write(10,*)'**********Error unexpected***********'
        write(*,*)'**********Error unexpected***********'
        call heprnt(0)
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(*,*)'status = gdreginfo(gdid_utm,regionid,"Impedance",nt,       &
     1rk,dims,size,iuplft,ilrgt)'
         write(*,*)'Value returned by gdreginfo ',status
         write(*,*)'Number type of region ',nt
         write(*,*)'Rank of region ',rk
         write(*,*)'Size of region ',size
         write(*,11)'Dimensions of region',dims(1),' ',dims(2)
         write(*,12)'Upper left point of region ',iuplft(1),' ',iuplft(2       &
     1)
         write(*,12)'Lower right point of region ',ilrgt(1),' ',ilrgt(2)
         write(10,*)'status = gdreginfo(gdid_utm,regionid,"Impedance",nt       &
     1,rk,dims,size,iuplft,ilrgt)'
         write(10,*)'Value returned by gdreginfo ',status
         write(10,*)'Number type of region ',nt
         write(10,*)'Rank of region ',rk
         write(10,*)'Size of region ',size
         write(10,11)'Dimensions of region',dims(1),' ',dims(2)
         write(10,12)'Upper left point of region ',iuplft(1),' ',iuplft(       &
     12)
         write(10,12)'Lower right point of region ',ilrgt(1),' ',ilrgt(2       &
     1)
      endif
      write(10,*)' '
      write(*,*)' '

c Test Case -- gdextreg
c
      write(10,27)
      write(10,*)'Testing gdextreg... '
      write(10,*)'=================='
      write(*,*)'Testing gdextreg... '
      write(*,*)'=================='

      status = gdextreg(gdid_utm,regionid,'Impedance',datbuf)
      if (status .lt. zero) then
        write(10,*)'**********Error unexpected***********'
        write(*,*)'**********Error unexpected***********'
        call heprnt(0)
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(*,*)'status = gdextreg(gdid_utm,regionid,"Impedance",datb       &
     1uf)'
         write(*,*)'Value returned by gdextreg ',status
         write(10,*)'status = gdextreg(gdid_utm,regionid,"Impedance",dat       &
     1buf)'
         write(10,*)'Value returned by gdextreg ',status
         do 175 i=100,150
            write(*,*)'Value of region ',datbuf(i)
            write(10,*)'Value of region ',datbuf(i)
  175    continue
      endif
      write(10,*)' '
      write(*,*)' '

c Test Case -- gddeftmeper
c
      write(10,27)
      write(10,*)'Testing gddeftmeper... '
      write(10,*)'=================='
      write(*,*)'Testing gddeftmeper... '
      write(*,*)'=================='

      periodid = gddeftmeper(gdid_utm,HDFE_NOPREVSUB,starttime,stoptime)
      if (periodid .lt. zero) then
        write(10,*)'**********Error unexpected***********'
        write(*,*)'**********Error unexpected***********'
        call heprnt(0)
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
        write(10,*)'periodid = gddeftmeper(gdid_utm,HDFE_NOPREVSUB,start       &
     1time,stoptime)'
        write(10,*)'Define a time period '
        write(10,*)'Period id returned by gddeftmeper ',periodid
        write(*,*)'periodid = gddeftmeper(gdid_utm,HDFE_NOPREVSUB,startt       &
     1ime,stoptime)'
        write(*,*)'Define a time period '
        write(*,*)'Period id returned by gddeftmeper ',periodid
      endif
      write(10,*)' '
      write(*,*)' '

c Test Case -- gddefvrtreg
c
      write(10,27)
      write(10,*)'Testing gddefvrtreg... '
      write(10,*)'=================='
      write(*,*)'Testing gddefvrtreg... '
      write(*,*)'=================='

      regionid = gddefvrtreg(gdid_utm,HDFE_NOPREVSUB,'Height',range)
      if (regionid .lt. zero) then
        write(10,*)'**********Error unexpected***********'
        write(*,*)'**********Error unexpected***********'
        call heprnt(0)
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
        write(10,*)'regionid = gddefvrtreg(gdid_utm,HDFE_NOPREVSUB,"Heig       &
     1ht",range)'
        write(10,*)'Define a vertical region '
        write(10,*)'Region id returned by gddefvrtreg ',regionid
        write(*,*)'regionid = gddefvrtreg(gdid_utm,HDFE_NOPREVSUB,"Heigh       &
     1t",range)'
        write(*,*)'Define a vertical region '
        write(*,*)'Region id returned by gddefvrtreg ',regionid
      endif
      write(10,*)' '
      write(*,*)' '

c Test Case -- gddupreg
c
      write(10,27)
      write(10,*)'Testing gddupreg... '
      write(10,*)'=================='
      write(*,*)'Testing gddupreg... '
      write(*,*)'=================='

      regionid2 = gddupreg(regionid)
      if (regionid2 .lt. zero) then
        write(10,*)'**********Error unexpected***********'
        write(*,*)'**********Error unexpected***********'
        call heprnt(0)
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
        write(10,*)'regionid2 = gddupreg(regionid)'
        write(10,*)'Generate a new region id '
        write(10,*)'New region id ',regionid2
        write(*,*)'regionid2 = gddupreg(regionid)'
        write(*,*)'Generate a new region id '
        write(*,*)'New region id ',regionid2
      endif
      write(10,*)' '
      write(*,*)' '

c Test Case -- gdgetpix
c
      write(10,27)
      write(10,*)'Testing gdgetpix... '
      write(10,*)'=================='
      write(*,*)'Testing gdgetpix... '
      write(*,*)'=================='

      status = gdgetpix(gdid_utm,5,lonval,latval,rowval,colval)             
      if (status .lt. zero) then
        write(10,*)'**********Error unexpected***********'
        write(*,*)'**********Error unexpected***********'
        call heprnt(0)
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
        write(10,*)'status = gdgetpix(gdid_utm,5,lonval,latval,rowval,co       &
     1lval)'
        write(10,*)'Retrieve pixel row. column values '
        write(*,*)'status = gdgetpix(gdid_utm,5,lonval,latval,rowval,col       &
     1val)'
        write(*,*)'Retrieve pixel row. column values '
        do 37 i=1,5
           write(10,5)'Pixel position lon lat ',lonval(i),' ',                 &
     1latval(i),' ','Row Column ',rowval(i),' ',colval(i) 
           write(*,5)'Pixel position lon lat ',lonval(i),' ',                  &
     1latval(i),' ','Row Column ',rowval(i),' ',colval(i) 
   37   continue
      endif
    5 format(a,f6.1,a,f6.1,a,a,i2,a,i2)
      write(10,*)' '
      write(*,*)' '

c Test Case -- gdgetpixval
c
      write(10,27)
      write(10,*)'Testing gdgetpixval... '
      write(10,*)'=================='
      write(*,*)'Testing gdgetpixval... '
      write(*,*)'=================='

      lstatus = gdgetpixval(gdid_utm,5,rowval,colval,"Voltage",fldval)
      if (lstatus .lt. zero) then
        write(10,*)'**********Error unexpected***********'
        write(*,*)'**********Error unexpected***********'
        call heprnt(0)
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
        write(10,*)'lstatus = gdgetpixval(gdid_utm,5,rowval,colval,"Volt       &
     1age",fldval)'
        write(10,*)'Retrieve pixel values for specific locations '
        write(*,*)'lstatus = gdgetpixval(gdid_utm,5,rowval,colval,"Volta       &
     1ge",fldval)'
        write(*,*)'Retrieve pixel values for specific locations '
        do 42 i=1,5
           write(10,17)'Row Col ',rowval(i),' ',colval(i),' ','Pixel Val       &
     1ue ',fldval(i)
           write(*,17)'Row Col ',rowval(i),' ',colval(i),' ','Pixel Valu       &
     1e ',fldval(i)
   42   continue
      endif
   17 format(a8,i2,a1,i2,a1,a12,f9.3)
      write(10,*)' '
      write(*,*)' '


c Test Case -- gdinterpolate
c
      write(10,27)
      write(10,*)'Testing gdinterpolate... '
      write(10,*)'=================='
      write(*,*)'Testing gdinterpolate... '
      write(*,*)'=================='

      lstatus=gdinterpolate(gdid_utm,5,lonval,latval,'Voltage',interval)
      if (lstatus .lt. zero) then
        write(10,*)'**********Error unexpected***********'
        write(*,*)'**********Error unexpected***********'
        call heprnt(0)
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
        write(10,*)'lstatus=gdinterpolate(gdid_utm,5,lonval,latval,"Volt       &
     1age",interval)'
        write(10,*)'Interpolate 5 values for field Voltage '
        write(*,*)'lstatus=gdinterpolate(gdid_utm,5,lonval,latval,"Volta       &
     1ge",interval)'
        write(*,*)'Interpolate 5 values for field Voltage '
        write(*,*)'Status returned by call to gdinterpolate ',lstatus
        do 38 index1=1,5
           write(*,4)'Interpolated value ',interval(index1,1)
           write(10,4)'Interpolated value ',interval(index1,1)
   38   continue
      endif
    4 format(a,f9.3)
      write(10,*)' '
      write(*,*)' '


      status = gddetach(gdid_utm)
      if (status .lt. zero) then
        write(10,*)'**********Error unexpected***********'
        write(*,*)'**********Error unexpected***********'
        call heprnt(0)
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(*,*)'status = gddetach(gdid_utm)'
         write(*,*)'Value returned by gddetach ',status
         write(10,*)'status = gddetach(gdid_utm)'
         write(10,*)'Value returned by gddetach ',status
      endif

      status = gdclose(gdfid)
      if (status .lt. zero) then
        write(10,*)'**********Error unexpected***********'
        write(*,*)'**********Error unexpected***********'
        call heprnt(0)
      else
         write(*,*)' '
         write(*,240)
         write(10,*)' '
         write(10,240)
         write(*,*)'status = gdclose(gdfid)'
         write(*,*)'Returned from gdclose ', status
         write(10,*)'status = gdclose(gdfid)'
         write(10,*)'Returned from gdclose ', status
      endif

      close(unit=10)
  27  format('')
      stop
      end

c
c	In this example we will retrieve (1) information about the
c	dimensions, (2) the dimension mappings (geolocation relations), 
c	and (3) the swath fields.
c 

	program inquireswath

	integer         i, swmapinfo, swfldinfo, status
	integer         swdetach, swclose
	integer*4       swinqdims, swinqmaps, swinqdflds, swinqgflds
	integer*4       swdiminfo, offset, incr, rk, nt
	integer*4       swimapinfo, swinqimaps
	integer*4       swfid, swid, ndims, nmaps, nflds
	integer*4       swopen, swattach
	integer*4       dims(32), off(32), inc(32), rank(32), ntype(32)
	integer*4       sizes(8), indx(32), dimsize
	character*72    dimname, dimmap, fieldlist, dimlist
	integer         DFACC_READ
	parameter        (DFACC_READ=1)

c
c	Open the Swath File for read only access
c

	swfid = swopen("SwathFile_created_with_hadeos_sample_file_write"//
     1"r_of_HDFEOS2_version_219_or_higher_release.hdf", DFACC_READ)

    
	if (swfid .NE. -1) then

c	   Attach the swath

	   swid = swattach(swfid, "Swath1")
	
	   if (swid .NE. -1) then


c	    Inquire Dimensions

	      ndims = swinqdims(swid, dimname, dims)

	      write(*,*) 'Dimension list: ', dimname
	      do i = 1,ndims
		 write(*,*) 'dim size: ', dims(i)
	      enddo
	      write(*,*)	      


c           Inquire Dimension Mappings

	      nmaps = swinqmaps(swid, dimmap, off, inc)

	      write(*,*) 'Dimension map: ', dimmap
	      do i = 1,nmaps
		 write(*,*) 'offset increment: ', off(i), inc(i)
	      enddo
	      write(*,*)

	      
	      
c	    Inquire Indexed Dimension Mappings

	      nmaps = swinqimaps(swid, dimmap, sizes)

	      write(*,*) 'Index Dimension map: ', dimmap
	      do i=1,nmaps
		 write(*,*) 'sizes: ', sizes(i)
	      enddo
	      write(*,*)	      

	     
c         Inquire Geolocation Fields
	    
	      nflds = swinqgflds(swid, fieldlist, rank, ntype)
	      write(*,*) 'Geolocation fieldlist: ', fieldlist
	      do i=1,nflds
		 write(*,*) 'field rank & datatype: ', rank(i), ntype(i)
	      enddo
	      write(*,*) 
	    
	      
c         Inquire Data Fields	      

	      nflds = swinqdflds(swid, fieldlist, rank, ntype)
	      write(*,*) 'Data Fieldlist: ', fieldlist
	      do i=1,nflds
		 write(*,*) 'field rank & datatype: ', rank(i), ntype(i)
	      enddo
	      write(*,*) 
	    



c	  Get info on "GeoTrack" dim

	      dimsize = swdiminfo(swid, "GeoTrack")
	      write(*,*) 'Size of GeoTrack: ', dimsize
	      write(*,*)
	      

c	  Get info on "GeoTrack/Res2tr" mapping

	      status = swmapinfo(swid, "GeoTrack", "Res2tr", offset,
     1                           incr)	      
	      write(*,*) 'Mapping Offset: ', offset
	      write(*,*) 'Mapping Increment: ', incr
	      write(*,*)


c	  Get info on "IndxTrack/Res2tr" indexed mapping

	      n = swimapinfo(swid, "IndxTrack", "Res2tr", indx)
	      do i=1,n
		 write(*,*) 'Index Mapping Entry ', i, indx(i)
	      enddo
	      write(*,*)
	      

c	  Get info on "Longitude" Field

	      status = swfldinfo(swid, "Longitude", rk, dims, nt, dimlist)
	      write(*,*) 'Longitude Rank: ', rk
	      write(*,*) 'Longitude NumberType: ', nt
	      write(*,*) 'Longitude Dimlist: ', dimlist
	      do i=1,rk
		 write(*,*) 'Dimension ',i,dims(i)
	      enddo
	     
	  endif
	endif
	
	status = swdetach(swid)
	status = swclose(swfid)
	stop
	end

c testswath.f
c In this program we create, define and write a simple swath hdfeos file
c using the swath interface
c
      program testswath

      integer index1, index2, swfid, swid, status
      integer swid2, rank, sd_id, sds1_id, sds2_id
      integer dim_id, strbufsize, nmaps, ndims, dimsize
      integer n, size
      integer start(2), stride(2), dataedge(2), geoedge(2)
      integer rdattr(4),geostart(2), attr(4)
      integer istart(2),iedge(2),dedge(2)
      integer indexmap(30), dimsizes(2)
      integer sd_start(2), sd_stride(2), sd_edge(2)
      integer rd_start(2), rd_stride(2), rd_edge(2)

      integer swdefdim, swdetach, swdefgfld, swdefdfld
      integer swdefmap, swwrfld, swwrattr, swclose, sfsdmname
      integer sfwdata, sfendacc, sfend, swwrdmeta, swwrgmeta
      integer swfldinfo,swmapinfo, swattrinfo, swrdfld
      integer swrdattr, swgetfill, swsetfill, swdefimap
      integer swreginfo, swextreg, swperinfo, swextper

      integer*4 swopen, swcreate, swattach, sfstart
      integer*4 swinqmaps, regionid
      integer*4 sfcreate, sfdimid, swnentries, swinqimaps
      integer*4 swinqdims, swinqgflds, swinqdflds, swdiminfo
      integer*4 swdefboxreg, swdeftmeper, swimapinfo

      integer*4 offset, inc, nt, zero,status4
      integer*4 ndxmap(2), rnk(4), ntype(4), dims(4),latdims(2)
      integer*4 idxmap(30)

      real ray1(100,40), ray2(100,40), lat(50,40), lon(50,40)
      real ray3(40,40), temp(100,40)
      real idxlat(30,30), idxlon(30,30)
      real latcnt, loncnt, raycnt, idxlatcnt, idxloncnt	
      real fillvalue, rdfilval, tempbuf(13000)

      real*8 cornerlon(2), cornerlat(2)
      real*8 twodtime(50,40)
      real*4 timeptr(1)
      equivalence(timeptr, twodtime)
      real*8 tmcnt,starttime, endtime

      character idxdimmap(39)
      character*(72) dimmap, dimname, fieldlist, dimens

      integer DFACC_CREATE
      parameter (DFACC_CREATE=4)
      integer DFACC_RDWR
      parameter (DFACC_RDWR=3)
      integer DFNT_FLOAT32
      parameter (DFNT_FLOAT32=5)
      integer DFNT_FLOAT64
      parameter (DFNT_FLOAT64=6)
      integer DFNT_INT32
      parameter (DFNT_INT32=24)
      integer HDFE_NOMERGE
      parameter (HDFE_NOMERGE=0)
      integer HDFE_AUTOMERGE
      parameter (HDFE_AUTOMERGE=1)
      integer HDFE_MIDPOINT
      parameter (HDFE_MIDPOINT=0)
      integer HDFE_ENDPOINT
      parameter (HDFE_ENDPOINT=1)
      integer HDFE_INTERNAL
      parameter (HDFE_INTERNAL=0)

      raycnt=-799.0
      tmcnt=46353400.0
      starttime=46353450.0
      endtime=46500000.0
      latcnt=39.8
      loncnt=78.0
      attr(1)=11
      attr(2)=33
      attr(3)=66
      attr(4)=99
      start(1)=10
      start(2)=10
      geostart(1)=0
      geostart(2)=0
      stride(1)=1
      stride(2)=1
      sd_start(1)=0
      sd_start(2)=0
      sd_stride(1)=1
      sd_stride(2)=1
      sd_edge(1)=100
      sd_edge(2)=40
      rd_start(1)=0
      rd_start(2)=0
      rd_stride(1)=1
      rd_stride(2)=1
      rd_edge(1)=40
      rd_edge(2)=100
      dataedge(1)=20
      dataedge(2)=50
      geoedge(1)=40
      geoedge(2)=50
      idxlatcnt=39.8
      idxloncnt=78.0
      istart(1)=0
      istart(2)=0
      iedge(1)=30
      iedge(2)=30
      dedge(1)=40
      dedge(2)=40
      dimsizes(1)=100
      dimsizes(2)=40
      rank=2
      fillvalue=16.0
      cornerlon(1)=75.0
      cornerlon(2)=78.0
      cornerlat(1)=38.0
      cornerlat(2)=39.8
      indexmap(1)=1
      indexmap(2)=2
      indexmap(3)=3
      indexmap(4)=4
      indexmap(5)=6
      indexmap(6)=7
      indexmap(7)=8
      indexmap(8)=9
      indexmap(9)=11
      indexmap(10)=12
      indexmap(11)=13
      indexmap(12)=14
      indexmap(13)=16
      indexmap(14)=17
      indexmap(15)=18
      indexmap(16)=19
      indexmap(17)=21
      indexmap(18)=22
      indexmap(19)=23
      indexmap(20)=24
      indexmap(21)=26
      indexmap(22)=27
      indexmap(23)=28
      indexmap(24)=29
      indexmap(25)=31
      indexmap(26)=32
      indexmap(27)=33
      indexmap(28)=34
      indexmap(29)=36
      indexmap(30)=37
      zero = 0

c
c This section of the program just fills some arrays with data that will be
c used later in the program
c
      do 110 index1=1,100
         do 100 index2=1,40
            ray1(index1, index2)=raycnt
            ray2(index1, index2)=raycnt + 1.0
            raycnt = raycnt +1.
  100    continue
  110 continue

      do 130 index1=1,50
         do 120 index2=1,40
            lat(index1, index2)=latcnt
            lon(index1, index2)=loncnt
            twodtime(index1,index2)=tmcnt
            loncnt=loncnt-.1
            tmcnt=tmcnt+5.0
  120    continue
         latcnt=latcnt-0.1
         loncnt = 78.0
  130 continue

      do 150 index1=1,30
         do 140 index2=1,30
            idxlat(index1, index2)=idxlatcnt
            idxlon(index1, index2)=idxloncnt
            idxloncnt=idxloncnt-.1
  140    continue
         idxlatcnt=idxlatcnt-.1
         idxloncnt=78.0
  150 continue


      do 170 index1=1,40
         do 160 index2=1,40
            ray3(index1, index2)=raycnt
            raycnt = raycnt+1.25
  160    continue
  170 continue


      open(unit=1, file="testswath_f.txtout", status = "NEW")

      write(*,*)'Testing Swath FORTRAN 77 interface'
      write(*,*)'=================================='
      write(1,*)'Testing Swath FORTRAN 77 interface'
      write(1,*)'=================================='
      write(*,*)' '
      write(1,*)' '

c Test Case -- swopen
c
      write(*,*)'Testing swopen '
      write(*,*)'================='
      write(1,*)'Testing swopen '
      write(1,*)'================='
      swfid=swopen("Swathf_Test.hdf", DFACC_CREATE)
      write(*,*)'	swfid=swopen("Swathf_Test.hdf", DFACC_CREATE)'
      write(*,*)'	Value returned by swopen ', swfid
      write(1,*)'	swfid=swopen("Swathf_Test.hdf", DFACC_CREATE)'
      write(1,*)'	Value returned by swopen ', swfid
      write(*,*)' '
      write(1,*)' '

c Test Case -- swcreate
c
      write(1,27)
      write(*,*)'Testing swcreate '
      write(*,*)'================='
      write(1,*)'Testing swcreate '
      write(1,*)'================='
      swid=swcreate(swfid, "Simplef")
      write(*,*)'	swid=swcreate(swfid, "Simplef")'
      write(*,*)'	Value returned by swcreate ', swid
      write(1,*)'	swid=swcreate(swfid, "Simplef")'
      write(1,*)'	Value returned by swcreate ', swid
      write(*,*)' '
      write(1,*)' '

      swid2=swcreate(swfid, "Indexedf")
      write(*,*)'	swid2=swcreate(swfid, "Indexedf")'
      write(*,*)'	Value returned by swcreate ', swid2
      write(1,*)'	swid2=swcreate(swfid, "Indexedf")'
      write(1,*)'	Value returned by swcreate ', swid2
      write(*,*)' '
      write(1,*)' '


c Test Case -- swdefdim
c
      write(1,27)
      write(*,*)'Testing swdefdim '
      write(*,*)'================='
      write(1,*)'Testing swdefdim '
      write(1,*)'================='
      status=swdefdim(swid, "DataTrack", 100)
      write(*,*)'	status=swdefdim(swid, "DataTrack", 100)'
      write(*,*)'	Value returned by swdefdim ',status
      write(1,*)'	status=swdefdim(swid, "DataTrack", 100)'
      write(1,*)'	Value returned by swdefdim ',status
      write(*,*)' '
      write(1,*)' '

      status=swdefdim(swid, "DataXtrack", 40)
      write(*,*)'	status=swdefdim(swid, "DataXtrack", 40)'
      write(*,*)'	Value returned by swdefdim ',status
      write(1,*)'	status=swdefdim(swid, "DataXtrack", 40)'
      write(1,*)'	Value returned by swdefdim ',status
      write(*,*)' '
      write(1,*)' '

      status=swdefdim(swid, "GeoTrack", 50) 
      write(*,*)'	status=swdefdim(swid, "GeoTrack", 50)'
      write(*,*)'	Value returned by swdefdim ',status
      write(1,*)'	status=swdefdim(swid, "GeoTrack", 50)'
      write(1,*)'	Value returned by swdefdim ',status
      write(*,*)' '
      write(1,*)' '

      status=swdefdim(swid, "GeoXtrack", 40)
      write(*,*)'	status=swdefdim(swid, "GeoXtrack", 40)'
      write(*,*)'	Value returned by swdefdim ',status
      write(1,*)'	status=swdefdim(swid, "GeoXtrack", 40)'
      write(1,*)'	Value returned by swdefdim ',status
      write(*,*)' '
      write(1,*)' '

      status=swdefdim(swid2, "DataTrack", 40)
      write(*,*)'	status=swdefdim(swid2, "DataTrack", 40)'
      write(*,*)'	Value returned by swdefdim ', status
      write(1,*)'	status=swdefdim(swid2, "DataTrack", 40)'
      write(1,*)'	Value returned by swdefdim ', status
      write(*,*)' '
      write(1,*)' '

      status=swdefdim(swid2, "DataXtrack", 40)
      write(*,*)'	status=swdefdim(swid2, "DataXtrack", 40)'
      write(*,*)'	Value returned by swdefdim ', status
      write(1,*)'	status=swdefdim(swid2, "DataXtrack", 40)'
      write(1,*)'	Value returned by swdefdim ', status
      write(*,*)' '
      write(1,*)' '

      status=swdefdim(swid2, "GeoTrack", 30)
      write(*,*)'	status=swdefdim(swid2, "GeoTrack", 30)'
      write(*,*)'	Value returned by swdefdim ', status
      write(1,*)'	status=swdefdim(swid2, "GeoTrack", 30)'
      write(1,*)'	Value returned by swdefdim ', status
      write(*,*)' '
      write(1,*)' '

      status=swdefdim(swid2, "GeoXtrack", 30)
      write(*,*)'	status=swdefdim(swid2, "GeoXtrack", 30)'
      write(*,*)'	Value returned by swdefdim ', status
      write(1,*)'	status=swdefdim(swid2, "GeoXtrack", 30)'
      write(1,*)'	Value returned by swdefdim ', status
      write(*,*)' '
      write(1,*)' '

c Test Case -- swdefgfld
c
      write(1,27)
      write(*,*)'Testing swdefgfld '
      write(*,*)'================='
      write(1,*)'Testing swdefgfld '
      write(1,*)'================='
      status=swdefgfld(swid, "Latitude","GeoXtrack,GeoTrack", 
     1DFNT_FLOAT32, HDFE_AUTOMERGE)
      write(*,*)'status=swdefgfld(swid, "Latitude",                      &
     1"GeoXtrack,GeoTrack",DFNT_FLOAT32, HDFE_AUTOMERGE)'
      write(*,*)'Value returned by swdefgfld ',status
      write(1,*)'status=swdefgfld(swid,"Latitude","GeoXtrack,GeoTrack",  &
     1DFNT_FLOAT32, HDFE_AUTOMERGE)'
      write(1,*)'Value returned by swdefgfld ',status
      write(*,*)' '
      write(1,*)' '

      status=swdefgfld(swid, "Longitude","GeoXtrack,GeoTrack",
     1DFNT_FLOAT32,HDFE_AUTOMERGE)
      write(*,*)'status=swdefgfld(swid,"Longitude","GeoXtrack,GeoTrack",
     1DFNT_FLOAT32,HDFE_AUTOMERGE)'
      write(*,*)'Value returned by swdefgfld ',status
      write(1,*)'status=swdefgfld(swid,"Longitude","GeoXtrack,GeoTrack",
     1DFNT_FLOAT32,HDFE_AUTOMERGE)'
      write(1,*)'Value returned by swdefgfld ',status
      write(*,*)' '
      write(1,*)' '

      status=swdefgfld(swid2, "Latitude", "GeoXtrack,GeoTrack",
     1DFNT_FLOAT32,HDFE_NOMERGE)
      write(*,*)'status=swdefgfld(swid2, "Latitude",                     &
     1"GeoTrack,GeoXtrack",DFNT_FLOAT32,HDFE_NOMERGE)'
      write(*,*)'Value returned by swdefgfld ', status
      write(1,*)'status=swdefgfld(swid2, "Latitude",                     &
     1"GeoTrack,GeoXtrack",DFNT_FLOAT32,HDFE_NOMERGE)'
      write(1,*)'Value returned by swdefgfld ', status
      write(*,*)' '
      write(1,*)' '

      status=swdefgfld(swid2, "Longitude", "GeoXtrack,GeoTrack",
     1DFNT_FLOAT32,HDFE_NOMERGE)
      write(*,*)'status=swdefgfld(swid2, "Longitude",                    &
     1"GeoTrack,GeoXtrack",DFNT_FLOAT32,HDFE_NOMERGE)'
      write(*,*)'Value returned by swdefgfld ', status
      write(1,*)'status=swdefgfld(swid2, "Longitude",                    &
     1"GeoTrack,GeoXtrack",DFNT_FLOAT32,HDFE_NOMERGE)'
      write(1,*)'Value returned by swdefgfld ', status
      write(*,*)' '
      write(1,*)' '

      status=swdefgfld(swid, "Time", "GeoXtrack,GeoTrack",               &
     1DFNT_FLOAT64, HDFE_NOMERGE)
      write(*,*)'status=swdefgfld(swid, "Time",                          &
     1"GeoXtrack,GeoTrack",DFNT_FLOAT64, HDFE_NOMERGE)'
      write(*,*)'Value returned by swdefgfld ',status
      write(1,*)'status=swdefgfld(swid, "Time",                          &
     1"GeoXtrack,GeoTrack",DFNT_FLOAT64, HDFE_NOMERGE)'
      write(1,*)'Value returned by swdefgfld ',status
      write(*,*)' '
      write(1,*)' '

c Test Case -- swdefdfld
c
      write(1,27)
      write(*,*)'Testing swdefdfld '
      write(*,*)'================='
      write(1,*)'Testing swdefdfld '
      write(1,*)'================='
      status=swdefdfld(swid, "Temperature", "DataXtrack,DataTrack",
     1DFNT_FLOAT32, HDFE_NOMERGE)
      write(*,*)'status=swdefdfld(swid,"Temperature",                    &
     1"DataXtrack,DataTrack",DFNT_FLOAT32, HDFE_NOMERGE)'
      write(*,*)'Value returned by swdefdfld ',status
      write(1,*)'status=swdefdfld(swid,"Temperature",                    &
     1"DataXtrack,DataTrack",DFNT_FLOAT32, HDFE_NOMERGE)'
      write(1,*)'Value returned by swdefdfld ',status
      write(*,*)' '
      write(1,*)' '

      status=swdefdfld(swid, "Conduction", "DataXtrack,DataTrack",
     1DFNT_FLOAT32, HDFE_NOMERGE)
      write(*,*)'status=swdefdfld(swid,"Conduction",                     &
     1"DataXtrack,DataTrack",DFNT_FLOAT32, HDFE_NOMERGE)'
      write(*,*)'Value returned by swdefdfld ',status
      write(1,*)'status=swdefdfld(swid,"Conduction",                     &
     1"DataXtrack,DataTrack",DFNT_FLOAT32, HDFE_NOMERGE)'
      write(1,*)'Value returned by swdefdfld ',status
      write(*,*)' '
      write(1,*)' '

      status=swdefdfld(swid2, "Sensor1", "DataXtrack,DataTrack",
     1DFNT_FLOAT32, HDFE_NOMERGE)
      write(*,*)'status=swdefdfld(swid2, "Sensor1",                      &
     1"DataTrack,DataXtrack",DFNT_FLOAT32, HDFE_NOMERGE)'
      write(*,*)'Value returned by swdefdfld ',status
      write(1,*)'status=swdefdfld(swid2, "Sensor1",                      &
     1"DataTrack,DataXtrack",DFNT_FLOAT32, HDFE_NOMERGE)'
      write(1,*)'Value returned by swdefdfld ',status
      write(*,*)' '
      write(1,*)' '

c Test Case -- swdetach
c
      write(1,27)
      write(*,*)'Testing swdetach '
      write(*,*)'================='
      write(1,*)'Testing swdetach '
      write(1,*)'================='
      status=swdetach(swid)
      write(*,*)'status=swdetach(swid)'
      write(*,*)'Value returned by swdetach ',status
      write(1,*)'status=swdetach(swid)'
      write(1,*)'Value returned by swdetach ',status
      write(*,*)' '
      write(1,*)' '

      status=swdetach(swid2)
      write(*,*)'status=swdetach(swid2)'
      write(*,*)'Value returned by swdetach ',status
      write(1,*)'status=swdetach(swid2)'
      write(1,*)'Value returned by swdetach ',status
      write(*,*)' '
      write(1,*)' '

      swid=swattach(swfid, "Simplef")
      write(*,*)'swid=swattach(swfid, "Simplef")'
      write(*,*)'Value returned by swattach ',swid
      write(1,*)'swid=swattach(swfid, "Simplef")'
      write(1,*)'Value returned by swattach ',swid
      write(*,*)' '
      write(1,*)' '

      swid2=swattach(swfid, "Indexedf")
      write(*,*)'swid2=swattach(swfid, "Indexedf")'
      write(*,*)'Value returned by swattach ',swid2
      write(1,*)'swid2=swattach(swfid, "Indexedf")'
      write(1,*)'Value returned by swattach ',swid2
      write(*,*)' '
      write(1,*)' '

c Test Case -- swdefmap
c
      write(1,27)
      write(*,*)'Testing swdefmap '
      write(*,*)'================='
      write(1,*)'Testing swdefmap '
      write(1,*)'================='
      status=swdefmap(swid, "GeoTrack", "DataTrack", 0, 2)
      write(*,*)'status=swdefmap(swid, "GeoTrack", "DataTrack", 0, 2)'
      write(*,*)'Value returned by swdefmap ',status
      write(1,*)'status=swdefmap(swid, "GeoTrack", "DataTrack", 0, 2)'
      write(1,*)'Value returned by swdefmap ',status
      write(*,*)' '
      write(1,*)' '

c Test Case -- swdefimap
c
      write(1,27)
      write(*,*)'Testing swdefimap '
      write(*,*)'================='
      write(1,*)'Testing swdefimap '
      write(1,*)'================='
      status=swdefimap(swid2, "GeoTrack", "DataTrack", indexmap)
      write(*,*)'status=swdefimap(swid2, "GeoTrack", "DataTrack",        &
     1indexmap)'
      write(*,*)'Value returned by swdefimap ',status
      write(1,*)'status=swdefimap(swid2, "GeoTrack", "DataTrack",        &
     1indexmap)'
      write(1,*)'Value returned by swdefimap ',status
      write(*,*)' '
      write(1,*)' '

      status=swdefimap(swid2, "GeoXtrack", "DataXtrack", indexmap)
      write(*,*)'status=swdefimap(swid2, "GeoXtrack", "DataXtrack",      &
     1indexmap)'
      write(*,*)'Value returned by swdefimap ',status
      write(1,*)'status=swdefimap(swid2, "GeoXtrack", "DataXtrack",      &
     1indexmap)'
      write(1,*)'Value returned by swdefimap ',status
      write(*,*)' '
      write(1,*)' '


c Test Case  -- swsetfill
c
      write(1,27)
      write(*,*)'Testing swsetfill '
      write(*,*)'================='
      write(1,*)'Testing swsetfill '
      write(1,*)'================='
      status=swsetfill(swid, "Temperature", fillvalue)
      write(*,*)'status=swsetfill(swid, "Temperature", fillvalue)'
      write(*,*)'Value returned by swsetfill ',status
      write(1,*)'status=swsetfill(swid, "Temperature", fillvalue)'
      write(1,*)'Value returned by swsetfill ',status
      write(*,*)' '
      write(1,*)' '

      status=swsetfill(swid, "Conduction", fillvalue)
      write(*,*)'status=swsetfill(swid, "Conduction", fillvalue)'
      write(*,*)'Value returned by swsetfill ',status
      write(1,*)'status=swsetfill(swid, "Conduction", fillvalue)'
      write(1,*)'Value returned by swsetfill ',status
      write(*,*)' '
      write(1,*)' '

c Test Case -- swdetach
c
      write(1,27)
      write(*,*)'Testing swdetach '
      write(*,*)'================='
      write(1,*)'Testing swdetach '
      write(1,*)'================='
      status=swdetach(swid)
      write(*,*)'status=swdetach(swid)'
      write(*,*)'Value returned by swdetach ',status
      write(1,*)'status=swdetach(swid)'
      write(1,*)'Value returned by swdetach ',status
      write(*,*)' '
      write(1,*)' '

      status=swdetach(swid2)
      write(*,*)'status=swdetach(swid2)'
      write(*,*)'Value returned by swdetach ',status
      write(1,*)'status=swdetach(swid2)'
      write(1,*)'Value returned by swdetach ',status
      write(*,*)' '
      write(1,*)' '

      status=swclose(swfid)
      write(*,*)'Value returned by swclose ',status
      write(1,*)'status=swclose(swfid)'
      write(1,*)'Value returned by swclose ',status
      write(*,*)' '
      write(1,*)' '

      swfid=swopen("Swathf_Test.hdf", DFACC_RDWR)
      write(*,*)'swfid=swopen("Swathf_Test.hdf", DFACC_RDWR)'
      write(*,*)'Value returned by swopen ', swfid
      write(1,*)'swfid=swopen("Swathf_Test.hdf", DFACC_RDWR)'
      write(1,*)'Value returned by swopen ', swfid
      write(*,*)' '
      write(1,*)' '


c Test Case -- swattach
c
      write(1,27)
      write(*,*)'Testing swattach '
      write(*,*)'================='
      write(1,*)'Testing swattach '
      write(1,*)'================='
      swid=swattach(swfid, "Simplef")
      write(*,*)'swid=swattach(swfid, "Simplef")'
      write(*,*)'Value returned by swattach ',swid
      write(1,*)'swid=swattach(swfid, "Simplef")'
      write(1,*)'Value returned by swattach ',swid
      write(*,*)' '
      write(1,*)' '

      swid2=swattach(swfid, "Indexedf")
      write(*,*)'swid2=swattach(swfid, "Indexedf")'
      write(*,*)'Value returned by swattach ',swid2
      write(1,*)'swid2=swattach(swfid, "Indexedf")'
      write(1,*)'Value returned by swattach ',swid2
      write(*,*)' '
      write(1,*)' '


c Test Case -- swwrfld
c
      write(1,27)
      write(*,*)'Testing swwrfld '
      write(*,*)'================='
      write(1,*)'Testing swwrfld '
      write(1,*)'================='
      status=swwrfld(swid, "Temperature", start, stride, dataedge, ray1)
      write(*,*)'status=swwrfld(swid, "Temperature", start, stride,      &
     1dataedge, ray1)'
      write(*,*)'Value returned by swwrfld ',status
      write(1,*)'status=swwrfld(swid, "Temperature", start, stride,      &
     1dataedge, ray1)'
      write(1,*)'Value returned by swwrfld ',status
      write(*,*)' '
      write(1,*)' '

      status=swwrfld(swid, "Conduction", start, stride, dataedge, ray2)
      write(*,*)'status=swwrfld(swid, "Conduction", start, stride,       &
     1dataedge, ray2)'
      write(*,*)'Value returned by swwrfld ',status
      write(1,*)'status=swwrfld(swid, "Conduction", start, stride,       &
     1dataedge, ray2)'
      write(1,*)'Value returned by swwrfld ',status
      write(*,*)' '
      write(1,*)' '

      status=swwrfld(swid, "Latitude", geostart, stride, geoedge, lat)
      write(*,*)'status=swwrfld(swid, "Latitude", geostart, stride,      &
     1geoedge, lat)'
      write(*,*)'Value returned by swwrfld ',status
      write(1,*)'status=swwrfld(swid, "Latitude", geostart, stride,      &
     1geoedge, lat)'
      write(1,*)'Value returned by swwrfld ',status
      write(*,*)' '
      write(1,*)' '

      status=swwrfld(swid, "Longitude", geostart, stride, geoedge, lon)
      write(*,*)'status=swwrfld(swid, "Longitude", geostart, stride,     &
     1geoedge, lon)'
      write(*,*)'Value returned by swwrfld ',status
      write(1,*)'status=swwrfld(swid, "Longitude", geostart, stride,     &
     1geoedge, lon)'
      write(1,*)'Value returned by swwrfld ',status
      write(*,*)' '
      write(1,*)' '

      status=swwrfld(swid,"Time",geostart,stride,geoedge,timeptr)
      write(*,*)'status=swwrfld(swid, "Time", geostart, stride,          &
     1geoedge, twodtime)'
      write(*,*)'Value returned by swwrfld for Time ',status
      write(1,*)'status=swwrfld(swid, "Time", geostart, stride,          &
     1geoedge, twodtime)'
      write(1,*)'Value returned by swwrfld for Time ',status
      write(*,*)' '
      write(1,*)' '

      status=swwrfld(swid2, "Latitude", istart, stride, iedge, idxlat)
      write(*,*)'status=swwrfld(swid2, "Latitude", istart, stride,       &
     1iedge, idxlat)'
      write(*,*)'Value returned by swwrfld ',status
      write(1,*)'status=swwrfld(swid2, "Latitude", istart, stride,       &
     1iedge, idxlat)'
      write(1,*)'Value returned by swwrfld ',status
      write(*,*)' '
      write(1,*)' '

      status=swwrfld(swid2, "Longitude", istart, stride, iedge, idxlon)
      write(*,*)'status=swwrfld(swid2, "Longitude", istart, stride,      &
     1iedge, idxlon)'
      write(*,*)'Value returned by swwrfld ',status
      write(1,*)'status=swwrfld(swid2, "Longitude", istart, stride,      &
     1iedge, idxlon)'
      write(1,*)'Value returned by swwrfld ',status
      write(*,*)' '
      write(1,*)' '

      status=swwrfld(swid2, "Sensor1", istart, stride, iedge, ray3)
      write(*,*)'status=swwrfld(swid2, "Sensor1", istart, stride,        &
     1iedge, ray3)'
      write(*,*)'Value returned by swwrfld ',status
      write(1,*)'status=swwrfld(swid2, "Sensor1", istart, stride,        &
     1iedge, ray3)'
      write(1,*)'Value returned by swwrfld ',status
      write(*,*)' '
      write(1,*)' '


c Test Case -- swwrattr
c
      write(1,27)
      write(*,*)'Testing swwrattr '
      write(*,*)'================='
      write(1,*)'Testing swwrattr '
      write(1,*)'================='
      status=swwrattr(swid, "Drift", DFNT_INT32, 4, attr)
      write(*,*)'status=swwrattr(swid, "Drift", DFNT_INT32, 4, attr)'
      write(*,*)'Value returned by swwrattr ',status
      write(1,*)'status=swwrattr(swid, "Drift", DFNT_INT32, 4, attr)'
      write(1,*)'Value returned by swwrattr ',status
      write(*,*)' '
      write(1,*)' '

      status=swdetach(swid)
      write(*,*)'status=swdetach(swid)'
      write(*,*)'Value returned by swdetach ',status
      write(1,*)'status=swdetach(swid)'
      write(1,*)'Value returned by swdetach ',status
      write(*,*)' '
      write(1,*)' '

      status=swdetach(swid2)
      write(*,*)'status=swdetach(swid2)'
      write(*,*)'Value returned by swdetach ',status
      write(1,*)'status=swdetach(swid2)'
      write(1,*)'Value returned by swdetach ',status
      write(*,*)' '
      write(1,*)' '


c Test Case -- swclose
c
      write(1,27)
      write(*,*)'Testing swclose '
      write(*,*)'================='
      write(1,*)'Testing swclose '
      write(1,*)'================='
      status=swclose(swfid)
      write(*,*)'Value returned by swclose ',status
      write(1,*)'status=swclose(swfid)'
      write(1,*)'Value returned by swclose ',status
      write(*,*)' '
      write(1,*)' '


      sd_id=sfstart("Swathf_Test.hdf", DFACC_RDWR)
      write(*,*)'sd_id=sfstart("Swathf_Test.hdf", DFACC_RDWR)'
      write(*,*)'Value returned by sfstart ',sd_id
      write(1,*)'sd_id=sfstart("Swathf_Test.hdf", DFACC_RDWR)'
      write(1,*)'Value returned by sfstart ',sd_id
      write(*,*)' '
      write(1,*)' '

      sds1_id=sfcreate(sd_id, "DataOne", DFNT_FLOAT32, rank,dimsizes)
      write(*,*)'sds1_id=sfcreate(sd_id, "DataOne", DFNT_FLOAT32,        &
     1rank, dimsizes)'
      write(*,*)'Value returned by sfcreate ',sds1_id
      write(1,*)'sds1_id=sfcreate(sd_id, "DataOne", DFNT_FLOAT32,        &
     1rank, dimsizes)'
      write(1,*)'Value returned by sfcreate ',sds1_id
      write(*,*)' '
      write(1,*)' '

      sds2_id=sfcreate(sd_id, "GeoOne", DFNT_FLOAT32, rank,dimsizes)
      write(*,*)'sds2_id=sfcreate(sd_id, "GeoOne", DFNT_FLOAT32,         &
     1rank,dimsizes)'
      write(*,*)'Value returned by sfcreate ',sds2_id
      write(1,*)'sds2_id=sfcreate(sd_id, "GeoOne", DFNT_FLOAT32,         &
     1rank,dimsizes)'
      write(1,*)'Value returned by sfcreate ',sds2_id
      write(*,*)' '
      write(1,*)' '

      dim_id=sfdimid(sds1_id, 0)
      write(*,*)'dim_id=sfdimid(sds1_id, 0)'
      write(*,*)'Value returned by sfdimid ',dim_id
      write(1,*)'dim_id=sfdimid(sds1_id, 0)'
      write(1,*)'Value returned by sfdimid ',dim_id
      write(*,*)' '
      write(1,*)' '

      status=sfsdmname(dim_id, "DataTrack")
      write(*,*)'status=sfsdmname(dim_id, "DataTrack")'
      write(*,*)'Value returned by sfsdmname ',status
      write(1,*)'status=sfsdmname(dim_id, "DataTrack")'
      write(1,*)'Value returned by sfsdmname ',status
      write(*,*)' '
      write(1,*)' '

      dim_id=sfdimid(sds1_id, 1)
      write(*,*)'dim_id=sfdimid(sds1_id, 1)'
      write(*,*)'Value returned by sfdimid ',dim_id
      write(1,*)'dim_id=sfdimid(sds1_id, 1)'
      write(1,*)'Value returned by sfdimid ',dim_id
      write(*,*)' '
      write(1,*)' '
 
      status=sfsdmname(dim_id, "DataXtrack")
      write(*,*)'status=sfsdmname(dim_id, "DataXtrack")'
      write(*,*)'Value returned by sfsdmname ',status
      write(1,*)'status=sfsdmname(dim_id, "DataXtrack")'
      write(1,*)'Value returned by sfsdmname ',status
      write(*,*)' '
      write(1,*)' '

      dim_id=sfdimid(sds2_id, 0)
      write(*,*)'dim_id=sfdimid(sds2_id, 0)'
      write(*,*)'Value returned by sfdimid ',dim_id
      write(1,*)'dim_id=sfdimid(sds2_id, 0)'
      write(1,*)'Value returned by sfdimid ',dim_id
      write(*,*)' '
      write(1,*)' '

      status=sfsdmname(dim_id, "GeoTrack")
      write(*,*)'status=sfsdmname(dim_id, "GeoTrack")'
      write(*,*)'Value returned by sfsdmname ',status
      write(1,*)'status=sfsdmname(dim_id, "GeoTrack")'
      write(1,*)'Value returned by sfsdmname ',status
      write(*,*)' '
      write(1,*)' '

      dim_id=sfdimid(sds2_id, 1)
      write(*,*)'dim_id=sfdimid(sds2_id, 1)'
      write(*,*)'Value returned by sfdimid ',dim_id
      write(1,*)'dim_id=sfdimid(sds2_id, 1)'
      write(1,*)'Value returned by sfdimid ',dim_id
      write(*,*)' '
      write(1,*)' '

      status=sfsdmname(dim_id, "GeoXtrack")
      write(*,*)'status=sfsdmname(dim_id, "GeoXtrack")'
      write(*,*)'Value returned by sfsdmname ',status
      write(1,*)'status=sfsdmname(dim_id, "GeoXtrack")'
      write(1,*)'Value returned by sfsdmname ',status
      write(*,*)' '
      write(1,*)' '

      status=sfwdata(sds1_id, sd_start, sd_stride, sd_edge, ray1)
      write(*,*)'status=sfwdata(sds1_id, sd_start, sd_stride,            &
     1sd_edge, ray1)'
      write(*,*)'Value returned by sfwdata ',status
      write(1,*)'status=sfwdata(sds1_id, sd_start, sd_stride,            &
     1sd_edge, ray1)'
      write(1,*)'Value returned by sfwdata ',status
      write(*,*)' '
      write(1,*)' '

      status=sfwdata(sds2_id, sd_start, sd_stride, sd_edge, ray2)
      write(*,*)'status=sfwdata(sds2_id, sd_start, sd_stride,            &
     1sd_edge, ray2)'
      write(*,*)'Value returned by sfwdata ',status
      write(1,*)'status=sfwdata(sds2_id, sd_start, sd_stride,            &
     1sd_edge, ray2)'
      write(1,*)'Value returned by sfwdata ',status
      write(*,*)' '
      write(1,*)' '

      status=sfendacc(sds1_id)
      write(*,*)'status=sfendacc(sds1_id)'
      write(*,*)'Value returned by sfendacc ',status
      write(1,*)'status=sfendacc(sds1_id)'
      write(1,*)'Value returned by sfendacc ',status
      write(*,*)' '
      write(1,*)' '

      status=sfendacc(sds2_id)
      write(*,*)'status=sfendacc(sds2_id)'
      write(*,*)'Value returned by sfendacc ',status
      write(1,*)'status=sfendacc(sds2_id)'
      write(1,*)'Value returned by sfendacc ',status
      write(*,*)' '
      write(1,*)' '

      status=sfend(sd_id)
      write(*,*)'status=sfend(sd_id)'
      write(*,*)'Value returned by sfend ',status
      write(1,*)'status=sfend(sd_id)'
      write(1,*)'Value returned by sfend ',status
      write(*,*)' '
      write(1,*)' '

      swfid=swopen("Swathf_Test.hdf", DFACC_RDWR)
      write(*,*)'swfid=swopen("Swathf_Test.hdf", DFACC_RDWR)'
      write(*,*)'Value returned by swopen ', swfid
      write(1,*)'swfid=swopen("Swathf_Test.hdf", DFACC_RDWR)'
      write(1,*)'Value returned by swopen ', swfid
      write(*,*)' '
      write(1,*)' '

      swid=swattach(swfid, "Simplef")
      write(*,*)'swid=swattach(swfid, "Simplef")'
      write(*,*)'Value returned by swattach ',swid
      write(1,*)'swid=swattach(swfid, "Simplef")'
      write(1,*)'Value returned by swattach ',swid
      write(*,*)' '
      write(1,*)' '

c Test Case -- swwrdmeta
c
      write(1,27)
      write(*,*)'Testing swwrdmeta '
      write(*,*)'================='
      write(1,*)'Testing swwrdmeta '
      write(1,*)'================='
      status=swwrdmeta(swid, "DataOne", "DataXtrack,DataTrack",
     1DFNT_FLOAT32)
      write(*,*)'status=swwrdmeta(swid, "DataOne",                       &
     1"DataXtrack,DataTrack",DFNT_FLOAT32)'
      write(*,*)'Value returned by swwrdmeta ',status
      write(1,*)'status=swwrdmeta(swid, "DataOne",                       &
     1"DataXtrack,DataTrack",DFNT_FLOAT32)'
      write(1,*)'Value returned by swwrdmeta ',status
      write(*,*)' '
      write(1,*)' '

c Test Case -- swwrgmeta
c
      write(1,27)
      write(*,*)'Testing swwrgmeta '
      write(*,*)'================='
      write(1,*)'Testing swwrgmeta '
      write(1,*)'================='
      status=swwrgmeta(swid, "GeoOne", "GeoXtrack,GeoTrack",
     1DFNT_FLOAT32)
      write(*,*)'status=swwrgmeta(swid, "GeoOne",                        &
     1"GeoXtrack,GeoTrack",DFNT_FLOAT32)'
      write(*,*)'Value returned by swwrdmeta ',status
      write(1,*)'status=swwrgmeta(swid, "GeoOne",                        &
     1"GeoXtrack,GeoTrack",DFNT_FLOAT32)'
      write(1,*)'Value returned by swwrdmeta ',status
      write(*,*)' '
      write(1,*)' '

      status=swdetach(swid)
      write(*,*)'status=swdetach(swid)'
      write(*,*)'Value returned by swdetach ',status
      write(1,*)'status=swdetach(swid)'
      write(1,*)'Value returned by swdetach ',status
      write(*,*)' '
      write(1,*)' '

      status=swclose(swfid)
      write(*,*)'status=swclose(swfid)'
      write(*,*)'Value returned by swclose ',status
      write(1,*)'status=swclose(swfid)'
      write(1,*)'Value returned by swclose ',status
      write(*,*)' '
      write(1,*)' '


      swfid=swopen("Swathf_Test.hdf", DFACC_RDWR)
      write(*,*)'swfid=swopen("Swathf_Test.hdf", DFACC_RDWR)'
      write(*,*)'Value returned by swopen ',swfid
      write(1,*)'swfid=swopen("Swathf_Test.hdf", DFACC_RDWR)'
      write(1,*)'Value returned by swopen ',swfid
      write(*,*)' '
      write(1,*)' '

      swid=swattach(swfid, "Simplef")
      write(*,*)'swid=swattach(swfid, "Simplef")'
      write(*,*)'Value returned by swattach ',swid
      write(1,*)'swid=swattach(swfid, "Simplef")'
      write(1,*)'Value returned by swattach ',swid
      write(*,*)' '
      write(1,*)' '

      swid2=swattach(swfid, "Indexedf")
      write(*,*)'swid2=swattach(swfid, "Indexedf")'
      write(*,*)'Value returned by swattach ',swid2
      write(1,*)'swid2=swattach(swfid, "Indexedf")'
      write(1,*)'Value returned by swattach ',swid2
      write(*,*)' '
      write(1,*)' '

c Test Case -- swnentries
c
      write(1,27)
      write(*,*)'Testing swnentries '
      write(*,*)'================='
      write(1,*)'Testing swnentries '
      write(1,*)'================='
      nmaps=swnentries(swid, 1, strbufsize)
      write(*,*)'nmaps=swnentries(swid, 1, strbufsize)'
      write(*,*)'Number of dimension mappings ',nmaps
      write(*,*)'Size of strbufsize ',strbufsize
      write(1,*)'nmaps=swnentries(swid, 1, strbufsize)'
      write(1,*)'Number of dimension mappings ',nmaps
      write(1,*)'Size of strbufsize ',strbufsize
      write(*,*)' '
      write(1,*)' '

c Test Case -- swinqmaps
c
      write(1,27)
      write(*,*)'Testing swinqmaps '
      write(*,*)'================='
      write(1,*)'Testing swinqmaps '
      write(1,*)'================='
      nmaps=swinqmaps(swid, dimmap, offset, inc)
      write(*,*)'nmaps=swinqmaps(swid, dimmap, offset, inc)'
      write(*,*)'Dimension mappings ',dimmap
      write(*,*)'offset ',offset
      write(*,*)'increment ',inc
      write(1,*)'nmaps=swinqmaps(swid, dimmap, offset, inc)'
      write(1,*)'Dimension mappings ',dimmap
      write(1,*)'offset ',offset
      write(1,*)'increment ',inc
      write(*,*)' '
      write(1,*)' '

c Test Case -- swinqimaps
c
      write(1,27)
      write(*,*)'Testing swinqimaps '
      write(*,*)'================='
      write(1,*)'Testing swinqimaps '
      write(1,*)'================='
      nmaps=swinqimaps(swid2, idxdimmap, ndxmap)
      write(*,*)'nmaps=swinqimaps(swid2, idxdimmap, ndxmap)'
      write(*,*)'Number of indexed mappings ',nmaps
      write(*,*)'Indexed Dimension mappings ',idxdimmap
      write(*,*)'Index size ',ndxmap
      write(1,*)'nmaps=swinqimaps(swid2, idxdimmap, ndxmap)'
      write(1,*)'Number of indexed mappings ',nmaps
      write(1,*)'Indexed Dimension mappings ',idxdimmap
      write(1,*)'Index size ',ndxmap
      write(*,*)' '
      write(1,*)' '

c Test Case -- swinqdims
c
      write(1,27)
      write(*,*)'Testing swinqdims '
      write(*,*)'================='
      write(1,*)'Testing swinqdims '
      write(1,*)'================='
      ndims=swinqdims(swid, dimname, dims)
      write(*,*)'ndims=swinqdims(swid, dimname, dims)'
      write(*,*)'Number of dimesions ',ndims
      write(*,*)'Names of dimensions ',dimname
      write(*,*)'Size of dimensions ',dims
      write(1,*)'ndims=swinqdims(swid, dimname, dims)'
      write(1,*)'Number of dimesions ',ndims
      write(1,*)'Names of dimensions ',dimname
      write(1,*)'Size of dimensions ',dims
      write(*,*)' '
      write(1,*)' '

      ndims=swinqdims(swid2, dimname, dims)
      write(*,*)'ndims=swinqdims(swid2, dimname, dims)'
      write(*,*)'Number of dimesions ',ndims
      write(*,*)'Names of dimensions ',dimname
      write(*,*)'Size of dimensions ',dims
      write(1,*)'ndims=swinqdims(swid2, dimname, dims)'
      write(1,*)'Number of dimesions ',ndims
      write(1,*)'Names of dimensions ',dimname
      write(1,*)'Size of dimensions ',dims
      write(*,*)' '
      write(1,*)' '

c Test Case -- swinqgflds
c
      write(1,27)
      write(*,*)'Testing swinqgflds '
      write(*,*)'================='
      write(1,*)'Testing swinqgflds '
      write(1,*)'================='
      ndims=swinqdims(swid, dimname, dims)
      nflds=swinqgflds(swid, fieldlist, rnk, ntype)
      write(*,*)'nflds=swinqgflds(swid, fieldlist, rnk, ntype)'
      write(*,*)'Number of geolocation fields in swath ',nflds
      write(*,*)'Names of geolocation fields ',fieldlist
      write(*,*)'Rank of fields ',rnk
      write(*,*)'Number type of fields ',ntype
      write(1,*)'nflds=swinqgflds(swid, fieldlist, rnk, ntype)'
      write(1,*)'Number of geolocation fields in swath ',nflds
      write(1,*)'Names of geolocation fields ',fieldlist
      write(1,*)'Rank of fields ',rnk
      write(1,*)'Number type of fields ',ntype
      write(*,*)' '
      write(1,*)' '

c Test Case -- swinqdflds
c
      write(1,27)
      write(*,*)'Testing swinqdflds '
      write(*,*)'================='
      write(1,*)'Testing swinqdflds '
      write(1,*)'================='
      nflds=swinqdflds(swid, fieldlist, rnk, ntype)
      write(*,*)'nflds=swinqdflds(swid, fieldlist, rnk, ntype)'
      write(*,*)'Number of data fields in swath ',nflds
      write(*,*)'Names of data fields ',fieldlist
      write(*,*)'Rank of fields ',rnk
      write(*,*)'Number type of fields ',ntype
      write(1,*)'nflds=swinqdflds(swid, fieldlist, rnk, ntype)'
      write(1,*)'Number of data fields in swath ',nflds
      write(1,*)'Names of data fields ',fieldlist
      write(1,*)'Rank of fields ',rnk
      write(1,*)'Number type of fields ',ntype
      write(*,*)' '
      write(1,*)' '

c Test Case -- swdiminfo
c
      write(1,27)
      write(*,*)'Testing swdiminfo '
      write(*,*)'================='
      write(1,*)'Testing swdiminfo '
      write(1,*)'================='
      dimsize=swdiminfo(swid, "DataTrack")
      write(*,*)'dimsize=swdiminfo(swid, "DataTrack")'
      write(*,*)'Size of dimension DataTrack ',dimsize
      write(1,*)'dimsize=swdiminfo(swid, "DataTrack")'
      write(1,*)'Size of dimension DataTrack ',dimsize
      write(*,*)' '
      write(1,*)' '

c Test Case -- swrdfld
c
      write(1,27)
      write(*,*)'Testing swrdfld '
      write(*,*)'================='
      write(1,*)'Testing swrdfld '
      write(1,*)'================='
      status=swrdfld(swid, "Conduction", rd_start,rd_stride,
     1rd_edge, temp)
      write(*,*)'status=swrdfld(swid, "Conduction", rd_start,rd_stride, &
     1rd_edge, temp)'
      write(*,*)'Value returned by swrdfld ',status
      write(1,*)'Value returned by swrdfld ',status
      do 190 index1=10,15
         do 180 index2=10,15
            write(*,*)'value of conduction ',temp(index1, index2)
            write(1,*)'value of conduction ',temp(index1, index2)
  180    continue
  190 continue

      write(*,*)' '
      write(1,*)' '

c Test Case -- swfldinfo
C
      write(1,27)
      write(*,*)'Testing swfldinfo '
      write(*,*)'================='
      write(1,*)'Testing swfldinfo '
      write(1,*)'================='
      status=swfldinfo(swid, "Latitude", rank, latdims, nt, dimens)
      write(*,*)'status=swfldinfo(swid, "Latitude", rank, latdims,       &
     1nt, dimens)'
      write(*,*)'Value returned by swfldinfo ',status
      write(*,*)'Rank of field latitude ',rank
      write(*,*)'dimension list of field latitude ',dimens
      write(*,*)'Size of latitude dimensions ',latdims
      write(*,*)'number type of field latitude ',nt
      write(1,*)'status=swfldinfo(swid, "Latitude", rank, latdims,       &
     1nt, dimens)'
      write(1,*)'Value returned by swfldinfo ',status
      write(1,*)'Rank of field latitude ',rank
      write(1,*)'dimension list of field latitude ',dimens
      write(1,*)'Size of latitude dimensions ',latdims
      write(1,*)'number type of field latitude ',nt
      write(*,*)' '
      write(1,*)' '

c Test Case -- swmapinfo
c
      write(1,27)
      write(*,*)'Testing swmapinfo '
      write(*,*)'================='
      write(1,*)'Testing swmapinfo '
      write(1,*)'================='
      status=swmapinfo(swid, "GeoTrack", "DataTrack", 
     1offset, inc)
      write(*,*)'status=swmapinfo(swid, "GeoTrack", "DataTrack",         &
     1offset, inc)'
      write(*,*)'Value returned by swmapinfo ',status
      write(*,*)'Offset ',offset,' Increment ',inc
      write(1,*)'status=swmapinfo(swid, "GeoTrack", "DataTrack",         &
     1offset, inc)'
      write(1,*)'Value returned by swmapinfo ',status
      write(1,*)'Offset ',offset,' Increment ',inc
      write(*,*)' '
      write(1,*)' '

c Test Case -- swimapinfo
c
      write(1,27)
      write(*,*)'Testing swimapinfo '
      write(*,*)'================='
      write(1,*)'Testing swimapinfo '
      write(1,*)'================='
      status4=swimapinfo(swid2,"GeoXtrack","DataXtrack",idxmap)
      if(status4 .lt. zero) call heprnt(0)
      if(status4 .lt. zero) write(*,*)'status4 is less than zero'
      write(*,*)'status4=swimapinfo(swid2,"GeoXtrack","DataXtrack",      &
     1idxmap)'
      write(*,*)'Value returned by swimapinfo ',status4
      write(*,*)'Indexed map values ',idxmap
      write(1,*)'status4=swimapinfo(swid2, "GeoXtrack", "DataXtrack",    &
     1idxmap)'
      write(1,*)'Value returned by swimapinfo ',status4
      write(*,*)'Indexed map values ',idxmap
      write(1,*)'Indexed map values ',idxmap
      write(*,*)' '
      write(1,*)' '
 
c Test Case -- swattrinfo
c
      write(1,27)
      write(*,*)'Testing swattrinfo '
      write(*,*)'================='
      write(1,*)'Testing swattrinfo '
      write(1,*)'================='
      status=swattrinfo(swid, "Drift", n, size)
      write(*,*)'status=swattrinfo(swid, "Drift", n, size)'
      write(*,*)'Value returned by swattrinfo ',status
      write(*,*)'Number of attributes ',n,' Size ',size
      write(1,*)'status=swattrinfo(swid, "Drift", n, size)'
      write(1,*)'Value returned by swattrinfo ',status
      write(1,*)'Number of attributes ',n,' Size ',size
      write(*,*)' '
      write(1,*)' '

c Test Case -- swrdattr
c
      write(1,27)
      write(*,*)'Testing swrdattr '
      write(*,*)'================='
      write(1,*)'Testing swrdattr '
      write(1,*)'================='
      status=swrdattr(swid,"Drift", rdattr)
      write(*,*)'status=swrdattr(swid,"Drift", rdattr)'
      write(*,*)'Value returned by swrdattr ',status
      write(*,*)'attribute ',rdattr
      write(1,*)'status=swrdattr(swid,"Drift", rdattr)'
      write(1,*)'Value returned by swrdattr ',status
      write(1,*)'attribute ',rdattr
      write(*,*)' '
      write(1,*)' '

c Test Case -- swgetfill
c
      write(1,27)
      write(*,*)'Testing swgetfill '
      write(*,*)'================='
      write(1,*)'Testing swgetfill '
      write(1,*)'================='
      status=swgetfill(swid, "Conduction", rdfilval)
      write(*,*)'status=swgetfill(swid, "Conduction", rdfilval)'
      write(*,*)'Value returned by swgetfill ',status
      write(*,*)'Value of fill ',rdfilval
      write(1,*)'status=swgetfill(swid, "Conduction", rdfilval)'
      write(1,*)'Value returned by swgetfill ',status
      write(1,*)'Value of fill ',rdfilval
      write(*,*)' '
      write(1,*)' '

c Test Case -- swdefboxreg
c
      write(1,27)
      write(*,*)'Testing swdefboxreg '
      write(*,*)'================='
      write(1,*)'Testing swdefboxreg '
      write(1,*)'================='
      regionid=swdefboxreg(swid, cornerlon, cornerlat,
     1HDFE_ENDPOINT)
      call heprnt(0)
      write(*,*)'regionid=swdefboxreg(swid, cornerlon, cornerlat,        &
     1HDFE_ENDPOINT)'
      write(*,*)'Value returned by swdefboxreg ',regionid
      write(1,*)'regionid=swdefboxreg(swid, cornerlon, cornerlat,        &
     1HDFE_ENDPOINT)'
      write(1,*)'Value returned by swdefboxreg ',regionid
      write(*,*)' '
      write(1,*)' '

c Test Case -- swreginfo
c
      write(1,27)
      write(*,*)'Testing swreginfo '
      write(*,*)'================='
      write(1,*)'Testing swreginfo '
      write(1,*)'================='
      status = swreginfo(swid, regionid, "Temperature", nt, rank,
     1dims,size)      
      write(*,*)'status = swreginfo(swid, regionid, "Temperature",       &
     1nt, rank,dims,size)'
      write(*,*)'Value returned by swreginfo ',status
      write(*,*)'Number type of region ',nt,' Rank of region ',rank
      write(*,*)'Dimensions of region ',dims(1),' ',dims(2)
      write(*,*)'Value of size ',size
      write(1,*)'status = swreginfo(swid, regionid, "Temperature",       &
     1nt, rank,dims,size)'
      write(1,*)'Value returned by swreginfo ',status
      write(1,*)'Value of size ',size
      write(*,*)' '
      write(1,*)' '

c Test Case -- swextreg
c
      write(1,27)
      write(*,*)'Testing swextreg '
      write(*,*)'================='
      write(1,*)'Testing swextreg '
      write(1,*)'================='
      status = swextreg(swid, regionid, "Temperature", HDFE_INTERNAL, 
     1tempbuf) 
      write(*,*)'status = swextreg(swid, regionid, "Temperature",       &
     1HDFE_INTERNAL,tempbuf)'
      write(*,*)'Value returned by swextreg ', status
      write(1,*)'status = swextreg(swid, regionid, "Temperature",       &
     1HDFE_INTERNAL,tempbuf)'
      write(1,*)'Value returned by swextreg ', status
      do 210 index1=10,15
         write(*,*)'region value at position ',tempbuf(index1)
  210 continue

      write(*,*)' '
      write(1,*)' '

c Test Case -- swdeftmeper
c
      write(1,27)
      write(*,*)'Testing swdeftmeper '
      write(*,*)'================='
      write(1,*)'Testing swdeftmeper '
      write(1,*)'================='
      regionid=swdeftmeper(swid, starttime, endtime,HDFE_ENDPOINT)
      call heprnt(0)
      write(*,*)'regionid=swdeftmeper(swid, starttime, endtime,         &
     1HDFE_ENDPOINT)'
      write(*,*)'Value returned by swdeftmeper ',regionid
      write(1,*)'regionid=swdeftmeper(swid, starttime, endtime,         &
     1HDFE_ENDPOINT)'
      write(1,*)'Value returned by swdeftmeper ',regionid
      write(*,*)' '
      write(1,*)' '

c Test Case -- swperinfo
c
      write(1,27)
      write(*,*)'Testing swperinfo '
      write(*,*)'================='
      write(1,*)'Testing swperinfo '
      write(1,*)'================='
      status = swperinfo(swid, regionid, "Temperature", nt, rank,       &
     1dims,size)
      write(*,*)'status = swperinfo(swid, regionid, "Temperature",      &
     1nt, rank,dims,size)'
      write(*,*)'Value returned by swperinfo ',status
      write(*,*)'Rank of field ',rank,' Number type of region ',nt
      write(*,*)'Dimensions of region ',dims(1),' ',dims(2)
      write(1,*)'status = swperinfo(swid, regionid, "Temperature",      &
     1nt, rank,dims,size)'
      write(1,*)'Value returned by swperinfo ',status
      write(1,*)'Rank of field ',rank,' Number type of region ',nt
      write(1,*)'Dimensions of region ',dims(1),' ',dims(2)
      write(*,*)' '
      write(1,*)' '

c Test Case -- swextper
c
      write(1,27)
      write(*,*)'Testing swextper '
      write(*,*)'================='
      write(1,*)'Testing swextper '
      write(1,*)'================='
      status=swextper(swid, regionid, "Temperature",HDFE_INTERNAL,
     1tempbuf)
      write(*,*)'status=swextper(swid, regionid, "Temperature",         &
     1HDFE_INTERNAL, tempbuf)'
      write(*,*)'Value returned by swextper swath ',status
      write(1,*)'status=swextper(swid, regionid, "Temperature",         &
     1HDFE_INTERNAL, tempbuf) '
      write(1,*)'Value returned by swextper swath ',status
      do 220 index1=10,15
         write(*,*)'region value at position ',tempbuf(index1)
  220 continue
      write(*,*)' '
      write(1,*)' '

      status=swdetach(swid)
      write(*,*)'status=swdetach(swid)'
      write(*,*)'Value returned by swdetach ',status
      write(1,*)'status=swdetach(swid)'
      write(1,*)'Value returned by swdetach ',status
      write(*,*)' '
      write(1,*)' '

      status=swdetach(swid2)
      write(*,*)'status=swdetach(swid2)'
      write(*,*)'Value returned by swdetach ',status
      write(1,*)'status=swdetach(swid2)'
      write(1,*)'Value returned by swdetach ',status
      write(*,*)' '
      write(1,*)' '

      status=swclose(swfid)
      write(*,*)'status=swclose(swfid)'
      write(*,*)'Value returned by swclose ',status
      write(1,*)'status=swclose(swfid)'
      write(1,*)'Value returned by swclose ',status
      write(*,*)' '
      write(1,*)' '

      close(unit=1)
   27 format('')
      stop
      end

c
c	In this example we will (1) open the "SwathFile" HDF file, (2)
c	attach to
c	the "Swath1" swath, and (3) define the swath fields.
c
	program definefields

	integer            status, swdefgfld, swdefdfld, swdetach, swclose
	integer*4          swfid, swid, swopen, swattach

	integer  DFACC_RDWR
	parameter (DFACC_RDWR=3)
	integer  DFNT_INT16, DFNT_FLOAT32, DFNT_FLOAT64
	parameter (DFNT_INT16=22)
	parameter (DFNT_FLOAT32=5)	
	parameter (DFNT_FLOAT64=6)
	integer*4 HDFE_NOMERGE, HDFE_AUTOMERGE
	parameter (HDFE_NOMERGE=0)
	parameter (HDFE_AUTOMERGE=1)
c
c	We first open the HDF swath file, "SwathFile.hdf".  Because this
c	file already exist and we wish to write to it, we use the
c	DFACC_RDWR accesscode in the open statement.  The SWopen
c	routine returns the swath fileid, swfid, which is used to
c	identify the file in subsequent routines.

	swfid = swopen("SwathFile_created_with_hadeos_sample_file_write"//
     1"r_of_HDFEOS2_version_219_or_higher_release.hdf", DFACC_RDWR)


c
c	If the swath file cannot be found, SWopen will return -1 for the
c	filehandle (swfid).  We there check that this is not the
c       case becforeproceeding with the other routines.  The SWattach
c	routine returns the handle to the existing swath "Swath1", swid.
c	If the swath is not found, SWattach returns -1 for
c	the handle.
c

	if (swfid .NE. -1) then

	   swid = swattach(swfid, "Swath1")

	   if (swid .NE. -1) then

c
c	     We define six fields.  The first three, "Time", "Longitude"
c	     and "Latitude" are geolocation fields and thus we use the
c	     geolocation dimensions "GeoTrack" and "GeoXtrack" in the field
c	     definitions.  We also must specify the data type using the
c	     standard HDF data type codes.  In this example the geolocation
c	     are 4-byte (32 bit) floating point numbers.
c	     
c	     The next three fields are data fields.  Note that either
c	     geolocation or data dimensions can be used.  If an error
c            occurs during the definition, such as a dimension that cannot
c	     be found, then the return status will be set to -1.
c

	      status = swdefgfld(swid, "Time", "GeoTrack", DFNT_FLOAT64,
     1                           HDFE_NOMERGE)

	      status = swdefgfld(swid, "Longitude", "GeoXtrack,GeoTrack",
     1	                         DFNT_FLOAT32, HDFE_AUTOMERGE)

	      status = swdefgfld(swid, "Latitude", "GeoXtrack,GeoTrack",
     1                           DFNT_FLOAT32, HDFE_AUTOMERGE)

	      status = swdefdfld(swid, "Density", "GeoTrack",
     1                           DFNT_FLOAT32, HDFE_NOMERGE)

	      status = swdefdfld(swid, "Temperature", 
     1	                         "GeoXtrack,GeoTrack", DFNT_FLOAT32,
     2                           HDFE_NOMERGE)	      
	      
	      status = swdefdfld(swid, "Pressure", "Res2xtr,Res2tr",
     1                           DFNT_FLOAT64, HDFE_NOMERGE)
	      
	      status = swdefdfld(swid, "Spectra", "Res2xtr,Res2tr,Bands",
     1                           DFNT_FLOAT64, HDFE_NOMERGE)	      


c       Define Appendable Field
	      status = swdefdfld(swid, "Count", "Unlim",
     1                           DFNT_INT16, HDFE_NOMERGE)	      

	      endif

	   endif

	   status = swdetach(swid)
	   status = swclose(swfid)

	   stop
	   end

c testgrid.f
c In this program we create, define and write a simple grid hdfeos file
c using the grid interface
c

      program testgrid
      
      integer*4		index1
      integer*4		index2
      integer*4		dimsizes(2)
      real*4		ray3(250)
      real*4		utmray(60,80), georay(60,80)
      real*4		utmcnt, geocnt
      real*4		fillvalue, ifillv
      real*4		raycnt, ray3cnt
      real*4		tempray(60,80)
      real*4		datbuf(4800)
      
      integer   	status
      integer*4		lstatus, n, one
      integer*4 	gdfid, gdfid2, gdid_utm, gdid2
      integer*4 	zonecode
      integer*4		attr(4), iattr(4)
      integer*4 	spherecode, xdim, ydim, zero
      integer*4		tmpvar1, nt, rk, size, tmpvar2
      integer*4 	start(2)
      integer*4 	stride(2)
      integer*4 	edge(2)
      integer*4 	start1d(1), stride1d(1), edge1d(1)
      real*8		projparm(16), uplft(2), lowrgt(2), pparm(16)
      real*8		iuplft(2), ilrgt(2)

      integer*4		lat(40,50)
      integer*4		latcnt
      integer*4		lon(40,50)
      integer*4		loncnt

      integer   	gddefproj, gddefdim, gddeffld, gddetach 
      integer		gdclose, gdgetfill, gdreginfo
      integer   	gdwrfld, gdwrattr, gdsetfill, gddeforigin
      integer		gdgridinfo, gdprojinfo,gdfldinfo
      integer		gdrdfld, gddefpreg,gdrdattr, gdextreg
      integer		gdattrinfo, gdwrmeta
      integer*4 	gdopen, gdcreate, gdattach, gdinqgrid
      integer*4		gdinqdims, gddiminfo, gdinqflds
      integer*4		gdnentries, gdinqattrs, gddefboxreg
      integer*4		gdorginfo, gdpreginfo

      integer*4		strbufsize, pcode,nflds
      integer		zcode, scode
      character*80	grdnames, dimname, fldlist, attrlist
      integer*4		dims(8), rnk(8), numtype(8)
      real*8		upleftpt(2), lowrtpt(2),corlon(2),corlat(2)
      integer*4		xdimsize, ydimsize, regionid
      
      integer DFACC_CREATE
      parameter (DFACC_CREATE=4)
      integer DFACC_RDWR
      parameter (DFACC_RDWR=3)
      integer DFACC_READ
      parameter (DFACC_READ=1)      
      integer GCTP_UTM
      parameter (GCTP_UTM=1)

      integer DFNT_FLOAT32
      parameter (DFNT_FLOAT32=5)
      integer DFNT_INT32
      parameter (DFNT_INT32=24)      
      
      integer HDFE_NOMERGE
      parameter (HDFE_NOMERGE=0)
      integer HDFE_AUTOMERGE
      parameter (HDFE_AUTOMERGE=1)
      
      integer HDFE_CORNER
      parameter (HDFE_CORNER=1)
      integer HDFE_GD_UL
      parameter (HDFE_GD_UL=0)
      integer HDFE_NENTDIM
      parameter(HDFE_NENTDIM=0)
      integer HDFE_NENTDFLD
      parameter (HDFE_NENTDFLD=4)

      index1 = 0
      index2 = 0
      dimsizes(1) = 40
      dimsizes(2) = 100
      fillvalue = 1996.0
      raycnt = -799.0
      ray3cnt = -19.5
      attr(1) = 11
      attr(2) = 33
      attr(3) = 66
      attr(4) = 99
      utmcnt=-799.0
      geocnt=2001.0

      latcnt = 38.0
      loncnt = 78.0
      zero = 0
      one = 1
      
c
c This section of the program just fills some arrays with data that we will
c use later in the program
c
      do 70 index1=1,60
         do 80 index2=1,80
            utmray(index2,index1) = utmcnt
            georay(index2,index1) = geocnt
            utmcnt = utmcnt + .4
            geocnt = geocnt + .2
 80      continue
 70   continue
  
      
      do 30 index1=1,250
            ray3(index1) = ray3cnt
            ray3cnt = ray3cnt + .1
 30   continue
      

      do 50 index1=1,50
         do 60 index2=1,40      
            lat(index2,index1) = latcnt
            lon(index2,index1) = loncnt
            loncnt = loncnt - 0.1
 60      continue
         latcnt = latcnt + 0.1
         loncnt = 78.0
 50   continue
      

      open(unit=10, file='testgrid_f.txtout')

      write(*,*)'Testing Grid FORTRAN 77 interface '
      write(*,*)'=================================='
      write(10,*)'Testing Grid FORTRAN 77 interface '
      write(10,*)'=================================='
      write(10,*)' '
      write(*,*)' '

c Test Case -- gdopen
c
      write(10,*)'Testing gdopen... '
      write(10,*)'=================='
      write(*,*)'Testing gdopen... '
      write(*,*)'=================='
      gdfid2 = gdopen("Gridf_Test2.hdf", DFACC_READ)
      write(10,*)'gdfid2 = gdopen("Gridf_Test2.hdf", DFACC_READ)'
      write(10,*)'********Error Expected************'
      write(10,*)'Value returned by gdopen ', gdfid2
      write(*,*)'gdfid2 = gdopen("Gridf_Test2.hdf", DFACC_READ)'
      write(*,*)'********Error Expected************'
      write(*,*)'Value returned by gdopen ', gdfid2
      if(gdfid2 .le. zero) call heprnt(0)

      write(*,*)'Opening file Gridf_Test.hdf'
      write(10,*)'Opening file Gridf_Test.hdf'
      gdfid = gdopen('Gridf_Test.hdf', DFACC_CREATE)
      write(10,*) 'gdfid = gdopen("Gridf_Test.hdf", DFACC_CREATE)'
      write(10,*) 'File id returned from gdopen ', gdfid
      write(*,*) 'gdfid = gdopen("Gridf_Test.hdf", DFACC_CREATE)'
      write(*,*) 'File id returned from gdopen ', gdfid
      write(10,*)' '
      write(*,*)' '


c Test Case -- gdcreate
c
      write(10,27)
      write(10,*)'Testing gdcreate... '
      write(10,*)'=================='
      write(*,*)'Testing gdcreate... '
      write(*,*)'=================='

      xdim = 60
      ydim = 80
      uplft(1) = 353299.39125
      uplft(2) = -7100284.64348
      lowrgt(1) = 603434.52148
      lowrgt(2) = -7991341.17870

      gdid2 = gdcreate(gdfid2, 'UTMGrid2', xdim, ydim, uplft, lowrgt)
      write(10,*) 'Create UTMGrid2'
      write(10,*) 'Value returned by gdcreate ', gdid2
      write(*,*) 'Create UTMGrid2'
      write(*,*) 'Value returned by gdcreate ', gdid2
      if(gdid2 .le. zero) call heprnt(0)
    
      write(10,*)'Creating UTMGrid'
      write(*,*)'Creating UTMGrid'
      gdid_utm = gdcreate(gdfid, 'UTMGrid', xdim, ydim, uplft, lowrgt)
      write(*,*)'gdid_utm = gdcreate(gdfid, "UTMGrid", xdim,
     1ydim, uplft, lowrgt)'
      write(10,*)'gdid_utm = gdcreate(gdfid, "UTMGrid", xdim,
     1ydim, uplft, lowrgt)'
      write(10,*)'UTM grid id returned from gdcreate ', gdid_utm
      write(*,*)'UTM grid id returned from gdcreate ', gdid_utm
      write(10,*)' '
      write(*,*)' '

c Test Case -- gddefproj
c
      write(10,27)
      write(10,*)'Testing gddefproj... '
      write(10,*)'=================='
      write(*,*)'Testing gddefproj... '
      write(*,*)'=================='

      zonecode = 10
      spherecode = 0

      do 120 index1=1,16
         projparm(index1)=0
 120  continue
  
      write(10,*)'Defining UTM projection'
      write(*,*)'Defining UTM projection'
      status = gddefproj(gdid_utm, GCTP_UTM, zonecode, 
     1spherecode, projparm)
      write(*,*)'status = gddefproj(gdid_utm, GCTP_UTM, zonecode,
     1spherecode, projparm)'
      write(10,*)'status = gddefproj(gdid_utm, GCTP_UTM, zonecode,
     1spherecode, projparm)'
      write(10,*)'Returned value from gddefproj ', status
      write(*,*)'Returned value from gddefproj ', status

      status = gddefproj(gdid2,GCTP_UTM,zonecode,spherecode,projparm)
      write(10,*)'Defining UTM'
      write(10,*)'Value returned by gddefproj ', status
      write(*,*)'Defining UTM'
      write(*,*)'Value returned by gddefproj ', status
      if(status .lt. zero) call heprnt(0)
      write(10,*)' '
      write(*,*)' '


c Test Case -- gddefpreg
c
      write(10,27)
      write(10,*)'Testing gddefpreg... '
      write(10,*)'=================='
      write(*,*)'Testing gddefpreg... '
      write(*,*)'=================='
      status = gddefpreg(gdid_utm, HDFE_CORNER)
      write(10,*)'Returned from gddefpreg ', status
      write(*,*)'Returned from gddefpreg ', status
      write(10,*)' '
      write(*,*)' '

c Test Case -- gddeforigin
c
      write(10,27)
      write(10,*)'Testing gddeforigin... '
      write(10,*)'=================='
      write(*,*)'Testing gddeforigin... '
      write(*,*)'=================='
      status = gddeforigin(gdid_utm, HDFE_GD_UL)
      write(*,*)'status = gddeforigin(gdid_utm, HDFE_GD_UL)'
      write(*,*)'Value of status from gddeforigin ',status
      write(10,*)' '
      write(*,*)' '

c Test Case -- gddefdim
c
      write(10,27)
      write(10,*)'Testing gddefdim... '
      write(10,*)'=================='
      write(*,*)'Testing gddefdim... '
      write(*,*)'=================='
      status = gddefdim(gdid2, 'TestDim1', 40)
      write(10,*)'status = gddefdim(gdid2, "TestDim1", 40)'
      write(10,*)'Value returned by gddefdim ', status
      write(*,*)'status = gddefdim(gdid2, "TestDim1", 40)'
      write(*,*)'Value returned by gddefdim ', status
      if(status .lt. zero) call heprnt(0)

      status = gddefdim(gdid2, 'TestDim2', 25)
      write(10,*)'status = gddefdim(gdid2, "TestDim2", 25)'
      write(10,*)'Value returned by gddefdim ', status
      write(*,*)'status = gddefdim(gdid2, "TestDim2", 25)'
      write(*,*)'Value returned by gddefdim ', status
      if(status .lt. zero) call      heprnt(0)


      status = gddefdim(gdid_utm, 'Conduction', 250)
      write(10,*)'status = gddefdim(gdid_utm, "Conduction", 250)'
      write(10,*)'Returned value from gddefdim ', status
      write(*,*)'status = gddefdim(gdid_utm, "Conduction", 250)'
      write(*,*)'Returned value from gddefdim ', status
      write(10,*)' '
      write(*,*)' '

c Test Case -- gddetach
c
      write(10,27)
      write(10,*)'Testing gddetach... '
      write(10,*)'=================='
      write(*,*)'Testing gddetach... '
      write(*,*)'=================='
      status = gddetach(gdid2)
      write(10,*)'status = gddetach(gdid2)'
      write(10,*)'Value returned by gddetach ', status
      write(*,*)'status = gddetach(gdid2)'
      write(*,*)'Value returned by gddetach ', status

      status = gddetach(gdid_utm)
      write(10,*)'status = gddetach(gdid_utm)'
      write(10,*)'Returned value from gddetach ', status
      write(*,*)'status = gddetach(gdid_utm)'
      write(*,*)'Returned value from gddetach ', status
      write(10,*)' '
      write(*,*)' '
 
c Test Case -- gdattach
c
      write(10,27)
      write(10,*)'Testing gdattach... '
      write(10,*)'=================='
      write(*,*)'Testing gdattach... '
      write(*,*)'=================='
      gdid_utm = gdattach(gdfid, 'UTMGrid')
      write(10,*)'gdid_utm = gdattach(gdfid, "UTMGrid")'
      write(10,*)'Handle returned from gdattach ', gdid_utm
      write(*,*)'gdid_utm = gdattach(gdfid, "UTMGrid")'
      write(*,*)'Handle returned from gdattach ', gdid_utm

      gdid2 = gdattach(gdfid2, 'UTMGrid2')
      write(10,*)'gdid2 = gdattach(gdfid2, "UTMGrid2")'
      write(10,*)'Value returned by gdattach ', status
      write(*,*)'gdid2 = gdattach(gdfid2, "UTMGrid2")'
      write(*,*)'Value returned by gdattach ', status
      write(10,*)' '
      write(*,*)' '

c Test Case -- gddeffld
c
      write(10,27)
      write(10,*)'Testing gddeffld... '
      write(10,*)'=================='
      write(*,*)'Testing gddeffld... '
      write(*,*)'=================='

      status = gddeffld(gdid2, 'tempfield', 'TestDim2,TestDim1', 
     1 DFNT_FLOAT32, HDFE_NOMERGE)
      write(10,*)'Define: "tempfield"'
      write(10,*)'Value returned by gddeffld ', status
      write(*,*)'Define: "tempfield"'
      write(*,*)'Value returned by gddeffld ', status
      if(status .lt. zero) call heprnt(0)


      status = gddeffld(gdid_utm,'Voltage','XDim,YDim',
     1DFNT_FLOAT32,HDFE_AUTOMERGE)
      if(status .lt. zero) call heprnt(0)
      write(10,*)'Define: "Voltage"'
      write(10,*)'Value returned from gddeffld ', status
      write(*,*)'Define: "Voltage"'
      write(*,*)'Value returned from gddeffld ', status

      status = gddeffld(gdid_utm, 'Drift', 'XDim,YDim',DFNT_FLOAT32,
     1HDFE_AUTOMERGE)
      if(status .lt. zero) call heprnt(0)
      write(10,*)'Define: "Drift"'      
      write(10,*)'Value returned from gddeffld ', status
      write(*,*)'Define: "Drift"'      
      write(*,*)'Value returned from gddeffld ', status

      status = gddeffld(gdid_utm, 'Impedance', 'XDim,YDim', 
     1DFNT_FLOAT32,HDFE_AUTOMERGE)
      if(status .lt. zero) call heprnt(0)
      write(10,*)'Define: "Impedance"'            
      write(10,*)'Value returned from gddeffld ', status
      write(*,*)'Define: "Impedance"'            
      write(*,*)'Value returned from gddeffld ', status

      status = gddeffld(gdid_utm, 'Grounding', 'Conduction', 
     1DFNT_FLOAT32, HDFE_NOMERGE)
      write(10,*)'Define: "Grounding"'                  
      write(10,*)'Value returned by gddeffld ', status
      write(*,*)'Define: "Grounding"'                  
      write(*,*)'Value returned by gddeffld ', status
      call heprnt(0)
      write(10,*)' '
      write(*,*)' '

c Test Case -- gdwrmeta
c
      write(10,27)
      write(10,*)'Testing gdwrmeta... '
      write(10,*)'=================='
      write(*,*)'Testing gdwrmeta... '
      write(*,*)'=================='

      status = gdwrmeta(gdid_utm, 'Extern',
     1'XDim,YDim',DFNT_FLOAT32)
      write(*,*)'Value returned by gdwrmeta ',status
      write(10,*)' '
      write(*,*)' '

c Test Case -- gdsetfill
c
      write(10,27)
      write(10,*)'Testing gdsetfill... '
      write(10,*)'=================='
      write(*,*)'Testing gdsetfill... '
      write(*,*)'=================='

      status = gdsetfill(gdid_utm, 'Voltage', fillvalue)
      write(10,*)'Testing gdsetfill'
      write(10,*)'Returned from gdsetfill ', status
      write(*,*)'Testing gdsetfill'
      write(*,*)'Returned from gdsetfill ', status
      write(10,*)' '
      write(*,*)' '

      status = gddetach(gdid_utm)
      write(10,*)'status = gddetach(gdid_utm)'
      write(*,*)'status = gddetach(gdid_utm)'
      if(status .lt. zero) call heprnt(0)
      write(10,*)'Returned value from gddetach ', status
      write(*,*)'Returned value from gddetach ', status
      write(10,*)' '
      write(*,*)' '

      gdid_utm = gdattach(gdfid, 'UTMGrid')
      write(10,*)'gdid_utm = gdattach(gdfid, "UTMGrid")'
      write(10,*)'Handle returned from gdattach ', gdid_utm
      write(*,*)'gdid_utm = gdattach(gdfid, "UTMGrid")'
      write(*,*)'Handle returned from gdattach ', gdid_utm
      write(10,*)' '
      write(*,*)' '

c Test Case -- gdwrfld
c
      write(10,27)
      write(10,*)'Testing gdwrfld... '
      write(10,*)'=================='
      write(*,*)'Testing gdwrfld... '
      write(*,*)'=================='

      start(1) = 10
      start(2) = 10
      stride(1) = 1
      stride(2) = 1
      edge(1) = 10
      edge(2) = 10
      
      status = gdwrfld(gdid_utm, 'Voltage', start, stride, edge, utmray)
      write(10,*)
     1'status=gdwrfld(gdid_utm,"Voltage",start,stride,edge,utmray)'
      write(10,*)'Value returned by gdwrietfield ', status
      write(*,*)
     1'status=gdwrfld(gdid_utm,"Voltage",start,stride,edge,utmray)'
      write(*,*)'Value returned by gdwrietfield ', status


      start(1) = 0
      start(2) = 0
      edge(1) = 60
      edge(2) = 80
      status = gdwrfld(gdid_utm, 'Drift', start,stride,edge,utmray)
      write(10,*)
     1'status = gdwrfld(gdid_utm, "Drift", start,stride,edge,utmray)'
      write(10,*)'Returned from gdwrfld ', status
      write(*,*)
     1'status = gdwrfld(gdid_utm, "Drift", start,stride,edge,utmray)'
      write(*,*)'Returned from gdwrfld ', status

      status = gdwrfld(gdid_utm, 'Impedance', start,stride,edge,utmray)
      write(10,*) 
     1'status=gdwrfld(gdid_utm,"Impedance",start,stride,edge,utmray)'
      write(10,*)'Returned from gdwrfld ', status
      write(*,*) 
     1'status=gdwrfld(gdid_utm,"Impedance",start,stride,edge,utmray)'
      write(*,*)'Returned from gdwrfld ', status

      start1d(1)=0
      stride1d(1)=1
      edge1d(1)=250
      status=gdwrfld(gdid_utm,'Grounding',start1d,stride1d,edge1d,ray3)
      call heprnt(0)
      write(10,*)'status=gdwrfld(gdid_utm,"Grounding",start1d,
     1stride1d,edge1d,ray3)'
      write(10,*)'Value returned by gdwrfld ', status
      write(*,*)'status=gdwrfld(gdid_utm,"Grounding",start1d,
     1stride1d,edge1d,ray3)'
      write(*,*)'Value returned by gdwrfld ', status
      write(10,*)' '
      write(*,*)' '


c Test Case -- gdwrattr
c
      write(10,27)
      write(10,*)'Testing gdwrattr... '
      write(10,*)'=================='
      write(*,*)'Testing gdwrattr... '
      write(*,*)'=================='

      status = gdwrattr(gdid_utm, 'Resistance', DFNT_INT32, 4, attr)
      write(10,*)
     1'status = gdwrattr(gdid_utm, "Resistance", DFNT_INT32, 4, attr)'
      write(10,*)'Returned from gdwrattr ', status
      write(*,*)
     1'status = gdwrattr(gdid_utm, "Resistance", DFNT_INT32, 4, attr)'
      write(*,*)'Returned from gdwrattr ', status

      status = gddetach(gdid_utm)
      write(10,*)'status = gddetach(gdid_utm)'
      write(10,*)'Returned from gddetach ', status
      write(*,*)'status = gddetach(gdid_utm)'
      write(*,*)'Returned from gddetach ', status

      status = gddetach(gdid2)
      write(10,*)'status = gddetach(gdid2)'
      write(10,*)'Value returned by gddetach ', status
      write(*,*)'status = gddetach(gdid2)'
      write(*,*)'Value returned by gddetach ', status
      write(10,*)' '
      write(*,*)' '

c Test Case -- gdclose
c
      write(10,27)
      write(10,*)'Testing gdclose... '
      write(10,*)'=================='
      write(*,*)'Testing gdclose... '
      write(*,*)'=================='

      status = gdclose(gdfid2)
      write(10,*)'status = gdclose(gdfid2)'
      write(10,*)'Value returned by gdclose ', status
      write(*,*)'status = gdclose(gdfid2)'
      write(*,*)'Value returned by gdclose ', status
      if(status .lt. zero) call heprnt(0)

      status = gdclose(gdfid)
      write(10,*)'status = gdclose(gdfid)'
      write(10,*)'Returned from gdclose ', status
      write(*,*)'status = gdclose(gdfid)'
      write(*,*)'Returned from gdclose ', status
      write(10,*)' '
      write(*,*)' '

      
      gdfid = gdopen('Gridf_Test.hdf', DFACC_RDWR)
      write(*,*)'gdfid = gdopen("Gridf_Test.hdf", DFACC_RDWR)'
      write(10,*)'gdfid = gdopen("Gridf_Test.hdf", DFACC_RDWR)'
      write(*,*)'Grid file id returned by gdopen ',gdfid
      write(10,*)'Grid file id returned by gdopen ',gdfid

      gdid_utm = gdattach(gdfid, 'UTMGrid')
      write(*,*)'gdid_utm = gdattach(gdfid, "UTMGrid")'
      write(10,*)'gdid_utm = gdattach(gdfid, "UTMGrid")'
      write(*,*)'Grid id returned by gdattach ',gdid_utm
      write(10,*)'Grid id returned by gdattach ',gdid_utm
      write(*,*)' '

c Test Case -- gdinqgrid
c
      write(10,27)
      write(10,*)'Testing gdinqgrid... '
      write(10,*)'=================='
      write(*,*)'Testing gdinqgrid... '
      write(*,*)'=================='

      lstatus = gdinqgrid('Gridf_Test.hdf',grdnames,strbufsize)
      write(*,*)'Names of grids ',grdnames
      write(*,*)'Number of grids ',lstatus
      write(*,*)'Size of names of grids ',strbufsize
      write(10,*)'Names of grids ',grdnames
      write(10,*)'Number of grids ',lstatus
      write(10,*)'Size of names of grids ',strbufsize
      write(10,*)' '
      write(*,*)' '

c Test Case -- gdorginfo
c
      write(10,27)
      write(10,*)'Testing gdorginfo... '
      write(10,*)'=================='
      write(*,*)'Testing gdorginfo... '
      write(*,*)'=================='

      lstatus = gdorginfo(gdid_utm, tmpvar1)
      write(*,*)'lstatus = gdorginfo(gdid_utm, tmpvar1)'
      write(10,*)'lstatus = gdorginfo(gdid_utm, tmpvar1)'
      write(*,*)'Value returned by gdorginfo ',lstatus
      write(10,*)'Value returned by gdorginfo ',lstatus
      write(10,*)' '
      write(*,*)' '

c Test Case -- gdpreginfo
c
      write(10,27)
      write(10,*)'Testing gdpreginfo... '
      write(10,*)'=================='
      write(*,*)'Testing gdpreginfo... '
      write(*,*)'=================='

      lstatus = gdpreginfo(gdid_utm, tmpvar1)
      write(*,*)'lstatus = gdpreginfo(gdid_utm, tmpvar1)'
      write(10,*)'lstatus = gdpreginfo(gdid_utm, tmpvar1)'
      write(*,*)'Value returned by gdpreginfo ',lstatus
      write(10,*)'Value returned by gdpreginfo ',lstatus
      write(10,*)' '
      write(*,*)' '

c Test Case -- gdinqdims
c
      write(10,27)
      write(10,*)'Testing gdinqdims... '
      write(10,*)'=================='
      write(*,*)'Testing gdinqdims... '
      write(*,*)'=================='

      lstatus = gdinqdims(gdid_utm, dimname, dims)
      write(*,*)'lstatus = gdinqdims(gdid_utm, dimname, dims)'
      write(*,*)'Number of dimensions ',lstatus
      write(*,*)'Dimensions in grid UTM ',dimname
      write(*,*)'Size of dimensions '
      write(10,*)'lstatus = gdinqdims(gdid_utm, dimname, dims)'
      write(10,*)'Number of dimensions ',lstatus
      write(10,*)'Dimensions in grid UTM ',dimname
      write(10,*)'Size of dimensions '
      do 130 i=1,lstatus
         write(*,*)' ',dims(i)
         write(10,*)' ',dims(i)
 130  continue
      write(10,*)' '
      write(*,*)' '

c Test Case -- gddiminfo
c
      write(10,27)
      write(10,*)'Testing gddiminfo... '
      write(10,*)'=================='
      write(*,*)'Testing gddiminfo... '
      write(*,*)'=================='

      lstatus = gddiminfo(gdid_utm, 'Conduction')
      write(*,*)'lstatus = gddiminfo(gdid_utm, "Conduction")'
      write(*,*)'Size of dimension Conduction ',lstatus
      write(10,*)'lstatus = gddiminfo(gdid_utm, "Conduction")'
      write(10,*)'Size of dimension Conduction ',lstatus
      write(10,*)' '
      write(*,*)' '

c Test Case -- gdgridinfo
c
      write(10,27)
      write(10,*)'Testing gdgridinfo... '
      write(10,*)'=================='
      write(*,*)'Testing gdgridinfo... '
      write(*,*)'=================='

      status = gdgridinfo(gdid_utm,xdimsize,ydimsize,upleftpt,lowrtpt)
      write(*,*)'status = gdgridinfo(gdid_utm,xdimsize,ydimsize,
     1upleftpt,lowrtpt)'
      write(*,*)'Value returned by gdgridinfo ',status
      write(*,*)'X dim size ',xdimsize, ' Y dim size ',ydimsize
      write(*,*)'Upper left pt ',upleftpt(1),upleftpt(2)
      write(*,*)'Lower right pt ',lowrtpt(1),lowrtpt(2)
      write(10,*)'status = gdgridinfo(gdid_utm,xdimsize,ydimsize,
     1upleftpt,lowrtpt)'
      write(10,*)'Value returned by gdgridinfo ',status
      write(10,*)'X dim size ',xdimsize, ' Y dim size ',ydimsize
      write(10,*)'Upper left pt ',upleftpt(1),upleftpt(2)
      write(10,*)'Lower right pt ',lowrtpt(1),lowrtpt(2)
      write(10,*)' '
      write(*,*)' '

c Test Case -- gdprojinfo
c
      write(10,27)
      write(10,*)'Testing gdprojinfo... '
      write(10,*)'=================='
      write(*,*)'Testing gdprojinfo... '
      write(*,*)'=================='

      status = gdprojinfo(gdid_utm,pcode,zcode,scode,pparm)
      write(*,*)'status = gdprojinfo(gdid_utm,pcode,
     1zcode,scode,pparm)'
      write(*,*)'Value returned by gdprojinfo ',status
      write(*,*)'Projection code ',pcode, ' Zone code ',zcode
      write(*,*)'Sphere code ',scode
      write(10,*)'status = gdprojinfo(gdid_utm,pcode,
     1zcode,scode,pparm)'
      write(10,*)'Value returned by gdprojinfo ',status
      write(10,*)'Projection code ',pcode, ' Zone code ',zcode
      write(10,*)'Sphere code ',scode
      do 140 i=1,16
         write(*,*)' ',pparm(i)
         write(10,*)' ',pparm(i)
 140  continue
      write(10,*)' '
      write(*,*)' '

c Test Case -- gdinqflds
c
      write(10,27)
      write(10,*)'Testing gdinqflds... '
      write(10,*)'=================='
      write(*,*)'Testing gdinqflds... '
      write(*,*)'=================='

      nflds = gdinqflds(gdid_utm,fldlist,rnk,numtype)
      write(*,*)'nflds = gdinqflds(gdid_utm,fldlist,rnk,numtype)'
      write(*,*)'Number of fields ',nflds
      write(10,*)'nflds = gdinqflds(gdid_utm,fldlist,rnk,numtype)'
      write(10,*)'Number of fields ',nflds
      if (nflds .ne. 0) then
         write(*,*)'Fields ',fldlist
         write(10,*)'Fields ',fldlist
         do 150 i=1,nflds
            write(*,*)'Rank and type ',rnk(i), ' ', numtype(i)
            write(10,*)'Rank and type ',rnk(i), ' ', numtype(i)
  150    continue
      end if
      write(10,*)' '
      write(*,*)' '

c Test Case -- gdfldinfo
c
      write(10,27)
      write(10,*)'Testing gdfldinfo... '
      write(10,*)'=================='
      write(*,*)'Testing gdfldinfo... '
      write(*,*)'=================='

      status = gdfldinfo(gdid_utm,'Drift',rnk,dims,
     1numtype,dimname)
      write(*,*)'status = gdfldinfo(gdid_utm,"Drift",rnk,dims,
     1numtype,dimname)'
      write(*,*)'Value returned by gdfldinfo for field Drift ',status
      write(*,*)'Drift rank ',rnk(1)
      write(10,*)'status = gdfldinfo(gdid_utm,"Drift",rnk,dims,
     1numtype,dimname)'
      write(10,*)'Value returned by gdfldinfo for field Drift ',status
      write(10,*)'Drift rank ',rnk(1)
      write(10,*)' '
      write(*,*)' '

c Test Case -- gdrdfld
c
      write(10,27)
      write(10,*)'Testing gdrdfld... '
      write(10,*)'=================='
      write(*,*)'Testing gdrdfld... '
      write(*,*)'=================='

      start(1) = 0
      start(2) = 0
      stride(1) = 1
      stride(2) = 1
      edge(1) = 60
      edge(2) = 80
      status = gdrdfld(gdid_utm,'Drift',start,stride,edge,tempray)
      write(*,*)'status = gdrdfld(gdid_utm,"Drift",start,stride,
     1edge,tempray)'
      write(*,*)'Value returned by gdrdfld ',status
      write(10,*)'status = gdrdfld(gdid_utm,"Drift",start,stride,
     1edge,tempray)'
      write(10,*)'Value returned by gdrdfld ',status
      write(10,*)' '
      write(*,*)' '

c Test Case -- gdnentries
c
      write(10,27)
      write(10,*)'Testing gdnentries... '
      write(10,*)'=================='
      write(*,*)'Testing gdnentries... '
      write(*,*)'=================='

      n = gdnentries(gdid_utm, HDFE_NENTDIM, strbufsize)
      write(*,*)'n = gdnentries(gdid_utm, HDFE_NENTDIM, strbufsize)'
      write(*,*)'Number of dimensions ', n
      write(*,*)'Dimension ',strbufsize
      write(10,*)'n = gdnentries(gdid_utm, HDFE_NENTDIM, strbufsize)'
      write(10,*)'Number of dimensions ', n
      write(10,*)'Dimension ',strbufsize

      n = gdnentries(gdid_utm,HDFE_NENTDFLD,strbufsize)
      write(*,*)'n = gdnentries(gdid_utm,HDFE_NENTDFLD,strbufsize)'
      write(*,*)'Number of data fields ',n
      write(10,*)'n = gdnentries(gdid_utm,HDFE_NENTDFLD,strbufsize)'
      write(10,*)'Number of data fields ',n
      write(10,*)' '
      write(*,*)' '

c Test Case -- gdattrinfo
c
      write(10,27)
      write(10,*)'Testing gdattrinfo... '
      write(10,*)'=================='
      write(*,*)'Testing gdattrinfo... '
      write(*,*)'=================='

      status = gdattrinfo(gdid_utm,'Resistance',tmpvar1,
     1tmpvar2)
      write(*,*)'status = gdattrinfo(gdid_utm,"Resistance",tmpvar1,
     1tmpvar2)'
      write(*,*)'Value returned by gdattrinfo ',status
      write(10,*)'status = gdattrinfo(gdid_utm,"Resistance",tmpvar1,
     1tmpvar2)'
      write(10,*)'Value returned by gdattrinfo ',status
      write(10,*)' '
      write(*,*)' '

c Test Case -- gdrdattr
c
      write(10,27)
      write(10,*)'Testing gdrdattr... '
      write(10,*)'=================='
      write(*,*)'Testing gdrdattr... '
      write(*,*)'=================='

      status = gdrdattr(gdid_utm,'Resistance',iattr)
      write(*,*)'status = gdrdattr(gdid_utm,"Resistance",iattr)'
      write(*,*)'Value returned by gdrdattr ',status
      write(10,*)'status = gdrdattr(gdid_utm,"Resistance",iattr)'
      write(10,*)'Value returned by gdrdattr ',status
      write(10,*)' '
      write(*,*)' '
  
c Test Case -- gdinqattrs
c
      write(10,27)
      write(10,*)'Testing gdinqattrs... '
      write(10,*)'=================='
      write(*,*)'Testing gdinqattrs... '
      write(*,*)'=================='

      lstatus = gdinqattrs(gdid_utm, attrlist,tmpvar1)
      write(*,*)'lstatus = gdinqattrs(gdid_utm, attrlist,tmpvar1)'
      write(*,*)'Value returned by gdinqattrs ',lstatus
      write(*,*)'List of attributes ',attrlist
      write(10,*)'lstatus = gdinqattrs(gdid_utm, attrlist,tmpvar1)'
      write(10,*)'Value returned by gdinqattrs ',lstatus
      write(10,*)'List of attributes ',attrlist
      write(10,*)' '
      write(*,*)' '

c Test Case -- gdgetfill
c
      write(10,27)
      write(10,*)'Testing gdgetfill... '
      write(10,*)'=================='
      write(*,*)'Testing gdgetfill... '
      write(*,*)'=================='

      status = gdgetfill(gdid_utm,'Voltage',ifillv)
      write(*,*)'status = gdgetfill(gdid_utm,"Voltage",ifillv)'
      write(*,*)'Value returned by gdgetfill ',status
      write(*,*)'Fill value ',ifillv
      write(10,*)'status = gdgetfill(gdid_utm,"Voltage",ifillv)'
      write(10,*)'Value returned by gdgetfill ',status
      write(10,*)'Fill value ',ifillv
      write(10,*)' '
      write(*,*)' '

c Test Case -- gddefboxreg
c
      write(10,27)
      write(10,*)'Testing gddefboxreg... '
      write(10,*)'=================='
      write(*,*)'Testing gddefboxreg... '
      write(*,*)'=================='

      corlon(1)=-126.0
      corlon(2)=-121.5
      corlat(1)=-70.0
      corlat(2)=-65.0

      regionid = gddefboxreg(gdid_utm,corlon,corlat)
      write(*,*)'regionid = gddefboxreg(gdid_utm,corlon,corlat)'
      write(*,*)'Region id returned by gddefboxreg ',regionid
      write(10,*)'regionid = gddefboxreg(gdid_utm,corlon,corlat)'
      write(10,*)'Region id returned by gddefboxreg ',regionid
      write(10,*)' '
      write(*,*)' '

c Test Case -- gdreginfo
c
      write(10,27)
      write(10,*)'Testing gdreginfo... '
      write(10,*)'=================='
      write(*,*)'Testing gdreginfo... '
      write(*,*)'=================='

      status = gdreginfo(gdid_utm,regionid,'Impedance',nt,
     1rk,dims,size,iuplft,ilrgt)
      write(*,*)'status = gdreginfo(gdid_utm,regionid,"Impedance",nt,
     1rk,dims,size,iuplft,ilrgt)'
      write(*,*)'Value returned by gdreginfo ',status
      write(*,*)'Number type of region ',nt
      write(*,*)'Rank of region ',rk
      write(*,*)'Size of region ',size
      write(*,*)'Dimensions of region',dims(1),' ',dims(2)
      write(*,*)'Upper left point of region ',iuplft(1),' ',iuplft(2)
      write(*,*)'Lower right point of region ',ilrgt(1),' ',ilrgt(2)
      write(10,*)'status = gdreginfo(gdid_utm,regionid,"Impedance",nt,
     1rk,dims,size,iuplft,ilrgt)'
      write(10,*)'Value returned by gdreginfo ',status
      write(10,*)'Number type of region ',nt
      write(10,*)'Rank of region ',rk
      write(10,*)'Size of region ',size
      write(10,*)'Dimensions of region',dims(1),' ',dims(2)
      write(10,*)'Upper left point of region ',iuplft(1),' ',iuplft(2)
      write(10,*)'Lower right point of region ',ilrgt(1),' ',ilrgt(2)
      write(10,*)' '
      write(*,*)' '

c Test Case -- gdextreg
c
      write(10,27)
      write(10,*)'Testing gdextreg... '
      write(10,*)'=================='
      write(*,*)'Testing gdextreg... '
      write(*,*)'=================='

      status = gdextreg(gdid_utm,regionid,'Impedance',datbuf)
      write(*,*)'status = gdextreg(gdid_utm,regionid,
     1"Impedance",datbuf)'
      write(*,*)'Value returned by gdextreg ',status
      write(10,*)'status = gdextreg(gdid_utm,regionid,
     1"Impedance",datbuf)'
      write(10,*)'Value returned by gdextreg ',status
      do 175 i=100,150
         write(*,*)'Value of region ',datbuf(i)
         write(10,*)'Value of region ',datbuf(i)
  175 continue


      status = gddetach(gdid_utm)
      write(*,*)'status = gddetach(gdid_utm)'
      write(*,*)'Value returned by gddetach ',status
      write(10,*)'status = gddetach(gdid_utm)'
      write(10,*)'Value returned by gddetach ',status

      status = gdclose(gdfid)
      write(*,*)'status = gdclose(gdfid)'
      write(*,*)'Returned from gdclose ', status
      write(10,*)'status = gdclose(gdfid)'
      write(10,*)'Returned from gdclose ', status

      close(unit=10)
  27  format('')
      stop
      end

	program definegdflds

	integer            status, gddeffld, gdsetfill, gdwrmeta
	integer            gddetach, gdclose
	integer*4          gdfid, gdid1, gdid2, gdopen, gdattach
    
	real*4             fillval1, fillval2
	
	integer DFACC_RDWR
	parameter (DFACC_RDWR=3)
	integer DFNT_FLOAT32
	parameter (DFNT_FLOAT32=5)
	integer DFNT_FLOAT64
	parameter (DFNT_FLOAT64=6)
	integer HDFE_NOMERGE
	parameter (HDFE_NOMERGE=0)
	integer HDFE_AUTOMERGE
	parameter (HDFE_AUTOMERGE=1)

	fillval1=-7.0
	fillval2=-9999.0

	gdfid = gdopen("GridFile_created_with_hadeos_sample_file_write"//
     1"r_of_HDFEOS2_version_219_or_higher_release.hdf", DFACC_RDWR)


	gdid1 = gdattach(gdfid, "UTMGrid")

	status = gddeffld(gdid1, "Pollution", "XDim,YDim,Time",
     1			    DFNT_FLOAT32, HDFE_NOMERGE)
	
	status = gddeffld(gdid1, "Vegetation", "XDim,YDim",
     1			    DFNT_FLOAT32, HDFE_NOMERGE)

	status = gdwrmeta(gdid1, "Extern", "XDim,YDim",
     1				  DFNT_FLOAT32)

	status = gdsetfill(gdid1, "Pollution", fillval1)
     1	

	

	gdid2 = gdattach(gdfid, "PolarGrid")

	status = gddeffld(gdid2, "Temperature", "XDim,YDim",
     1			    DFNT_FLOAT32, HDFE_AUTOMERGE)

	status = gddeffld(gdid2, "Pressure", "XDim,YDim",
     1			    DFNT_FLOAT32, HDFE_AUTOMERGE)

	status = gddeffld(gdid2, "Soil Dryness", "XDim,YDim",
     1				DFNT_FLOAT32, HDFE_NOMERGE)

	status = gddeffld(gdid2, "Spectra", "XDim,YDim,Bands",
     1			    DFNT_FLOAT64, HDFE_AUTOMERGE)

	status = gdsetfill(gdid2, "Pressure", fillval2)

	status = gddetach(gdid1)
	status = gddetach(gdid2)


	status = gdclose(gdfid)

	stop
	end

c
c	In this example we will (1) open the "PointFile" HDF file,
c	(2) attach to the three point structures, and (3) define
c	the fields within each point.
c
	program definelevels

	integer         status
	integer*4       ptfid, ptid
	integer*4       fieldtype(8), fieldorder(8)
	character*255   fldlist

	integer*4       ptopen, ptattach
	integer         ptdeflev, ptdeflink, ptdetach, ptclose
	
	integer  DFACC_RDWR
	parameter (DFACC_RDWR=3)

	integer  DFNT_CHAR8, DFNT_INT16, DFNT_INT32
	parameter (DFNT_CHAR8=4)
	parameter (DFNT_INT16=22)
	parameter (DFNT_INT32=24)
	
	integer  DFNT_FLOAT32, DFNT_FLOAT64
	parameter (DFNT_FLOAT32=5)
	parameter (DFNT_FLOAT64=6)
	
c
c	We first open the HDF point file, "PointFile.hdf".  Because this
c	file already exist and we wish to write to it, we use the
c	DFACC_RDWR access code in the open statement.  The ptopen
c	routine returns the point fileid, ptfid, which is used to
c	identify the file in subsequent routines.

	ptfid = ptopen("PointFile_created_with_hadeos_sample_file_write"//
     1"r_of_HDFEOS2_version_219_or_higher_release.hdf", DFACC_RDWR)


c
c	We next attach to the three point structures within the file
c       using the ptattach routine, identifying each point by its
c       name defined by the ptcreate routine previously.
c

	if (ptfid .ne. -1) then
	   
c
c      Define "Simple" point
c
	   
	   ptid = ptattach(ptfid, "Simple Point")
	   fldlist = "Time,Concentration,Species"


	   fieldtype(1) = DFNT_FLOAT64
	   fieldtype(2) = DFNT_FLOAT32
	   fieldtype(3) = DFNT_CHAR8
	   
	   fieldorder(1) = 1
	   fieldorder(2) = 4
	   fieldorder(3) = 4
	
	   status = ptdeflev(ptid, "Sensor", fldlist, fieldtype,
     1                       fieldorder)
	
	   status = ptdetach(ptid)
	   goto 5000
c
c      Define Fixed Buoy Point 
c	      

	   ptid = ptattach(ptfid, "FixedBuoy Point")


c     Define Description/Location Level

	   fldlist = "Label,Longitude,Latitude,DeployDate,ID"
	
	   fieldtype(1) = DFNT_CHAR8
	   fieldtype(2) = DFNT_FLOAT64
	   fieldtype(3) = DFNT_FLOAT64
	   fieldtype(4) = DFNT_INT32
	   fieldtype(5) = DFNT_CHAR8
	   
c   Note: order = 0 same as order = 1 for numeric scalars

	   fieldorder(1) = 8
	   fieldorder(2) = 0
	   fieldorder(3) = 0
	   fieldorder(4) = 0
	   fieldorder(5) = 1

	   status = ptdeflev(ptid, "Desc-Loc", fldlist, fieldtype, 
     1                       fieldorder)


c     Define Data Level

	   fldlist = "Time,Rainfall,Temperature,ID"
	
	   fieldtype(1) = DFNT_FLOAT64
	   fieldtype(2) = DFNT_FLOAT32
	   fieldtype(3) = DFNT_FLOAT32
	   fieldtype(4) = DFNT_CHAR8
	   
	   fieldorder(1) = 0
	   fieldorder(2) = 0
	   fieldorder(3) = 0
	   fieldorder(4) = 1

	   status = ptdeflev(ptid, "Observations", fldlist, 
     1			     fieldtype, fieldorder)

	   status = ptdeflink(ptid, "Desc-Loc", "Observations", "ID")

	   status = ptdetach(ptid)



c
c
c	Floating Buoy Point
c
	   ptid = ptattach(ptfid, "FloatBuoy Point")


c      Define Description Level */

	   fldlist = "Label,DeployDate,Weight,ID"
	
	   fieldtype(1) = DFNT_CHAR8
	   fieldtype(2) = DFNT_INT32
	   fieldtype(3) = DFNT_INT16
	   fieldtype(4) = DFNT_CHAR8
	   
	   fieldorder(1) = 8
	   fieldorder(2) = 0
	   fieldorder(3) = 0
	   fieldorder(4) = 1


	   status = ptdeflev(ptid, "Description", fldlist, 
     1                       fieldtype, fieldorder)


c	Define Data Level

	   fldlist = "Time,Longitude,Latitude,Rainfall,Temperature,ID"

	   fieldtype(1) = DFNT_FLOAT64
	   fieldtype(2) = DFNT_FLOAT64
	   fieldtype(3) = DFNT_FLOAT64
	   fieldtype(4) = DFNT_FLOAT32
	   fieldtype(5) = DFNT_FLOAT32
	   fieldtype(6) = DFNT_CHAR8
	   
	   fieldorder(1) = 0
	   fieldorder(2) = 0
	   fieldorder(3) = 0
	   fieldorder(4) = 0
	   fieldorder(5) = 0
	   fieldorder(6) = 1	

	   status = ptdeflev(ptid, "Measurements", fldlist, 
     1                       fieldtype, fieldorder)

	   status = ptdeflink(ptid, "Description", "Measurements", "ID")

	   status = ptdetach(ptid)
	
 5000	   continue
c
c      Close HDF file
c	
	   status = ptclose(swfid)

	   write(*,*) 'status close ', status
	endif
		   
	stop
	end

c
c 


	program subsetpoint

	integer            status, ptextreg, ptreginfo, ptdetach
	integer            ptextper, ptperinfo, ptclose
	
	integer*4          ptfid, ptid, ptopen, ptattach
	integer*4          size, ptdefboxreg, ptdeftmeper
	integer*4          regionid, periodid

	real*8             cornerlon(2), cornerlat(2)
	real*8             datbuf(128), starttime, stoptime
	
	integer DFACC_READ
	parameter (DFACC_READ=1)

c    
c     Open the HDF point file, "PointFile.hdf"
c 

	ptfid = ptopen("PointFile_created_with_hadeos_sample_file_write"//
     1"r_of_HDFEOS2_version_219_or_higher_release.hdf", DFACC_READ)

	if (ptfid .NE. -1) then

	   ptid = ptattach(ptfid, "FloatBuoy Point")

	   if (ptid .NE. -1) then
	      cornerlon(1) = -145.
	      cornerlat(1) = -15.
	      cornerlon(2) = -135.
	      cornerlat(2) = 8.



	      regionid = ptdefboxreg(ptid, cornerlon, cornerlat)

	      level = 1
	      status = ptreginfo(ptid, regionid, level, 
     1				 "Longitude,Latitude", size)

	      status = ptextreg(ptid, regionid, level, 
     1	                        "Longitude,Latitude", datbuf)

	      do 100 i=1,size/16
		 write(*,*) i, datbuf(2*i-1),datbuf(2*i)
 100	      continue
	      
c             Time Subsetting	      

	      starttime = 35208757.6d0
	      stoptime = 35984639.2d0
	    
	      periodid = ptdeftmeper(ptid, starttime, stoptime)

	      level = 1
	      status = ptperinfo(ptid, periodid, level, "Time", size)

	      status = ptextper(ptid, periodid, level, "Time", datbuf)
	      
	      do 200 i=1,size/8
		 write(*,*) i, datbuf(i)
 200	      continue
	      
	   endif
	
	   status = ptdetach(ptid)
	   status = ptclose(ptfid)

	endif
	stop
	end

	program writegdflds

	integer       i, j, status, gdwrfld, gdwrattr, gddetach, gdclose
	integer*4     gdfid, gdid, gdopen, gdattach
	integer*4     start(2), stride(2), count(2)
	real*4        f32, veg(120,200), temp(100,100)
	integer DFACC_RDWR
	parameter (DFACC_RDWR=3)
	integer DFNT_FLOAT32
	parameter (DFNT_FLOAT32=5)


	do i=1,200
	   do j=1,120
	      veg(j,i) = 10 + i
	   enddo
	enddo
	
	do i=1,100
	   do j=1,100
	      temp(j,i) = 100*(i-1) + j
	   enddo
	enddo


	gdfid = gdopen("GridFile_created_with_hadeos_sample_file_write"//
     1"r_of_HDFEOS2_version_219_or_higher_release.hdf", DFACC_RDWR)

	if (gdfid .ne. -1) then

	   gdid = gdattach(gdfid, "UTMGrid")

	   if (gdid .ne. -1) then
	
	      start(1) = 0
	      start(2) = 0
	      stride(1) = 1
	      stride(2) = 1
	      count(1) = 120
	      count(2) = 200
	      status = gdwrfld(gdid, "Vegetation", 
     1                  	   start, stride, count, veg)
	      
	      f32 = 1
	      status = gdwrattr(gdid, "float32", DFNT_FLOAT32, 1, f32)
	   endif
	endif

	status = gddetach(gdid)

	gdid = gdattach(gdfid, "PolarGrid")
	if (gdid .ne. -1) then
	   start(1) = 0
	   start(2) = 0
	   stride(1) = 1
	   stride(2) = 1
	   count(1) = 100
	   count(2) = 100
	   status = gdwrfld(gdid, "Temperature", 
     1	                    start, stride, count, temp)

	endif
	status = gddetach(gdid)
	
	status = gdclose(gdfid)

	stop
	end

c
c  In this example we will (1) open the "SwathFile" HDF file, (2) attach to
c  the "Swath1" swath, and (3) write data to the "Longitude",
c  "Longitude" and "Spectra" fields.
c


	program writefields

	integer            status, swwrfld, swwrattr, swdetach, swclose
	integer            track, start(3),stride(3),count(3)
	integer*4          swfid, SWid, swopen, swattach, attr(4)

	real*4         lng(10), lat(10)
	real*8         plane(800), tme(20)

	integer DFACC_RDWR
	parameter (DFACC_RDWR=3)
	integer DFNT_INT32
	parameter (DFNT_INT32=24)

c     Define longitude values along the cross track

	do i=1,10
	   lng(i) = i-1.0
	enddo


c
c     Open the HDF swath file, "SwathFile.hdf"
c

	swfid = swopen("SwathFile_created_with_hadeos_sample_file_write"//
     1"r_of_HDFEOS2_version_219_or_higher_release.hdf", DFACC_RDWR)


	if (swfid .NE. -1) then

	   SWid = swattach(swfid, "Swath1")

	   if (swid .NE. -1) then


c     Write data starting at the beginning of each cross track

	      start(1) = 0
	      stride(1) = 1
	      stride(2) = 1
	      count(1) = 10
	      count(2) = 1

c
c      Loop through all the tracks, incrementing the track starting
c      position by one each time.
c

	      do track = 1,20
		 start(2) = track - 1
		 status = swwrfld(swid, "Longitude", start, stride,
     1                            count, lng)

		 do xtrack = 1,10
		    lat(xtrack) = track
		 enddo

		 status = swwrfld(swid, "Latitude", start, stride,
     1                            count, lat)


	      enddo


	      do i = 1,20
 		 tme(i) = 34574087.3 + 84893.2*(i-1)
	      enddo

	      start(1) = 0
	      stride(1) = 1
	      count(1) = 20
	      status = swwrfld(swid, "Time", start, stride, count, tme)

c
c	     Write Spectra one plane at a time
c	     Value is 100 * track index + band index (0-based)
c
	    start(1) = 0
	    start(2) = 0
	    count(1) = 20
	    count(2) = 40
	    count(3) = 1
	    stride(3) = 1

	    do i=1,15
	       start(3) = i - 1
	       do j=1,40
		  do k=1,20
		     plane((j-1)*20+k) = (j-1)*100 + i-1
		  enddo
	       enddo

	       status = swwrfld(swid, "Spectra", start, stride,
     1	                        count, plane)

	    enddo


c      Write User Attribute
	      attr(1) = 3
	      attr(2) = 5
	      attr(3) = 7
	      attr(4) = 11
	      status = swwrattr(swid, "TestAttr", DFNT_INT32, 4, attr)

	   endif
	 endif

	 status =  swdetach(swid)
	 status = swclose(swfid)

	 stop
	 end

!
!Copyright (C) 1996 Hughes and Applied Research Corporation
!
!Permission to use, modify, and distribute this software and its documentation 
!for any purpose without fee is hereby granted, provided that the above 
!copyright notice appear in all copies and that both that copyright notice and 
!this permission notice appear in supporting documentation.
!

! Working Buffer Sizes
      integer HDFE_MAXMEMBUF
      integer HDFE_NAMBUFSIZE
      integer HDFE_DIMBUFSIZE

! Field Merge
      integer HDFE_NOMERGE
      integer HDFE_AUTOMERGE

! XXentries Modes
      integer HDFE_NENTDIM
      integer HDFE_NENTMAP
      integer HDFE_NENTIMAP
      integer HDFE_NENTGFLD
      integer HDFE_NENTDFLD

! GCTP projection codes
      integer GCTP_GEO
      integer GCTP_UTM
      integer GCTP_SPCS
      integer GCTP_ALBERS
      integer GCTP_LAMCC
      integer GCTP_MERCAT
      integer GCTP_PS
      integer GCTP_POLYC
      integer GCTP_EQUIDC
      integer GCTP_TM
      integer GCTP_STEREO
      integer GCTP_LAMAZ
      integer GCTP_AZMEQD
      integer GCTP_GNOMON
      integer GCTP_ORTHO
      integer GCTP_GVNSP
      integer GCTP_SNSOID
      integer GCTP_EQRECT
      integer GCTP_MILLER
      integer GCTP_VGRINT
      integer GCTP_HOM
      integer GCTP_ROBIN
      integer GCTP_SOM
      integer GCTP_ALASKA
      integer GCTP_GOOD
      integer GCTP_MOLL
      integer GCTP_IMOLL
      integer GCTP_HAMMER
      integer GCTP_WAGIV
      integer GCTP_WAGVII
      integer GCTP_OBLEQA
      integer GCTP_ISINUS1
      integer GCTP_CEA
      integer GCTP_BCEA
      integer GCTP_ISINUS

! Compression Modes
      integer HDFE_COMP_NONE
      integer HDFE_COMP_RLE
      integer HDFE_COMP_NBIT
      integer HDFE_COMP_SKPHUFF
      integer HDFE_COMP_DEFLATE
      integer HDFE_COMP_SZIP
      
! Tiling Codes
      integer HDFE_NOTILE
      integer HDFE_TILE

! Swath Subset Modes
      integer HDFE_MIDPOINT
      integer HDFE_ENDPOINT
      integer HDFE_ANYPOINT
      integer HDFE_INTERNAL
      integer HDFE_EXTERNAL
      integer HDFE_NOPREVSUB

! Grid Origin
      integer HDFE_GD_UL
      integer HDFE_GD_UR
      integer HDFE_GD_LL
      integer HDFE_GD_LR

! Grid Pixel Registration
      integer HDFE_CENTER
      integer HDFE_CORNER

! Angle Conversion Codes
      integer HDFE_RAD_DEG
      integer HDFE_DEG_RAD
      integer HDFE_DMS_DEG
      integer HDFE_DEG_DMS
      integer HDFE_RAD_DMS
      integer HDFE_DMS_RAD

! SZIP paramters
      integer SZ_EC, SZ_NN
      
! EASE GRID PARAMETERS
      integer BCEA_COLS25       ! total number of columns for EASE grid 
      integer BCEA_ROWS25       ! total number of rows for EASE grid 
      float BCEA_CELL_M         ! Cell size for EASE grid 
      float BCEA_RE_M           ! Earth radius used in GCTP projection tools
                                ! for Behrmann Cylindrical Equal Area proj.
      float DEFAULT_BCEA_LTRUESCALE !Latitude of true scale in DMS 
      float BCEA_COS_PHI1
      float PI
      float EASE_GRID_DEFAULT_UPLEFT_LON
      float EASE_GRID_DEFAULT_UPLEFT_LAT
      float EASE_GRID_DEFAULT_LOWRGT_LON
      float EASE_GRID_DEFAULT_LOWRGT_LAT



! Working Buffer Sizes
      parameter ( HDFE_MAXMEMBUF  = 1048576)
      parameter ( HDFE_NAMBUFSIZE = 32000)
      parameter ( HDFE_DIMBUFSIZE = 64000)

! Field Merge
      parameter ( HDFE_NOMERGE   = 0)
      parameter ( HDFE_AUTOMERGE = 1)

! XXentries Modes
      parameter ( HDFE_NENTDIM   = 0)
      parameter ( HDFE_NENTMAP   = 1)
      parameter ( HDFE_NENTIMAP  = 2)
      parameter ( HDFE_NENTGFLD  = 3)
      parameter ( HDFE_NENTDFLD  = 4)

! GCTP projection codes
      parameter ( GCTP_GEO       = 0)
      parameter ( GCTP_UTM       = 1)
      parameter ( GCTP_SPCS      = 2)
      parameter ( GCTP_ALBERS    = 3)
      parameter ( GCTP_LAMCC     = 4)
      parameter ( GCTP_MERCAT    = 5)
      parameter ( GCTP_PS        = 6)
      parameter ( GCTP_POLYC     = 7)
      parameter ( GCTP_EQUIDC    = 8)
      parameter ( GCTP_TM        = 9)
      parameter ( GCTP_STEREO    = 10)
      parameter ( GCTP_LAMAZ     = 11)
      parameter ( GCTP_AZMEQD    = 12)
      parameter ( GCTP_GNOMON    = 13)
      parameter ( GCTP_ORTHO     = 14)
      parameter ( GCTP_GVNSP     = 15)
      parameter ( GCTP_SNSOID    = 16)
      parameter ( GCTP_EQRECT    = 17)
      parameter ( GCTP_MILLER    = 18)
      parameter ( GCTP_VGRINT    = 19)
      parameter ( GCTP_HOM       = 20)
      parameter ( GCTP_ROBIN     = 21)
      parameter ( GCTP_SOM       = 22)
      parameter ( GCTP_ALASKA    = 23)
      parameter ( GCTP_GOOD      = 24)
      parameter ( GCTP_MOLL      = 25)
      parameter ( GCTP_IMOLL     = 26)
      parameter ( GCTP_HAMMER    = 27)
      parameter ( GCTP_WAGIV     = 28)
      parameter ( GCTP_WAGVII    = 29)
      parameter ( GCTP_OBLEQA    = 30)
      parameter ( GCTP_ISINUS1   = 31)
      parameter ( GCTP_CEA       = 97)
      parameter ( GCTP_BCEA      = 98)
      parameter ( GCTP_ISINUS    = 99)

! Compression Modes
      parameter ( HDFE_COMP_NONE     = 0)
      parameter ( HDFE_COMP_RLE      = 1)    
      parameter ( HDFE_COMP_NBIT     = 2)
      parameter ( HDFE_COMP_SKPHUFF  = 3)    
      parameter ( HDFE_COMP_DEFLATE  = 4)
      parameter ( HDFE_COMP_SZIP     = 5)

! Tiling Codes
      parameter ( HDFE_NOTILE         = 0)
      parameter ( HDFE_TILE           = 1)

! Swath Subset Modes
      parameter ( HDFE_MIDPOINT       = 0)
      parameter ( HDFE_ENDPOINT       = 1)
      parameter ( HDFE_ANYPOINT       = 2)
      parameter ( HDFE_INTERNAL       = 0)
      parameter ( HDFE_EXTERNAL       = 1)
      parameter ( HDFE_NOPREVSUB      = -1)

! Grid Origin
      parameter ( HDFE_GD_UL         = 0)
      parameter ( HDFE_GD_UR         = 1)
      parameter ( HDFE_GD_LL         = 2)
      parameter ( HDFE_GD_LR         = 3)

! Grid Pixel Registration
      parameter ( HDFE_CENTER        = 0)
      parameter ( HDFE_CORNER        = 1)

! Angle Conversion Codes
      parameter ( HDFE_RAD_DEG      = 0)
      parameter ( HDFE_DEG_RAD      = 1)
      parameter ( HDFE_DMS_DEG      = 2)
      parameter ( HDFE_DEG_DMS      = 3)
      parameter ( HDFE_RAD_DMS      = 4)
      parameter ( HDFE_DMS_RAD      = 5)

!     SZIP parameters
      parameter (SZ_EC = 4)
      parameter (SZ_NN = 32)

! EASE GRID PARAMETERS
      parameter( BCEA_COLS25             = 1383)
      parameter( BCEA_ROWS25             = 586)
      parameter( BCEA_CELL_M             = 25067.525)
      parameter( BCEA_RE_M               = 6371228.0)
      parameter( DEFAULT_BCEA_LTRUESCALE = 30.00)
! BCEA_COS_PHI1 = cos(DEFAULT_BCEA_LTRUESCALE *3.141592653589793238 /180.0)
      parameter( BCEA_COS_PHI1                 = 0.8660254)
      parameter( PI                            = 3.141592653589793238)
      parameter( EASE_GRID_DEFAULT_UPLEFT_LON  = -180.0)
      parameter( EASE_GRID_DEFAULT_UPLEFT_LAT  = 86.72)
      parameter( EASE_GRID_DEFAULT_LOWRGT_LON  = 180.0)
      parameter( EASE_GRID_DEFAULT_LOWRGT_LAT  = -86.72)

c
c  In this example we will (1) open the "PointFile" HDF file, (2) attach to
c  the points, and (3) read data from each level of the points.
c 
	program readlevels
	

	integer*4         ptfid, ptid, recs(32)
	integer*4         fldtype(32), fldorder(32)

        integer            status, i, pntr
	integer*2          wgt
	integer*4          n, date
	
	real*4             rain, temp, conc(4)
	real*8             lon, lat, time
				
	character         fldlist*256, buffer*100000, id*2
	character          spc*4, desc*8
        character          ctime*8, cconc*16, clon*8, clat*8
	character          cdate*4, crain*4, ctemp*4, cwgt*2
	equivalence        (time,ctime), (conc,cconc), (lon,clon)
	equivalence        (lat,clat), (rain,crain), (temp,ctemp)
	equivalence        (date,cdate), (wgt,cwgt)
			
	integer           ptrdlev
	integer           ptdetach, ptclose, ptlevinfo
	integer*4         ptopen, ptattach, ptnrecs
	
	
	integer DFACC_READ
	parameter (DFACC_READ=1)

	
c
c     Open the HDF swath file, "PointFile.hdf".
c

	ptfid = ptopen("PointFile_created_with_hadeos_sample_file_write"//
     1"r_of_HDFEOS2_version_219_or_higher_release.hdf", DFACC_READ)

c
c    Read Simple Point
c
	ptid = ptattach(ptfid, "Simple Point")

	status = ptlevinfo(ptid, 0, fldlist, fldtype, fldorder)
	n = ptnrecs(ptid, 0)
	write(*,*) n 

	do 5 i=1,n
	   recs(i) = i - 1
 5	continue
	   
	status = ptrdlev(ptid, 0, fldlist, n, recs, buffer)
	pntr = 1

	do 10 i=1,n
	   ctime = buffer(pntr:pntr+8)
	   pntr = pntr + 8
	   cconc = buffer(pntr:pntr+4*4)
	   pntr = pntr + 4*4
	   spc = buffer(pntr:pntr+4)
	   pntr = pntr + 4
	   write(*,*) time, conc(1), conc(2), conc(3), conc(4), spc
10	continue
    
	status = ptdetach(ptid)
    

c
c    Read Fixed Buoy Point
c
	ptid = ptattach(ptfid, "FixedBuoy Point")

c
c       Read First (0th) Level
c
	status = ptlevinfo(ptid, 0, fldlist, fldtype, fldorder)

	n = 2
	recs(1) = 0
	recs(2) = 2
    
	pntr = 1
	status = ptrdlev(ptid, 0, fldlist, n, recs, buffer)

	do 20 i=1,n
	   desc = buffer(pntr:pntr+8)
	   pntr = pntr + 8
	   clon = buffer(pntr:pntr+8)
	   pntr = pntr + 8
	   clat = buffer(pntr:pntr+8)
	   pntr = pntr + 8
	   cdate = buffer(pntr:pntr+4)
	   pntr = pntr + 4
	   id = buffer(pntr:pntr+1)
	   pntr = pntr + 1
	   write(*,*) desc, lon, lat, date, id(1:1)
 20	continue
	
c
c    Read Second (1th) Level
c
	status = ptlevinfo(ptid, 1, fldlist, fldtype, fldorder)
	n = ptnrecs(ptid, 1)


	do 30 i=1,n

	   recs(1) = i - 1
	   status = ptrdlev(ptid, 1, fldlist, 1, recs, buffer)

	   pntr = 1
	   
	   ctime = buffer(pntr:pntr+8)
	   pntr = pntr + 8
	   crain = buffer(pntr:pntr+4)
	   pntr = pntr + 4
	   ctemp = buffer(pntr:pntr+4)
	   pntr = pntr + 4
	   id = buffer(pntr:pntr+1)
	   pntr = pntr + 1
	   write(*,*) time, rain, temp, '  ', id(1:1)
 30	continue	

	status = ptdetach(ptid)
	status = ptclose(ptfid)

	stop
	end

!/*
! * In this example we will (1) open the "GridFile" HDF file, (2) attach to
! * the "gdid" grid, and (3) set dimension scale for a dimension in a filed.
! */

	program writedimscalegrid

	integer       j, status, gddetach, gdclose
	integer*4     gdfid, gdid, gdopen, gdattach
	integer*4     gdsetdimscale, gdsetdimstrs
	real*8        veg1(120),veg2(200)
	real*8        temp1(100),temp2(100)
	integer*4     bands(3)
	integer*4     xdim,ydim,nbands

	integer DFACC_RDWR
	parameter (DFACC_RDWR=3)
	integer DFNT_FLOAT32
	parameter (DFNT_FLOAT32=5)
	integer DFNT_FLOAT64
	parameter (DFNT_FLOAT64=6)
	integer DFNT_INT32
	parameter (DFNT_INT32=24)

!    /*
!     * We first open the HDF grid file, "GridFile.hdf".  Because this file
!     * already exist and we wish to write to it, we use the DFACC_RDWR access
!     * code in the open statement.  The gdopen routine returns the grid file
!     * id, gdfid, which is used to identify the file in subsequent routines.
!     */

	gdfid = gdopen("GridFile_created_with_hadeos_sample_file_write"//
     1"r_of_HDFEOS2_version_219_or_higher_release.hdf", DFACC_RDWR)

!    /*
!     * If the grid file cannot be found, gdopen will return -1 for the file
!     * handle (gdfid).  We there check that this is not the case before
!     * proceeding with the other routines.
!     * 
!     * The gdattach routine returns the handle to the existing grid "gdid",
!     * gdid.  If the grid is not found, gdattach returns -1 for the handle.
!     */
	
	if (gdfid .ne. -1) then
	   
	   gdid = gdattach(gdfid, "UTMGrid")
	   
	   if (gdid .ne. -1) then
	      
              xdim = 120;
              ydim = 200;
	      
              status = gdsetdimscale(gdid, "Vegetation", "XDim", xdim,
     1	      DFNT_FLOAT64, veg1)
	      write(*,*) 'status: gdsetdimscale Vegetation:XDim',status
              status = gdsetdimscale(gdid, "Vegetation", "YDim", ydim,
     1	      DFNT_FLOAT64, veg2)
	      write(*,*) 'status: gdsetdimscale Vegetation:YDim',status

!	label, = 'X Dimension'
!	unit, = 'meters'
!	format, = 'F7.2'

              status = gdsetdimstrs(gdid, "Vegetation", "YDim", 
     1	      "Y Dimension", "meters", "F7.2")

	   endif

	   status = gddetach(gdid)

	   gdid = gdattach(gdfid, "PolarGrid")
	   if (gdid .ne. -1) then
	      
	      xdim = 100
	      ydim = 100
	      
	      status = gdsetdimscale(gdid, "Temperature", "XDim", xdim,
     1	      DFNT_FLOAT64, temp1)
	      write(*,*) 'status: gdsetdimscale Temperature:XDim',status
	      write(*,*) 'this -1 was expected for Temperature:XDim'
	      status = gdsetdimscale(gdid, "Temperature", "YDim", ydim,
     1	      DFNT_FLOAT64, temp2)
	      write(*,*) 'status: gdsetdimscale Temperature:YDim',status
	      write(*,*) 'this -1 was expected for Temperature:YDim'
	      nbands = 3;
	      do j=1,nbands
		 bands(j) = j*2+1
	      enddo
	      status = gdsetdimscale(gdid, "Spectra", "YDim", ydim, 
     1	      DFNT_FLOAT64, temp2)
	      write(*,*) 'status: gdsetdimscale Spectra:YDim',status

 	      status = gdsetdimscale(gdid, "Spectra", "Bands", nbands,
     1	      DFNT_INT32, bands);
	      write(*,*) 'status: gdsetdimscale Spectra:Bands',status
	      
	      status = gdsetdimstrs(gdid, "Spectra", "YDim", "YDim Dim",
     1	      "meters", "F7.2")
	      
	      status = gdsetdimstrs(gdid, "Spectra", "Bands", "BANDS",
     1	      "None", "I2")
	      
	      status = gddetach(gdid)
	   endif
	   
	   status = gdclose(gdfid)
	endif
	stop
	end

!/*
! * In this example we will (1) open the "SwathFile" HDF file, (2) attach to
! * the "swid" swath, and (3) set dimension scale for a dimension in a filed.
! */

	program readdimscaleswath
	
	integer       j, status, swdetach, swclose
	integer*4     swfid, swid, swopen, swattach
	integer*4     swdiminfo
	integer*4     swgetdimscale, swgetdimstrs
	real*8        BuffGeoTrack(20)
	integer*4     dimsize
	integer*4     dimsize1
 	integer*4     nbands
	integer*4     bands(15)
	integer*4     ntype(32)
	character*16  label, unit, format
	integer*4     len
	integer DFACC_RDWR
	parameter (DFACC_RDWR=3)
	integer DFNT_FLOAT32
	parameter (DFNT_FLOAT32=5)
	integer DFNT_FLOAT64
	parameter (DFNT_FLOAT64=6)
	integer DFNT_INT32
	parameter (DFNT_INT32=24)

!    /*
!     * We first open the HDF swath file, "SwathFile.hdf".  Because this file
!     * already exist and we wish to write to it, we use the DFACC_RDWR access
!     * code in the open statement.  The swopen routine returns the swath file
!     * id, swfid, which is used to identify the file in subsequent routines.
!     */

	swfid = swopen("SwathFile_created_with_hadeos_sample_file_write"//
     1"r_of_HDFEOS2_version_219_or_higher_release.hdf", DFACC_RDWR)

!    /*
!     * If the swath file cannot be found, swopen will return -1 for the file
!     * handle (swfid).  We there check that this is not the case before
!     * proceeding with the other routines.
!     * 
!     * The swattach routine returns the handle to the existing swath "swid",
!     * swid.  If the swath is not found, swattach returns -1 for the handle.
!     */

	if (swfid .ne. -1) then
	   
	   swid = swattach(swfid, "Swath1")
	   
	   if (swid .ne. -1) then
	      
	      dimsize = swdiminfo(swid, "GeoTrack")
	      
	      write(*,*) 'GeoTrack dim size (Swath1): ', dimsize
	      
	      buffsize = swgetdimscale(swid, "Temperature", "GeoTrack", 
     1	   dimsize1, ntype,BuffGeoTrack)
	      if (buffsize .eq. -1) then	   
		 write(*,*) 'Error:Cannot get Dim Scale for',
     1	      ' GeoTrack in field Density'
		 stop  
	      else
		 write(*,*) 'For Density field GeoTrack: buffsize = ',
     1	      buffsize
	      write(*,*) 'GeoTrack dimsize1 (Swath1): ', dimsize1
	      endif
	      
	      write(*,*) 'For Density field GeoTrack',
     1                   ' dimension scale values:'
	      do j=1,dimsize
		 write(*,*) 'j =',j,'  BuffGeoTrack = ',BuffGeoTrack(j)
	      enddo
	      write(*,*) '  '
	      
	      len = 15
	      
	      status = swgetdimstrs(swid, "Temperature", "GeoTrack", 
     1	   label, unit, format, len)
	      
	      
	      if(status .eq. 0) then	  
	       write(*,*) 'For Density field GeoTrack dimension scale',
     1                      ' attr. strings:'
	       write(*,*) 'label =',label,
     1	      '  unit =',unit,'  format = ',format
	      endif
	      write(*,*) ' '
	      
				!         nbands = 15
	      
	      dimsize = swdiminfo(swid, "Bands");
	      status = swgetdimscale(swid, "Spectra", "Bands", 
     1	   nbands, ntype, bands)
	      write(*,*) 'For nbands for Spectra field = ',nbands
	      write(*,*) 'For Spectra field Bands dim scale values:'
	      do j=1,nbands
		 write(*,*) 'j =',j,'         Bnads = ',bands(j)
	      enddo
	      write(*,*) '  '
	      
	      status = swgetdimstrs(swid, "Spectra", "Bands", 
     1	   label, unit, format, len)
	      
	      if(status .eq. 0) then
		 write(*,*) 'For Spectra field Bands dim scale',
     1		 ' attr. strings:'
		 write(*,*) 'label =',label,'  unit =',
     1	      unit,'  format = ',format
	      endif
	      status = swdetach(swid)
	   endif
	   status = swclose(swfid)
	endif 
	stop
	end
	

#!/bin/csh -f
#-----------------------------------------------------------------------------
# file:         cleanup.csh
#
# description:
#       Shell script to cleanup all the files produced by testing (these files
#       include driver output files, difference files and old binaries).
#
# usage:
#       cleanup.csh [GROUP1 GROUP2]  (ex. cleanup.csh point grid)
#
# author:
#       Jason R. Watts / Hughes Applied Information Systems
#       Abe Taaheri / Raytheon IIS
# history:
#       26-Jul-1995 JRW Initial version
#       11-Jul-2014 AT  Initial version for hdfeos2
#----------------------------------------------------------------------------

# set the tool group directories to be cleaned
# If no tool groups are input on the command line,
# then clean all of the groups.

if ($#argv > 0) then
    set TOOL_GRPS = ($argv)
else
    set TOOL_GRPS = (point grid swath)
endif


# loop through each group and cleanup that directory

foreach group ($TOOL_GRPS)

        if (-d $HDFEOS2_TST_SRC/$group) then

            echo ""; echo "Removing test files in $HDFEOS2_TST_SRC/$group ..."; echo ""
            cd $HDFEOS2_TST_SRC/$group
            \rm -f *.txtout *.diff *out *out.* *_f *_c core *.o
        endif
end

#!/bin/csh -f
#-----------------------------------------------------------------------------
# file:         diff.csh
#
# description:
#       Shell script to compare two output files, removing
#       differences caused by time/date stamps, host names
#       missing leading zeros, and other values that change 
#       over time
#
# usage:
#       diff.csh file_name.out_sample file_name.out...
#
# author:
#       Carl R Fosler / Intermetrics, Inc.
#
# history:
#        29-Aug-1997 CRF Initial version
#       11-Jul-2014 AT  Initial version for hdfeos2
#
#
#   Inputs:
#     $1 = file_name.out_sample
#     $2 = file_name.out.xxx
#
#
  if ( ! -r $1 ) then
	echo "ERROR - unable to read input file $1"
	exit -1
  endif
#
  if ( ! -r $2 ) then
	echo "ERROR - unable to read input file $2"
	exit -1
  endif
#
  set filen = "`basename $1 .out_sample`"
  echo $filen
#
  set sample_temp = "/tmp/$$.sample"
  set out_temp    = "/tmp/$$.out"
#
   if ( -r $filen"77.out" || -r $filen"90.out" ) then
#
# fortran
#
     \rm -f $sample_temp $out_temp
     sed -e "/ -\./s/-\./-0\./g" \
         -e "/ \./s/ \./ 0./g" \
         -e "/File Attribute/d" \
         -e "/Reference ID/d" \
         -e "/BEGIN_PGE: /d" \
         -e "/FILE: /d" \
         -e "/pgstest/s,/usr/pgstest/HDFEOS2/message,$PGSMSG,g" \
         -e "/PGSTK/s,/ecs/sdps/pgs/HDFEOS2/message,$PGSMSG,g" \
         -e "/pgstest/s,/fire2/pgstest/TOOLKIT/message,$PGSMSG,g" \
         -e "/open file/s,No such file or directory,No such file," \
                 $1 > $sample_temp
     sed -e "/ -\./s/-\./-0\./g" \
         -e "/ \./s/ \./ 0./g" \
         -e "/File Attribute/d" \
         -e "/Reference ID/d" \
         -e "/BEGIN_PGE: /d" \
         -e "/FILE: /d" \
         -e "/PGS_E_UNIX/s,No such file or,No such file," \
         -e "/PGS_E_UNIX/s,No such file o,No such file," \
                 $2 > $out_temp
     diff -bw $out_temp $sample_temp
     \rm -f $sample_temp $out_temp
#
# C or shell
#
  else

     \rm -f $sample_temp $out_temp
     sed -e "/Value of file pointer/d" \
         -e "/Machine Name/d" \
         -e "/Start Date/d" \
         -e "/End Date/d" \
         -e "/\*\*\*\*\*-----/d" \
         -e "/\*\*\*---/d" \
         -e "/File Attribute/d" \
         -e "/Reference ID/d" \
         -e "/BEGIN_PGE: /d" \
         -e "/FILE: /d" \
         -e "/File Reference :/d" \
         -e "/Attribute :/d" \
         -e "/\-0.000/s/\-0.000/ 0.000/g" \
         -e "/PGSTK/s,/ecs/sdps/pgs/PGSTK/message,$PGSMSG,g" \
         -e "/pgstest/s,/fire2/pgstest/TOOLKIT/message,$PGSMSG,g" \
         -e "/bin/s,/fire2/pgstest/TOOLKIT/bin/sun5,$PGSBIN,g" \
         -e "/TOOLKIT/s,/fire2/pgstest/TOOLKIT/test/test_drivers,$HDFEOS2_TST_SRC,g" \
         -e "/runtime/s,/fire2/pgstest/TOOLKIT/runtime,$PGSRUN,g" \
			$1 > $sample_temp
     sed -e "/Value of file pointer/d" \
	 -e "/Machine Name/d" \
         -e "/Start Date/d" \
         -e "/End Date/d" \
         -e "/\*\*\*\*\*-----/d" \
         -e "/\*\*\*---/d" \
         -e "/File Attribute/d" \
         -e "/Reference ID/d" \
         -e "/BEGIN_PGE: /d" \
         -e "/FILE: /d" \
         -e "/File Reference :/d" \
         -e "/Attribute :/d" \
         -e "/\-0.000/s/\-0.000/ 0.000/g" \
                   	$2 > $out_temp

#  The negative zero test is not right, but since we convert both
#  the sample output as well as the output, this will convert all
#  strings with -0.000 to  0.000, so that even very small numbers
#  will get convert to postive numbers, but for our comparision, this
#  is good enought for now.  CRF

     diff -bw $out_temp $sample_temp
     \rm -f $sample_temp $out_temp

  endif

  echo "$filen done"

# Clear all conditional flags
setenv MACINTEL_COMP_FLAG "-mmacosx-version-min=10.5 -isysroot /Developer/SDKs/MacOSX10.5.sdk -fPIC"
set MAC_BRAND=macintel64	        # set MACINTEL for -64 mode
#setenv LNX_COMP_FLAG "-m32"
#set LINUX_BRAND=linux32		# set LINUX for -32 mode
setenv HDFEOS_HOME  /net/origin/devdata1/ataaheri/TK2.20_dev_2017_new/TOOLKIT/hdfeos
setenv HDFEOS5_HOME /net/origin/devdata1/ataaheri/TK2.20_dev_2017_new/TOOLKIT/hdfeos5
setenv HDFHOME  /net/origin/devdata1/ataaheri/TK2.20_dev_2017_new/TOOLKIT/hdf/$BRAND/hdf-4.2.13
setenv HDF5HOME /net/origin/devdata1/ataaheri/TK2.20_dev_2017_new/TOOLKIT/hdf5/$BRAND/hdf5-1.8.19
setenv SZIPHOME /net/origin/devdata1/ataaheri/TK2.20_dev_2017_new/TOOLKIT/szip/$BRAND/szip-2.1.1
setenv JPEGHOME /net/origin/devdata1/ataaheri/TK2.20_dev_2017_new/TOOLKIT/jpeg/$BRAND/jpeg-9b
setenv ZLIBHOME /net/origin/devdata1/ataaheri/TK2.20_dev_2017_new/TOOLKIT/zlib/$BRAND/zlib-1.2.11
#-----------------------------------------------------------------------------
# file:	
# 	hdfeos2_env.csh
#
# description:
# 	This file defines environment variables used for hdfeos2 testdrivers.
# 	This version is for use under the C shell (csh).
#
# usage:
# 	This file should before soutced after setting correct 
#       HDFEOS_HOME, HDFHOME, and SZIPHOME above
#
# 	    source <HDFEOS2_TST_DIR>/Common/hdfeos2_env.csh
#	
# 	where <HDFEOS2_TST_DIR> is the full path of the  HDF-EOS2
#       testdriver home directory, set before running test scripts.
#
# author:
#	Abe Taaheri / Raytheon IIS
#
# notes:
# 	   
#
#
#-----------------------------------------------------------------------------
set pgs_path  = ( $path )       # add SZIPBIN to pgs  path
set user_path = ( $path )	# save user path

# set path to a base subset of directories, allowing startup on unknown host
# note: once the host has been determined the path is appropriately customized

set path=(/usr/local/bin /bin /usr/bin /etc /usr/etc /usr/ucb /usr/bin/X11)


# get operating system type, login
# special cases: SCO and Cray  - uname works differently,

setenv MACHINE `uname -m | awk '{print $1}'`	# needed on Cray & SCO

switch ( "$MACHINE" )

    case "i386":        			# SCO box
        breaksw

    case "CRAY":    				# CRAY
        breaksw

    default:					# everybody else
	setenv OSTYPE `uname`
        breaksw

endsw

# Intel Macintosh is also i386 or i686 (?) machine

    if ( "$MACHINE" == "i386" ) then
	if ( "$temp_ostype" == "Darwin" ) then 
	    setenv OSTYPE DarwinIntel
	endif
    endif
    if ( "$MACHINE" == "i686" ) then
	if ( "$temp_ostype" == "Darwin" ) then 
	    setenv OSTYPE DarwinIntel
	endif
    endif


set user=`id | cut -d\( -f2 | cut -d\) -f1`
if ($?LOGNAME == 0) setenv LOGNAME $user	# make sure $LOGNAME is defined
setenv USER $LOGNAME				# make sure $USER is defined


# set machine-dependent environment variables:
# 	HOST  the host name of this machine
# 	BRAND used by other achitecture-specific code
# 	path  the execution search path exported to PATH

switch ( "$OSTYPE" )

    case "AIX": 
	set path=(/usr/local/bin /bin /usr/bin /etc /usr/etc /usr/ucb /usr/bin/X11 /usr/ccs/bin /usr/sbin)
	setenv HOST `hostname`
        breaksw

    case "HP-UX": 
	set path=(/usr/local/bin /bin /usr/bin /etc /usr/etc /usr/bin/X11)
	setenv HOST `hostname`
        breaksw

    case "IRIX":  
	set path=(/usr/local/bin /bin /usr/bin /etc /usr/etc /usr/bsd /usr/bin/X11 /usr/sbin)
	setenv HOST `hostname`
        breaksw

    case "IRIX64":  
	set path=(/usr/local/bin /bin /usr/bin /etc /usr/etc /usr/bsd /usr/bin/X11 /usr/sbin)
	setenv HOST `hostname`
        breaksw

    case "Linux": 
	set path=(/usr/local/bin /bin /usr/bin /etc /usr/etc /usr/X11/bin)
	setenv HOST `hostname`
        breaksw

    case "Linux32": 
	set path=(/usr/local/bin /bin /usr/bin /etc /usr/etc /usr/X11/bin)
	setenv HOST `hostname`
        breaksw

    case "Linux64": 
	set path=(/usr/local/bin /bin /usr/bin /etc /usr/etc /usr/X11/bin)
	setenv HOST `hostname`
        breaksw

    case "DarwinIntel":
        set path=(/bin /sbin /usr/bin /usr/sbin)
        setenv HOST `hostname -s`
         breaksw

    case "SunOS": 
	set path=(/usr/local/bin /bin /usr/bin /etc /usr/etc /usr/bin/X11)
        breaksw

    case "UNICOS": 
	set path=(/usr/local/bin /bin /usr/bin /etc /usr/ucb /usr/bin/X11)
	setenv HOST `hostname`
        breaksw

    default:
	echo "Operating system: $OSTYPE not supported"
        breaksw

endsw

# set machine-dependent compilers and compilation switches:
#
#

switch ($BRAND)

    case cray:
	setenv CC cc 			# C compiler
	setenv CFLAGS "" 		# default C flags (optimize, ansi)
	setenv C_CFH "-DCRAYFortran"    # C/cfortran.h called from FORTRAN
	setenv CFHFLAGS "$CFLAGS $C_CFH" # CFLAGS + C_CFH
	setenv F77 cf77			# FORTRAN compiler
	setenv F77FLAGS "" 		# common FORTRAN flags
        setenv F77_CFH ""               # FORTRAN callable from C w/ cfortran.h
	setenv F77_C_CFH ""          	# calling C w/ cfortran.h
	setenv F77_C_LIB ""		# C lib called by FORTRAN main 
	setenv HDFSYS UNICOS		# system type as defined by HDF
	breaksw

    case dec:
	setenv CC cc 			# C compiler
	setenv CFLAGS "-std"		# default C flags (optimize, ansi)
	setenv C_CFH "-DDECFortran"	# C w/ cfortran.h callable from FORTRAN
	setenv CFHFLAGS "$CFLAGS $C_CFH" # CFLAGS + C_CFH
	setenv F77 f77 			# FORTRAN compiler
	setenv F77FLAGS "" 		# common FORTRAN flags
        setenv F77_CFH ""               # FORTRAN callable from C w/ cfortran.h
	setenv F77_C_CFH ""             # calling C w/ cfortran.h
	setenv F77_C_LIB ""		# C lib called by FORTRAN main
	setenv HDFSYS DEC_ALPHA		# system type as defined by HDF
	breaksw

    case hp:
	setenv CC cc 			# C compiler
	setenv CFLAGS "-Ae" 		# default C flags (optimize, ansi)
	setenv C_CFH "" 		# C w/ cfortran.h callable from FORTRAN
	setenv CFHFLAGS "$CFLAGS $C_CFH" # CFLAGS + C_CFH
	setenv F77 fort77		# FORTRAN compiler
	setenv F77FLAGS "" 		# common FORTRAN flags
        setenv F77_CFH ""               # FORTRAN callable from C w/ cfortran.h
	setenv F77_C_CFH ""          	# calling C w/ cfortran.h
	setenv F77_C_LIB ""		# C lib called by FORTRAN main
	setenv HDFSYS HP9000		# system type as defined by HDF
	breaksw

    case ibm:
	setenv CC cc 			# C compiler
	setenv CFLAGS "-qlanglvl=ansi" # default C flags (optimize, ansi)
	setenv C_CFH "" 		# C w/ cfortran.h callable from FORTRAN
	setenv CFHFLAGS "$CFLAGS $C_CFH" # CFLAGS + C_CFH
	setenv F77 xlf 			# FORTRAN compiler
	setenv F77FLAGS "" 		# common FORTRAN flags
        setenv F77_CFH ""               # FORTRAN callable from C w/ cfortran.h
	setenv F77_C_CFH ""          	# calling C w/ cfortran.h
	setenv F77_C_LIB ""		# C lib called by FORTRAN main
	setenv HDFSYS IBM6000		# system type as defined by HDF
	breaksw

    case linux:
    case linux32:
	echo " Setting 32-bit LINUX environment variables"
	setenv CC "gcc -m32" 			# C compiler
	setenv CFLAGS ""	# default C flags (optimize, ansi)
	setenv C_CFH "-Df2cFortran"	# C w/ cfortran.h callable from FORTRAN
	setenv CFHFLAGS "$CFLAGS $C_CFH" # CFLAGS + C_CFH
	setenv F77 "g77 -m32"			# FORTRAN compiler
	setenv F77FLAGS "-fno-second-underscore" # common FORTRAN flags
        setenv F77_CFH "-fno-second-underscore"          # FORTRAN callable from C w/ cfortran.h
	setenv F77 "g77 -m32"		# FORTRAN compiler - default
	setenv F77_C_CFH ""          	# calling C w/ cfortran.h
	setenv F77_C_LIB ""		# C lib called by FORTRAN main
	setenv HDFSYS LINUX		# system type as defined by HDF
	breaksw

    case linux64:
	echo " Setting 64-bit LINUX environment variables"
	setenv CC "gcc -fPIC" 			# C compiler
	setenv CFLAGS ""	# default C flags (optimize, ansi)
	setenv C_CFH "-Df2cFortran"	# C w/ cfortran.h callable from FORTRAN
	setenv CFHFLAGS "$CFLAGS $C_CFH" # CFLAGS + C_CFH
	setenv F77 "g77 -fPIC"			# FORTRAN compiler
	setenv F77FLAGS "-fno-second-underscore" # common FORTRAN flags
        setenv F77_CFH "-fno-second-underscore"          # FORTRAN callable from C w/ cfortran.h
	setenv F77 "g77 -fPIC"		# FORTRAN compiler - default
	setenv F77_C_CFH ""          	# calling C w/ cfortran.h
	setenv F77_C_LIB ""		# C lib called by FORTRAN main
	setenv HDFSYS LINUX		# system type as defined by HDF
	breaksw

    case macintosh:
        setenv CC gcc                   # C compiler
        setenv CFLAGS "-O2 -DMACINTOSH" # default C flags (optimize, ansi)
        setenv C_CFH "-Df2cFortran"     # C w/ cfortran.h callable from FORTRAN
        setenv CFHFLAGS "$CFLAGS $C_CFH"# CFLAGS + C_CFH
        setenv F77 gfortran                  # FORTRAN compiler - default
        setenv F77FLAGS "-O2 -fno-second-underscore" # common FORTRAN flags  
        setenv F77_CFH "-fno-second-underscore"      # FORTRAN callable from C w/cfortran.h
        setenv F77_C_CFH ""             # calling C w/ cfortran.h
        setenv F77_C_LIB ""             # C lib called by FORTRAN main
        setenv HDFSYS MACINTOSH         # system type as defined by HDF
        breaksw

    case macintel:
    case macintel32:
    case macintel64:
        setenv CC "gcc $MACINTEL_COMP_FLAG"                 # C compiler
        setenv CFLAGS "$opt_flag $ext_cc_flags -ansi" # default C flags (optimize, ansi)
        setenv C_CFH "-Df2cFortran"     # C w/ cfortran.h callable from FORTRAN
        setenv CFHFLAGS "$CFLAGS $C_CFH" # CFLAGS + C_CFH
        setenv C_F77_CFH "$C_CFH"       # calling FORTRAN
        setenv C_F77_LIB ""             # FORTRAN lib called by C main
        setenv F77 "gfortran $MACINTEL_COMP_FLAG"                # FORTRAN compiler
        setenv F77FLAGS " $ext_fc_flags "              # common FORTRAN flags
        setenv F77_CFH ""               # FORTRAN callable from C w/ cfortran.h
        setenv F77_C_CFH "$F77_CFH"     # calling C w/ cfortran.h
        setenv CFH_F77 "$F77_C_CFH"     # old version of F77_C_CFH
        setenv F77_C_LIB ""             # C lib called by FORTRAN main
        setenv HDFSYS MACINTEL         # system type as defined by HDF
        setenv MACHINE MACINTEL        # system type as defined by HDFEOS
        breaksw

    case sco:
	setenv CC cc 			# C compiler
	setenv CFLAGS " -posix"	# default C flags (optimize, ansi)
	setenv C_CFH "-Df2cFortran"	# C w/ cfortran.h callable from FORTRAN
	setenv CFHFLAGS "$CFLAGS $C_CFH" # CFLAGS + C_CFH
	setenv F77 ""			# FORTRAN compiler
	setenv F77FLAGS "" 		# common FORTRAN flags
        setenv F77_CFH ""               # FORTRAN callable from C w/ cfortran.h
	setenv F77_C_CFH ""          	# calling C w/ cfortran.h
	setenv F77_C_LIB ""		# C lib called by FORTRAN main
	setenv HDFSYS SCO		# system type as defined by HDF
	breaksw

    case sgi:
	if ($OSTYPE == "IRIX64") then
		setenv CC "cc -32"	# C compiler (32 bit)
		setenv F77 "f77 -32"	# FORTRAN compiler (32 bit)
	else
                setenv CC cc		# C compiler
                setenv F77 f77		# FORTRAN compiler
	endif
	setenv CFLAGS "-xansi -D_POSIX_SOURCE"	# default C flags (optimize, ansi)
	setenv C_CFH ""	 		# C w/ cfortran.h callable from FORTRAN
	setenv CFHFLAGS "$CFLAGS $C_CFH" # CFLAGS + C_CFH
	setenv F77FLAGS "" 		# common FORTRAN flags
        setenv F77_CFH ""               # FORTRAN callable from C w/ cfortran.h
	setenv F77_C_CFH ""          	# calling C w/ cfortran.h
	setenv F77_C_LIB ""		# C lib called by FORTRAN main
	setenv HDFSYS IRIX		# system type as defined by HDF
	breaksw

    case sgi32:
	setenv CC "cc -n32"		# C compiler (new-style 32 bit)
	setenv F77 "f77 -n32"		# FORTRAN compiler (new-style 32 bit)
	setenv CFLAGS "-xansi -D_POSIX_SOURCE"	# default C flags (optimize, ansi)
	setenv C_CFH ""	 		# C w/ cfortran.h callable from FORTRAN
	setenv CFHFLAGS "$CFLAGS $C_CFH" # CFLAGS + C_CFH
	setenv F77FLAGS "" 		# common FORTRAN flags
        setenv F77_CFH ""               # FORTRAN callable from C w/ cfortran.h
	setenv F77_C_CFH ""          	# calling C w/ cfortran.h
	setenv F77_C_LIB ""		# C lib called by FORTRAN main
	setenv HDFSYS IRIX		# system type as defined by HDF
	breaksw

    case sgi64:
        if (`hinv | fgrep CPU | cut -d' ' -f3 | cut -b2` == "4") then
                setenv CC "cc -64 -mips3"       # C compiler (R4?00 chip)
                setenv F77 "f77 -64 -mips3"     # FORTRAN compiler (R4?00 chip)
        else
                setenv CC "cc -64"      # C compiler
                setenv F77 "f77 -64"    # FORTRAN compiler
        endif
	setenv CFLAGS "xansi -D_POSIX_SOURCE"	# default C flags (optimize, ansi)
	setenv C_CFH ""	 		# C w/ cfortran.h callable from FORTRAN
	setenv CFHFLAGS "$CFLAGS $C_CFH" # CFLAGS + C_CFH
	setenv F77FLAGS "" 		# common FORTRAN flags
        setenv F77_CFH ""               # FORTRAN callable from C w/ cfortran.h
	setenv F77_C_CFH ""          	# calling C w/ cfortran.h
	setenv F77_C_LIB ""		# C lib called by FORTRAN main
	setenv HDFSYS IRIX		# system type as defined by HDF
	breaksw

    case irix65:
	setenv CC "cc -n32"		# C compiler (new-style 32 bit)
	setenv F77 "f77 -n32"		# FORTRAN compiler (new-style 32 bit)
	setenv CFLAGS "-xansi -D_POSIX_SOURCE"	# default C flags (optimize, ansi)
	setenv C_CFH ""	 		# C w/ cfortran.h callable from FORTRAN
	setenv CFHFLAGS "$CFLAGS $C_CFH" # CFLAGS + C_CFH
	setenv F77FLAGS "" 		# common FORTRAN flags
        setenv F77_CFH ""               # FORTRAN callable from C w/ cfortran.h
	setenv F77_C_CFH ""          	# calling C w/ cfortran.h
	setenv F77_C_LIB ""		# C lib called by FORTRAN main
	setenv HDFSYS IRIX		# system type as defined by HDF
	breaksw

	
    case sun4:
	setenv CC acc			# C compiler
	setenv CFLAGS "-Xa" 		# default C flags (optimize, ansi)
	setenv C_CFH "-DsunFortran"	# C w/ cfortran.h callable from FORTRAN
	setenv CFHFLAGS "$CFLAGS $C_CFH" # CFLAGS + C_CFH
	setenv F77 f77 			# FORTRAN compiler
	setenv F77FLAGS "" 		# common FORTRAN flags
        setenv F77_CFH ""               # FORTRAN callable from C w/ cfortran.h
	setenv F77_C_CFH ""           	# calling C w/ cfortran.h
	setenv F77_C_LIB "-lm" 		# C lib called by FORTRAN main
	setenv HDFSYS SUN		# system type as defined by HDF
	breaksw

    case sun5:
	setenv CC cc			# C compiler
	setenv CFLAGS "-Xa" 		# default C flags (optimize, ansi)
	setenv C_CFH "-DsunFortran"	# C w/ cfortran.h callable from FORTRAN
	setenv CFHFLAGS "$CFLAGS $C_CFH" # CFLAGS + C_CFH
	setenv F77 f77 			# FORTRAN compiler
	setenv F77FLAGS "" 		# common FORTRAN flags
        setenv F77_CFH ""               # FORTRAN callable from C w/ cfortran.h
	setenv F77_C_CFH ""           	# calling C w/ cfortran.h
	setenv F77_C_LIB "-lm" 		# C lib called by FORTRAN main
	setenv HDFSYS SUN		# system type as defined by HDF
	breaksw

     case sun5.8:
	setenv CC cc			# C compiler
	setenv CFLAGS "-Xa" 		# default C flags (optimize, ansi)
	setenv C_CFH "-DsunFortran"	# C w/ cfortran.h callable from FORTRAN
	setenv CFHFLAGS "$CFLAGS $C_CFH" # CFLAGS + C_CFH
	setenv F77 f77 			# FORTRAN compiler
	setenv F77FLAGS "" 		# common FORTRAN flags
        setenv F77_CFH ""               # FORTRAN callable from C w/ cfortran.h
	setenv F77_C_CFH ""           	# calling C w/ cfortran.h
	setenv F77_C_LIB "-lm" 		# C lib called by FORTRAN main
	setenv HDFSYS SUN		# system type as defined by HDF
	breaksw

     case sun5.9:
	setenv CC cc			# C compiler
	setenv CFLAGS "-Xa" 		# default C flags (optimize, ansi)
	setenv C_CFH "-DsunFortran"	# C w/ cfortran.h callable from FORTRAN
	setenv CFHFLAGS "$CFLAGS $C_CFH" # CFLAGS + C_CFH
	setenv F77 f77 			# FORTRAN compiler
	setenv F77FLAGS "" 		# common FORTRAN flags
        setenv F77_CFH ""               # FORTRAN callable from C w/ cfortran.h
	setenv F77_C_CFH ""           	# calling C w/ cfortran.h
	setenv F77_C_LIB "-lm" 		# C lib called by FORTRAN main
	setenv HDFSYS SUN		# system type as defined by HDF
	breaksw

     case sun5.10:
	setenv CC cc			# C compiler
	setenv CFLAGS "-Xa" 		# default C flags (optimize, ansi)
	setenv C_CFH "-DsunFortran"	# C w/ cfortran.h callable from FORTRAN
	setenv CFHFLAGS "$CFLAGS $C_CFH" # CFLAGS + C_CFH
	setenv F77 f77 			# FORTRAN compiler
	setenv F77FLAGS "" 		# common FORTRAN flags
        setenv F77_CFH ""               # FORTRAN callable from C w/ cfortran.h
	setenv F77_C_CFH ""           	# calling C w/ cfortran.h
	setenv F77_C_LIB "-lm" 		# C lib called by FORTRAN main
	setenv HDFSYS SUN		# system type as defined by HDF
	breaksw
     case sun5.11:
	setenv CC "gcc -m32"  		# C compiler
	setenv CFLAGS "-Xa" 		# default C flags (optimize, ansi)
	setenv C_CFH "-DsunFortran"	# C w/ cfortran.h callable from FORTRAN
	setenv CFHFLAGS "$CFLAGS $C_CFH" # CFLAGS + C_CFH
	setenv F77 "gfortran -m32 "			# FORTRAN compiler
	setenv F77FLAGS "" 		# common FORTRAN flags
        setenv F77_CFH ""               # FORTRAN callable from C w/ cfortran.h
	setenv F77_C_CFH ""           	# calling C w/ cfortran.h
	setenv F77_C_LIB "-lm" 		# C lib called by FORTRAN main
	setenv HDFSYS SUN		# system type as defined by HDF
	breaksw
    default:
	setenv CC cc 			# C compiler
	setenv CFLAGS "" 		# default C flags (optimize)
	setenv C_CFH ""	        	# C w/ cfortran.h callable from FORTRAN
	setenv CFHFLAGS "$CFLAGS $C_CFH" # CFLAGS + C_CFH
	setenv F77 f77  		# FORTRAN compiler
	setenv F77FLAGS "" 		# common FORTRAN flags
        setenv F77_CFH ""               # FORTRAN callable from C w/ cfortran.h
	setenv F77_C_CFH ""           	# calling C w/ cfortran.h
	setenv F77_C_LIB "-lm" 		# C lib called by FORTRAN main
	setenv HDFSYS unknown		# system type as defined by HDF
	breaksw
endsw


# set HDF-related environment variables
# these may be referred to in makefiles and on compiler command lines

#
# Set HDF directories:
#
# - first look in $HDFHOME
# - if not found, default to $HDFHOME/hdf
#

if ($?HDFHOME) then

    if ( -d $HDFHOME/bin ) then		# HDF utilities
        setenv HDFBIN $HDFHOME/bin
    else
        setenv HDFBIN $HDFHOME/hdf/bin
    endif

    if ( -d $HDFHOME/include ) then	# HDF header files
        setenv HDFINC $HDFHOME/include
	setenv JPEGINC $HDFHOME/include
	setenv ZLIBINC $HDFHOME/include
    else
	if ( -d $HDFHOME/hdf/include ) then	# HDF header files
	    setenv HDFINC $HDFHOME/hdf/include
	    setenv JPEGINC $HDFHOME/hdf/include
	    setenv ZLIBINC $HDFHOME/hdf/include
	else
	    setenv HDFINC $HDFHOME/hdf4/include
	    setenv JPEGINC $HDFHOME/hdf4/include
	    setenv ZLIBINC $HDFHOME/hdf4/include
	endif
    endif

    if ( -d $HDFHOME/lib ) then		# HDF libraries
        setenv HDFLIB $HDFHOME/lib
        setenv JPEGLIB $HDFHOME/lib
        setenv ZLIBLIB $HDFHOME/lib
    else
	if ( -d $HDFHOME/hdf/lib ) then		# HDF libraries
	    setenv HDFLIB $HDFHOME/hdf/lib
	    setenv JPEGLIB $HDFHOME/hdf/lib
	    setenv ZLIBLIB $HDFHOME/hdf/lib
	else
	    setenv HDFLIB $HDFHOME/hdf4/lib
	    setenv JPEGLIB $HDFHOME/hdf4/lib
	    setenv ZLIBLIB $HDFHOME/hdf4/lib
	endif
    endif


    set pgs_path  = ($pgs_path  $HDFBIN)	# add HDFBIN to pgs  path
    set user_path = ($user_path $HDFBIN)	# add HDFBIN to user path

endif

#
# Set HDF5 directories:
#
# - first look in $HDF5HOME
# - if not found, default to $HDF5HOME/hdf5
#

if ($?HDF5HOME) then

    if ( -d $HDF5HOME/bin ) then                # HDF5 utilities
        setenv HDF5BIN $HDF5HOME/bin
    else
        setenv HDF5BIN $HDF5HOME/hdf5/bin
    endif

    if ( -d $HDF5HOME/include ) then    	# HDF5 header files
        setenv HDF5INC $HDF5HOME/include
    else
        setenv HDF5INC $HDF5HOME/hdf5/include
    endif

    if ( -d $HDF5HOME/lib ) then                # HDF5 libraries
        setenv HDF5LIB $HDF5HOME/lib
    else
        setenv HDF5LIB $HDF5HOME/hdf5/lib
    endif



    set pgs_path  = ($pgs_path  $HDF5BIN)       # add HDF5BIN to pgs  path
    set user_path = ($user_path $HDF5BIN)       # add HDF5BIN to user path

endif

#
# Set SZIP directories:
#
# - first look in $SZIPHOME
# - if not found, default to $SZIPHOME/szip
#

if ($?SZIPHOME) then

if ( -d $SZIPHOME/bin ) then         # SZIP utilities
        setenv SZIPBIN $SZIPHOME/bin
    else
        setenv SZIPBIN $HDFHOME/szip/bin
    endif

if ( -d $SZIPHOME/include ) then     # SZIP header files
        setenv SZIPINC $SZIPHOME/include
    else
        setenv SZIPINC $SZIPHOME/szip/include
    endif

    if ( -d $SZIPHOME/lib ) then         # SZIP libraries
        setenv SZIPLIB $SZIPHOME/lib
    else
        setenv SZIPLIB $SZIPHOME/szip/lib
    endif


    set pgs_path  = ($pgs_path  $SZIPBIN)        # add SZIPBIN to pgs  path
    set user_path = ($user_path $SZIPBIN)        # add SZIPBIN to user path

endif
  
#
# Set HDF-EOS directories:
#

if ($?HDFEOS_HOME) then

    setenv HDFEOS_INC $HDFEOS_HOME/include
    setenv HDFEOS_LIB $HDFEOS_HOME/lib/$BRAND
    setenv HDFEOS_BIN $HDFEOS_HOME/bin/$BRAND
    setenv HDFEOS_OBJ $HDFEOS_HOME/obj/$BRAND
endif


#
# restore augmented user path
#
set path = ( $user_path )

if ( ! -f $HDFEOS_LIB/libGctp.a ) then
    switch ($BRAND)

	case linux:
	case linux32:
	    /bin/cp $HDFEOS_HOME/lib/tmp/geolibLINUX.a $HDFEOS_LIB/libGctp.a
	    echo "libGctp.a library does not exist. It is created."
	breaksw
	case linux64:
	    /bin/cp $HDFEOS_HOME/lib/tmp/geolibLINUX64.a $HDFEOS_LIB/libGctp.a
	    echo "libGctp.a library does not exist. It is created."
	breaksw
	case macintosh:
	    /usr/bin/cp $HDFEOS_HOME/lib/tmp/geolibMAC.a $HDFEOS_LIB/libGctp.a
	    echo "libGctp.a library does not exist. It is created."
	breaksw

	case macintel:
	case macintel32:
	    /usr/bin/cp $HDFEOS_HOME/lib/tmp/geolibMAC.a $HDFEOS_LIB/libGctp.a
	    echo "libGctp.a library does not exist. It is created."
	breaksw

	case macintel64:
	    /usr/bin/cp $HDFEOS_HOME/lib/tmp/geolibMAC64.a $HDFEOS_LIB/libGctp.a
	    echo "libGctp.a library does not exist. It is created."
	breaksw

	case sgi32:
	    /usr/bin/cp $HDFEOS_HOME/lib/tmp/geolibIRIX65-n32.a $HDFEOS_LIB/libGctp.a
	    echo "libGctp.a library does not exist. It is created."
	breaksw

	case sun5.8:
	    /usr/bin/cp $HDFEOS_HOME/lib/tmp/geolibSOL28.a $HDFEOS_LIB/libGctp.a
	    echo "libGctp.a library does not exist. It is created."
	breaksw

	case sun5.10:
	    /usr/bin/cp $HDFEOS_HOME/lib/tmp/geolibSOL210.a $HDFEOS_LIB/libGctp.a
	    echo "libGctp.a library does not exist. It is created."
	breaksw

	case sun5.11:
	    /usr/bin/cp $HDFEOS_HOME/lib/tmp/geolibSOL211.a $HDFEOS_LIB/libGctp.a
	    echo "libGctp.a library does not exist. It is created."
	breaksw

	default:
	    echo " Platform not supported"
	breaksw
    endsw
endif

#!/bin/csh -f
#-----------------------------------------------------------------------------
# file:         rundrivers.csh
#
# description:
#       Shell script to run all the HDFEOS Drivers within a directory.
#
# notes:
#       1) Any existing driver output files (except the samples) should be 
#	   deleted.  The difference check will fail if they aren't.  Its 
#	   probably a good idea to delete all the output files generated 
#	   after each run.  The difference files can hang around without
#	   causing a problem (they will be overwritten if the script is run
#	   again.
#	2) It is up to the user to set the FORTRAN90 flags and have the
#	   Toolkit compiled using FORTRAN90 prior to the running this script.
#	3) The script will take care of calling the proper makefile.
#	   (FORTRAN90 uses makefile.f90)
#
# usage:
#       rundrivers.csh LANGUAGE [LANGUAGE2] (ex. rundrivers.csh c f90)
#
#       At least one parameter(language) needs to be specified on the command
#	line.  If none are specified, no drivers will be run.  For each language
#	all the drivers within the directory will be run using the input file 
#	and the resulting output file will be checked against the sample output
#	file.
#
# author:
#       Abe Taaheri
#
# history:
#       07-Jul-2014 AT  Used TOOLKIT testdrivers originally written by
#                       Jason R. Watts / Hughes Applied Information Systems
#                       to create this and other scripts that this script runs
#----------------------------------------------------------------------------
 
# check the number of arguments coming in

if ($#argv < 1) then
    echo "";echo "No language(s) specified, exiting ..."; echo ""
    exit
endif

# set environment to build binary in current directory

setenv HDFEOS2_TST_BIN .
setenv DIFF $HDFEOS2_TST_SRC/Common/diff.csh
setenv HDFDIFF $HDFEOS2_TST_SRC/Common/hediff.csh

# loop through each argument on the command line
# (c ==> 'C', f ==> 'FORTRAN', f90 ==> 'FORTRAN90')

foreach LANG ($argv)

    if ($LANG == "c" || $LANG == "f" || $LANG == "f90") then

        # setup variables for which makefile to use
        # and how to name the output file
        # The filenames the 'C' drivers generate have '_c.out.(date)'
        # appended to the end, the FORTRAN drivers append '_f77.out'
        # (or f90) only (no date).  This makes it necessary to have
        # a SUFFIX variable.
 
        if ($LANG == "c") then
            set OUT_LANG = "c"
            set CODE_EXT = "c"
            set F_type = ""
            set SUFFIX = "c.out"
            set MAKE_FILE = "$HDFEOS2_TST_SRC/makefile_tst"
        else if ($LANG == "f") then
            set OUT_LANG = "f"
            set CODE_EXT = "f"
            set F_type = "77"
            set SUFFIX = "f77.out"
            set MAKE_FILE = "$HDFEOS2_TST_SRC/makefile_tst"
        else if ($LANG == "f90") then
            set LANG = "f"
            set CODE_EXT = "f"
            set F_type = "f90"
            set OUT_LANG = "90"
            set SUFFIX = "f90.out"
            set MAKE_FILE = "$HDFEOS2_TST_SRC/makefile_tst"
        endif

	echo ""
	echo "Processing ${OUT_LANG} drivers ..."
	
	# List all the drivers into 'DRIVERS'

	if ($LANG == "c") then
	    set SRCDRIVERS = `ls *.${CODE_EXT}`
	    set DRIVERS = ""
	    foreach DRIVER ($SRCDRIVERS)
		set DRIVERS = ( $DRIVERS `( echo  $DRIVER| \
		awk -F\.${CODE_EXT} '{len=length($1); \
		printf("%s\n", substr($1,1,len))}' )`)
	    end
        else
	    set SRCDRIVERS = `ls *.${CODE_EXT}|grep ${F_type}`

	    set DRIVERS = ""
	    foreach DRIVER ($SRCDRIVERS)
		if ( ${DRIVER} == testgrid77.f || ${DRIVER} == testswath77.f || ${DRIVER} == testpoint77.f || \
		     ${DRIVER} == testgrid90.f || ${DRIVER} == testswath90.f || ${DRIVER} == testpoint90.f ) then
		    set DRIVERS = ( $DRIVERS `( echo  $DRIVER| \
		    awk -F\.${CODE_EXT} '{len=length($1); \
		    printf("%s\n", substr($1,1,len))}' )`)

		else if (${DRIVER} == testgrid_szip77.f || ${DRIVER} == testswath_szip77.f || ${DRIVER} == testpoint_szip77.f ) then
		    set DRIVERS1 = ( `( echo  $DRIVER| \
		    awk -F\.${CODE_EXT} '{len=length($1); \
		    printf("%s\n", substr($1,1,len))}' )`)
		    set DRIVERS = ( $DRIVERS ${DRIVERS}_szip)
		endif
	    end
	endif

	# Go through list of drivers and do make, run driver, log difference
	
    	foreach DRIVER ($DRIVERS)
	
		echo ""; echo "Making ${DRIVER}_${LANG} ..."; echo ""
	
		# remove the existing driver

		\rm -f ${DRIVER}_${LANG}
	
		# make the driver

		make -f ${MAKE_FILE} ${DRIVER}_${LANG}
	
		# if make has a problem report an error 
                # and don't even try and run the driver

		if ($status != 0) then
	
	    	    echo ""; echo "ERROR::Could not compile ${DRIVER}_${LANG}."
	
		else
	
		    # make was successful, run driver 
                    # and check difference against sample

	    	    echo ""; echo "Running ${DRIVER}  DRIVER ..."
#	    	    ./${DRIVER}_${LANG} -v h >&! ${DRIVER}_${SUFFIX}
	    	    ./${DRIVER}_${LANG} -v h >&! ${DRIVER}_${LANG}.out
		    if ( $LANG == "f") then
			if ( -f *_${CODE_EXT}.txtout) then
			    /bin/mv *_${CODE_EXT}.txtout ${DRIVER}_${LANG}.out
			endif
		    endif
                echo ""; echo "Running diff ${DRIVER}_${LANG}.out_sample ${DRIVER}_${SUFFIX} >&! ${DRIVER}_${OUT_LANG}.diff ..."
#                ${DIFF} ${DRIVER}_${LANG}.out_sample ${DRIVER}_${SUFFIX} >&! ${DRIVER}_${OUT_LANG}.diff
		 ${DIFF} ${DRIVER}_${LANG}.out_sample ${DRIVER}_${LANG}.out >&! ${DRIVER}_${OUT_LANG}.diff
		endif
    	end

# we are done with drivers. Lets diff output hdf files
	set HDFFILES = `ls *.hdf`
    	foreach HEFILE ($HDFFILES)
	    if ( `echo $HEFILE | grep sample | wc -l` == 0 ) then
		echo ""; echo "Comparing ${HEFILE} with sample using ncdump and diff ..."; echo ""
                ${HDFDIFF} ${HEFILE} sample_{${HEFILE}} >&! ${HEFILE}.diff
		echo ""; echo "Done comparing ${HEFILE} with sample."
	    endif
    	end
    else

	echo "";echo "ERROR::$LANG is an invalid language...";echo ""

    endif

end

echo "Processing complete, check the difference files (*.diff) ...";echo ""

#!/bin/csh
 
################################################################################
#
#  CLS applications
#
################################################################################
 
# create the directory structure
 
echo "creating $SUBSYSTOP directory structure ..."
 
mkdir -p $SUBSYSTOP/install/data
 
# copy the data directories into the install data directory
 
echo "copying data into $SUBSYSTOP/install/data directory ..."
 
cp -r $SUBSYSTOP/DESKT/data/* $SUBSYSTOP/install/data
 

#!/bin/csh -f
#-----------------------------------------------------------------------------
# file:         hediff.csh
#
# description:
#       Shell script to compare two hdf output files, removing
#       differences caused by time/date stamps, host names
#       missing leading zeros, and other values that change 
#       over time
#
# usage:
#       hediff.csh sample_hefile_name.hdf hefile_name.hdf...
#
# author:
#       Abe Taaheri
#
# history:
#       11-Jul-2014 AT  Initial version for hdfeos2
#
#
#   Inputs:
#     $1 = sample_hefile_name.hdf
#     $2 = hefile_name.hdf
#
#
  if ( ! -r $1 ) then
	echo "ERROR - unable to read input file $1"
	exit -1
  endif
#
  if ( ! -r $2 ) then
	echo "ERROR - unable to read input file $2"
	exit -1
  endif
#
#    set filen ="`basename $2 .hdf`"
  set filen1 = "$1"
  set filen2 = "$2"
#
  set sample_temp = "/tmp/$$.sample"
  set out_temp    = "/tmp/$$.out"
  set sample_temp_orig = "/tmp/$$.sample_orig"
  set out_temp_orig    = "/tmp/$$.out_orig"
#
# dump hdf files onto ascii files
#
${HDFBIN}/ncdump $2 > &! ${sample_temp_orig}
${HDFBIN}/ncdump $1 > &! ${out_temp_orig}

     \rm -f $sample_temp $out_temp
     sed -e "/netcdf/d" \
			$sample_temp_orig > $sample_temp
     sed -e "/netcdf/d" \
                        $out_temp_orig > $out_temp


diff -bw $out_temp $sample_temp
\rm -f $sample_temp $out_temp
\rm -f $sample_temp_orig $out_temp_orig

echo " diff of $filen1 and $filen2 done"
